// MARKERS
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

layout(set = 0, binding = 0, std140) uniform _38_40
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _40;

layout(set = 1, binding = 0, std140) uniform _98_100
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
} _100;

layout(set = 2, binding = 0, std140) uniform _146_148
{
    vec4 _m0;
} _148;

layout(push_constant, std430) uniform _211_213
{
    int _m0;
    int _m1;
} _213;

layout(set = 2, binding = 1) uniform SAMPLER_2D _77;
layout(set = 1, binding = 1) uniform SAMPLER_2D _84;
layout(set = 2, binding = 2) uniform SAMPLER_2D _118;

layout(location = 2) in vec4 _79;
layout(location = 0) in vec4 _88;
layout(location = 3) in vec4 _90;
layout(location = 0) out vec4 _129;

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    vec2 _32 = gl_FragCoord.xy * _40._m4.zw;
    vec2 _48 = vec2(1.0) / _40._m4.zw;
    vec2 _54;
    _54.x = _48.x / 256.0;
    _54.y = _48.y / 256.0;
    vec2 _67 = fract(_32 * _54);
    vec4 _73 = SAMPLE_TEXTURE(_77, _79.xy);
    
    // Filter OUT the damn MARKERS
    vec2 tex_size = TEXTURE_SIZE(_77 , 0);
    if (tex_size.x == 128 && tex_size.y == 128)     _73 = vec4(0);
    
    vec4 _83 = SAMPLE_TEXTURE(_84, _67);
    _73 *= (_88 + _90);
    vec3 _108 = vec3(1.0) - (_83.xyz * _100._m5.w);
    vec3 _109 = _16(_108);
    _83 = vec4(_109.x, _109.y, _109.z, _83.w);
    _73.w *= _83.y;
    _73.w *= SAMPLE_TEXTURE(_118, _79.zw).w;
    vec3 _130 = _73.xyz;
    vec3 _139 = (_16(_130) * _73.w) * _40._m5.x;
    _129 = vec4(_139.x, _139.y, _139.z, _129.w);
    _129.w = _73.w;
    if (_148._m0.x == 0.0)
    {
    }
    else
    {
        if (_148._m0.x == 1.0)
        {
            _129.w = 9.9999997473787516355514526367188e-05;
        }
        else
        {
            if (_148._m0.x == 2.0)
            {
                _129.w = 1.0;
            }
            else
            {
                if (_148._m0.x == 3.0)
                {
                    float _179 = _129.w;
                    _129.w = _10(_179);
                    vec3 _188 = _129.xyz * _129.w;
                    _129 = vec4(_188.x, _188.y, _188.z, _129.w);
                }
                else
                {
                    if (_148._m0.x == 4.0)
                    {
                        float _198 = _129.w;
                        _129.w = _10(_198);
                        vec3 _207 = _129.xyz * _129.w;
                        _129 = vec4(_207.x, _207.y, _207.z, _129.w);
                        _129.w = 9.9999997473787516355514526367188e-05;
                    }
                }
            }
        }
    }
}


