// FIX FOR DECALS CLIPPING
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require
#extension GL_EXT_nonuniform_qualifier : require
layout(early_fragment_tests) in;

struct _792
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1097
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _2297
{
    int _m0;
    int _m1;
};

struct _2300
{
    int _m0;
    int _m1;
};

struct _2400
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _3339
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _4136
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4901
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _813_815
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _815;

layout(set = 0, binding = 0, std140) uniform _835_837
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _837;

layout(set = 2, binding = 0, std140) uniform _944_946
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _946;

layout(set = 0, binding = 14, std430) restrict readonly buffer _2302_2304
{
    _2300 _m0[];
} _2304;

layout(set = 0, binding = 15, std430) restrict readonly buffer _2375_2377
{
    uint _m0[];
} _2377;

layout(set = 0, binding = 16, std140) uniform _2405_2407
{
    vec4 _m0[4096];
} _2407;

layout(set = 0, binding = 17, std140) uniform _2425_2427
{
    vec4 _m0[4096];
} _2427;

layout(set = 0, binding = 18, std140) uniform _2477_2479
{
    vec4 _m0[4096];
} _2479;

layout(set = 0, binding = 20, std140) uniform _3343_3345
{
    vec4 _m0[4096];
} _3345;

layout(set = 0, binding = 21, std140) uniform _3382_3384
{
    vec4 _m0[4096];
} _3384;

layout(set = 0, binding = 22, std140) uniform _3450_3452
{
    vec4 _m0[4096];
} _3452;

layout(set = 0, binding = 24, std140) uniform _4140_4142
{
    vec4 _m0[4095];
} _4142;

layout(set = 0, binding = 26, std140) uniform _4905_4907
{
    vec4 _m0[4096];
} _4907;

layout(set = 0, binding = 1, std430) restrict readonly buffer _5286_5288
{
    uint _m0[];
} _5288;

layout(push_constant, std430) uniform _5282_5284
{
    int _m0;
    int _m1;
} _5284;

layout(set = 3, binding = 0) uniform texture2D _972[16384];
layout(set = 0, binding = 3) uniform sampler _980;
layout(set = 3, binding = 2) uniform texture2D _989[16384];
layout(set = 0, binding = 4) uniform sampler _994;
layout(set = 3, binding = 1) uniform texture2D _1004[16384];
layout(set = 0, binding = 5) uniform sampler _1009;
layout(set = 3, binding = 3) uniform texture2D _1017[16384];
layout(set = 0, binding = 6) uniform sampler _1022;
layout(set = 3, binding = 7) uniform texture2D _1031[16384];
layout(set = 0, binding = 7) uniform sampler _1036;
layout(set = 3, binding = 4) uniform texture2D _1044[16384];
layout(set = 0, binding = 8) uniform sampler _1049;
layout(set = 3, binding = 6) uniform texture2D _1057[16384];
layout(set = 0, binding = 9) uniform sampler _1062;
layout(set = 0, binding = 10) uniform SAMPLER_2D _1869;
layout(set = 0, binding = 11) uniform SAMPLER_2D _1878;
layout(set = 0, binding = 12) uniform SAMPLER_2D _1934;
layout(set = 0, binding = 13, r32f) uniform writeonly image2D _2162;
layout(set = 0, binding = 19) uniform SAMPLER_2D _2700;
layout(set = 0, binding = 23) uniform SAMPLER_2D _3698;
layout(set = 0, binding = 25) uniform sampler2DShadow _4464;
layout(set = 0, binding = 27) uniform SAMPLER_2D _5046;
layout(set = 3, binding = 5) uniform texture2D _5281[16384];

layout(location = 2) in vec4 _806;
layout(location = 5) in vec4 _824;
layout(location = 3) in vec4 _827;
layout(location = 4) in vec4 _850;
layout(location = 14) flat in uvec3 _902;
layout(location = 0) out vec4 _5199;
layout(location = 1) out vec4 _5207;
layout(location = 2) out vec4 _5215;
layout(location = 3) out vec4 _5233;

float _288;

uvec4 _44(vec4 _43)
{
    return floatBitsToUint(_43);
}

float _64(float _63)
{
    if (_63 <= 0.040449999272823333740234375)
    {
        return _63 / 12.9200000762939453125;
    }
    else
    {
        return pow((_63 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _76(float _75)
{
    float _342 = _75;
    return _64(_342);
}

float _67(float _66)
{
    return _66 * ((_66 * ((_66 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _29(vec2 _27, vec2 _28)
{
    return dot(_27, _28);
}

float _35(uint _34)
{
    return uintBitsToFloat(_34);
}

float _150(float _146, vec4 _147, float _148, bool _149)
{
    float _647 = _147.w / (_146 + _147.z);
    return _647 * _148;
}

vec3 _155(vec3 _153, bool _154)
{
    vec3 _660 = (_153 * 2.0) - vec3(1.0);
    float _677 = (1.0 - (_660.x * _660.x)) - (_660.y * _660.y);
    _660.z = sqrt(_10(_677));
    if (_154 == false)
    {
        _660.z = -_660.z;
    }
    return _660;
}

vec3 _162(vec3 _160, mat3 _161)
{
    return normalize(vec3(dot(_160, _161[0]), dot(_160, _161[1]), dot(_160, _161[2])));
}

uint _39(float _38)
{
    return floatBitsToUint(_38);
}

float _55(float _52, float _53, float _54)
{
    return min(_52, min(_53, _54));
}

float _50(float _47, float _48, float _49)
{
    return max(_47, max(_48, _49));
}

vec4 _105(uint _104)
{
    return unpackUnorm4x8(_104).wzyx;
}

vec4 _118(uvec2 _117)
{
    return vec4(float((_117.x >> uint(16)) & 65535u), float(_117.x & 65535u), float((_117.y >> uint(16)) & 65535u), float(_117.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _108(uint _107)
{
    return vec4(float((_107 >> uint(24)) & 255u), float((_107 >> uint(16)) & 255u), float((_107 >> uint(8)) & 255u), float(_107 & 255u));
}

float _98(float _97)
{
    return (step(0.0, _97) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _70(vec3 _69)
{
    float _303 = _69.x;
    vec3 _302;
    _302.x = _67(_303);
    float _309 = _69.y;
    _302.y = _67(_309);
    float _315 = _69.z;
    _302.z = _67(_315);
    return _302;
}

vec4 _73(vec4 _72)
{
    vec3 _325 = _72.xyz;
    vec4 _324 = vec4(_70(_325), 1.0);
    float _333 = _72.w;
    _324.w = _67(_333);
    return _324;
}

float _82(float _81)
{
    return _81 * _81;
}

vec3 _79(vec3 _78)
{
    return _78 * _78;
}

float _87(float _84, float _85, float _86)
{
    float _364 = (_84 - _85) / (_86 - _85);
    return _10(_364);
}

vec3 _112(uint _111)
{
    return vec3(float((_111 >> uint(21)) & 2047u), float((_111 >> uint(10)) & 2047u), float(_111 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _61(float _58, float _59, float _60)
{
    bool _229 = abs(_60) >= abs(_58);
    bool _237;
    if (_229)
    {
        _237 = abs(_60) >= abs(_59);
    }
    else
    {
        _237 = _229;
    }
    if (_237)
    {
        return uint((_60 < 0.0) ? 5 : 4);
    }
    if (abs(_59) >= abs(_58))
    {
        return uint((_59 < 0.0) ? 3 : 2);
    }
    return uint(int(_58 < 0.0));
}

float _90(float _89)
{
    return exp2(_89);
}

vec3 _121(uint _120)
{
    uint _462 = _120;
    vec4 _461 = _105(_462);
    float _473 = (_461.w * 255.0) - 128.0;
    return _461.xyz * _90(_473);
}

float _95(float _93, float _94)
{
    return pow(_93, _94);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _126(vec3 _124, float _125)
{
    float _485 = 50.0 * dot(_124, vec3(0.33329999446868896484375));
    float _478 = _10(_485);
    float _494 = 1.0 - _125;
    float _497 = _10(_494);
    float _498 = 5.0;
    vec3 _502 = _124 + ((vec3(_478) - _124) * _95(_497, _498));
    return _16(_502);
}

vec3 _134(vec3 _129, vec3 _130, vec3 _131, vec3 _132, float _133)
{
    vec3 _506 = normalize(_130 + _131);
    float _511 = 1.0 - (_133 * 0.800000011920928955078125);
    _511 *= _511;
    _511 *= _511;
    float _522 = _511 * _511;
    float _530 = dot(_129, _506);
    float _526 = _10(_530);
    float _532 = ((_526 * _526) * (_522 - 1.0)) + 1.0;
    _532 = _522 / ((_532 * _532) + 9.9999999392252902907785028219223e-09);
    float _551 = dot(_129, _130);
    float _547 = (_10(_551) * (1.0 - _511)) + _511;
    float _562 = dot(_129, _131);
    float _558 = (_10(_562) * (1.0 - _511)) + _511;
    _532 /= (((4.0 * _547) * _558) + 9.9999999392252902907785028219223e-09);
    vec3 _580 = _132;
    float _582 = dot(_131, _506);
    return _126(_580, _582) * _532;
}

vec3 _141(vec3 _137, vec3 _138, vec3 _139, float _140)
{
    float _588 = 1.0 - (_140 * 0.800000011920928955078125);
    _588 *= _588;
    _588 *= _588;
    float _598 = _588 * _588;
    float _606 = dot(_137, _138);
    float _602 = _10(_606);
    float _608 = ((_602 * _602) * (_598 - 1.0)) + 1.0;
    _608 = _598 / ((_608 * _608) + 9.9999999392252902907785028219223e-09);
    float _626 = dot(_137, _138);
    float _622 = (_10(_626) * (1.0 - _588)) + _588;
    _608 /= (((4.0 * _622) * _622) + 9.9999999392252902907785028219223e-09);
    vec3 _640 = _139;
    return _16(_640) * _608;
}

vec2 _166(vec2 _165)
{
    return (vec2(1.0) - abs(_165.yx)) * vec2((_165.x >= 0.0) ? 1.0 : (-1.0), (_165.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _171(inout vec3 _169, bool _170)
{
    _169 /= vec3((abs(_169.x) + abs(_169.y)) + abs(_169.z));
    vec2 _744;
    if (_169.z >= 0.0)
    {
        _744 = _169.xy;
    }
    else
    {
        vec2 _750 = _169.xy;
        _744 = _166(_750);
    }
    _169 = vec3(_744.x, _744.y, _169.z);
    if (_170)
    {
        vec2 _765 = (_169.xy * 0.5) + vec2(0.5);
        _169 = vec3(_765.x, _765.y, _169.z);
    }
    return _169.xy;
}

float _101(float _100)
{
    return sqrt(_100);
}

float _174(float _173)
{
    float _775 = abs(_173);
    float _772 = _101(_775);
    float _779;
    if (_173 > 0.0)
    {
        _779 = _772;
    }
    else
    {
        _779 = -_772;
    }
    return (_779 * 0.5) + 0.5;
}

void main()
{
    _792 _794 = _792(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _794._m15 = _806;
    _794._m16 = gl_FragCoord;
    _794._m40 = (uint(_815._m16.z) & 3u) << uint(4);
    vec3 _823 = vec3(_824.zw, _827.w);
    _794._m14 = _837._m0.xyz + _823;
    vec3 _845 = normalize(_827.xyz);
    vec3 _849 = normalize(_850.xyz);
    vec3 _854 = normalize(cross(_845, _849) * sign(_850.w));
    _794._m17 = mat3(vec3(_849.x, _854.x, _845.x), vec3(_849.y, _854.y, _845.y), vec3(_849.z, _854.z, _845.z));
    _794._m13 = normalize(-_823);
    uint _892 = 0u;
    vec4 _893 = vec4(0.0);
    vec4 _894 = vec4(0.0);
    vec4 _895 = vec4(0.0);
    vec4 _896 = vec4(0.0);
    vec4 _897 = vec4(0.0);
    uvec3 _900 = _902;
    vec3 _904 = vec3(abs(_850.w) - 1.0, 0.0, _824.x);
    bool _915 = _900.y == 65535u;
    bool _921;
    if (_915)
    {
        _921 = _900.z == 65535u;
    }
    else
    {
        _921 = _915;
    }
    bool _912 = _921;
    bool _922 = !_912;
    bool _925 = _900.z != 65535u;
    uint _929 = _900.x & 7u;
    uint _939;
    if (_837._m1.x == 0.0)
    {
        _939 = _929;
    }
    else
    {
        vec4 _947 = _946._m3;
        uvec4 _943 = _44(_947);
        uint _951 = _943[_929 / 2u];
        uint _956 = 16u * (_929 & 1u);
        _939 = (_951 >> _956) & 65535u;
    }
    uint _965 = _939;
    uint _974 = _965;
    vec3 _967 = texture(sampler2D(_972[nonuniformEXT(_974)], _980), _806.zw).xyz;
    uint _991 = _965;
    vec2 _988 = texture(sampler2D(_989[nonuniformEXT(_991)], _994), _806.zw).yx;
    vec3 _1001 = vec3(0.039999999105930328369140625);
    uint _1006 = _965;
    _1001 = texture(sampler2D(_1004[nonuniformEXT(_1006)], _1009), _806.zw).xyz;
    uint _1019 = _965;
    float _1016 = texture(sampler2D(_1017[nonuniformEXT(_1019)], _1022), _806.zw).x;
    float _1029 = 1.0;
    uint _1033 = _965;
    float _1030 = texture(sampler2D(_1031[nonuniformEXT(_1033)], _1036), _806.zw).x;
    uint _1046 = _965;
    float _1043 = texture(sampler2D(_1044[nonuniformEXT(_1046)], _1049), _806.zw).x;
    uint _1059 = _965;
    vec3 _1056 = texture(sampler2D(_1057[nonuniformEXT(_1059)], _1062), _806.zw).xyz;
    _895 = vec4(_967.x, _967.y, _967.z, _895.w);
    _895.w = _988.y;
    _896 = vec4(_1001.x, _1001.y, _1001.z, _896.w);
    _896.w = _1043;
    _897 = vec4(_897.x, _988.x, _897.z, _988.y);
    _893.x = _1030;
    _893.y = _1029;
    _893.z = _1043;
    _893.w = _1016;
    _894 = vec4(_1056.x, _1056.y, _1056.z, _894.w);
    vec2 _1094 = _806.zw;
    _1097 _1099;
    _1099._m0 = _895;
    _1099._m1 = _896;
    float _1104 = _893.x;
    _1099._m2.x = _76(_1104);
    _1099._m2 = vec4(_1099._m2.x, _893.yzw.x, _893.yzw.y, _893.yzw.z);
    _1099._m3 = _897;
    _1099._m4 = _894;
    _1097 _1118 = _1099;
    vec3 _1120 = vec3(0.0);
    bool _1128;
    if (_922)
    {
        _1128 = _904.x < 65534.0;
    }
    else
    {
        _1128 = _922;
    }
    bool _1134;
    if (_1128)
    {
        _1134 = _904.x > 0.0;
    }
    else
    {
        _1134 = _1128;
    }
    if (_1134)
    {
        uint _1137 = 0u;
        _1097 _1138 = _1097(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1140 = _900.y & 7u;
        uint _1149;
        if (_837._m1.x == 0.0)
        {
            _1149 = _1140;
        }
        else
        {
            vec4 _1153 = _946._m3;
            uvec4 _1152 = _44(_1153);
            uint _1157 = _1152[_1140 / 2u];
            uint _1162 = 16u * (_1140 & 1u);
            _1149 = (_1157 >> _1162) & 65535u;
        }
        uint _1170 = _1149;
        uint _1174 = _1170;
        vec3 _1172 = texture(sampler2D(_972[nonuniformEXT(_1174)], _980), _1094).xyz;
        uint _1184 = _1170;
        vec2 _1182 = texture(sampler2D(_989[nonuniformEXT(_1184)], _994), _1094).yx;
        vec3 _1192 = vec3(0.039999999105930328369140625);
        uint _1194 = _1170;
        _1192 = texture(sampler2D(_1004[nonuniformEXT(_1194)], _1009), _1094).xyz;
        uint _1204 = _1170;
        float _1202 = texture(sampler2D(_1017[nonuniformEXT(_1204)], _1022), _1094).x;
        float _1212 = 1.0;
        uint _1215 = _1170;
        float _1213 = texture(sampler2D(_1031[nonuniformEXT(_1215)], _1036), _1094).x;
        uint _1225 = _1170;
        float _1223 = texture(sampler2D(_1044[nonuniformEXT(_1225)], _1049), _1094).x;
        uint _1235 = _1170;
        vec3 _1233 = texture(sampler2D(_1057[nonuniformEXT(_1235)], _1062), _1094).xyz;
        _1138._m0 = vec4(_1172.x, _1172.y, _1172.z, _1138._m0.w);
        _1138._m0.w = _1182.y;
        _1138._m1 = vec4(_1192.x, _1192.y, _1192.z, _1138._m1.w);
        _1138._m1.w = _1223;
        _1138._m3 = vec4(_1138._m3.x, _1182.x, _1138._m3.z, _1182.y);
        _1138._m2.x = _1213;
        _1138._m2.y = _1212;
        _1138._m2.z = _1223;
        _1138._m2.w = _1202;
        _1138._m4 = vec4(_1233.x, _1233.y, _1233.z, _1138._m4.w);
        float _1272 = _1138._m2.x;
        _1138._m2.x = _67(_1272);
        float _1277 = _1138._m1.w;
        float _1280 = _904.x * _1277;
        float _1285 = _1099._m2.x;
        float _1288 = 0.0;
        float _1289 = 0.0;
        float _1290 = (_1280 * 1.5) - 0.5;
        float _1298 = 1.0 - _1285;
        float _1295 = _10(_1298);
        float _1307 = ((_1295 + _1290) - 0.5) * 10.0;
        float _1300 = _10(_1307);
        _1288 = _1300;
        float _1310 = (_904.x * 1.5) - 0.5;
        float _1318 = 1.0 - _1285;
        float _1315 = _10(_1318);
        float _1326 = ((_1315 + _1310) - 0.5) * 10.0;
        float _1320 = _10(_1326);
        _1289 = _1320;
        _1118._m0 = mix(_1118._m0, _1138._m0, vec4(_1288));
        _1118._m1 = mix(_1118._m1, _1138._m1, vec4(_1288));
        _1118._m2 = mix(_1118._m2, _1138._m2, vec4(_1288));
        _1118._m3 = mix(_1118._m3, _1138._m3, vec4(_1288));
        _1118._m4 = mix(_1118._m4, _1138._m4, vec4(_1288));
        _892 = (_1288 > 0.5) ? _1137 : _892;
        _1120.x = _1288;
    }
    bool _1382;
    if (_925)
    {
        _1382 = _904.y < 65534.0;
    }
    else
    {
        _1382 = _925;
    }
    bool _1388;
    if (_1382)
    {
        _1388 = _904.y > 0.0;
    }
    else
    {
        _1388 = _1382;
    }
    if (_1388)
    {
        uint _1391 = 0u;
        _1097 _1392 = _1097(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1393 = _900.z & 7u;
        uint _1402;
        if (_837._m1.x == 0.0)
        {
            _1402 = _1393;
        }
        else
        {
            vec4 _1406 = _946._m3;
            uvec4 _1405 = _44(_1406);
            uint _1410 = _1405[_1393 / 2u];
            uint _1415 = 16u * (_1393 & 1u);
            _1402 = (_1410 >> _1415) & 65535u;
        }
        uint _1423 = _1402;
        uint _1427 = _1423;
        vec3 _1425 = texture(sampler2D(_972[nonuniformEXT(_1427)], _980), _1094).xyz;
        uint _1437 = _1423;
        vec2 _1435 = texture(sampler2D(_989[nonuniformEXT(_1437)], _994), _1094).yx;
        vec3 _1445 = vec3(0.039999999105930328369140625);
        uint _1447 = _1423;
        _1445 = texture(sampler2D(_1004[nonuniformEXT(_1447)], _1009), _1094).xyz;
        uint _1457 = _1423;
        float _1455 = texture(sampler2D(_1017[nonuniformEXT(_1457)], _1022), _1094).x;
        float _1465 = 1.0;
        uint _1468 = _1423;
        float _1466 = texture(sampler2D(_1031[nonuniformEXT(_1468)], _1036), _1094).x;
        uint _1478 = _1423;
        float _1476 = texture(sampler2D(_1044[nonuniformEXT(_1478)], _1049), _1094).x;
        uint _1488 = _1423;
        vec3 _1486 = texture(sampler2D(_1057[nonuniformEXT(_1488)], _1062), _1094).xyz;
        _1392._m0 = vec4(_1425.x, _1425.y, _1425.z, _1392._m0.w);
        _1392._m0.w = _1435.y;
        _1392._m1 = vec4(_1445.x, _1445.y, _1445.z, _1392._m1.w);
        _1392._m1.w = _1476;
        _1392._m3 = vec4(_1392._m3.x, _1435.x, _1392._m3.z, _1435.y);
        _1392._m2.x = _1466;
        _1392._m2.y = _1465;
        _1392._m2.z = _1476;
        _1392._m2.w = _1455;
        _1392._m4 = vec4(_1486.x, _1486.y, _1486.z, _1392._m4.w);
        float _1525 = _1392._m2.x;
        _1392._m2.x = _67(_1525);
        float _1530 = _1392._m1.w;
        float _1533 = _904.y * _1530;
        float _1538 = _1118._m2.x;
        float _1541 = 0.0;
        float _1542 = 0.0;
        float _1543 = (_1533 * 1.5) - 0.5;
        float _1550 = 1.0 - _1538;
        float _1547 = _10(_1550);
        float _1558 = ((_1547 + _1543) - 0.5) * 10.0;
        float _1552 = _10(_1558);
        _1541 = _1552;
        float _1561 = (_904.y * 1.5) - 0.5;
        float _1569 = 1.0 - _1538;
        float _1566 = _10(_1569);
        float _1577 = ((_1566 + _1561) - 0.5) * 10.0;
        float _1571 = _10(_1577);
        _1542 = _1571;
        _1118._m0 = mix(_1118._m0, _1392._m0, vec4(_1541));
        _1118._m1 = mix(_1118._m1, _1392._m1, vec4(_1541));
        _1118._m2 = mix(_1118._m2, _1392._m2, vec4(_1541));
        _1118._m3 = mix(_1118._m3, _1392._m3, vec4(_1541));
        _1118._m4 = mix(_1118._m4, _1392._m4, vec4(_1541));
        _892 = (_1541 > 0.5) ? _1391 : _892;
        _1120.y = _1541;
    }
    bool _1633;
    if (_922)
    {
        _1633 = _904.z > 0.0;
    }
    else
    {
        _1633 = _922;
    }
    if (_1633)
    {
        _794._m37 = _904.z;
        float _1644 = 1.0 - _1118._m2.x;
        _794._m38 = _10(_1644);
    }
    _895 = _1118._m0;
    _896 = _1118._m1;
    vec3 _1652;
    if (_922)
    {
        _1652 = vec3(0.0);
    }
    else
    {
        _1652 = _893.xyz;
    }
    _893 = vec4(_1652.x, _1652.y, _1652.z, _893.w);
    _893.w = _1118._m2.w;
    _897 = _1118._m3;
    _894 = _1118._m4;
    vec3 _1668 = vec3(1.0);
    _794._m10 *= _904;
    _794._m10 *= vec3(_837._m2.x);
    uint _1682 = 0u;
    _794._m15.x = (_794._m15.x * _815._m2.x) + _815._m2.z;
    _794._m15.y = (_794._m15.y * _815._m2.y) + _815._m2.w;
    float _1701 = _837._m3.z;
    float _1704 = _837._m4.z;
    vec2 _1707 = _794._m15.xy * _1701;
    vec2 _1713 = dFdx(_1707) / vec2(float(gl_FragmentSizeNV.x));
    vec2 _1725 = dFdy(_1707) / vec2(float(gl_FragmentSizeNV.y));
    vec2 _1734 = _1713;
    vec2 _1736 = _1713;
    float _1733 = _29(_1734, _1736);
    vec2 _1740 = _1725;
    vec2 _1742 = _1725;
    float _1739 = _29(_1740, _1742);
    float _1745 = 0.5 * log2(max(_1733, _1739));
    float _1751 = 0.5 * log2(min(_1733, _1739));
    float _1757 = _1745 - min(_1704, _1745 - _1751);
    float _1765 = _1757;
    float _1767 = _837._m3.y;
    float _1770 = _837._m4.y;
    uvec2 _1773 = uvec2(_794._m15.xy * _1767);
    uint _1780 = uint(min(_837._m4.w, max(0.0, _1757) + _1770));
    uint _1789 = uint(_837._m3.x);
    _1682 = _1773.x & 255u;
    _1682 |= ((_1773.y & 255u) << uint(8));
    _1682 |= ((_1773.x >> uint(8)) << uint(16));
    _1682 |= ((_1773.y >> uint(8)) << uint(24));
    _1682 |= (_1780 << uint(19));
    _1682 |= (_1789 << uint(27));
    vec3 _1882;
    if (_837._m5.y != 0.0)
    {
        float _1829 = fract(_1765);
        float _1832 = 0.375;
        float _1834 = 0.625;
        bool _1841;
        float _1842;
        float _1845;
        if (_1829 <= _1832)
        {
            _1841 = false;
            _1842 = _1765 - 0.5;
            _1845 = 0.0;
        }
        else
        {
            if (_1829 >= _1834)
            {
                _1841 = false;
                _1842 = _1765 + 0.5;
                _1845 = 0.0;
            }
            else
            {
                _1841 = true;
                _1842 = _1765 - 0.5;
                _1845 = _1765 + 0.5;
            }
        }
        vec4 _1860 = vec4(_794._m15.x, _794._m15.y, 0.0, _1842);
        vec2 _1867 = TEXTURE_LOD(_1869, _1860.xy, _1860.w).xy;
        vec4 _1877 = SAMPLE_TEXTURE(_1878, _1867);
        _1882.x = (_794._m15.x * _1877.x) + _1877.z;
        _1882.y = (_794._m15.y * (_1877.x * _837._m6.x)) + _1877.w;
        _1882.z = _1877.y;
        vec2 _1908 = (dFdx(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1882.z;
        vec2 _1921 = (dFdy(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1882.z;
        vec3 _1941 = TEXTURE_GRAD(_1934, _1882.xy, _1908, _1921).xyz;
        _893 = vec4(_1941.x, _1941.y, _1941.z, _893.w);
        if (_1841)
        {
            vec4 _1947 = vec4(_794._m15.x, _794._m15.y, 0.0, _1845);
            vec2 _1954 = TEXTURE_LOD(_1869, _1947.xy, _1947.w).xy;
            vec4 _1962 = SAMPLE_TEXTURE(_1878, _1954);
            _1882.x = (_794._m15.x * _1962.x) + _1962.z;
            _1882.y = (_794._m15.y * (_1962.x * _837._m6.x)) + _1962.w;
            _1882.z = _1962.y;
            vec2 _1990 = (dFdx(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1882.z;
            vec2 _2003 = (dFdy(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1882.z;
            vec3 _2023 = TEXTURE_GRAD(_1934, _1882.xy, _1990, _2003).xyz;
            vec4 _2016;
            _2016 = vec4(_2023.x, _2023.y, _2023.z, _2016.w);
            float _2026 = 0.0;
            float _2027 = 0.375;
            float _2032 = (_1829 - _2027) * 4.0;
            _2026 = _10(_2032);
            vec3 _2040 = mix(_893.xyz, _2016.xyz, vec3(_2026));
            _2016 = vec4(_2040.x, _2040.y, _2040.z, _2016.w);
        }
    }
    else
    {
        vec4 _2044 = vec4(_794._m15.x, _794._m15.y, 0.0, _1765 - 0.5);
        vec2 _2052 = TEXTURE_LOD(_1869, _2044.xy, _2044.w).xy;
        vec4 _2060 = SAMPLE_TEXTURE(_1878, _2052);
        _1882.x = (_794._m15.x * _2060.x) + _2060.z;
        _1882.y = (_794._m15.y * (_2060.x * _837._m6.x)) + _2060.w;
        _1882.z = _2060.y;
        vec2 _2088 = (dFdx(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1882.z;
        vec2 _2101 = (dFdy(_794._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1882.z;
        vec3 _2120 = TEXTURE_GRAD(_1934, _1882.xy, _2088, _2101).xyz;
        _893 = vec4(_2120.x, _2120.y, _2120.z, _893.w);
    }
    vec2 _2123 = vec2(160.0, 90.0);
    vec2 _2127 = _2123 * _837._m7.zw;
    vec2 _2134 = (gl_FragCoord.xy * _837._m7.zw) * _2123;
    bool _2148 = fract(_2134.x) < _2127.x;
    bool _2157;
    if (_2148)
    {
        _2157 = fract(_2134.y) < _2127.y;
    }
    else
    {
        _2157 = _2148;
    }
    if (_2157)
    {
        uint _2166 = _1682;
        imageStore(_2162, ivec2(_2134), vec4(_35(_2166), 0.0, 0.0, 0.0));
    }
    _892 = _1682;
    _794._m0 = _895.xyz;
    _794._m2 = _896.xyz;
    _794._m1 = _894.xyz;
    _794._m9 = _893.xyz;
    _794._m3 = _893.w;
    _794._m6 = _897.wyz;
    uint _2190 = 8u;
    float _2192 = 16.0;
    float _2194 = 8.0;
    float _2196 = 24.0;
    vec2 _2205 = _794._m16.xy * _837._m7.xy;
    vec3 _2198;
    _2198 = vec3(_2205.x, _2205.y, _2198.z);
    _2198.y = 1.0 - _2198.y;
    
    _2198.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _2218 = floor(_2198.xy * vec2(_2192, _2194));
    _2198 = vec3(_2218.x, _2218.y, _2198.z);
    float _2222 = _794._m16.z;
    vec4 _2225 = _837._m8;
    float _2228 = 1.0;
    bool _2229 = false;
    float _2221 = _150(_2222, _2225, _2228, _2229);
    float _2231 = log2(max(1.0, _2221 / _837._m9.z)) * _837._m9.w;
    _2198.z = min(_2196 - 1.0, floor(_2231));
    uint _2247 = uint((_2198.x + (_2198.y * _2192)) + ((_2198.z * _2192) * _2194));
    _2247 = min(_2247, uint(((_2192 * _2194) * _2196) - 1.0));
    bool _2272 = true;
    vec3 _2273 = _794._m6;
    bool _2276 = _2272;
    _794._m7 = _155(_2273, _2276);
    vec3 _2280 = _794._m7;
    mat3 _2283 = _794._m17;
    _794._m6 = _162(_2280, _2283);
    uint _2288 = 0u;
    uint _2289 = 0u;
    uint _2290 = 0u;
    uint _2291 = 0u;
    uint _2292 = 0u;
    uint _2293 = 0u;
    int _2295 = 256;
    _2297 _2299;
    _2299._m0 = _2304._m0[_2247]._m0;
    _2299._m1 = _2304._m0[_2247]._m1;
    int _2313 = _2299._m0 & (~(_2299._m0 >> 31));
    int _2322 = _2299._m1 & (~(_2299._m1 >> 31));
    _2288 = uint((_2313 >> 16) * _2295);
    _2289 = _2288 + uint(_2322 & 255);
    _2290 = _2288;
    _2291 = _2290 + uint((_2322 >> 8) & 255);
    _2292 = _2288;
    _2293 = _2292 + uint((_2322 >> 16) & 255);
    vec3 _2355 = dFdx(_794._m14);
    vec3 _2359 = dFdy(_794._m14);
    uint _2363 = _2290;
    _2400 _2402;
    vec3 _2754;
    float _2859;
    while (_2363 < _2291)
    {
        uint _2373 = _2377._m0[_2363];
        uint _2382 = (_2373 >> uint(12)) & 4095u;
        uint _2388 = _2382;
        if (_2388 >= _2382)
        {
            _2363++;
        }
        int _2397 = 2;
        int _2398 = 2;
        int _2399 = 2;
        _2402._m0 = _2407._m0[(uint(_2397) * _2388) + 0u];
        _2402._m1 = _2407._m0[(uint(_2397) * _2388) + 1u];
        _2402._m2 = _2427._m0[(uint(_2398) * _2388) + 0u];
        float _2441 = _2427._m0[(uint(_2398) * _2388) + 1u].x;
        _2402._m3.x = _39(_2441);
        float _2451 = _2427._m0[(uint(_2398) * _2388) + 1u].y;
        _2402._m3.y = _39(_2451);
        float _2461 = _2427._m0[(uint(_2398) * _2388) + 1u].z;
        _2402._m4.x = _39(_2461);
        float _2471 = _2427._m0[(uint(_2398) * _2388) + 1u].w;
        _2402._m4.y = _39(_2471);
        float _2485 = _2479._m0[(uint(_2399) * _2388) + 0u].x;
        _2402._m5.x = _39(_2485);
        float _2495 = _2479._m0[(uint(_2399) * _2388) + 0u].y;
        _2402._m5.y = _39(_2495);
        float _2505 = _2479._m0[(uint(_2399) * _2388) + 0u].z;
        _2402._m6 = _39(_2505);
        float _2515 = _2479._m0[(uint(_2399) * _2388) + 0u].w;
        _2402._m7 = _39(_2515);
        float _2525 = _2479._m0[(uint(_2399) * _2388) + 1u].x;
        _2402._m8 = _39(_2525);
        float _2535 = _2479._m0[(uint(_2399) * _2388) + 1u].y;
        _2402._m9 = _39(_2535);
        float _2545 = _2479._m0[(uint(_2399) * _2388) + 1u].z;
        _2402._m10 = _39(_2545);
        float _2556 = _2479._m0[(uint(_2399) * _2388) + 1u].w;
        _2402._m11 = _39(_2556);
        vec4 _2561 = vec4(_794._m14, 1.0);
        vec3 _2568 = vec3(dot(_2561, _2402._m0), dot(_2561, _2402._m1), dot(_2561, _2402._m2));
        float _2582 = 0.0039215688593685626983642578125;
        float _2584 = _2568.x;
        float _2587 = _2568.y;
        float _2590 = _2568.z;
        bool _2595 = _55(_2584, _2587, _2590) <= _2582;
        bool _2612;
        if (!_2595)
        {
            float _2599 = _2568.x;
            float _2602 = _2568.y;
            float _2605 = _2568.z;
            _2612 = _50(_2599, _2602, _2605) >= (1.0 - _2582);
        }
        else
        {
            _2612 = _2595;
        }
        if (_2612)
        {
            continue;
        }
        uint _2616 = _2402._m11;
        bool _2620 = _2190 != 0u;
        bool _2627;
        if (_2620)
        {
            _2627 = (_2616 & 1024u) != 0u;
        }
        else
        {
            _2627 = _2620;
        }
        bool _2640;
        if (!_2627)
        {
            bool _2632 = _2190 == 0u;
            bool _2639;
            if (_2632)
            {
                _2639 = (_2616 & 2048u) != 0u;
            }
            else
            {
                _2639 = _2632;
            }
            _2640 = _2639;
        }
        else
        {
            _2640 = _2627;
        }
        if (_2640)
        {
            continue;
        }
        vec3 _2644 = _2402._m0.xyz;
        vec3 _2648 = _2402._m1.xyz;
        vec3 _2652 = _2402._m2.xyz;
        vec2 _2656 = vec2(dot(_2355, _2644), dot(_2355, _2648));
        vec2 _2664 = vec2(dot(_2359, _2644), dot(_2359, _2648));
        float _2672 = 1.0;
        float _2673 = 1.0;
        vec3 _2674 = vec3(0.5, 0.5, 1.0);
        uint _2676 = _2402._m7;
        uint _2680 = _2402._m9;
        vec4 _2679 = _105(_2680);
        uvec2 _2685 = _2402._m5;
        vec4 _2684 = _118(_2685);
        vec2 _2689 = _2656 * _2684.xy;
        vec2 _2694 = _2664 * _2684.xy;
        vec4 _2699 = TEXTURE_GRAD(_2700, (_2568.xy * _2684.xy) + _2684.zw, _2689, _2694);
        _2672 = _2699.z;
        float _2715 = _2699.w;
        _2673 = _67(_2715);
        bool _2722 = _2673 <= (4.0 * _2582);
        bool _2729;
        if (_2722)
        {
            _2729 = _2679.w <= _2582;
        }
        else
        {
            _2729 = _2722;
        }
        if (_2729)
        {
            continue;
        }
        vec2 _2733 = (_2699.xy * 2.0) - vec2(1.0);
        float _2744 = 1.0 - dot(_2733, _2733);
        _2674 = vec3(_2733, sqrt(_10(_2744)));
        if ((_2616 & 256u) != 0u)
        {
            _2754 = vec3(-_2674.x, -_2674.y, _2674.z);
        }
        else
        {
            _2754 = _2674;
        }
        _2674 = _2754;
        uint _2769 = _2402._m8;
        uint _2773 = _2769;
        float _2772 = 1.0 + (_108(_2773).w * 0.062745101749897003173828125);
        uint _2781 = _2676;
        float _2780 = _105(_2781).z;
        float _2794 = _2772 - (_2772 * abs((_2568.z * 2.0) - 1.0));
        _2673 *= _10(_2794);
        if ((_2676 & 64u) != 0u)
        {
            uint _2805 = _2676;
            float _2804 = _105(_2805).x;
            uint _2810 = _2676;
            float _2809 = _108(_2810).y;
            float _2816 = _2804;
            float _2814 = mix(_2809, 0.0, _10(_2816));
            float _2825 = _2672 - (_2814 / 255.0);
            float _2820 = float(_10(_2825) > 0.0);
            _2673 *= _2820;
        }
        vec3 _2832 = normalize(vec3(_794._m17[0].z, _794._m17[1].z, _794._m17[2].z));
        float _2841 = dot(_2832, normalize(_2652));
        float _2846 = _2841;
        vec2 _2851 = _2674.xy * _98(_2846);
        _2674 = vec3(_2851.x, _2851.y, _2674.z);
        if ((_2616 & 32768u) != 0u)
        {
            float _2864 = abs(_2841);
            _2859 = _10(_2864);
        }
        else
        {
            float _2867 = _2841;
            _2859 = _10(_2867);
        }
        float _2854 = _2859;
        float _2871 = _2673 * _2854;
        uint _2875 = _2402._m6;
        uint _2879 = _2875;
        vec4 _2884 = _105(_2879) * _2871;
        vec4 _2878 = _22(_2884);
        _794._m11 = max(_794._m11, _2878.x);
        _2644 += (_2832 * dot(_2644, _2832));
        _2648 += (_2832 * dot(_2648, _2832));
        _2674 = ((normalize(_2644) * _2674.x) + (normalize(_2648) * _2674.y)) + (_2832 * _2674.z);
        if ((_2616 & 512u) != 0u)
        {
            vec3 _2928 = mix(_2832, _2674, _2878.www);
            float _2934 = dot(_2928, _2832);
            _2674 = (_794._m6 * _2934) + ((_2928 - (_2832 * _2934)) * dot(_794._m6, _2832));
        }
        else
        {
            if ((_2616 & 128u) != 0u)
            {
                _2674 = mix(mix(_794._m6, _2832, vec3(_2871)), _2674, _2878.www);
            }
            else
            {
                _2674 = mix(_794._m6, _2674, _2878.www);
            }
        }
        _794._m6 = normalize(_2674);
        uint _2981 = _2769;
        vec3 _2980 = _105(_2981).xyz;
        float _2985 = _2673;
        if ((_2676 & 1u) != 0u)
        {
            uvec2 _2993 = _2402._m3;
            vec4 _2992 = _118(_2993);
            vec2 _2997 = _2656 * _2992.xy;
            vec2 _3002 = _2664 * _2992.xy;
            vec4 _3007 = TEXTURE_GRAD(_2700, (_2568.xy * _2992.xy) + _2992.zw, _2997, _3002);
            vec4 _3020 = _3007;
            _3007 = _73(_3020);
            float _3030 = (_3007.w - _2582) / (1.0 - _2582);
            _2985 = _10(_3030);
            _2980 *= _3007.xyz;
        }
        _794._m0 = mix(_794._m0, _2980, _2878.xxx);
        float _3043 = ((_2854 * _2985) * _2679.w) * _2780;
        _794._m10 += (_2679.xyz * (_3043 * 64.0));
        uint _3062 = _2402._m10;
        uint _3066 = _3062;
        vec4 _3065 = _105(_3066);
        float _3069 = 0.0;
        if ((_2676 & 10u) != 0u)
        {
            uvec2 _3077 = _2402._m4;
            vec4 _3076 = _118(_3077);
            vec2 _3081 = _2656 * _3076.xy;
            vec2 _3086 = _2664 * _3076.xy;
            vec4 _3091 = TEXTURE_GRAD(_2700, (_2568.xy * _3076.xy) + _3076.zw, _3081, _3086);
            if ((_2676 & 2u) != 0u)
            {
                _3065 = _3091 * _3091;
            }
            else
            {
                _3069 = _3091.w;
            }
        }
        _794._m2 = mix(_794._m2, _3065.xyz, _2878.yyy);
        _794._m3 = mix(_794._m3, _3065.w, _2878.z);
        _794._m37 = max(_794._m37, _3069);
        float _3141 = (_2672 - 0.5) * 2.0;
        _794._m38 = max(_794._m38, _10(_3141));
    }
    float _3146 = _794._m37;
    float _3145 = _82(_3146);
    float _3153 = _3145 - 0.5;
    float _3150 = _10(_3153) * 2.0;
    float _3164 = _3145 * 2.0;
    float _3156 = (_794._m38 * _794._m38) * _10(_3164);
    float _3171 = _3156 + _3150;
    float _3167 = _10(_3171);
    if (_3167 > 0.0039215688593685626983642578125)
    {
        vec3 _3179 = _794._m0;
        float _3186 = _3167 * 1.0;
        float _3187 = 0.0;
        float _3188 = 0.3499999940395355224609375;
        _794._m0 = mix(_794._m0, _79(_3179), vec3(_87(_3186, _3187, _3188) * (1.0 - _794._m3)));
        float _3202 = _3167 * 1.0;
        float _3203 = 0.25;
        float _3204 = 0.5;
        _794._m2 = mix(_794._m2, vec3(0.039999999105930328369140625), vec3(_87(_3202, _3203, _3204)));
        vec3 _3209 = vec3(_794._m17[0].z, _794._m17[1].z, _794._m17[2].z);
        float _3223 = _3209.z + 0.0625;
        float _3217 = _3167 * _10(_3223);
        float _3232 = _3217 * 1.0;
        float _3233 = 0.20000000298023223876953125;
        float _3234 = 1.0;
        _794._m3 = mix(_794._m3, 0.89999997615814208984375, _87(_3232, _3233, _3234));
        float _3243 = _3217 * 1.0;
        float _3244 = 0.449999988079071044921875;
        float _3245 = 0.980000019073486328125;
        float _3238 = _87(_3243, _3244, _3245);
        _794._m6 = normalize(mix(_794._m6, vec3(0.0, 0.0, 1.0), vec3(_3238)));
        _794._m7 = mix(_794._m6, vec3(0.5, 0.5, 1.0), vec3(_3238));
        if (_3217 > 0.980000019073486328125)
        {
            float _3268 = _3217 * _3238;
            float _3269 = 0.980000019073486328125;
            float _3270 = 1.0;
            _3209 = normalize(mix(_3209, vec3(0.0, 0.0, 1.0), vec3(_87(_3268, _3269, _3270))));
            _794._m17[0].z = _3209.x;
            _794._m17[1].z = _3209.y;
            _794._m17[2].z = _3209.z;
        }
    }
    vec3 _3284 = vec3(0.0);
    _3284 = _794._m9 * _837._m10.x;
    float _3294;
    if (dot(_794._m10, vec3(1.0)) > 0.0)
    {
        _3294 = -_794._m3;
    }
    else
    {
        _3294 = _794._m3;
    }
    _794._m3 = _3294;
    _794._m18 = _3284;
    _794._m19 = _3284;
    uint _3310 = _2288;
    _3339 _3341;
    vec3 _3659;
    float _3748;
    float _3766;
    uint _4110;
    _4136 _4138;
    uint _4260;
    _4136 _4284;
    while (_3310 < _2289)
    {
        uint _3320 = _2377._m0[_3310];
        uint _3324 = _3320 & 4095u;
        uint _3327 = _3324;
        if (_3327 >= _3324)
        {
            _3310++;
        }
        int _3336 = 4;
        int _3337 = 4;
        int _3338 = 4;
        _3341._m0 = _3345._m0[(uint(_3336) * _3327) + 0u].xyz;
        float _3360 = _3345._m0[(uint(_3336) * _3327) + 0u].w;
        _3341._m1 = _39(_3360);
        _3341._m2 = _3345._m0[(uint(_3336) * _3327) + 1u];
        _3341._m3 = _3345._m0[(uint(_3336) * _3327) + 2u];
        _3341._m4 = _3384._m0[(uint(_3337) * _3327) + 0u];
        _3341._m5 = _3384._m0[(uint(_3337) * _3327) + 1u];
        _3341._m6 = _3384._m0[(uint(_3337) * _3327) + 2u];
        float _3414 = _3345._m0[(uint(_3336) * _3327) + 3u].x;
        _3341._m7.x = _39(_3414);
        float _3424 = _3345._m0[(uint(_3336) * _3327) + 3u].y;
        _3341._m7.y = _39(_3424);
        float _3434 = _3345._m0[(uint(_3336) * _3327) + 3u].z;
        _3341._m7.z = _39(_3434);
        float _3444 = _3345._m0[(uint(_3336) * _3327) + 3u].w;
        _3341._m7.w = _39(_3444);
        _3341._m8 = _3452._m0[(uint(_3338) * _3327) + 0u];
        _3341._m9 = _3452._m0[(uint(_3338) * _3327) + 1u];
        _3341._m10 = _3452._m0[(uint(_3338) * _3327) + 2u];
        _3341._m11 = _3452._m0[(uint(_3338) * _3327) + 3u];
        float _3490 = _3384._m0[(uint(_3337) * _3327) + 3u].x;
        _3341._m12 = _39(_3490);
        float _3500 = _3384._m0[(uint(_3337) * _3327) + 3u].y;
        _3341._m13 = _39(_3500);
        _3341._m14 = _3384._m0[(uint(_3337) * _3327) + 3u].z;
        float _3518 = _3384._m0[(uint(_3337) * _3327) + 3u].w;
        _3341._m15 = _39(_3518);
        uint _3523 = (_3341._m12 >> uint(16)) & 3u;
        if (((_794._m40 >> uint(4)) & 3u) != _3523)
        {
            continue;
        }
        float _3537 = 0.0039215688593685626983642578125;
        vec4 _3538 = vec4(_794._m14, 1.0);
        float _3545 = 1.0 / dot(_3538, _3341._m6);
        vec3 _3551 = vec3(dot(_3538, _3341._m4) * _3545, dot(_3538, _3341._m5) * _3545, dot(_3538, _3341._m3));
        uint _3569 = _3341._m1;
        uint _3572 = _2190;
        _3572 |= 64u;
        float _3576 = _3551.x;
        float _3579 = _3551.y;
        float _3582 = _3551.z;
        bool _3587 = _55(_3576, _3579, _3582) <= _3537;
        bool _3604;
        if (!_3587)
        {
            float _3591 = _3551.x;
            float _3594 = _3551.y;
            float _3597 = _3551.z;
            _3604 = _50(_3591, _3594, _3597) >= (1.0 - _3537);
        }
        else
        {
            _3604 = _3587;
        }
        bool _3612;
        if (!_3604)
        {
            _3612 = (_3569 & _3572) != 0u;
        }
        else
        {
            _3612 = _3604;
        }
        if (_3612)
        {
            continue;
        }
        if ((_3569 & 3u) == 2u)
        {
            vec2 _3631 = fract((_3551.xy * _837._m11.xy) + _837._m11.zw);
            _3551 = vec3(_3631.x, _3631.y, _3551.z);
        }
        vec3 _3634 = _3341._m0;
        float _3637 = 1.0;
        float _3638 = 1.0;
        vec3 _3639 = vec3(0.0, 0.0, 1.0);
        vec3 _3640 = vec3(0.0, 0.0, 1.0);
        uint _3641 = _3341._m1;
        vec3 _3644 = (_3551 * 2.0) - vec3(1.0);
        vec2 _3649 = _3551.xy;
        vec3 _3652 = _3341._m10.xyz;
        if ((_3641 & 3u) == 2u)
        {
            _3659 = _3652;
        }
        else
        {
            _3659 = normalize(_3634 - _794._m14);
        }
        _3639 = _3659;
        _3639 = _3639;
        float _3676 = dot(_794._m6, _3639);
        float _3671 = _10(_3676);
        bool _3680 = _3671 <= _3537;
        bool _3687;
        if (_3680)
        {
            _3687 = (_3641 & 48u) == 0u;
        }
        else
        {
            _3687 = _3680;
        }
        if (_3687)
        {
            continue;
        }
        uvec2 _3692 = _3341._m7.zw;
        vec4 _3691 = _118(_3692);
        float _3697 = TEXTURE_LOD(_3698, vec4((_3649 * _3691.xy) + _3691.zw, 0.0, 0.0).xy, vec4((_3649 * _3691.xy) + _3691.zw, 0.0, 0.0).w).x;
        float _3724 = _3697 * _3697;
        uint _3728 = _3641 & 3u;
        bool _3733 = _3728 == 1u;
        bool _3745;
        if (!_3733)
        {
            bool _3738 = _3728 == 0u;
            bool _3744;
            if (_3738)
            {
                _3744 = _3341._m8.z != 0.0;
            }
            else
            {
                _3744 = _3738;
            }
            _3745 = _3744;
        }
        else
        {
            _3745 = _3733;
        }
        bool _3731 = _3745;
        if (_3731)
        {
            float _3751 = _3341._m8.w;
            _3748 = _10(_3751);
        }
        else
        {
            _3748 = 0.5;
        }
        float _3746 = _3748;
        bool _3759 = _3728 == 0u;
        bool _3765;
        if (_3759)
        {
            _3765 = _3341._m8.z != 0.0;
        }
        else
        {
            _3765 = _3759;
        }
        if (_3765)
        {
            float _3774 = sqrt(dot(_3644, _3644));
            _3766 = min(0.9921875, _10(_3774));
        }
        else
        {
            _3766 = _3551.z;
        }
        float _3757 = _3766;
        uvec2 _3782 = _3341._m7.xy;
        vec4 _3781 = _118(_3782);
        vec2 _3787 = vec2(_3757, _3746);
        float _3791 = TEXTURE_LOD(_3698, vec4((_3787 * _3781.xy) + _3781.zw, 0.0, 0.0).xy, vec4((_3787 * _3781.xy) + _3781.zw, 0.0, 0.0).w).x;
        _3791 *= _3791;
        _3637 = _3791 * _3724;
        if ((_3641 & 48u) != 0u)
        {
            vec4 _3828 = _3341._m10;
            vec4 _3831 = _3341._m8;
            vec4 _3834 = _3341._m9;
            float _3837 = dot(_794._m14, _3828.xyz) + _3828.w;
            if (_3837 < 0.0)
            {
                continue;
            }
            float _3851 = length(_3828.xyz);
            float _3858 = _3837 * 50.0;
            float _3855 = _10(_3858);
            _3637 *= (_3855 * _3855);
            _3837 /= _3851;
            _3828 /= vec4(_3851);
            vec3 _3872 = reflect(-_794._m13, _794._m6);
            if (dot(_3872, _3828.xyz) > 0.0)
            {
                _3872 = reflect(_3872, _3828.xyz);
            }
            float _3890 = dot(_3872, _3828.xyz);
            float _3895 = _3837 / _3890;
            vec3 _3899 = _794._m14 - (_3872 * _3895);
            vec3 _3906 = _3899 - _3634;
            float _3910 = dot(_3906, _3831.xyz) / _3831.w;
            float _3918 = dot(_3906, _3834.xyz) / _3834.w;
            if ((_3641 & 48u) == 32u)
            {
                vec2 _3932 = vec2(_3910, _3918);
                float _3936 = 1.0 / max(1.0, length(vec2(_3910, _3918)));
                _3910 *= (_3936 * _3831.w);
                _3918 *= (_3936 * _3834.w);
            }
            else
            {
                float _3958 = abs(_3910);
                float _3960 = _3910;
                _3910 = (_10(_3958) * _98(_3960)) * _3831.w;
                float _3969 = abs(_3918);
                float _3971 = _3918;
                _3918 = (_10(_3969) * _98(_3971)) * _3834.w;
            }
            vec3 _3978 = (_3831.xyz * _3910) + (_3834.xyz * _3918);
            _3634 += _3978;
            _3639 = normalize(_3634 - _794._m14);
            _3639 = _3639;
        }
        else
        {
            uint _3998 = (_3341._m15 >> uint(16)) & 255u;
            if (_3998 == 0u)
            {
                vec4 _4007 = _3341._m9;
                if (dot(_4007.xyz, _794._m14) < (_4007.w - _3537))
                {
                    continue;
                }
            }
            else
            {
                if (_3998 == 1u)
                {
                    vec3 _4028 = _3341._m9.xyz;
                    float _4033 = _3341._m9.w;
                    uint _4037 = _39(_4033);
                    vec3 _4032 = (((_112(_4037) * 2.0) - vec3(1.0)) * _4028) + _3634;
                    vec3 _4046 = abs((_794._m14 - _4032) / _4028);
                    float _4054 = _4046.x;
                    float _4057 = _4046.y;
                    float _4060 = _4046.z;
                    if (_50(_4054, _4057, _4060) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3637 <= (_3537 / 256.0))
        {
            continue;
        }
        float _4076 = 1.0;
        if ((_3569 & 4u) != 0u)
        {
            float _4083 = float(_3341._m15 & 255u) / 255.0;
            float _4089 = 0.00999999977648258209228515625;
            vec3 _4091 = _794._m14 + (_794._m6 * _4089);
            if ((_3569 & 3u) == 0u)
            {
                vec3 _4104 = _4091 - _3341._m2.xyz;
                float _4111 = _4104.x;
                float _4114 = _4104.y;
                float _4117 = _4104.z;
                _4110 = _61(_4111, _4114, _4117);
            }
            else
            {
                if ((_3569 & 3u) == 2u)
                {
                    float _4127 = 0.0;
                    _4110 = 0u;
                    for (; _4110 < 3u; _4110++)
                    {
                        int _4135 = 5;
                        _4138._m0 = _4142._m0[(uint(_4135) * ((_3569 >> uint(22)) + _4110)) + 0u];
                        _4138._m1 = _4142._m0[(uint(_4135) * ((_3569 >> uint(22)) + _4110)) + 1u];
                        _4138._m2 = _4142._m0[(uint(_4135) * ((_3569 >> uint(22)) + _4110)) + 2u];
                        _4138._m3 = _4142._m0[(uint(_4135) * ((_3569 >> uint(22)) + _4110)) + 3u];
                        _4138._m4 = _4142._m0[(uint(_4135) * ((_3569 >> uint(22)) + _4110)) + 4u];
                        vec2 _4199 = vec2(dot(_4091, _4138._m0.xyz) + _4138._m0.w, dot(_4091, _4138._m1.xyz) + _4138._m1.w);
                        _4199 = abs((_4199 * 2.0) - vec2(1.0));
                        bool _4225 = _4199.x < 0.99500000476837158203125;
                        bool _4231;
                        if (_4225)
                        {
                            _4231 = _4199.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _4231 = _4225;
                        }
                        if (_4231)
                        {
                            _4127 = (1.0 - max(_4199.x, _4199.y)) * _837._m12.w;
                            break;
                        }
                    }
                    _4110 = min(2u, _4110);
                    uint _4248 = uint(_794._m16.x) ^ (uint(_794._m16.y) << uint(1));
                    if (_837._m13.w > 0.0)
                    {
                        _4260 = uint(_837._m14.x);
                    }
                    else
                    {
                        _4260 = 0u;
                    }
                    _4248 ^= _4260;
                    _4110 += uint(int(((float(_4248 & 3u) * 0.25) + 0.125) > _4127));
                }
                else
                {
                    _4110 = 0u;
                }
            }
            int _4283 = 5;
            _4284._m0 = _4142._m0[(uint(_4283) * ((_3569 >> uint(22)) + _4110)) + 0u];
            _4284._m1 = _4142._m0[(uint(_4283) * ((_3569 >> uint(22)) + _4110)) + 1u];
            _4284._m2 = _4142._m0[(uint(_4283) * ((_3569 >> uint(22)) + _4110)) + 2u];
            _4284._m3 = _4142._m0[(uint(_4283) * ((_3569 >> uint(22)) + _4110)) + 3u];
            _4284._m4 = _4142._m0[(uint(_4283) * ((_3569 >> uint(22)) + _4110)) + 4u];
            vec4 _4340 = vec4((_4091.x * _4284._m0.x) + ((_4091.y * _4284._m0.y) + ((_4091.z * _4284._m0.z) + _4284._m0.w)), (_4091.x * _4284._m1.x) + ((_4091.y * _4284._m1.y) + ((_4091.z * _4284._m1.z) + _4284._m1.w)), (_4091.x * _4284._m2.x) + ((_4091.y * _4284._m2.y) + ((_4091.z * _4284._m2.z) + _4284._m2.w)), (_4091.x * _4284._m3.x) + ((_4091.y * _4284._m3.y) + ((_4091.z * _4284._m3.z) + _4284._m3.w)));
            vec3 _4427 = _4340.xyz / vec3(_4340.w);
            _4340 = vec4(_4427.x, _4427.y, _4427.z, _4340.w);
            bool _4435 = min(_4340.x, _4340.y) > 0.0;
            bool _4444;
            if (_4435)
            {
                _4444 = max(_4340.x, _4340.y) < 1.0;
            }
            else
            {
                _4444 = _4435;
            }
            if (_4444)
            {
                vec2 _4456 = (_4340.xy * _4284._m4.xy) + _4284._m4.zw;
                _4340 = vec4(_4456.x, _4456.y, _4340.z, _4340.w);
                if (false)
                {
                    _4076 = textureLod(_4464, vec3(_4340.xyz.xy, _4340.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4471 = (_4340.xy * _837._m15.xy) + vec2(0.5);
                    vec2 _4480 = floor(_4471);
                    vec2 _4483 = _4471 - _4480;
                    _4480 -= vec2(0.5);
                    vec2 _4490 = vec2(4.0) - (_4483 * 3.0);
                    vec2 _4496 = vec2(7.0);
                    vec2 _4499 = vec2(1.0) + (_4483 * 3.0);
                    vec2 _4504 = (_4480 + (((vec2(3.0) - (_4483 * 2.0)) / _4490) - vec2(2.0))) * _837._m15.zw;
                    vec2 _4519 = (_4480 + ((vec2(3.0) + _4483) / _4496)) * _837._m15.zw;
                    vec2 _4531 = (_4480 + ((_4483 / _4499) + vec2(2.0))) * _837._m15.zw;
                    vec3 _4555 = vec3(_4504.x, _4504.y, _4340.z);
                    _4076 = (_4490.x * _4490.y) * textureLod(_4464, vec3(_4555.xy, _4555.z), 0.0);
                    vec3 _4571 = vec3(_4519.x, _4504.y, _4340.z);
                    _4076 += ((_4496.x * _4490.y) * textureLod(_4464, vec3(_4571.xy, _4571.z), 0.0));
                    vec3 _4589 = vec3(_4531.x, _4504.y, _4340.z);
                    _4076 += ((_4499.x * _4490.y) * textureLod(_4464, vec3(_4589.xy, _4589.z), 0.0));
                    vec3 _4607 = vec3(_4504.x, _4519.y, _4340.z);
                    _4076 += ((_4490.x * _4496.y) * textureLod(_4464, vec3(_4607.xy, _4607.z), 0.0));
                    vec3 _4625 = vec3(_4519.x, _4519.y, _4340.z);
                    _4076 += ((_4496.x * _4496.y) * textureLod(_4464, vec3(_4625.xy, _4625.z), 0.0));
                    vec3 _4643 = vec3(_4531.x, _4519.y, _4340.z);
                    _4076 += ((_4499.x * _4496.y) * textureLod(_4464, vec3(_4643.xy, _4643.z), 0.0));
                    vec3 _4661 = vec3(_4504.x, _4531.y, _4340.z);
                    _4076 += ((_4490.x * _4499.y) * textureLod(_4464, vec3(_4661.xy, _4661.z), 0.0));
                    vec3 _4679 = vec3(_4519.x, _4531.y, _4340.z);
                    _4076 += ((_4496.x * _4499.y) * textureLod(_4464, vec3(_4679.xy, _4679.z), 0.0));
                    vec3 _4697 = vec3(_4531.x, _4531.y, _4340.z);
                    _4076 += ((_4499.x * _4499.y) * textureLod(_4464, vec3(_4697.xy, _4697.z), 0.0));
                    _4076 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _4076 = float((_3569 & 3u) == 2u);
            }
            float _4711 = float((_3569 >> uint(16)) & 63u) / 63.0;
            float _4725 = ((_4076 * _4711) + 1.0) - _4711;
            _4076 = _10(_4725);
        }
        uint _4728 = _3341._m13;
        vec3 _4727 = (_121(_4728) * _4076) * _3637;
        _3638 *= _3341._m14;
        vec3 _4740 = _4727;
        vec3 _4742 = _3639;
        float _4749 = dot(_794._m6, _4742);
        float _4744 = _10(_4749);
        vec3 _4755 = _794._m6;
        vec3 _4758 = _794._m13;
        vec3 _4761 = _3639;
        vec3 _4763 = _794._m2;
        float _4766 = abs(_794._m3);
        vec3 _4751 = _134(_4755, _4758, _4761, _4763, _4766);
        _794._m20 += (((_4751 * _3638) * _4740) * _4744);
        vec3 _4780 = mix(_4740, vec3(0.0), bvec3((_3569 & 256u) > 0u));
        _794._m19 += (_4780 * _4744);
    }
    float _4795 = _837._m16.x;
    if (_4795 > 0.00999999977648258209228515625)
    {
        float _4802 = float(int(_837._m14.x) & 1023) / 1023.0;
        _4795 = max(0.0, _4795 + (((_4802 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4818 = _794._m13;
        float _4826 = dot(_794._m6, _4818);
        float _4821 = _10(_4826);
        float _4828 = _4821 * _4795;
        vec3 _4836 = _794._m6;
        vec3 _4839 = _794._m13;
        vec3 _4842 = _794._m2;
        float _4845 = abs(_794._m3);
        vec3 _4832 = _141(_4836, _4839, _4842, _4845) * _4795;
        _794._m19 += vec3(_4828);
        _794._m20 += vec3(_4832);
    }
    _794._m19 = _794._m19;
    _794._m20 += _794._m10;
    float _4873 = 0.064999997615814208984375;
    float _4875 = 1.0 + _4873;
    bool _4878 = false;
    uint _4883;
    if (_837._m17.w > 0.00999999977648258209228515625)
    {
        _4883 = uint(_837._m17.x);
    }
    else
    {
        _4883 = 0u;
    }
    uint _4879 = _4883;
    _4901 _4903;
    for (uint _4891 = 0u; _4891 < _4879; _4891++)
    {
        int _4900 = 4;
        _4903._m0 = _4907._m0[(uint(_4900) * _4891) + 0u];
        _4903._m1 = _4907._m0[(uint(_4900) * _4891) + 1u];
        _4903._m2 = _4907._m0[(uint(_4900) * _4891) + 2u];
        float _4937 = _4907._m0[(uint(_4900) * _4891) + 3u].x;
        _4903._m3 = _39(_4937);
        float _4947 = _4907._m0[(uint(_4900) * _4891) + 3u].y;
        _4903._m4 = _39(_4947);
        float _4957 = _4907._m0[(uint(_4900) * _4891) + 3u].z;
        _4903._m5 = _39(_4957);
        vec4 _4962 = vec4(_794._m14, 1.0);
        vec3 _4969 = vec3(dot(_4962, _4903._m1), dot(_4962, _4903._m2), dot(_4962, _4903._m0));
        float _4983 = _4969.x;
        float _4986 = _4969.y;
        float _4989 = _4969.z;
        bool _4993 = _55(_4983, _4986, _4989) >= 0.0;
        bool _5002;
        if (_4993)
        {
            _5002 = max(_4969.x, _4969.y) < 1.0;
        }
        else
        {
            _5002 = _4993;
        }
        bool _5009;
        if (_5002)
        {
            _5009 = _4969.z < _4875;
        }
        else
        {
            _5009 = _5002;
        }
        if (_5009)
        {
            float _5012 = _4969.z;
            vec4 _5015 = vec4(_794._m14, 1.0);
            vec2 _5022 = vec2(0.0);
            _5022 = (((_5015.xy - _837._m18.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _5035 = 0.000244140625;
            float _5041 = abs(_794._m6.z) * 2.0;
            _5035 *= _10(_5041);
            vec3 _5045 = vec3(TEXTURE_LOD(_5046, vec4(_5022 + vec2(_5035), 0.0, 0.0).xy, vec4(_5022 + vec2(_5035), 0.0, 0.0).w).x, TEXTURE_LOD(_5046, vec4(_5022, 0.0, 0.0).xy, vec4(_5022, 0.0, 0.0).w).x, TEXTURE_LOD(_5046, vec4(_5022 - vec2(_5035), 0.0, 0.0).xy, vec4(_5022 - vec2(_5035), 0.0, 0.0).w).x);
            float _5109 = 2.0 - (2.0 * (length(_5015.xy - _837._m18.zw) / 16.0));
            _5045 *= _10(_5109);
            float _5116 = 1.0 - _5012;
            float _5113 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_5116));
            float _5127 = (_794._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _5119 = (_5045 * _5113) * _10(_5127);
            float _5136 = _4875 - _5012;
            float _5130 = (1.0 - _5113) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_5136));
            float _5150 = ((-_794._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _5140 = (_5045 * _5130) * _10(_5150);
            _5045 = _5119 + _5140;
            float _5161 = 1.02499997615814208984375 - _5012;
            float _5156 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_5161));
            float _5164 = _837._m17.w;
            _794._m19 = mix(_794._m19, (_794._m19 * _5045) + (_794._m19 * mix(1.0, 0.5, _5156)), vec3(_5164));
            break;
        }
    }
    _794._m19 *= _794._m0;
    _794._m21 = _794._m19 + _794._m20;
    vec3 _5204 = _794._m19 + _794._m20;
    _5199 = vec4(_5204.x, _5204.y, _5204.z, _5199.w);
    vec3 _5208 = _794._m6;
    bool _5211 = false;
    vec2 _5212 = _171(_5208, _5211);
    _5207 = vec4(_5212.x, _5212.y, _5207.z, _5207.w);
    float _5216 = _794._m2.x;
    float _5220 = _794._m2.y;
    float _5224 = _794._m2.z;
    float _5228 = _794._m3;
    _5215 = vec4(_101(_5216), _101(_5220), _101(_5224), _174(_5228));
    _5233 = vec4(0.0, 0.0, 0.0, float((uint(_815._m16.z) & 3u) << uint(4)) / 255.0);
    vec3 _5246 = _794._m19 + _794._m20;
    _5199 = vec4(_5246.x, _5246.y, _5246.z, _5199.w);
    vec3 _5249 = _794._m6;
    bool _5252 = false;
    vec2 _5253 = _171(_5249, _5252);
    _5207 = vec4(_5253.x, _5253.y, _5207.z, _5207.w);
    float _5256 = _794._m2.x;
    float _5260 = _794._m2.y;
    float _5264 = _794._m2.z;
    float _5268 = _794._m3;
    _5215 = vec4(_101(_5256), _101(_5260), _101(_5264), _174(_5268));
    vec3 _5278 = _5199.xyz + _815._m18.xyz;
    _5199 = vec4(_5278.x, _5278.y, _5278.z, _5199.w);
}


