#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

struct _754
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1095
{
    int _m0;
    int _m1;
};

struct _1098
{
    int _m0;
    int _m1;
};

struct _1418
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _2864
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform _775_777
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _777;

layout(set = 0, binding = 0, std140) uniform _786_788
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _788;

layout(set = 2, binding = 0, std140) uniform _866_868
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
} _868;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1100_1102
{
    _1098 _m0[];
} _1102;

layout(set = 0, binding = 6, std430) restrict readonly buffer _1394_1396
{
    uint _m0[];
} _1396;

layout(set = 0, binding = 7, std140) uniform _1423_1425
{
    vec4 _m0[4096];
} _1425;

layout(set = 0, binding = 8, std140) uniform _1462_1464
{
    vec4 _m0[4096];
} _1464;

layout(set = 0, binding = 9, std140) uniform _1530_1532
{
    vec4 _m0[4096];
} _1532;

layout(set = 0, binding = 12, std140) uniform _2868_2870
{
    vec4 _m0[4095];
} _2870;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4143_4145
{
    vec4 _m0[];
} _4145;

layout(push_constant, std430) uniform _4139_4141
{
    int _m0;
    int _m1;
} _4141;

layout(set = 3, binding = 0) uniform texture2D _891[65536];
layout(set = 0, binding = 4) uniform sampler _899;
layout(set = 2, binding = 1) uniform SAMPLER_2D _946;
layout(set = 2, binding = 2) uniform SAMPLER_2D _959;
layout(set = 0, binding = 10) uniform samplerCubeArray _2016;
layout(set = 0, binding = 11) uniform SAMPLER_2D _2425;
layout(set = 0, binding = 13) uniform sampler2DShadow _3192;
layout(set = 2, binding = 3) uniform SAMPLER_2D _3911;
layout(set = 2, binding = 4) uniform SAMPLER_2D _4117;
layout(set = 0, binding = 2) uniform sampler3D _4149;
layout(set = 0, binding = 3) uniform sampler3D _4150;

layout(location = 2) in vec4 _768;
layout(location = 6) in vec4 _793;
layout(location = 3) in vec4 _805;
layout(location = 4) in vec4 _808;
layout(location = 5) in vec4 _811;
layout(location = 10) in vec4 _829;
layout(location = 11) in vec4 _833;
layout(location = 12) in vec4 _837;
layout(location = 7) in vec4 _3913;
layout(location = 0) out vec4 _4034;
layout(location = 1) out vec4 _4042;
layout(location = 2) out vec4 _4050;
layout(location = 3) out vec4 _4068;

float _277;

uint _32(float _31)
{
    return floatBitsToUint(_31);
}

float _52(float _51)
{
    if (_51 <= 0.040449999272823333740234375)
    {
        return _51 / 12.9200000762939453125;
    }
    else
    {
        return pow((_51 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _62(float _61)
{
    float _318 = _61;
    return _52(_318);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _55(vec3 _54)
{
    float _279 = _54.x;
    vec3 _278;
    _278.x = _52(_279);
    float _285 = _54.y;
    _278.y = _52(_285);
    float _291 = _54.z;
    _278.z = _52(_291);
    return _278;
}

vec4 _59(vec4 _58)
{
    vec3 _301 = _58.xyz;
    vec4 _300 = vec4(_55(_301), 1.0);
    float _309 = _58.w;
    _300.w = _52(_309);
    return _300;
}

vec4 _65(vec4 _64)
{
    vec4 _323 = _64;
    return _59(_323);
}

vec4 _118(SAMPLER_2D _116, vec2 _117)
{
    vec4 _442 = SAMPLE_TEXTURE(_116, _117);
    vec4 _446 = _442;
    _442 = _65(_446);
    return _442;
}

float _148(float _144, vec4 _145, float _146, bool _147)
{
    float _607 = _145.w / (_144 + _145.z);
    return _607 * _146;
}

vec3 _153(vec3 _151, bool _152)
{
    vec3 _620 = (_151 * 2.0) - vec3(1.0);
    float _637 = (1.0 - (_620.x * _620.x)) - (_620.y * _620.y);
    _620.z = sqrt(_10(_637));
    if (_152 == false)
    {
        _620.z = -_620.z;
    }
    return _620;
}

vec3 _160(vec3 _158, mat3 _159)
{
    return normalize(vec3(dot(_158, _159[0]), dot(_158, _159[1]), dot(_158, _159[2])));
}

float _71(float _70)
{
    return _70 * _70;
}

vec3 _68(vec3 _67)
{
    return _67 * _67;
}

float _76(float _73, float _74, float _75)
{
    float _345 = (_73 - _74) / (_75 - _74);
    return _10(_345);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _95(uint _94)
{
    return unpackUnorm4x8(_94).wzyx;
}

float _79(float _78)
{
    return exp2(_78);
}

vec3 _121(uint _120)
{
    uint _453 = _120;
    vec4 _452 = _95(_453);
    float _464 = (_452.w * 255.0) - 128.0;
    return _452.xyz * _79(_464);
}

vec3 _102(uint _101)
{
    return vec3(float((_101 >> uint(21)) & 2047u), float((_101 >> uint(10)) & 2047u), float(_101 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

vec4 _98(uint _97)
{
    return vec4(float((_97 >> uint(24)) & 255u), float((_97 >> uint(16)) & 255u), float((_97 >> uint(8)) & 255u), float(_97 & 255u));
}

vec3 _139(float _136, float _137, vec3 _138)
{
    float _559 = 0.0949999988079071044921875 + (_137 * (0.60000002384185791015625 + (4.190000057220458984375 * _137)));
    float _569 = _136 + 0.02500000037252902984619140625;
    float _573 = (9.5 * _137) * _136;
    float _587 = 1.0 - (14.0 * _136);
    float _579 = (_559 * _569) * _79(_587);
    float _594 = -_573;
    float _590 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _79(_594)));
    return mix(vec3(_579), vec3(_590), _138);
}

vec4 _108(uvec2 _107)
{
    return vec4(float((_107.x >> uint(16)) & 65535u), float(_107.x & 65535u), float((_107.y >> uint(16)) & 65535u), float(_107.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _87(float _86)
{
    return (step(0.0, _86) * 2.0) - 1.0;
}

uint _49(float _46, float _47, float _48)
{
    bool _218 = abs(_48) >= abs(_46);
    bool _226;
    if (_218)
    {
        _226 = abs(_48) >= abs(_47);
    }
    else
    {
        _226 = _218;
    }
    if (_226)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _84(float _82, float _83)
{
    return pow(_82, _83);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _126(vec3 _124, float _125)
{
    float _476 = 50.0 * dot(_124, vec3(0.33329999446868896484375));
    float _469 = _10(_476);
    float _485 = 1.0 - _125;
    float _488 = _10(_485);
    float _489 = 5.0;
    vec3 _493 = _124 + ((vec3(_469) - _124) * _84(_488, _489));
    return _16(_493);
}

vec3 _133(vec3 _129, vec3 _130, vec3 _131, float _132)
{
    float _497 = 1.0 - (_132 * 0.800000011920928955078125);
    _497 *= _497;
    _497 *= _497;
    float _508 = _497 * _497;
    float _516 = dot(_129, _130);
    float _512 = _10(_516);
    float _518 = ((_512 * _512) * (_508 - 1.0)) + 1.0;
    _518 = _508 / ((_518 * _518) + 9.9999999392252902907785028219223e-09);
    float _537 = dot(_129, _130);
    float _533 = (_10(_537) * (1.0 - _497)) + _497;
    _518 /= (((4.0 * _533) * _533) + 9.9999999392252902907785028219223e-09);
    vec3 _552 = _131;
    return _16(_552) * _518;
}

float _27(vec4 _25, vec4 _26)
{
    return dot(_25, _26);
}

void _20(float _19)
{
    if (_19 < 0.0)
    {
        discard;
    }
}

vec2 _164(vec2 _163)
{
    return (vec2(1.0) - abs(_163.yx)) * vec2((_163.x >= 0.0) ? 1.0 : (-1.0), (_163.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _169(inout vec3 _167, bool _168)
{
    _167 /= vec3((abs(_167.x) + abs(_167.y)) + abs(_167.z));
    vec2 _704;
    if (_167.z >= 0.0)
    {
        _704 = _167.xy;
    }
    else
    {
        vec2 _710 = _167.xy;
        _704 = _164(_710);
    }
    _167 = vec3(_704.x, _704.y, _167.z);
    if (_168)
    {
        vec2 _725 = (_167.xy * 0.5) + vec2(0.5);
        _167 = vec3(_725.x, _725.y, _167.z);
    }
    return _167.xy;
}

float _90(float _89)
{
    return sqrt(_89);
}

float _172(float _171)
{
    float _735 = abs(_171);
    float _732 = _90(_735);
    float _739;
    if (_171 > 0.0)
    {
        _739 = _732;
    }
    else
    {
        _739 = -_732;
    }
    return (_739 * 0.5) + 0.5;
}

void main()
{
    float _751 = 0.0;
    _754 _756 = _754(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _756._m15 = _768;
    _756._m16 = gl_FragCoord;
    _756._m40 = (uint(_777._m8.z) & 3u) << uint(4);
    _756._m14 = _788._m4.xyz + _793.xyz;
    _756._m13 = normalize(-_793.xyz);
    _756._m17 = mat3(vec3(_805.xyz), vec3(_808.xyz), vec3(_811.xyz));
    _756._m34 = _829;
    _756._m35 = _833;
    _756._m36 = _837;
    uint _840 = 0u;
    vec4 _841 = vec4(0.0);
    vec4 _842 = vec4(0.0);
    vec4 _843 = vec4(0.0);
    vec4 _844 = vec4(0.0);
    vec4 _845 = vec4(0.0);
    _756._m0 = _843.xyz;
    _756._m2 = _844.xyz;
    _756._m1 = _842.xyz;
    _756._m9 = _841.xyz;
    _756._m3 = _841.w;
    _756._m6 = _845.wyz;
    _756._m2 = _868._m4.xxx;
    _756._m3 = _868._m4.y;
    _756._m6 = vec3(0.5, 0.5, 1.0);
    if (_788._m6.x == 1.0)
    {
        float _884 = _868._m5.x;
        uint _883 = _32(_884);
        uint _893 = _883;
        float _909 = texture(sampler2D(_891[nonuniformEXT(_893)], _899), _768.xy * _868._m6.xy).x;
        float _913 = _62(_909) * 4.0;
        _751 = _10(_913);
        float _917 = _868._m7.x;
        uint _915 = _32(_917);
        uint _922 = _915;
        vec4 _941 = texture(sampler2D(_891[nonuniformEXT(_922)], _899), vec4(_768.xy, 0.0, -2.0).xy, vec4(_768.xy, 0.0, -2.0).w);
        _756._m0 = _65(_941).xyz;
    }
    else
    {
        vec2 _953 = _768.xy * _868._m6.xy;
        float _957 = _118(_946, _953).x * 4.0;
        _751 = _10(_957);
        vec4 _974 = SAMPLE_TEXTURE1(_959, vec4(_768.xy, 0.0, -2.0).xy, vec4(_768.xy, 0.0, -2.0).w);
        _756._m0 = _65(_974).xyz;
    }
    _756._m11 = 1.0;
    uint _980 = uint((_777._m8.x > 0.0) ? 8 : 0);
    float _986 = 16.0;
    float _988 = 8.0;
    float _990 = 24.0;
    vec2 _999 = _756._m16.xy * _788._m7.xy;
    vec3 _992;
    _992 = vec3(_999.x, _999.y, _992.z);
    _992.y = 1.0 - _992.y;
    vec2 _1012 = floor(_992.xy * vec2(_986, _988));
    _992 = vec3(_1012.x, _1012.y, _992.z);
    float _1016 = _756._m16.z;
    vec4 _1019 = _788._m8;
    float _1022 = 1.0;
    bool _1023 = false;
    float _1015 = _148(_1016, _1019, _1022, _1023);
    float _1025 = log2(max(1.0, _1015 / _788._m9.z)) * _788._m9.w;
    _992.z = min(_990 - 1.0, floor(_1025));
    uint _1041 = uint((_992.x + (_992.y * _986)) + ((_992.z * _986) * _988));
    _1041 = min(_1041, uint(((_986 * _988) * _990) - 1.0));
    bool _1066 = true;
    _1066 = gl_FrontFacing;
    vec3 _1071 = _756._m6;
    bool _1074 = _1066;
    _756._m7 = _153(_1071, _1074);
    vec3 _1078 = _756._m7;
    mat3 _1081 = _756._m17;
    _756._m6 = _160(_1078, _1081);
    uint _1086 = 0u;
    uint _1087 = 0u;
    uint _1088 = 0u;
    uint _1089 = 0u;
    uint _1090 = 0u;
    uint _1091 = 0u;
    int _1093 = 256;
    _1095 _1097;
    _1097._m0 = _1102._m0[_1041]._m0;
    _1097._m1 = _1102._m0[_1041]._m1;
    int _1111 = _1097._m0 & (~(_1097._m0 >> 31));
    int _1120 = _1097._m1 & (~(_1097._m1 >> 31));
    _1086 = uint((_1111 >> 16) * _1093);
    _1087 = _1086 + uint(_1120 & 255);
    _1088 = _1086;
    _1089 = _1088 + uint((_1120 >> 8) & 255);
    _1090 = _1086;
    _1091 = _1090 + uint((_1120 >> 16) & 255);
    float _1155 = _756._m37;
    float _1153 = _71(_1155);
    float _1162 = _1153 - 0.5;
    float _1159 = _10(_1162) * 2.0;
    float _1174 = _1153 * 2.0;
    float _1165 = (_756._m38 * _756._m38) * _10(_1174);
    float _1181 = _1165 + _1159;
    float _1177 = _10(_1181);
    if (_1177 > 0.0039215688593685626983642578125)
    {
        vec3 _1190 = _756._m0;
        float _1197 = _1177 * 1.0;
        float _1198 = 0.0;
        float _1199 = 0.3499999940395355224609375;
        _756._m0 = mix(_756._m0, _68(_1190), vec3(_76(_1197, _1198, _1199) * (1.0 - _756._m3)));
        float _1215 = _1177 * 1.0;
        float _1216 = 0.25;
        float _1217 = 0.5;
        _756._m2 = mix(_756._m2, vec3(0.039999999105930328369140625), vec3(_76(_1215, _1216, _1217)));
        vec3 _1222 = vec3(_756._m17[0].z, _756._m17[1].z, _756._m17[2].z);
        float _1236 = _1222.z + 0.0625;
        float _1230 = _1177 * _10(_1236);
        float _1245 = _1230 * 1.0;
        float _1246 = 0.20000000298023223876953125;
        float _1247 = 1.0;
        _756._m3 = mix(_756._m3, 0.89999997615814208984375, _76(_1245, _1246, _1247));
        float _1256 = _1230 * 1.0;
        float _1257 = 0.449999988079071044921875;
        float _1258 = 0.980000019073486328125;
        float _1251 = _76(_1256, _1257, _1258);
        _756._m6 = normalize(mix(_756._m6, vec3(0.0, 0.0, 1.0), vec3(_1251)));
        _756._m7 = mix(_756._m6, vec3(0.5, 0.5, 1.0), vec3(_1251));
        if (_1230 > 0.980000019073486328125)
        {
            float _1281 = _1230 * _1251;
            float _1282 = 0.980000019073486328125;
            float _1283 = 1.0;
            _1222 = normalize(mix(_1222, vec3(0.0, 0.0, 1.0), vec3(_76(_1281, _1282, _1283))));
            _756._m17[0].z = _1222.x;
            _756._m17[1].z = _1222.y;
            _756._m17[2].z = _1222.z;
        }
    }
    vec3 _1297 = vec3(0.0);
    vec3 _1298 = vec3(_756._m34.x, _756._m34.y, _756._m34.z);
    vec3 _1306 = vec3(_756._m34.w, _756._m35.x, _756._m35.y);
    vec3 _1314 = vec3(_756._m35.z, _756._m35.w, _756._m36.x);
    vec3 _1322 = vec3(_756._m36.y, _756._m36.z, _756._m36.w);
    vec3 _1330 = ((_1298 - (_1306 * _756._m6.y)) + (_1314 * _756._m6.z)) - (_1322 * _756._m6.x);
    float _1353 = _777._m9.x * _788._m10.x;
    _1297 += max(_1330 * _10(_1353), vec3(0.0));
    float _1364;
    if (dot(_756._m10, vec3(1.0)) > 0.0)
    {
        _1364 = -_756._m3;
    }
    else
    {
        _1364 = _756._m3;
    }
    _756._m3 = _1364;
    _756._m18 = _1297;
    _756._m19 = _1297;
    float _1381 = 1.0;
    uint _1382 = _1090;
    _1418 _1420;
    while (_1382 < _1091)
    {
        uint _1392 = _1396._m0[_1382];
        uint _1401 = (_1392 >> uint(24)) & 4095u;
        uint _1406 = _1401;
        if (_1406 >= _1401)
        {
            _1382++;
        }
        int _1415 = 4;
        int _1416 = 4;
        int _1417 = 4;
        _1420._m0 = _1425._m0[(uint(_1415) * _1406) + 0u].xyz;
        float _1440 = _1425._m0[(uint(_1415) * _1406) + 0u].w;
        _1420._m1 = _32(_1440);
        _1420._m2 = _1425._m0[(uint(_1415) * _1406) + 1u];
        _1420._m3 = _1425._m0[(uint(_1415) * _1406) + 2u];
        _1420._m4 = _1464._m0[(uint(_1416) * _1406) + 0u];
        _1420._m5 = _1464._m0[(uint(_1416) * _1406) + 1u];
        _1420._m6 = _1464._m0[(uint(_1416) * _1406) + 2u];
        float _1494 = _1425._m0[(uint(_1415) * _1406) + 3u].x;
        _1420._m7.x = _32(_1494);
        float _1504 = _1425._m0[(uint(_1415) * _1406) + 3u].y;
        _1420._m7.y = _32(_1504);
        float _1514 = _1425._m0[(uint(_1415) * _1406) + 3u].z;
        _1420._m7.z = _32(_1514);
        float _1524 = _1425._m0[(uint(_1415) * _1406) + 3u].w;
        _1420._m7.w = _32(_1524);
        _1420._m8 = _1532._m0[(uint(_1417) * _1406) + 0u];
        _1420._m9 = _1532._m0[(uint(_1417) * _1406) + 1u];
        _1420._m10 = _1532._m0[(uint(_1417) * _1406) + 2u];
        _1420._m11 = _1532._m0[(uint(_1417) * _1406) + 3u];
        float _1571 = _1464._m0[(uint(_1416) * _1406) + 3u].x;
        _1420._m12 = _32(_1571);
        float _1581 = _1464._m0[(uint(_1416) * _1406) + 3u].y;
        _1420._m13 = _32(_1581);
        _1420._m14 = _1464._m0[(uint(_1416) * _1406) + 3u].z;
        float _1599 = _1464._m0[(uint(_1416) * _1406) + 3u].w;
        _1420._m15 = _32(_1599);
        uint _1604 = (_1420._m12 >> uint(16)) & 3u;
        if (((_756._m40 >> uint(4)) & 3u) != _1604)
        {
            continue;
        }
        vec3 _1618 = vec3((_756._m14.x * _1420._m4.x) + ((_756._m14.y * _1420._m4.y) + ((_756._m14.z * _1420._m4.z) + _1420._m4.w)), (_756._m14.x * _1420._m5.x) + ((_756._m14.y * _1420._m5.y) + ((_756._m14.z * _1420._m5.z) + _1420._m5.w)), (_756._m14.x * _1420._m6.x) + ((_756._m14.y * _1420._m6.y) + ((_756._m14.z * _1420._m6.z) + _1420._m6.w)));
        vec2 _1685 = _1618.xy / vec2(_1618.z);
        _1618 = vec3(_1685.x, _1685.y, _1618.z);
        _1618.z = (_756._m14.x * _1420._m3.x) + ((_756._m14.y * _1420._m3.y) + ((_756._m14.z * _1420._m3.z) + _1420._m3.w));
        float _1709 = 0.0039215688593685626983642578125;
        float _1710 = _1618.x;
        float _1713 = _1618.y;
        float _1716 = _1618.z;
        bool _1721 = _43(_1710, _1713, _1716) < _1709;
        bool _1738;
        if (!_1721)
        {
            float _1725 = _1618.x;
            float _1728 = _1618.y;
            float _1731 = _1618.z;
            _1738 = _38(_1725, _1728, _1731) >= (1.0 - _1709);
        }
        else
        {
            _1738 = _1721;
        }
        if (_1738)
        {
            continue;
        }
        uint _1742 = _1420._m1;
        uint _1746 = _1420._m13;
        vec3 _1745 = _121(_1746);
        float _1750 = _1420._m14;
        vec3 _1753 = _1420._m0;
        if (_1420._m9.w == 0.0)
        {
            if (dot(_1420._m11.xyz, _756._m14) < (_1420._m11.w - _1709))
            {
                continue;
            }
        }
        else
        {
            if (_1420._m9.w == 1.0)
            {
                float _1782 = _1420._m11.w;
                uint _1786 = _32(_1782);
                vec3 _1781 = (((_102(_1786) * 2.0) - vec3(1.0)) * _1420._m11.xyz) + _1753;
                vec3 _1797 = abs(_756._m14 - _1781) / _1420._m11.xyz;
                float _1807 = _1797.x;
                float _1810 = _1797.y;
                float _1813 = _1797.z;
                if (_38(_1807, _1810, _1813) > 1.0)
                {
                    continue;
                }
            }
        }
        uint _1822 = _1742;
        float _1821 = _95(_1822).y;
        vec3 _1826 = (_1618 * 2.0) - vec3(1.0);
        vec3 _1830 = _1826 * sqrt(((vec3(1.0) - ((_1826.yzx * _1826.yzx) * 0.5)) - ((_1826.zxy * _1826.zxy) * 0.5)) + ((((_1826.yzx * _1826.yzx) * _1826.zxy) * _1826.zxy) / vec3(3.0)));
        float _1874 = 1.0 - ((length(_1830) - _1821) / ((1.0 - _1821) + 9.9999999747524270787835121154785e-07));
        float _1863 = _10(_1874);
        _1863 *= _1863;
        _1863 *= (_1420._m8.w * _1381);
        _1381 *= (1.0 - _1863);
        if (_1863 <= (_1709 * 4.0))
        {
            continue;
        }
        vec3 _1896 = _1745;
        uint _1899 = _1742;
        float _1898 = _98(_1899).z;
        vec3 _1903 = vec3(0.0);
        vec3 _1904 = vec3(0.0);
        vec3 _1905 = _756._m6;
        _1905.x = dot(_1420._m2.xy, _756._m6.xy);
        _1905.y = dot(_1420._m2.zw, _756._m6.xy);
        vec3 _1924 = reflect(-_756._m13, _756._m6);
        vec3 _1931 = (_1420._m9.xyz - _756._m14) / _1924;
        vec3 _1940 = (_1420._m8.xyz - _756._m14) / _1924;
        vec3 _1949 = max(_1931, _1940);
        float _1954 = _1949.x;
        float _1957 = _1949.y;
        float _1960 = _1949.z;
        float _1953 = _43(_1954, _1957, _1960);
        vec3 _1964 = _756._m14 + (_1924 * _1953);
        vec3 _1971 = normalize(_1964 - _1753);
        vec3 _1976 = _1971;
        _1976.x = dot(_1420._m2.xy, _1971.xy);
        _1976.y = dot(_1420._m2.zw, _1971.xy);
        float _1998 = dot(_756._m13, _756._m6);
        float _1992 = _10(_1998);
        float _2000 = 0.0;
        float _2001 = 6.0;
        float _2003 = max(_2000, _2001 - (_2001 * abs(_756._m3)));
        _1904 = textureLod(_2016, vec4(_1976, _1898), _2003).xyz * _1750;
        float _2033 = _1992;
        float _2035 = abs(_756._m3);
        vec3 _2036 = _756._m2;
        vec3 _2029 = _139(_2033, _2035, _2036);
        _1904 *= _2029;
        float _2047 = _1863;
        _756._m20 += ((_1904 * _1896) * _10(_2047));
        if (_1381 <= (_1709 * 4.0))
        {
            break;
        }
    }
    uint _2062 = _1086;
    _1418 _2091;
    vec3 _2398;
    float _2475;
    float _2493;
    uint _2838;
    _2864 _2866;
    uint _2988;
    _2864 _3012;
    while (_2062 < _1087)
    {
        uint _2072 = _1396._m0[_2062];
        uint _2076 = _2072 & 4095u;
        uint _2079 = _2076;
        if (_2079 >= _2076)
        {
            _2062++;
        }
        int _2088 = 4;
        int _2089 = 4;
        int _2090 = 4;
        _2091._m0 = _1425._m0[(uint(_2088) * _2079) + 0u].xyz;
        float _2106 = _1425._m0[(uint(_2088) * _2079) + 0u].w;
        _2091._m1 = _32(_2106);
        _2091._m2 = _1425._m0[(uint(_2088) * _2079) + 1u];
        _2091._m3 = _1425._m0[(uint(_2088) * _2079) + 2u];
        _2091._m4 = _1464._m0[(uint(_2089) * _2079) + 0u];
        _2091._m5 = _1464._m0[(uint(_2089) * _2079) + 1u];
        _2091._m6 = _1464._m0[(uint(_2089) * _2079) + 2u];
        float _2156 = _1425._m0[(uint(_2088) * _2079) + 3u].x;
        _2091._m7.x = _32(_2156);
        float _2166 = _1425._m0[(uint(_2088) * _2079) + 3u].y;
        _2091._m7.y = _32(_2166);
        float _2176 = _1425._m0[(uint(_2088) * _2079) + 3u].z;
        _2091._m7.z = _32(_2176);
        float _2186 = _1425._m0[(uint(_2088) * _2079) + 3u].w;
        _2091._m7.w = _32(_2186);
        _2091._m8 = _1532._m0[(uint(_2090) * _2079) + 0u];
        _2091._m9 = _1532._m0[(uint(_2090) * _2079) + 1u];
        _2091._m10 = _1532._m0[(uint(_2090) * _2079) + 2u];
        _2091._m11 = _1532._m0[(uint(_2090) * _2079) + 3u];
        float _2228 = _1464._m0[(uint(_2089) * _2079) + 3u].x;
        _2091._m12 = _32(_2228);
        float _2238 = _1464._m0[(uint(_2089) * _2079) + 3u].y;
        _2091._m13 = _32(_2238);
        _2091._m14 = _1464._m0[(uint(_2089) * _2079) + 3u].z;
        float _2256 = _1464._m0[(uint(_2089) * _2079) + 3u].w;
        _2091._m15 = _32(_2256);
        uint _2261 = (_2091._m12 >> uint(16)) & 3u;
        if (((_756._m40 >> uint(4)) & 3u) != _2261)
        {
            continue;
        }
        float _2275 = 0.0039215688593685626983642578125;
        vec4 _2276 = vec4(_756._m14, 1.0);
        float _2283 = 1.0 / dot(_2276, _2091._m6);
        vec3 _2289 = vec3(dot(_2276, _2091._m4) * _2283, dot(_2276, _2091._m5) * _2283, dot(_2276, _2091._m3));
        uint _2307 = _2091._m1;
        uint _2310 = _980;
        _2310 |= 64u;
        float _2315 = _2289.x;
        float _2318 = _2289.y;
        float _2321 = _2289.z;
        bool _2326 = _43(_2315, _2318, _2321) <= _2275;
        bool _2343;
        if (!_2326)
        {
            float _2330 = _2289.x;
            float _2333 = _2289.y;
            float _2336 = _2289.z;
            _2343 = _38(_2330, _2333, _2336) >= (1.0 - _2275);
        }
        else
        {
            _2343 = _2326;
        }
        bool _2351;
        if (!_2343)
        {
            _2351 = (_2307 & _2310) != 0u;
        }
        else
        {
            _2351 = _2343;
        }
        if (_2351)
        {
            continue;
        }
        if ((_2307 & 3u) == 2u)
        {
            vec2 _2370 = fract((_2289.xy * _788._m11.xy) + _788._m11.zw);
            _2289 = vec3(_2370.x, _2370.y, _2289.z);
        }
        vec3 _2373 = _2091._m0;
        float _2376 = 1.0;
        float _2377 = 1.0;
        vec3 _2378 = vec3(0.0, 0.0, 1.0);
        vec3 _2379 = vec3(0.0, 0.0, 1.0);
        uint _2380 = _2091._m1;
        vec3 _2383 = (_2289 * 2.0) - vec3(1.0);
        vec2 _2388 = _2289.xy;
        vec3 _2391 = _2091._m10.xyz;
        if ((_2380 & 3u) == 2u)
        {
            _2398 = _2391;
        }
        else
        {
            _2398 = normalize(_2373 - _756._m14);
        }
        _2378 = _2398;
        _2378 = _2378;
        float _2415 = dot(_756._m6, _2378);
        float _2410 = _10(_2415);
        uvec2 _2418 = _2091._m7.zw;
        vec4 _2417 = _108(_2418);
        float _2424 = TEXTURE_LOD(_2425, vec4((_2388 * _2417.xy) + _2417.zw, 0.0, 0.0).xy, vec4((_2388 * _2417.xy) + _2417.zw, 0.0, 0.0).w).x;
        float _2451 = _2424 * _2424;
        uint _2455 = _2380 & 3u;
        bool _2460 = _2455 == 1u;
        bool _2472;
        if (!_2460)
        {
            bool _2465 = _2455 == 0u;
            bool _2471;
            if (_2465)
            {
                _2471 = _2091._m8.z != 0.0;
            }
            else
            {
                _2471 = _2465;
            }
            _2472 = _2471;
        }
        else
        {
            _2472 = _2460;
        }
        bool _2458 = _2472;
        if (_2458)
        {
            float _2478 = _2091._m8.w;
            _2475 = _10(_2478);
        }
        else
        {
            _2475 = 0.5;
        }
        float _2473 = _2475;
        bool _2486 = _2455 == 0u;
        bool _2492;
        if (_2486)
        {
            _2492 = _2091._m8.z != 0.0;
        }
        else
        {
            _2492 = _2486;
        }
        if (_2492)
        {
            float _2501 = sqrt(dot(_2383, _2383));
            _2493 = min(0.9921875, _10(_2501));
        }
        else
        {
            _2493 = _2289.z;
        }
        float _2484 = _2493;
        uvec2 _2509 = _2091._m7.xy;
        vec4 _2508 = _108(_2509);
        vec2 _2514 = vec2(_2484, _2473);
        float _2518 = TEXTURE_LOD(_2425, vec4((_2514 * _2508.xy) + _2508.zw, 0.0, 0.0).xy, vec4((_2514 * _2508.xy) + _2508.zw, 0.0, 0.0).w).x;
        _2518 *= _2518;
        _2376 = _2518 * _2451;
        if ((_2380 & 48u) != 0u)
        {
            vec4 _2556 = _2091._m10;
            vec4 _2559 = _2091._m8;
            vec4 _2562 = _2091._m9;
            float _2565 = dot(_756._m14, _2556.xyz) + _2556.w;
            if (_2565 < 0.0)
            {
                continue;
            }
            float _2579 = length(_2556.xyz);
            float _2586 = _2565 * 50.0;
            float _2583 = _10(_2586);
            _2376 *= (_2583 * _2583);
            _2565 /= _2579;
            _2556 /= vec4(_2579);
            vec3 _2600 = reflect(-_756._m13, _756._m6);
            if (dot(_2600, _2556.xyz) > 0.0)
            {
                _2600 = reflect(_2600, _2556.xyz);
            }
            float _2618 = dot(_2600, _2556.xyz);
            float _2623 = _2565 / _2618;
            vec3 _2627 = _756._m14 - (_2600 * _2623);
            vec3 _2634 = _2627 - _2373;
            float _2638 = dot(_2634, _2559.xyz) / _2559.w;
            float _2646 = dot(_2634, _2562.xyz) / _2562.w;
            if ((_2380 & 48u) == 32u)
            {
                vec2 _2660 = vec2(_2638, _2646);
                float _2664 = 1.0 / max(1.0, length(vec2(_2638, _2646)));
                _2638 *= (_2664 * _2559.w);
                _2646 *= (_2664 * _2562.w);
            }
            else
            {
                float _2686 = abs(_2638);
                float _2688 = _2638;
                _2638 = (_10(_2686) * _87(_2688)) * _2559.w;
                float _2697 = abs(_2646);
                float _2699 = _2646;
                _2646 = (_10(_2697) * _87(_2699)) * _2562.w;
            }
            vec3 _2706 = (_2559.xyz * _2638) + (_2562.xyz * _2646);
            _2373 += _2706;
            _2378 = normalize(_2373 - _756._m14);
            _2378 = _2378;
        }
        else
        {
            uint _2726 = (_2091._m15 >> uint(16)) & 255u;
            if (_2726 == 0u)
            {
                vec4 _2735 = _2091._m9;
                if (dot(_2735.xyz, _756._m14) < (_2735.w - _2275))
                {
                    continue;
                }
            }
            else
            {
                if (_2726 == 1u)
                {
                    vec3 _2756 = _2091._m9.xyz;
                    float _2761 = _2091._m9.w;
                    uint _2765 = _32(_2761);
                    vec3 _2760 = (((_102(_2765) * 2.0) - vec3(1.0)) * _2756) + _2373;
                    vec3 _2774 = abs((_756._m14 - _2760) / _2756);
                    float _2782 = _2774.x;
                    float _2785 = _2774.y;
                    float _2788 = _2774.z;
                    if (_38(_2782, _2785, _2788) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2376 <= (_2275 / 256.0))
        {
            continue;
        }
        float _2804 = 1.0;
        if ((_2307 & 4u) != 0u)
        {
            float _2811 = float(_2091._m15 & 255u) / 255.0;
            float _2817 = 0.00200000009499490261077880859375;
            vec3 _2819 = _756._m14 + (_756._m6 * _2817);
            if ((_2307 & 3u) == 0u)
            {
                vec3 _2832 = _2819 - _2091._m2.xyz;
                float _2839 = _2832.x;
                float _2842 = _2832.y;
                float _2845 = _2832.z;
                _2838 = _49(_2839, _2842, _2845);
            }
            else
            {
                if ((_2307 & 3u) == 2u)
                {
                    float _2855 = 0.0;
                    _2838 = 0u;
                    for (; _2838 < 3u; _2838++)
                    {
                        int _2863 = 5;
                        _2866._m0 = _2870._m0[(uint(_2863) * ((_2307 >> uint(22)) + _2838)) + 0u];
                        _2866._m1 = _2870._m0[(uint(_2863) * ((_2307 >> uint(22)) + _2838)) + 1u];
                        _2866._m2 = _2870._m0[(uint(_2863) * ((_2307 >> uint(22)) + _2838)) + 2u];
                        _2866._m3 = _2870._m0[(uint(_2863) * ((_2307 >> uint(22)) + _2838)) + 3u];
                        _2866._m4 = _2870._m0[(uint(_2863) * ((_2307 >> uint(22)) + _2838)) + 4u];
                        vec2 _2927 = vec2(dot(_2819, _2866._m0.xyz) + _2866._m0.w, dot(_2819, _2866._m1.xyz) + _2866._m1.w);
                        _2927 = abs((_2927 * 2.0) - vec2(1.0));
                        bool _2953 = _2927.x < 0.99500000476837158203125;
                        bool _2959;
                        if (_2953)
                        {
                            _2959 = _2927.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _2959 = _2953;
                        }
                        if (_2959)
                        {
                            _2855 = (1.0 - max(_2927.x, _2927.y)) * _788._m12.w;
                            break;
                        }
                    }
                    _2838 = min(2u, _2838);
                    uint _2976 = uint(_756._m16.x) ^ (uint(_756._m16.y) << uint(1));
                    if (_788._m13.w > 0.0)
                    {
                        _2988 = uint(_788._m14.x);
                    }
                    else
                    {
                        _2988 = 0u;
                    }
                    _2976 ^= _2988;
                    _2838 += uint(int(((float(_2976 & 3u) * 0.25) + 0.125) > _2855));
                }
                else
                {
                    _2838 = 0u;
                }
            }
            int _3011 = 5;
            _3012._m0 = _2870._m0[(uint(_3011) * ((_2307 >> uint(22)) + _2838)) + 0u];
            _3012._m1 = _2870._m0[(uint(_3011) * ((_2307 >> uint(22)) + _2838)) + 1u];
            _3012._m2 = _2870._m0[(uint(_3011) * ((_2307 >> uint(22)) + _2838)) + 2u];
            _3012._m3 = _2870._m0[(uint(_3011) * ((_2307 >> uint(22)) + _2838)) + 3u];
            _3012._m4 = _2870._m0[(uint(_3011) * ((_2307 >> uint(22)) + _2838)) + 4u];
            vec4 _3068 = vec4((_2819.x * _3012._m0.x) + ((_2819.y * _3012._m0.y) + ((_2819.z * _3012._m0.z) + _3012._m0.w)), (_2819.x * _3012._m1.x) + ((_2819.y * _3012._m1.y) + ((_2819.z * _3012._m1.z) + _3012._m1.w)), (_2819.x * _3012._m2.x) + ((_2819.y * _3012._m2.y) + ((_2819.z * _3012._m2.z) + _3012._m2.w)), (_2819.x * _3012._m3.x) + ((_2819.y * _3012._m3.y) + ((_2819.z * _3012._m3.z) + _3012._m3.w)));
            vec3 _3155 = _3068.xyz / vec3(_3068.w);
            _3068 = vec4(_3155.x, _3155.y, _3155.z, _3068.w);
            bool _3163 = min(_3068.x, _3068.y) > 0.0;
            bool _3172;
            if (_3163)
            {
                _3172 = max(_3068.x, _3068.y) < 1.0;
            }
            else
            {
                _3172 = _3163;
            }
            if (_3172)
            {
                vec2 _3184 = (_3068.xy * _3012._m4.xy) + _3012._m4.zw;
                _3068 = vec4(_3184.x, _3184.y, _3068.z, _3068.w);
                if (false)
                {
                    _2804 = textureLod(_3192, vec3(_3068.xyz.xy, _3068.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3199 = (_3068.xy * _788._m15.xy) + vec2(0.5);
                    vec2 _3208 = floor(_3199);
                    vec2 _3211 = _3199 - _3208;
                    _3208 -= vec2(0.5);
                    vec2 _3218 = vec2(4.0) - (_3211 * 3.0);
                    vec2 _3223 = vec2(7.0);
                    vec2 _3226 = vec2(1.0) + (_3211 * 3.0);
                    vec2 _3231 = (_3208 + (((vec2(3.0) - (_3211 * 2.0)) / _3218) - vec2(2.0))) * _788._m15.zw;
                    vec2 _3246 = (_3208 + ((vec2(3.0) + _3211) / _3223)) * _788._m15.zw;
                    vec2 _3258 = (_3208 + ((_3211 / _3226) + vec2(2.0))) * _788._m15.zw;
                    vec3 _3282 = vec3(_3231.x, _3231.y, _3068.z);
                    _2804 = (_3218.x * _3218.y) * textureLod(_3192, vec3(_3282.xy, _3282.z), 0.0);
                    vec3 _3298 = vec3(_3246.x, _3231.y, _3068.z);
                    _2804 += ((_3223.x * _3218.y) * textureLod(_3192, vec3(_3298.xy, _3298.z), 0.0));
                    vec3 _3316 = vec3(_3258.x, _3231.y, _3068.z);
                    _2804 += ((_3226.x * _3218.y) * textureLod(_3192, vec3(_3316.xy, _3316.z), 0.0));
                    vec3 _3334 = vec3(_3231.x, _3246.y, _3068.z);
                    _2804 += ((_3218.x * _3223.y) * textureLod(_3192, vec3(_3334.xy, _3334.z), 0.0));
                    vec3 _3352 = vec3(_3246.x, _3246.y, _3068.z);
                    _2804 += ((_3223.x * _3223.y) * textureLod(_3192, vec3(_3352.xy, _3352.z), 0.0));
                    vec3 _3370 = vec3(_3258.x, _3246.y, _3068.z);
                    _2804 += ((_3226.x * _3223.y) * textureLod(_3192, vec3(_3370.xy, _3370.z), 0.0));
                    vec3 _3388 = vec3(_3231.x, _3258.y, _3068.z);
                    _2804 += ((_3218.x * _3226.y) * textureLod(_3192, vec3(_3388.xy, _3388.z), 0.0));
                    vec3 _3406 = vec3(_3246.x, _3258.y, _3068.z);
                    _2804 += ((_3223.x * _3226.y) * textureLod(_3192, vec3(_3406.xy, _3406.z), 0.0));
                    vec3 _3424 = vec3(_3258.x, _3258.y, _3068.z);
                    _2804 += ((_3226.x * _3226.y) * textureLod(_3192, vec3(_3424.xy, _3424.z), 0.0));
                    _2804 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _2804 = float((_2307 & 3u) == 2u);
            }
            float _3438 = float((_2307 >> uint(16)) & 63u) / 63.0;
            float _3452 = ((_2804 * _3438) + 1.0) - _3438;
            _2804 = _10(_3452);
        }
        uint _3455 = _2091._m13;
        vec3 _3454 = (_121(_3455) * _2804) * _2376;
        _2377 *= _2091._m14;
        vec3 _3467 = _3454;
        vec3 _3469 = vec3(_756._m17[0].x, _756._m17[1].x, _756._m17[2].x);
        vec3 _3477 = vec3(_756._m17[0].y, _756._m17[1].y, _756._m17[2].y);
        float _3485 = (gl_FrontFacing == false) ? (-1.0) : 1.0;
        vec3 _3489 = _756._m13;
        vec3 _3492 = normalize(_2373 - _756._m14);
        vec3 _3498 = vec3(_756._m6.xy, _756._m6.z * _3485);
        float _3509 = 0.5;
        float _3510 = dot(_3498, _3492);
        float _3520 = 1.0 + _3509;
        float _3523 = (_3510 + _3509) / _71(_3520);
        float _3514 = _10(_3523);
        vec3 _3525 = normalize(_3489 + _3492);
        float _3530 = dot(_3498, _3525);
        vec3 _3534 = vec3(0.0);
        float _3535 = 1.0 - _868._m8.z;
        float _3539 = _3535 * _3535;
        float _3543 = 1.0;
        float _3544 = _3543 * _3543;
        float _3548 = dot(normalize(_3469 + ((_3498 * _868._m8.x) * _751)), _3525);
        float _3560 = dot(normalize(_3477 + ((_3498 * _868._m8.x) * _751)), _3525);
        float _3572 = (((_3548 * _3548) / _3544) + ((_3560 * _3560) / _3539)) + (_3530 * _3530);
        _3534 = vec3(1.0 / (_3572 * _3572)) / vec3((_3544 * _3539) + 9.9999999392252902907785028219223e-09);
        float _3603 = dot(_3498, _3489);
        float _3599 = (_10(_3603) * (1.0 - _3535)) + _3535;
        float _3614 = dot(_3498, _3492);
        float _3610 = (_10(_3614) * (1.0 - _3535)) + _3535;
        _3534 /= vec3(((4.0 * _3599) * _3610) + 9.9999999392252902907785028219223e-09);
        vec3 _3629 = vec3(0.0);
        float _3630 = 1.0 - _868._m8.w;
        float _3634 = _3630 * _3630;
        float _3638 = 1.0;
        float _3639 = _3638 * _3638;
        float _3643 = dot(normalize(_3469 + ((_3498 * _868._m8.y) * _751)), _3525);
        float _3655 = dot(normalize(_3477 + ((_3498 * _868._m8.y) * _751)), _3525);
        float _3667 = (((_3643 * _3643) / _3639) + ((_3655 * _3655) / _3634)) + (_3530 * _3530);
        _3629 = vec3(1.0 / (_3667 * _3667)) / vec3((_3639 * _3634) + 9.9999999392252902907785028219223e-09);
        float _3698 = dot(_3498, _3489);
        float _3694 = (_10(_3698) * (1.0 - _3630)) + _3630;
        float _3709 = dot(_3498, _3492);
        float _3705 = (_10(_3709) * (1.0 - _3630)) + _3630;
        _3629 /= vec3(((4.0 * _3694) * _3705) + 9.9999999392252902907785028219223e-09);
        vec3 _3731 = _756._m2;
        float _3734 = dot(_3492, _3525);
        vec3 _3724 = ((_3534 + _3629) * _126(_3731, _3734)) * max(0.0, _3485);
        float _3746 = _3510;
        vec3 _3740 = ((_3724 * _2377) * _3467) * _10(_3746);
        vec3 _3750 = ((_3724 * _2377) * _3467) * _3514;
        _756._m20 += _3740;
        _756._m19 += ((_3467 * _3514) + _3750);
    }
    float _3772 = _788._m16.x;
    if (_3772 > 0.00999999977648258209228515625)
    {
        float _3780 = float(int(_788._m14.x) & 1023) / 1023.0;
        _3772 = max(0.0, _3772 + (((_3780 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _3796 = _756._m13;
        float _3804 = dot(_756._m6, _3796);
        float _3799 = _10(_3804);
        float _3806 = _3799 * _3772;
        vec3 _3814 = _756._m6;
        vec3 _3817 = _756._m13;
        vec3 _3820 = _756._m2;
        float _3823 = abs(_756._m3);
        vec3 _3810 = _133(_3814, _3817, _3820, _3823) * _3772;
        _756._m19 += vec3(_3806);
        _756._m20 += vec3(_3810);
    }
    _756._m19 = _756._m19;
    _756._m20 += _756._m10;
    _756._m19 *= _756._m0;
    _756._m21 = _756._m19 + _756._m20;
    vec2 _3863 = gl_FragCoord.xy * _788._m7.xy;
    _3863.y = 1.0 - _3863.y;
    vec4 _3874 = vec4((_3863.x * 2.0) - 1.0, (_3863.y * 2.0) - 1.0, gl_FragCoord.z, 1.0);
    vec3 _3887;
    _3887.x = dot(_3874, _788._m17);
    _3887.y = dot(_3874, _788._m18);
    _3887.z = dot(_3874, _788._m19);
    _3887 /= vec3(dot(_3874, _788._m20));
    float _3910 = SAMPLE_TEXTURE(_3911, _3913.xy * vec2(_777._m10.w)).y;
    vec4 _3930 = vec4(_777._m6.xyz, 1.0);
    vec4 _3931 = _777._m1;
    vec3 _3922;
    _3922.x = _27(_3930, _3931);
    vec4 _3943 = vec4(_777._m6.xyz, 1.0);
    vec4 _3944 = _777._m2;
    _3922.y = _27(_3943, _3944);
    vec4 _3956 = vec4(_777._m6.xyz, 1.0);
    vec4 _3957 = _777._m3;
    _3922.z = _27(_3956, _3957);
    vec3 _3962 = _3922 - _3887;
    float _3966 = (_3910 * _868._m9.x) + (1.0 - _868._m9.x);
    float _3975 = length(_3962) * _3966;
    vec2 _3980 = vec2(6.666666507720947265625, 10.0);
    float _3984 = _3975 - _777._m7.w;
    float _3994 = _3984 * _3980.x;
    float _3989 = _10(_3994);
    float _4001 = _3984 * _3980.y;
    float _3996 = _10(_4001);
    float _4011 = (1.0 - _3996) * _3910;
    vec3 _4003 = _777._m10.xyz * _10(_4011);
    float _4014 = _3989;
    float _4021 = ceil(_4014 - 0.001000000047497451305389404296875);
    float _4016 = _10(_4021);
    float _4026 = _4016 - 9.9999997473787516355514526367188e-05;
    _20(_4026);
    _756._m19 += _4003;
    vec3 _4039 = _756._m19 + _756._m20;
    _4034 = vec4(_4039.x, _4039.y, _4039.z, _4034.w);
    vec3 _4043 = _756._m6;
    bool _4046 = false;
    vec2 _4047 = _169(_4043, _4046);
    _4042 = vec4(_4047.x, _4047.y, _4042.z, _4042.w);
    float _4051 = _756._m2.x;
    float _4055 = _756._m2.y;
    float _4059 = _756._m2.z;
    float _4063 = _756._m3;
    _4050 = vec4(_90(_4051), _90(_4055), _90(_4059), _172(_4063));
    _4068 = vec4(0.0, 0.0, 0.0, float((uint(_777._m8.z) & 3u) << uint(4)) / 255.0);
    vec3 _4081 = _756._m19 + _756._m20;
    _4034 = vec4(_4081.x, _4081.y, _4081.z, _4034.w);
    vec3 _4084 = _756._m6;
    bool _4087 = false;
    vec2 _4088 = _169(_4084, _4087);
    _4042 = vec4(_4088.x, _4088.y, _4042.z, _4042.w);
    float _4091 = _756._m2.x;
    float _4095 = _756._m2.y;
    float _4099 = _756._m2.z;
    float _4103 = _756._m3;
    _4050 = vec4(_90(_4091), _90(_4095), _90(_4099), _172(_4103));
    vec3 _4113 = _4034.xyz + _777._m11.xyz;
    _4034 = vec4(_4113.x, _4113.y, _4113.z, _4034.w);
    float _4122 = SAMPLE_TEXTURE(_4117, _768.xy).x;
    float _4125 = _868._m4.z;
    float _4130 = mix(1.0, _71(_4122), _10(_4125));
    float _4116 = _10(_4130);
    vec3 _4136 = _4034.xyz * vec3(_4116);
    _4034 = vec4(_4136.x, _4136.y, _4136.z, _4034.w);
}

