#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

struct _556
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1094
{
    int _m0;
    int _m1;
};

struct _1097
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform _579_581
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
} _581;

layout(set = 0, binding = 0, std140) uniform _593_595
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
} _595;

layout(set = 2, binding = 0, std140) uniform _746_748
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _748;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1099_1101
{
    _1097 _m0[];
} _1101;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1566_1568
{
    vec4 _m0[];
} _1568;

layout(push_constant, std430) uniform _1562_1564
{
    int _m0;
    int _m1;
} _1564;

layout(set = 2, binding = 1) uniform SAMPLER_2D _726;
layout(set = 2, binding = 2) uniform SAMPLER_2D _862;
layout(set = 1, binding = 1) uniform SAMPLER_2D _914;
layout(set = 1, binding = 2) uniform SAMPLER_2D _919;
layout(set = 3, binding = 0) uniform texture2D _1554[16384];
layout(set = 3, binding = 1) uniform texture2D _1555[16384];
layout(set = 3, binding = 2) uniform texture2D _1556[16384];
layout(set = 3, binding = 3) uniform texture2D _1557[16384];
layout(set = 3, binding = 4) uniform texture2D _1558[16384];
layout(set = 3, binding = 5) uniform texture2D _1559[16384];
layout(set = 3, binding = 6) uniform texture2D _1560[16384];
layout(set = 3, binding = 7) uniform texture2D _1561[16384];
layout(set = 0, binding = 3) uniform sampler3D _1572;
layout(set = 0, binding = 4) uniform sampler3D _1573;

layout(location = 2) in vec4 _571;
layout(location = 6) in vec4 _600;
layout(location = 3) in vec4 _612;
layout(location = 4) in vec4 _615;
layout(location = 5) in vec4 _618;
layout(location = 10) in vec4 _636;
layout(location = 11) in vec4 _640;
layout(location = 12) in vec4 _644;
layout(location = 8) in vec4 _924;
layout(location = 0) out vec4 _1418;
layout(location = 1) out vec4 _1429;
layout(location = 2) out vec4 _1437;
layout(location = 3) out vec4 _1478;
layout(location = 9) in vec4 _1497;
layout(location = 13) in vec4 _1500;
layout(location = 4) out vec4 _1534;

float _155;

float _43(float _42)
{
    return _42 * _42;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _25(float _24)
{
    return _24 * ((_24 * ((_24 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _28(vec3 _27)
{
    float _193 = _27.x;
    vec3 _192;
    _192.x = _25(_193);
    float _198 = _27.y;
    _192.y = _25(_198);
    float _203 = _27.z;
    _192.z = _25(_203);
    return _192;
}

vec4 _34(vec4 _33)
{
    vec3 _212 = _33.xyz;
    vec4 _211 = vec4(_28(_212), 1.0);
    float _220 = _33.w;
    _211.w = _25(_220);
    return _211;
}

vec4 _67(SAMPLER_2D _65, vec2 _66)
{
    vec4 _264 = SAMPLE_TEXTURE(_65, _66);
    vec4 _268 = _264;
    _264 = _34(_268);
    return _264;
}

float _71(vec3 _70)
{
    return dot(_70, vec3(0.2125999927520751953125, 0.715200006961822509765625, 0.072200000286102294921875));
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _98(vec3 _96, bool _97)
{
    vec3 _405 = (_96 * 2.0) - vec3(1.0);
    float _423 = (1.0 - (_405.x * _405.x)) - (_405.y * _405.y);
    _405.z = sqrt(_10(_423));
    if (_97 == false)
    {
        _405.z = -_405.z;
    }
    return _405;
}

vec3 _105(vec3 _103, mat3 _104)
{
    return normalize(vec3(dot(_103, _104[0]), dot(_103, _104[1]), dot(_103, _104[2])));
}

vec3 _111(vec3 _108, mat3 _109, bool _110)
{
    vec3 _460 = _108;
    bool _462 = _110;
    vec3 _459 = _98(_460, _462);
    vec3 _465 = _459;
    mat3 _467 = _109;
    return _105(_465, _467);
}

float _19(float _18)
{
    if (_18 <= 0.040449999272823333740234375)
    {
        return _18 / 12.9200000762939453125;
    }
    else
    {
        return pow((_18 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _22(vec3 _21)
{
    float _157 = _21.x;
    vec3 _156;
    _156.x = _19(_157);
    float _164 = _21.y;
    _156.y = _19(_164);
    float _170 = _21.z;
    _156.z = _19(_170);
    return _156;
}

vec3 _37(vec3 _36)
{
    vec3 _229 = _36;
    return _22(_229);
}

float _93(float _89, vec4 _90, float _91, bool _92)
{
    float _392 = _90.w / (_89 + _90.z);
    return _392 * _91;
}

vec3 _40(vec3 _39)
{
    return _39 * _39;
}

float _49(float _46, float _47, float _48)
{
    float _251 = (_46 - _47) / (_48 - _47);
    return _10(_251);
}

float _54(float _52, float _53)
{
    return pow(_52, _53);
}

vec3 _76(vec3 _74, float _75)
{
    float _289 = 50.0 * dot(_74, vec3(0.33329999446868896484375));
    float _282 = _10(_289);
    float _298 = 1.0 - _75;
    float _301 = _10(_298);
    float _302 = 5.0;
    vec3 _306 = _74 + ((vec3(_282) - _74) * _54(_301, _302));
    return _16(_306);
}

vec3 _84(vec3 _79, vec3 _80, vec3 _81, vec3 _82, float _83)
{
    vec3 _310 = normalize(_80 + _81);
    float _315 = 1.0 - (_83 * 0.800000011920928955078125);
    _315 *= _315;
    _315 *= _315;
    float _326 = _315 * _315;
    float _334 = dot(_79, _310);
    float _330 = _10(_334);
    float _336 = ((_330 * _330) * (_326 - 1.0)) + 1.0;
    _336 = _326 / ((_336 * _336) + 9.9999999392252902907785028219223e-09);
    float _355 = dot(_79, _80);
    float _351 = (_10(_355) * (1.0 - _315)) + _315;
    float _366 = dot(_79, _81);
    float _362 = (_10(_366) * (1.0 - _315)) + _315;
    _336 /= (((4.0 * _351) * _362) + 9.9999999392252902907785028219223e-09);
    vec3 _384 = _82;
    float _386 = dot(_81, _310);
    return _76(_384, _386) * _336;
}

vec2 _115(vec2 _114)
{
    return (vec2(1.0) - abs(_114.yx)) * vec2((_114.x >= 0.0) ? 1.0 : (-1.0), (_114.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _120(inout vec3 _118, bool _119)
{
    _118 /= vec3((abs(_118.x) + abs(_118.y)) + abs(_118.z));
    vec2 _507;
    if (_118.z >= 0.0)
    {
        _507 = _118.xy;
    }
    else
    {
        vec2 _513 = _118.xy;
        _507 = _115(_513);
    }
    _118 = vec3(_507.x, _507.y, _118.z);
    if (_119)
    {
        vec2 _528 = (_118.xy * 0.5) + vec2(0.5);
        _118 = vec3(_528.x, _528.y, _118.z);
    }
    return _118.xy;
}

float _57(float _56)
{
    return sqrt(_56);
}

float _123(float _122)
{
    float _538 = abs(_122);
    float _535 = _57(_538);
    float _542;
    if (_122 > 0.0)
    {
        _542 = _535;
    }
    else
    {
        _542 = -_535;
    }
    return (_542 * 0.5) + 0.5;
}

void main()
{
    _556 _558 = _556(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _556 _568 = _556(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _568._m15 = _571;
    _568._m16 = gl_FragCoord;
    _568._m40 = (uint(_581._m33.z) & 3u) << uint(4);
    _568._m14 = _595._m0.xyz + _600.xyz;
    _568._m13 = normalize(-_600.xyz);
    _568._m17 = mat3(vec3(_612.xyz), vec3(_615.xyz), vec3(_618.xyz));
    _568._m34 = _636;
    _568._m35 = _640;
    _568._m36 = _644;
    uint _647 = 0u;
    vec4 _648 = vec4(0.0);
    vec4 _649 = vec4(0.0);
    vec4 _650 = vec4(0.0);
    vec4 _651 = vec4(0.0);
    vec4 _652 = vec4(0.0);
    _568._m0 = _650.xyz;
    _568._m2 = _651.xyz;
    _568._m1 = _649.xyz;
    _568._m9 = _648.xyz;
    _568._m3 = _648.w;
    _568._m6 = _652.wyz;
    _568._m12 = 0.0;
    mat3 _676 = transpose(_568._m17);
    vec3 _680 = normalize(vec3(dot(_568._m13, _676[0]), dot(_568._m13, _676[1]), dot(_568._m13, _676[2])));
    vec2 _698 = _571.xy;
    int _702 = 8;
    vec3 _704 = vec3(-_680.xy, 1.0);
    vec3 _711 = _704 / vec3(float(_702));
    vec3 _717 = vec3(_698, 0.0);
    vec2 _722 = _717.xy;
    float _741 = TEXTURE_LOD(_726, vec4(_717.xy, 0.0, 0.0).xy, vec4(_717.xy, 0.0, 0.0).w).w;
    float _725 = _43(_741);
    float _744 = _725 * _748._m6.x;
    float _752 = _744;
    int _754 = 0;
    for (;;)
    {
        bool _762 = _754 < _702;
        bool _769;
        if (_762)
        {
            _769 = _717.z < _744;
        }
        else
        {
            _769 = _762;
        }
        if (_769)
        {
            _722 = _717.xy;
            _752 = _744;
            _717 += _711;
            float _790 = TEXTURE_LOD(_726, vec4(_717.xy, 0.0, 0.0).xy, vec4(_717.xy, 0.0, 0.0).w).w;
            _744 = _43(_790) * _748._m6.x;
            _754++;
            continue;
        }
        else
        {
            break;
        }
    }
    float _798 = _744 - _717.z;
    float _803 = (_752 - _717.z) + _711.z;
    float _817 = _798 / (_798 - _803);
    float _811 = _10(_817);
    vec2 _819 = mix(_717.xy, _722, vec2(_811));
    vec2 _827 = _819;
    vec4 _826 = _67(_726, _827);
    _558._m0 = _826.xyz;
    vec3 _835 = _826.xyz;
    vec3 _851 = (_826.www * _748._m7.w) * 8.0;
    _568._m0 = mix(_826.xyz, _748._m7.xyz * _71(_835), _16(_851));
    _568._m2 = _748._m8.xxx;
    _568._m3 = _748._m8.y;
    _568._m6 = SAMPLE_TEXTURE(_862, _698).xyz;
    vec3 _871 = _558._m0;
    _558._m2 = _748._m8.zzz * _71(_871);
    _558._m3 = _748._m8.w;
    _558._m6 = vec3(1.0) - SAMPLE_TEXTURE1(_862, vec4(_819, 0.0, 0.0).xy, vec4(_819, 0.0, 0.0).w).xyz;
    vec3 _897 = _558._m6;
    mat3 _900 = _568._m17;
    bool _903 = true;
    _558._m6 = _111(_897, _900, _903);
    vec2 _906 = _571.xy * _581._m34.xy;
    vec4 _913 = SAMPLE_TEXTURE(_914, _906);
    vec4 _918 = SAMPLE_TEXTURE(_919, _906);
    float _929 = _924.x * 0.5;
    float _923 = 1.0 - _10(_929);
    float _935 = _923 * 2.0;
    float _942 = (_10(_935) - (1.0 - _913.w)) * 1.0;
    float _932 = _10(_942);
    float _951 = (_923 - (1.0 - _918.w)) * 1.0;
    float _944 = _10(_951);
    vec3 _955 = _913.xyz;
    _568._m0 = mix(_568._m0, _37(_955), vec3(_932));
    _568._m2 = mix(_568._m2, vec3(0.0199999995529651641845703125), vec3(_932));
    _568._m3 = mix(_568._m3, 0.64999997615814208984375, _932);
    _568._m6 = mix(_568._m6, _918.xyz, vec3(_944));
    uint _985 = uint((_581._m33.x > 0.0) ? 8 : 0);
    float _991 = 16.0;
    float _993 = 8.0;
    float _994 = 24.0;
    vec2 _1003 = _568._m16.xy * _595._m12.xy;
    vec3 _996;
    _996 = vec3(_1003.x, _1003.y, _996.z);
    _996.y = 1.0 - _996.y;
    vec2 _1016 = floor(_996.xy * vec2(_991, _993));
    _996 = vec3(_1016.x, _1016.y, _996.z);
    float _1020 = _568._m16.z;
    vec4 _1023 = _595._m13;
    float _1026 = 1.0;
    bool _1027 = false;
    float _1019 = _93(_1020, _1023, _1026, _1027);
    float _1029 = log2(max(1.0, _1019 / _595._m14.z)) * _595._m14.w;
    _996.z = min(_994 - 1.0, floor(_1029));
    uint _1045 = uint((_996.x + (_996.y * _991)) + ((_996.z * _991) * _993));
    _1045 = min(_1045, uint(((_991 * _993) * _994) - 1.0));
    bool _1070 = true;
    vec3 _1071 = _568._m6;
    bool _1074 = _1070;
    _568._m7 = _98(_1071, _1074);
    vec3 _1078 = _568._m7;
    mat3 _1081 = _568._m17;
    _568._m6 = _105(_1078, _1081);
    uint _1086 = 0u;
    uint _1087 = 0u;
    uint _1088 = 0u;
    uint _1089 = 0u;
    uint _1090 = 0u;
    uint _1091 = 0u;
    int _1092 = 256;
    _1094 _1096;
    _1096._m0 = _1101._m0[_1045]._m0;
    _1096._m1 = _1101._m0[_1045]._m1;
    int _1110 = _1096._m0 & (~(_1096._m0 >> 31));
    int _1119 = _1096._m1 & (~(_1096._m1 >> 31));
    _1086 = uint((_1110 >> 16) * _1092);
    _1087 = _1086 + uint(_1119 & 255);
    _1088 = _1086;
    _1089 = _1088 + uint((_1119 >> 8) & 255);
    _1090 = _1086;
    _1091 = _1090 + uint((_1119 >> 16) & 255);
    float _1154 = _568._m37;
    float _1152 = _43(_1154);
    float _1161 = _1152 - 0.5;
    float _1158 = _10(_1161) * 2.0;
    float _1173 = _1152 * 2.0;
    float _1164 = (_568._m38 * _568._m38) * _10(_1173);
    float _1180 = _1164 + _1158;
    float _1176 = _10(_1180);
    if (_1176 > 0.0039215688593685626983642578125)
    {
        vec3 _1189 = _568._m0;
        float _1196 = _1176 * 1.0;
        float _1197 = 0.0;
        float _1198 = 0.3499999940395355224609375;
        _568._m0 = mix(_568._m0, _40(_1189), vec3(_49(_1196, _1197, _1198) * (1.0 - _568._m3)));
        float _1214 = _1176 * 1.0;
        float _1215 = 0.25;
        float _1216 = 0.5;
        _568._m2 = mix(_568._m2, vec3(0.039999999105930328369140625), vec3(_49(_1214, _1215, _1216)));
        vec3 _1221 = vec3(_568._m17[0].z, _568._m17[1].z, _568._m17[2].z);
        float _1235 = _1221.z + 0.0625;
        float _1229 = _1176 * _10(_1235);
        float _1244 = _1229 * 1.0;
        float _1245 = 0.20000000298023223876953125;
        float _1246 = 1.0;
        _568._m3 = mix(_568._m3, 0.89999997615814208984375, _49(_1244, _1245, _1246));
        float _1255 = _1229 * 1.0;
        float _1256 = 0.449999988079071044921875;
        float _1257 = 0.980000019073486328125;
        float _1250 = _49(_1255, _1256, _1257);
        _568._m6 = normalize(mix(_568._m6, vec3(0.0, 0.0, 1.0), vec3(_1250)));
        _568._m7 = mix(_568._m6, vec3(0.5, 0.5, 1.0), vec3(_1250));
        if (_1229 > 0.980000019073486328125)
        {
            float _1281 = _1229 * _1250;
            float _1282 = 0.980000019073486328125;
            float _1283 = 1.0;
            _1221 = normalize(mix(_1221, vec3(0.0, 0.0, 1.0), vec3(_49(_1281, _1282, _1283))));
            _568._m17[0].z = _1221.x;
            _568._m17[1].z = _1221.y;
            _568._m17[2].z = _1221.z;
        }
    }
    vec3 _1297 = vec3(0.0);
    vec3 _1298 = vec3(_568._m34.x, _568._m34.y, _568._m34.z);
    vec3 _1306 = vec3(_568._m34.w, _568._m35.x, _568._m35.y);
    vec3 _1314 = vec3(_568._m35.z, _568._m35.w, _568._m36.x);
    vec3 _1322 = vec3(_568._m36.y, _568._m36.z, _568._m36.w);
    vec3 _1330 = ((_1298 - (_1306 * _568._m6.y)) + (_1314 * _568._m6.z)) - (_1322 * _568._m6.x);
    float _1353 = _581._m35.x * _595._m15.x;
    _1297 += max(_1330 * _10(_1353), vec3(0.0));
    float _1365;
    if (dot(_568._m10, vec3(1.0)) > 0.0)
    {
        _1365 = -_568._m3;
    }
    else
    {
        _1365 = _568._m3;
    }
    _568._m3 = _1365;
    _568._m18 = _1297;
    float _1385 = dot(_568._m6, _568._m13);
    float _1379 = _10(_1385);
    vec3 _1389 = _568._m19;
    vec3 _1395 = _568._m6;
    vec3 _1398 = _568._m13;
    vec3 _1401 = _568._m13;
    vec3 _1404 = _568._m2;
    float _1407 = _568._m3;
    vec3 _1387 = (_16(_1389) * _1379) * _84(_1395, _1398, _1401, _1404, _1407);
    _568._m18 += _1387;
    vec3 _1426 = (_568._m18 * _568._m0) + _568._m10;
    _1418 = vec4(_1426.x, _1426.y, _1426.z, _1418.w);
    vec3 _1430 = _568._m6;
    bool _1433 = false;
    vec2 _1434 = _120(_1430, _1433);
    _1429 = vec4(_1434.x, _1434.y, _1429.z, _1429.w);
    float _1438 = _568._m2.x;
    float _1442 = _568._m2.y;
    float _1446 = _568._m2.z;
    float _1450 = _568._m3;
    _1437 = vec4(_57(_1438), _57(_1442), _57(_1446), _123(_1450));
    uint _1455 = uint((_581._m33.x > 0.0) ? 8 : 0);
    uint _1461 = uint(int(_1455 > 0u));
    _1461 |= 2u;
    _1461 |= 4u;
    _1461 |= ((uint(_581._m33.z) & 3u) << uint(4));
    float _1479 = _568._m0.x;
    float _1483 = _568._m0.y;
    float _1487 = _568._m0.z;
    _1478 = vec4(_57(_1479), _57(_1483), _57(_1487), float(_1461) / 255.0);
    vec4 _1496 = _1497;
    vec4 _1499 = _1500;
    vec2 _1502 = ((_1496.xy / vec2(_1496.w)) * 0.5) + vec2(0.5);
    vec2 _1512 = ((_1499.xy / vec2(_1499.w)) * 0.5) + vec2(0.5);
    _1502.y = 1.0 - _1502.y;
    _1512.y = 1.0 - _1512.y;
    vec2 _1530 = _595._m16.xy;
    _1534 = vec4((_1502 - _1512) * _1530, 0.0, 1.0);
    vec3 _1548 = _1418.xyz + _581._m36.xyz;
    _1418 = vec4(_1548.x, _1548.y, _1548.z, _1418.w);
}

