// DECALS & GLASS RTX 1
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _1085
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1363
{
    int _m0;
    int _m1;
};

struct _1366
{
    int _m0;
    int _m1;
};

struct _1477
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2488
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3931
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 1, binding = 0, std140) uniform _1106_1108
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _1108;

layout(set = 0, binding = 0, std140) uniform _1118_1120
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
} _1120;

layout(set = 2, binding = 0, std140) uniform _1200_1202
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _1202;

layout(set = 0, binding = 4, std430) restrict readonly buffer _1368_1370
{
    _1366 _m0[];
} _1370;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1452_1454
{
    uint _m0[];
} _1454;

layout(set = 0, binding = 6, std140) uniform _1482_1484
{
    vec4 _m0[4096];
} _1484;

layout(set = 0, binding = 7, std140) uniform _1502_1504
{
    vec4 _m0[4096];
} _1504;

layout(set = 0, binding = 8, std140) uniform _1554_1556
{
    vec4 _m0[4096];
} _1556;

layout(set = 0, binding = 10, std140) uniform _2492_2494
{
    vec4 _m0[4096];
} _2494;

layout(set = 0, binding = 11, std140) uniform _2531_2533
{
    vec4 _m0[4096];
} _2533;

layout(set = 0, binding = 12, std140) uniform _2599_2601
{
    vec4 _m0[4096];
} _2601;

layout(set = 0, binding = 15, std140) uniform _3935_3937
{
    vec4 _m0[4095];
} _3937;

layout(set = 0, binding = 1, std430) restrict readonly buffer _5393_5395
{
    vec4 _m0[];
} _5395;

layout(push_constant, std430) uniform _5389_5391
{
    int _m0;
    int _m1;
} _5391;

layout(set = 2, binding = 1) uniform SAMPLER_2D _1208;
layout(set = 2, binding = 2) uniform SAMPLER_2D _1216;
layout(set = 2, binding = 3) uniform SAMPLER_2D _1221;
layout(set = 0, binding = 9) uniform SAMPLER_2D _1776;
layout(set = 0, binding = 13) uniform samplerCubeArray _3084;
layout(set = 0, binding = 14) uniform SAMPLER_2D _3492;
layout(set = 0, binding = 16) uniform sampler2DShadow _4259;
layout(set = 0, binding = 17) uniform SAMPLER_2D _4770;
layout(set = 0, binding = 18) uniform SAMPLER_2D _4783;
layout(set = 0, binding = 19) uniform SAMPLER_2D _4937;
layout(set = 0, binding = 20) uniform SAMPLER_2D _4959;
layout(set = 0, binding = 21) uniform SAMPLER_2D _4998;
layout(set = 0, binding = 22) uniform SAMPLER_2D _5037;
layout(set = 0, binding = 23) uniform SAMPLER_2D _5072;
layout(set = 0, binding = 24) uniform sampler3D _5204;
layout(set = 0, binding = 25) uniform sampler3D _5225;
layout(set = 0, binding = 26) uniform sampler3D _5345;
layout(set = 0, binding = 2) uniform sampler3D _5396;
layout(set = 0, binding = 3) uniform sampler3D _5397;

layout(location = 2) in vec4 _1099;
layout(location = 6) in vec4 _1125;
layout(location = 3) in vec4 _1137;
layout(location = 4) in vec4 _1140;
layout(location = 5) in vec4 _1143;
layout(location = 10) in vec4 _1161;
layout(location = 11) in vec4 _1165;
layout(location = 12) in vec4 _1169;
layout(location = 3) out vec4 _4755;
layout(location = 0) out vec4 _5120;

float _307;
float _364;

float _51(float _50)
{
    if (_50 <= 0.040449999272823333740234375)
    {
        return _50 / 12.9200000762939453125;
    }
    else
    {
        return pow((_50 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _54(vec3 _53)
{
    float _309 = _53.x;
    vec3 _308;
    _308.x = _51(_309);
    float _315 = _53.y;
    _308.y = _51(_315);
    float _321 = _53.z;
    _308.z = _51(_321);
    return _308;
}

vec4 _57(vec4 _56)
{
    vec3 _331 = _56.xyz;
    vec4 _330 = vec4(_54(_331), 1.0);
    float _339 = _56.w;
    _330.w = _51(_339);
    return _330;
}

vec4 _72(vec4 _71)
{
    vec4 _414 = _71;
    return _57(_414);
}

vec4 _142(SAMPLER_2D _140, vec2 _141)
{
    vec4 _714 = SAMPLE_TEXTURE(_140, _141);
    vec4 _718 = _714;
    _714 = _72(_718);
    return _714;
}

float _60(float _59)
{
    if (_59 > 0.003130800090730190277099609375)
    {
        return (pow(_59, 0.4166666567325592041015625) * 1.05499994754791259765625) - 0.054999999701976776123046875;
    }
    else
    {
        return _59 * 12.9200000762939453125;
    }
}

float _180(float _176, vec4 _177, float _178, bool _179)
{
    float _958 = _177.w / (_176 + _177.z);
    return _958 * _178;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _185(vec3 _183, bool _184)
{
    vec3 _971 = (_183 * 2.0) - vec3(1.0);
    float _988 = (1.0 - (_971.x * _971.x)) - (_971.y * _971.y);
    _971.z = sqrt(_10(_988));
    if (_184 == false)
    {
        _971.z = -_971.z;
    }
    return _971;
}

vec3 _192(vec3 _190, mat3 _191)
{
    return normalize(vec3(dot(_190, _191[0]), dot(_190, _191[1]), dot(_190, _191[2])));
}

uint _31(float _30)
{
    return floatBitsToUint(_30);
}

float _42(float _39, float _40, float _41)
{
    return min(_39, min(_40, _41));
}

float _37(float _34, float _35, float _36)
{
    return max(_34, max(_35, _36));
}

vec4 _119(uint _118)
{
    return unpackUnorm4x8(_118).wzyx;
}

vec4 _132(uvec2 _131)
{
    return vec4(float((_131.x >> uint(16)) & 65535u), float(_131.x & 65535u), float((_131.y >> uint(16)) & 65535u), float(_131.y & 65535u)) * 3.0518509447574615478515625e-05;
}

void _26(float _25)
{
    if (_25 < 0.0)
    {
        discard;
    }
}

float _63(float _62)
{
    return _62 * ((_62 * ((_62 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _122(uint _121)
{
    return vec4(float((_121 >> uint(24)) & 255u), float((_121 >> uint(16)) & 255u), float((_121 >> uint(8)) & 255u), float(_121 & 255u));
}

float _101(float _100)
{
    return (step(0.0, _100) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _66(vec3 _65)
{
    float _379 = _65.x;
    vec3 _378;
    _378.x = _63(_379);
    float _384 = _65.y;
    _378.y = _63(_384);
    float _389 = _65.z;
    _378.z = _63(_389);
    return _378;
}

vec4 _69(vec4 _68)
{
    vec3 _398 = _68.xyz;
    vec4 _397 = vec4(_66(_398), 1.0);
    float _406 = _68.w;
    _397.w = _63(_406);
    return _397;
}

float _78(float _77)
{
    return _77 * _77;
}

vec3 _75(vec3 _74)
{
    return _74 * _74;
}

float _83(float _80, float _81, float _82)
{
    float _436 = (_80 - _81) / (_82 - _81);
    return _10(_436);
}

float _93(float _92)
{
    return exp2(_92);
}

vec3 _145(uint _144)
{
    uint _725 = _144;
    vec4 _724 = _119(_725);
    float _736 = (_724.w * 255.0) - 128.0;
    return _724.xyz * _93(_736);
}

vec3 _126(uint _125)
{
    return vec3(float((_125 >> uint(21)) & 2047u), float((_125 >> uint(10)) & 2047u), float(_125 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

vec3 _171(float _168, float _169, vec3 _170)
{
    float _910 = 0.0949999988079071044921875 + (_169 * (0.60000002384185791015625 + (4.190000057220458984375 * _169)));
    float _920 = _168 + 0.02500000037252902984619140625;
    float _924 = (9.5 * _169) * _168;
    float _938 = 1.0 - (14.0 * _168);
    float _930 = (_910 * _920) * _93(_938);
    float _945 = -_924;
    float _941 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _93(_945)));
    return mix(vec3(_930), vec3(_941), _170);
}

uint _48(float _45, float _46, float _47)
{
    bool _248 = abs(_47) >= abs(_45);
    bool _256;
    if (_248)
    {
        _256 = abs(_47) >= abs(_46);
    }
    else
    {
        _256 = _248;
    }
    if (_256)
    {
        return uint((_47 < 0.0) ? 5 : 4);
    }
    if (abs(_46) >= abs(_45))
    {
        return uint((_46 < 0.0) ? 3 : 2);
    }
    return uint(int(_45 < 0.0));
}

float _98(float _96, float _97)
{
    return pow(_96, _97);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _150(vec3 _148, float _149)
{
    float _748 = 50.0 * dot(_148, vec3(0.33329999446868896484375));
    float _741 = _10(_748);
    float _757 = 1.0 - _149;
    float _760 = _10(_757);
    float _761 = 5.0;
    vec3 _765 = _148 + ((vec3(_741) - _148) * _98(_760, _761));
    return _16(_765);
}

vec3 _158(vec3 _153, vec3 _154, vec3 _155, vec3 _156, float _157)
{
    vec3 _769 = normalize(_154 + _155);
    float _774 = 1.0 - (_157 * 0.800000011920928955078125);
    _774 *= _774;
    _774 *= _774;
    float _785 = _774 * _774;
    float _793 = dot(_153, _769);
    float _789 = _10(_793);
    float _795 = ((_789 * _789) * (_785 - 1.0)) + 1.0;
    _795 = _785 / ((_795 * _795) + 9.9999999392252902907785028219223e-09);
    float _814 = dot(_153, _154);
    float _810 = (_10(_814) * (1.0 - _774)) + _774;
    float _825 = dot(_153, _155);
    float _821 = (_10(_825) * (1.0 - _774)) + _774;
    _795 /= (((4.0 * _810) * _821) + 9.9999999392252902907785028219223e-09);
    vec3 _843 = _156;
    float _845 = dot(_155, _769);
    return _150(_843, _845) * _795;
}

vec3 _165(vec3 _161, vec3 _162, vec3 _163, float _164)
{
    float _851 = 1.0 - (_164 * 0.800000011920928955078125);
    _851 *= _851;
    _851 *= _851;
    float _861 = _851 * _851;
    float _869 = dot(_161, _162);
    float _865 = _10(_869);
    float _871 = ((_865 * _865) * (_861 - 1.0)) + 1.0;
    _871 = _861 / ((_871 * _871) + 9.9999999392252902907785028219223e-09);
    float _889 = dot(_161, _162);
    float _885 = (_10(_889) * (1.0 - _851)) + _851;
    _871 /= (((4.0 * _885) * _885) + 9.9999999392252902907785028219223e-09);
    vec3 _903 = _163;
    return _16(_903) * _871;
}

vec2 _196(vec2 _195)
{
    return (vec2(1.0) - abs(_195.yx)) * vec2((_195.x >= 0.0) ? 1.0 : (-1.0), (_195.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _201(inout vec3 _199, bool _200)
{
    _199 /= vec3((abs(_199.x) + abs(_199.y)) + abs(_199.z));
    vec2 _1055;
    if (_199.z >= 0.0)
    {
        _1055 = _199.xy;
    }
    else
    {
        vec2 _1061 = _199.xy;
        _1055 = _196(_1061);
    }
    _199 = vec3(_1055.x, _1055.y, _199.z);
    if (_200)
    {
        vec2 _1076 = (_199.xy * 0.5) + vec2(0.5);
        _199 = vec3(_1076.x, _1076.y, _199.z);
    }
    return _199.xy;
}

vec4 _90(vec3 _88, mat4 _89)
{
    return vec4((_88.x * _89[0].x) + ((_88.y * _89[0].y) + ((_88.z * _89[0].z) + _89[0].w)), (_88.x * _89[1].x) + ((_88.y * _89[1].y) + ((_88.z * _89[1].z) + _89[1].w)), (_88.x * _89[2].x) + ((_88.y * _89[2].y) + ((_88.z * _89[2].z) + _89[2].w)), (_88.x * _89[3].x) + ((_88.y * _89[3].y) + ((_88.z * _89[3].z) + _89[3].w)));
}

float _104(float _103)
{
    float _539 = (((-0.15658299624919891357421875) * abs(_103)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_103));
    float _553;
    if (_103 >= 0.0)
    {
        _553 = _539;
    }
    else
    {
        _553 = 3.1415927410125732421875 - _539;
    }
    return _553;
}

float _107(float _106)
{
    float _567;
    if (_106 < 1.0)
    {
        _567 = _106;
    }
    else
    {
        _567 = 1.0 / _106;
    }
    float _564 = _567;
    float _575 = _564 * _564;
    float _579 = 0.087292902171611785888671875;
    _579 = (-0.3018949925899505615234375) + (_579 * _575);
    _579 = 1.0 + (_579 * _575);
    _579 *= _564;
    float _595;
    if (_106 < 1.0)
    {
        _595 = _579;
    }
    else
    {
        _595 = 1.57079637050628662109375 - _579;
    }
    return _595;
}

float _110(float _109)
{
    float _608 = abs(_109);
    float _605 = _107(_608);
    float _612;
    if (_109 < 0.0)
    {
        _612 = -_605;
    }
    else
    {
        _612 = _605;
    }
    return _612;
}

float _114(float _112, float _113)
{
    float _626 = _112 / _113;
    float _622 = _110(_626);
    if (_113 < 0.0)
    {
        _622 += ((_112 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _622;
}

void main()
{
    _1085 _1087 = _1085(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _1087._m15 = _1099;
    _1087._m16 = gl_FragCoord;
    _1087._m40 = (uint(_1108._m6.z) & 3u) << uint(4);
    _1087._m14 = _1120._m4.xyz + _1125.xyz;
    _1087._m13 = normalize(-_1125.xyz);
    _1087._m17 = mat3(vec3(_1137.xyz), vec3(_1140.xyz), vec3(_1143.xyz));
    _1087._m34 = _1161;
    _1087._m35 = _1165;
    _1087._m36 = _1169;
    uint _1172 = 0u;
    vec4 _1173 = vec4(0.0);
    vec4 _1174 = vec4(0.0);
    vec4 _1175 = vec4(0.0);
    vec4 _1176 = vec4(0.0);
    vec4 _1177 = vec4(0.0);
    _1087._m0 = _1175.xyz;
    _1087._m2 = _1176.xyz;
    _1087._m1 = _1174.xyz;
    _1087._m9 = _1173.xyz;
    _1087._m3 = _1173.w;
    _1087._m6 = _1177.wyz;
    vec2 _1197 = _1099.xy * _1202._m4.xy;
    vec2 _1209 = _1197;
    vec4 _1207 = _142(_1208, _1209);
    vec4 _1212 = vec4(0.07999999821186065673828125);
    vec4 _1215 = SAMPLE_TEXTURE(_1216, _1197);
    float _1220 = SAMPLE_TEXTURE(_1221, _1197).x;
    _1087._m0 = _1202._m5.xyz * _1207.xyz;
    float _1236 = _1207.w;
    _1087._m11 = _1202._m5.w * _60(_1236);
    _1087._m2 = _1212.xyz;
    _1087._m3 = _1220;
    _1087._m6 = _1215.xyz;
    uint _1250 = uint((_1108._m6.x > 0.0) ? 8 : 0);
    float _1256 = 16.0;
    float _1258 = 8.0;
    float _1260 = 24.0;
    vec2 _1269 = _1087._m16.xy * _1120._m6.xy;
    vec3 _1262;
    _1262 = vec3(_1269.x, _1269.y, _1262.z);
    _1262.y = 1.0 - _1262.y;
    
       // DECALS
    _1262.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1282 = floor(_1262.xy * vec2(_1256, _1258));
    _1262 = vec3(_1282.x, _1282.y, _1262.z);
    float _1287 = _1087._m16.z;
    vec4 _1290 = _1120._m7;
    float _1293 = 1.0;
    bool _1294 = false;
    float _1285 = _180(_1287, _1290, _1293, _1294);
    float _1296 = log2(max(1.0, _1285 / _1120._m8.z)) * _1120._m8.w;
    _1262.z = min(_1260 - 1.0, floor(_1296));
    uint _1312 = uint((_1262.x + (_1262.y * _1256)) + ((_1262.z * _1256) * _1258));
    _1312 = min(_1312, uint(((_1256 * _1258) * _1260) - 1.0));
    bool _1337 = true;
    vec3 _1339 = _1087._m6;
    bool _1342 = _1337;
    _1087._m7 = _185(_1339, _1342);
    vec3 _1346 = _1087._m7;
    mat3 _1349 = _1087._m17;
    _1087._m6 = _192(_1346, _1349);
    uint _1354 = 0u;
    uint _1355 = 0u;
    uint _1356 = 0u;
    uint _1357 = 0u;
    uint _1358 = 0u;
    uint _1359 = 0u;
    int _1361 = 256;
    _1363 _1365;
    _1365._m0 = _1370._m0[_1312]._m0;
    _1365._m1 = _1370._m0[_1312]._m1;
    int _1379 = _1365._m0 & (~(_1365._m0 >> 31));
    int _1388 = _1365._m1 & (~(_1365._m1 >> 31));
    _1354 = uint((_1379 >> 16) * _1361);
    _1355 = _1354 + uint(_1388 & 255);
    _1356 = _1354;
    _1357 = _1356 + uint((_1388 >> 8) & 255);
    _1358 = _1354;
    _1359 = _1358 + uint((_1388 >> 16) & 255);
    vec3 _1421 = dFdx(_1087._m14);
    vec3 _1425 = dFdy(_1087._m14);
    bool _1430 = _1250 == 0u;
    bool _1436;
    if (_1430)
    {
        _1436 = _1108._m6.y == 0.0;
    }
    else
    {
        _1436 = _1430;
    }
    _1356 = _1436 ? _1357 : _1356;
    uint _1440 = _1356;
    _1477 _1479;
    vec3 _1840;
    float _1944;
    while (_1440 < _1357)
    {
        uint _1450 = _1454._m0[_1440];
        uint _1459 = (_1450 >> uint(12)) & 4095u;
        uint _1465 = _1459;
        if (_1465 >= _1459)
        {
            _1440++;
        }
        int _1474 = 2;
        int _1475 = 2;
        int _1476 = 2;
        _1479._m0 = _1484._m0[(uint(_1474) * _1465) + 0u];
        _1479._m1 = _1484._m0[(uint(_1474) * _1465) + 1u];
        _1479._m2 = _1504._m0[(uint(_1475) * _1465) + 0u];
        float _1518 = _1504._m0[(uint(_1475) * _1465) + 1u].x;
        _1479._m3.x = _31(_1518);
        float _1528 = _1504._m0[(uint(_1475) * _1465) + 1u].y;
        _1479._m3.y = _31(_1528);
        float _1538 = _1504._m0[(uint(_1475) * _1465) + 1u].z;
        _1479._m4.x = _31(_1538);
        float _1548 = _1504._m0[(uint(_1475) * _1465) + 1u].w;
        _1479._m4.y = _31(_1548);
        float _1562 = _1556._m0[(uint(_1476) * _1465) + 0u].x;
        _1479._m5.x = _31(_1562);
        float _1572 = _1556._m0[(uint(_1476) * _1465) + 0u].y;
        _1479._m5.y = _31(_1572);
        float _1582 = _1556._m0[(uint(_1476) * _1465) + 0u].z;
        _1479._m6 = _31(_1582);
        float _1592 = _1556._m0[(uint(_1476) * _1465) + 0u].w;
        _1479._m7 = _31(_1592);
        float _1602 = _1556._m0[(uint(_1476) * _1465) + 1u].x;
        _1479._m8 = _31(_1602);
        float _1612 = _1556._m0[(uint(_1476) * _1465) + 1u].y;
        _1479._m9 = _31(_1612);
        float _1622 = _1556._m0[(uint(_1476) * _1465) + 1u].z;
        _1479._m10 = _31(_1622);
        float _1632 = _1556._m0[(uint(_1476) * _1465) + 1u].w;
        _1479._m11 = _31(_1632);
        vec4 _1637 = vec4(_1087._m14, 1.0);
        vec3 _1644 = vec3(dot(_1637, _1479._m0), dot(_1637, _1479._m1), dot(_1637, _1479._m2));
        float _1658 = 0.0039215688593685626983642578125;
        float _1660 = _1644.x;
        float _1663 = _1644.y;
        float _1666 = _1644.z;
        bool _1671 = _42(_1660, _1663, _1666) <= _1658;
        bool _1688;
        if (!_1671)
        {
            float _1675 = _1644.x;
            float _1678 = _1644.y;
            float _1681 = _1644.z;
            _1688 = _37(_1675, _1678, _1681) >= (1.0 - _1658);
        }
        else
        {
            _1688 = _1671;
        }
        if (_1688)
        {
            continue;
        }
        uint _1692 = _1479._m11;
        bool _1696 = _1250 != 0u;
        bool _1703;
        if (_1696)
        {
            _1703 = (_1692 & 1024u) != 0u;
        }
        else
        {
            _1703 = _1696;
        }
        bool _1716;
        if (!_1703)
        {
            bool _1708 = _1250 == 0u;
            bool _1715;
            if (_1708)
            {
                _1715 = (_1692 & 2048u) != 0u;
            }
            else
            {
                _1715 = _1708;
            }
            _1716 = _1715;
        }
        else
        {
            _1716 = _1703;
        }
        if (_1716)
        {
            continue;
        }
        vec3 _1720 = _1479._m0.xyz;
        vec3 _1724 = _1479._m1.xyz;
        vec3 _1728 = _1479._m2.xyz;
        vec2 _1732 = vec2(dot(_1421, _1720), dot(_1421, _1724));
        vec2 _1740 = vec2(dot(_1425, _1720), dot(_1425, _1724));
        float _1748 = 1.0;
        float _1749 = 1.0;
        vec3 _1750 = vec3(0.5, 0.5, 1.0);
        uint _1752 = _1479._m7;
        uint _1756 = _1479._m9;
        vec4 _1755 = _119(_1756);
        uvec2 _1761 = _1479._m5;
        vec4 _1760 = _132(_1761);
        vec2 _1765 = _1732 * _1760.xy;
        vec2 _1770 = _1740 * _1760.xy;
        vec4 _1775 = TEXTURE_GRAD(_1776, (_1644.xy * _1760.xy) + _1760.zw, _1765, _1770);
        _1748 = _1775.z;
        if ((_1752 & 64u) == 0u)
        {
            float _1799 = _1748 - 0.5;
            _26(_1799);
        }
        float _1801 = _1775.w;
        _1749 = _63(_1801);
        bool _1808 = _1749 <= (4.0 * _1658);
        bool _1815;
        if (_1808)
        {
            _1815 = _1755.w <= _1658;
        }
        else
        {
            _1815 = _1808;
        }
        if (_1815)
        {
            continue;
        }
        vec2 _1819 = (_1775.xy * 2.0) - vec2(1.0);
        float _1830 = 1.0 - dot(_1819, _1819);
        _1750 = vec3(_1819, sqrt(_10(_1830)));
        if ((_1692 & 256u) != 0u)
        {
            _1840 = vec3(-_1750.x, -_1750.y, _1750.z);
        }
        else
        {
            _1840 = _1750;
        }
        _1750 = _1840;
        uint _1855 = _1479._m8;
        uint _1859 = _1855;
        float _1858 = 1.0 + (_122(_1859).w * 0.062745101749897003173828125);
        uint _1867 = _1752;
        float _1866 = _119(_1867).z;
        float _1880 = _1858 - (_1858 * abs((_1644.z * 2.0) - 1.0));
        _1749 *= _10(_1880);
        if ((_1752 & 64u) != 0u)
        {
            uint _1890 = _1752;
            float _1889 = _119(_1890).x;
            uint _1895 = _1752;
            float _1894 = _122(_1895).y;
            float _1901 = _1889;
            float _1899 = mix(_1894, 0.0, _10(_1901));
            float _1910 = _1748 - (_1899 / 255.0);
            float _1905 = float(_10(_1910) > 0.0);
            _1749 *= _1905;
        }
        vec3 _1917 = normalize(vec3(_1087._m17[0].z, _1087._m17[1].z, _1087._m17[2].z));
        float _1926 = dot(_1917, normalize(_1728));
        float _1931 = _1926;
        vec2 _1936 = _1750.xy * _101(_1931);
        _1750 = vec3(_1936.x, _1936.y, _1750.z);
        if ((_1692 & 32768u) != 0u)
        {
            float _1949 = abs(_1926);
            _1944 = _10(_1949);
        }
        else
        {
            float _1952 = _1926;
            _1944 = _10(_1952);
        }
        float _1939 = _1944;
        float _1956 = _1749 * _1939;
        uint _1960 = _1479._m6;
        uint _1964 = _1960;
        vec4 _1969 = _119(_1964) * _1956;
        vec4 _1963 = _22(_1969);
        _1087._m11 = max(_1087._m11, _1963.x);
        _1720 += (_1917 * dot(_1720, _1917));
        _1724 += (_1917 * dot(_1724, _1917));
        _1750 = ((normalize(_1720) * _1750.x) + (normalize(_1724) * _1750.y)) + (_1917 * _1750.z);
        if ((_1692 & 512u) != 0u)
        {
            vec3 _2013 = mix(_1917, _1750, _1963.www);
            float _2019 = dot(_2013, _1917);
            _1750 = (_1087._m6 * _2019) + ((_2013 - (_1917 * _2019)) * dot(_1087._m6, _1917));
        }
        else
        {
            if ((_1692 & 128u) != 0u)
            {
                _1750 = mix(mix(_1087._m6, _1917, vec3(_1956)), _1750, _1963.www);
            }
            else
            {
                _1750 = mix(_1087._m6, _1750, _1963.www);
            }
        }
        _1087._m6 = normalize(_1750);
        uint _2066 = _1855;
        vec3 _2065 = _119(_2066).xyz;
        float _2070 = _1749;
        if ((_1752 & 1u) != 0u)
        {
            uvec2 _2078 = _1479._m3;
            vec4 _2077 = _132(_2078);
            vec2 _2082 = _1732 * _2077.xy;
            vec2 _2087 = _1740 * _2077.xy;
            vec4 _2092 = TEXTURE_GRAD(_1776, (_1644.xy * _2077.xy) + _2077.zw, _2082, _2087);
            vec4 _2105 = _2092;
            _2092 = _69(_2105);
            float _2115 = (_2092.w - _1658) / (1.0 - _1658);
            _2070 = _10(_2115);
            _2065 *= _2092.xyz;
        }
        _1087._m0 = mix(_1087._m0, _2065, _1963.xxx);
        float _2128 = ((_1939 * _2070) * _1755.w) * _1866;
        _1087._m10 += (_1755.xyz * (_2128 * 64.0));
        uint _2147 = _1479._m10;
        uint _2151 = _2147;
        vec4 _2150 = _119(_2151);
        float _2154 = 0.0;
        if ((_1752 & 10u) != 0u)
        {
            uvec2 _2162 = _1479._m4;
            vec4 _2161 = _132(_2162);
            vec2 _2166 = _1732 * _2161.xy;
            vec2 _2171 = _1740 * _2161.xy;
            vec4 _2176 = TEXTURE_GRAD(_1776, (_1644.xy * _2161.xy) + _2161.zw, _2166, _2171);
            if ((_1752 & 2u) != 0u)
            {
                _2150 = _2176 * _2176;
            }
            else
            {
                _2154 = _2176.w;
            }
        }
        _1087._m2 = mix(_1087._m2, _2150.xyz, _1963.yyy);
        _1087._m3 = mix(_1087._m3, _2150.w, _1963.z);
        _1087._m37 = max(_1087._m37, _2154);
        float _2228 = (_1748 - 0.5) * 2.0;
        _1087._m38 = max(_1087._m38, _10(_2228));
    }
    float _2233 = _1087._m37;
    float _2232 = _78(_2233);
    float _2240 = _2232 - 0.5;
    float _2237 = _10(_2240) * 2.0;
    float _2251 = _2232 * 2.0;
    float _2243 = (_1087._m38 * _1087._m38) * _10(_2251);
    float _2258 = _2243 + _2237;
    float _2254 = _10(_2258);
    if (_2254 > 0.0039215688593685626983642578125)
    {
        vec3 _2266 = _1087._m0;
        float _2273 = _2254 * 1.0;
        float _2274 = 0.0;
        float _2275 = 0.3499999940395355224609375;
        _1087._m0 = mix(_1087._m0, _75(_2266), vec3(_83(_2273, _2274, _2275) * (1.0 - _1087._m3)));
        float _2291 = _2254 * 1.0;
        float _2292 = 0.25;
        float _2293 = 0.5;
        _1087._m2 = mix(_1087._m2, vec3(0.039999999105930328369140625), vec3(_83(_2291, _2292, _2293)));
        vec3 _2298 = vec3(_1087._m17[0].z, _1087._m17[1].z, _1087._m17[2].z);
        float _2312 = _2298.z + 0.0625;
        float _2306 = _2254 * _10(_2312);
        float _2321 = _2306 * 1.0;
        float _2322 = 0.20000000298023223876953125;
        float _2323 = 1.0;
        _1087._m3 = mix(_1087._m3, 0.89999997615814208984375, _83(_2321, _2322, _2323));
        float _2332 = _2306 * 1.0;
        float _2333 = 0.449999988079071044921875;
        float _2334 = 0.980000019073486328125;
        float _2327 = _83(_2332, _2333, _2334);
        _1087._m6 = normalize(mix(_1087._m6, vec3(0.0, 0.0, 1.0), vec3(_2327)));
        _1087._m7 = mix(_1087._m6, vec3(0.5, 0.5, 1.0), vec3(_2327));
        if (_2306 > 0.980000019073486328125)
        {
            float _2357 = _2306 * _2327;
            float _2358 = 0.980000019073486328125;
            float _2359 = 1.0;
            _2298 = normalize(mix(_2298, vec3(0.0, 0.0, 1.0), vec3(_83(_2357, _2358, _2359))));
            _1087._m17[0].z = _2298.x;
            _1087._m17[1].z = _2298.y;
            _1087._m17[2].z = _2298.z;
        }
    }
    vec3 _2373 = vec3(0.0);
    vec3 _2374 = vec3(_1087._m34.x, _1087._m34.y, _1087._m34.z);
    vec3 _2382 = vec3(_1087._m34.w, _1087._m35.x, _1087._m35.y);
    vec3 _2390 = vec3(_1087._m35.z, _1087._m35.w, _1087._m36.x);
    vec3 _2398 = vec3(_1087._m36.y, _1087._m36.z, _1087._m36.w);
    vec3 _2406 = ((_2374 - (_2382 * _1087._m6.y)) + (_2390 * _1087._m6.z)) - (_2398 * _1087._m6.x);
    float _2429 = _1108._m7.x * _1120._m9.x;
    _2373 += max(_2406 * _10(_2429), vec3(0.0));
    float _2440;
    if (dot(_1087._m10, vec3(1.0)) > 0.0)
    {
        _2440 = -_1087._m3;
    }
    else
    {
        _2440 = _1087._m3;
    }
    _1087._m3 = _2440;
    _1087._m18 = _2373;
    _1087._m19 = _2373;
    float _2457 = 1.0;
    uint _2458 = _1358;
    _2488 _2490;
    while (_2458 < _1359)
    {
        uint _2468 = _1454._m0[_2458];
        uint _2472 = (_2468 >> uint(24)) & 4095u;
        uint _2476 = _2472;
        if (_2476 >= _2472)
        {
            _2458++;
        }
        int _2485 = 4;
        int _2486 = 4;
        int _2487 = 4;
        _2490._m0 = _2494._m0[(uint(_2485) * _2476) + 0u].xyz;
        float _2509 = _2494._m0[(uint(_2485) * _2476) + 0u].w;
        _2490._m1 = _31(_2509);
        _2490._m2 = _2494._m0[(uint(_2485) * _2476) + 1u];
        _2490._m3 = _2494._m0[(uint(_2485) * _2476) + 2u];
        _2490._m4 = _2533._m0[(uint(_2486) * _2476) + 0u];
        _2490._m5 = _2533._m0[(uint(_2486) * _2476) + 1u];
        _2490._m6 = _2533._m0[(uint(_2486) * _2476) + 2u];
        float _2563 = _2494._m0[(uint(_2485) * _2476) + 3u].x;
        _2490._m7.x = _31(_2563);
        float _2573 = _2494._m0[(uint(_2485) * _2476) + 3u].y;
        _2490._m7.y = _31(_2573);
        float _2583 = _2494._m0[(uint(_2485) * _2476) + 3u].z;
        _2490._m7.z = _31(_2583);
        float _2593 = _2494._m0[(uint(_2485) * _2476) + 3u].w;
        _2490._m7.w = _31(_2593);
        _2490._m8 = _2601._m0[(uint(_2487) * _2476) + 0u];
        _2490._m9 = _2601._m0[(uint(_2487) * _2476) + 1u];
        _2490._m10 = _2601._m0[(uint(_2487) * _2476) + 2u];
        _2490._m11 = _2601._m0[(uint(_2487) * _2476) + 3u];
        float _2639 = _2533._m0[(uint(_2486) * _2476) + 3u].x;
        _2490._m12 = _31(_2639);
        float _2649 = _2533._m0[(uint(_2486) * _2476) + 3u].y;
        _2490._m13 = _31(_2649);
        _2490._m14 = _2533._m0[(uint(_2486) * _2476) + 3u].z;
        float _2667 = _2533._m0[(uint(_2486) * _2476) + 3u].w;
        _2490._m15 = _31(_2667);
        uint _2672 = (_2490._m12 >> uint(16)) & 3u;
        if (((_1087._m40 >> uint(4)) & 3u) != _2672)
        {
            continue;
        }
        vec3 _2686 = vec3((_1087._m14.x * _2490._m4.x) + ((_1087._m14.y * _2490._m4.y) + ((_1087._m14.z * _2490._m4.z) + _2490._m4.w)), (_1087._m14.x * _2490._m5.x) + ((_1087._m14.y * _2490._m5.y) + ((_1087._m14.z * _2490._m5.z) + _2490._m5.w)), (_1087._m14.x * _2490._m6.x) + ((_1087._m14.y * _2490._m6.y) + ((_1087._m14.z * _2490._m6.z) + _2490._m6.w)));
        vec2 _2753 = _2686.xy / vec2(_2686.z);
        _2686 = vec3(_2753.x, _2753.y, _2686.z);
        _2686.z = (_1087._m14.x * _2490._m3.x) + ((_1087._m14.y * _2490._m3.y) + ((_1087._m14.z * _2490._m3.z) + _2490._m3.w));
        float _2777 = 0.0039215688593685626983642578125;
        float _2778 = _2686.x;
        float _2781 = _2686.y;
        float _2784 = _2686.z;
        bool _2789 = _42(_2778, _2781, _2784) < _2777;
        bool _2806;
        if (!_2789)
        {
            float _2793 = _2686.x;
            float _2796 = _2686.y;
            float _2799 = _2686.z;
            _2806 = _37(_2793, _2796, _2799) >= (1.0 - _2777);
        }
        else
        {
            _2806 = _2789;
        }
        if (_2806)
        {
            continue;
        }
        uint _2810 = _2490._m1;
        uint _2814 = _2490._m13;
        vec3 _2813 = _145(_2814);
        float _2818 = _2490._m14;
        vec3 _2821 = _2490._m0;
        if (_2490._m9.w == 0.0)
        {
            if (dot(_2490._m11.xyz, _1087._m14) < (_2490._m11.w - _2777))
            {
                continue;
            }
        }
        else
        {
            if (_2490._m9.w == 1.0)
            {
                float _2850 = _2490._m11.w;
                uint _2854 = _31(_2850);
                vec3 _2849 = (((_126(_2854) * 2.0) - vec3(1.0)) * _2490._m11.xyz) + _2821;
                vec3 _2865 = abs(_1087._m14 - _2849) / _2490._m11.xyz;
                float _2875 = _2865.x;
                float _2878 = _2865.y;
                float _2881 = _2865.z;
                if (_37(_2875, _2878, _2881) > 1.0)
                {
                    continue;
                }
            }
        }
        uint _2890 = _2810;
        float _2889 = _119(_2890).y;
        vec3 _2894 = (_2686 * 2.0) - vec3(1.0);
        vec3 _2898 = _2894 * sqrt(((vec3(1.0) - ((_2894.yzx * _2894.yzx) * 0.5)) - ((_2894.zxy * _2894.zxy) * 0.5)) + ((((_2894.yzx * _2894.yzx) * _2894.zxy) * _2894.zxy) / vec3(3.0)));
        float _2942 = 1.0 - ((length(_2898) - _2889) / ((1.0 - _2889) + 9.9999999747524270787835121154785e-07));
        float _2931 = _10(_2942);
        _2931 *= _2931;
        _2931 *= (_2490._m8.w * _2457);
        _2457 *= (1.0 - _2931);
        if (_2931 <= (_2777 * 4.0))
        {
            continue;
        }
        vec3 _2964 = _2813;
        uint _2967 = _2810;
        float _2966 = _122(_2967).z;
        vec3 _2971 = vec3(0.0);
        vec3 _2972 = vec3(0.0);
        vec3 _2973 = _1087._m6;
        _2973.x = dot(_2490._m2.xy, _1087._m6.xy);
        _2973.y = dot(_2490._m2.zw, _1087._m6.xy);
        vec3 _2992 = reflect(-_1087._m13, _1087._m6);
        vec3 _2999 = (_2490._m9.xyz - _1087._m14) / _2992;
        vec3 _3008 = (_2490._m8.xyz - _1087._m14) / _2992;
        vec3 _3017 = max(_2999, _3008);
        float _3022 = _3017.x;
        float _3025 = _3017.y;
        float _3028 = _3017.z;
        float _3021 = _42(_3022, _3025, _3028);
        vec3 _3032 = _1087._m14 + (_2992 * _3021);
        vec3 _3039 = normalize(_3032 - _2821);
        vec3 _3044 = _3039;
        _3044.x = dot(_2490._m2.xy, _3039.xy);
        _3044.y = dot(_2490._m2.zw, _3039.xy);
        float _3066 = dot(_1087._m13, _1087._m6);
        float _3060 = _10(_3066);
        float _3068 = 0.0;
        float _3069 = 6.0;
        float _3071 = max(_3068, _3069 - (_3069 * abs(_1087._m3)));
        _2972 = textureLod(_3084, vec4(_3044, _2966), _3071).xyz * _2818;
        float _3101 = _3060;
        float _3103 = abs(_1087._m3);
        vec3 _3104 = _1087._m2;
        vec3 _3097 = _171(_3101, _3103, _3104);
        _2972 *= _3097;
        float _3115 = _2931;
        _1087._m27 += ((_2972 * _2964) * _10(_3115));
        if (_2457 <= (_2777 * 4.0))
        {
            break;
        }
    }
    uint _3130 = _1354;
    _2488 _3159;
    vec3 _3465;
    float _3542;
    float _3560;
    uint _3905;
    _3931 _3933;
    uint _4055;
    _3931 _4079;
    vec3 _4553;
    vec3 _4566;
    while (_3130 < _1355)
    {
        uint _3140 = _1454._m0[_3130];
        uint _3144 = _3140 & 4095u;
        uint _3147 = _3144;
        if (_3147 >= _3144)
        {
            _3130++;
        }
        int _3156 = 4;
        int _3157 = 4;
        int _3158 = 4;
        _3159._m0 = _2494._m0[(uint(_3156) * _3147) + 0u].xyz;
        float _3174 = _2494._m0[(uint(_3156) * _3147) + 0u].w;
        _3159._m1 = _31(_3174);
        _3159._m2 = _2494._m0[(uint(_3156) * _3147) + 1u];
        _3159._m3 = _2494._m0[(uint(_3156) * _3147) + 2u];
        _3159._m4 = _2533._m0[(uint(_3157) * _3147) + 0u];
        _3159._m5 = _2533._m0[(uint(_3157) * _3147) + 1u];
        _3159._m6 = _2533._m0[(uint(_3157) * _3147) + 2u];
        float _3224 = _2494._m0[(uint(_3156) * _3147) + 3u].x;
        _3159._m7.x = _31(_3224);
        float _3234 = _2494._m0[(uint(_3156) * _3147) + 3u].y;
        _3159._m7.y = _31(_3234);
        float _3244 = _2494._m0[(uint(_3156) * _3147) + 3u].z;
        _3159._m7.z = _31(_3244);
        float _3254 = _2494._m0[(uint(_3156) * _3147) + 3u].w;
        _3159._m7.w = _31(_3254);
        _3159._m8 = _2601._m0[(uint(_3158) * _3147) + 0u];
        _3159._m9 = _2601._m0[(uint(_3158) * _3147) + 1u];
        _3159._m10 = _2601._m0[(uint(_3158) * _3147) + 2u];
        _3159._m11 = _2601._m0[(uint(_3158) * _3147) + 3u];
        float _3296 = _2533._m0[(uint(_3157) * _3147) + 3u].x;
        _3159._m12 = _31(_3296);
        float _3306 = _2533._m0[(uint(_3157) * _3147) + 3u].y;
        _3159._m13 = _31(_3306);
        _3159._m14 = _2533._m0[(uint(_3157) * _3147) + 3u].z;
        float _3324 = _2533._m0[(uint(_3157) * _3147) + 3u].w;
        _3159._m15 = _31(_3324);
        uint _3329 = (_3159._m12 >> uint(16)) & 3u;
        if (((_1087._m40 >> uint(4)) & 3u) != _3329)
        {
            continue;
        }
        float _3343 = 0.0039215688593685626983642578125;
        vec4 _3344 = vec4(_1087._m14, 1.0);
        float _3351 = 1.0 / dot(_3344, _3159._m6);
        vec3 _3357 = vec3(dot(_3344, _3159._m4) * _3351, dot(_3344, _3159._m5) * _3351, dot(_3344, _3159._m3));
        uint _3375 = _3159._m1;
        uint _3378 = _1250;
        _3378 |= 64u;
        float _3382 = _3357.x;
        float _3385 = _3357.y;
        float _3388 = _3357.z;
        bool _3393 = _42(_3382, _3385, _3388) <= _3343;
        bool _3410;
        if (!_3393)
        {
            float _3397 = _3357.x;
            float _3400 = _3357.y;
            float _3403 = _3357.z;
            _3410 = _37(_3397, _3400, _3403) >= (1.0 - _3343);
        }
        else
        {
            _3410 = _3393;
        }
        bool _3418;
        if (!_3410)
        {
            _3418 = (_3375 & _3378) != 0u;
        }
        else
        {
            _3418 = _3410;
        }
        if (_3418)
        {
            continue;
        }
        if ((_3375 & 3u) == 2u)
        {
            vec2 _3437 = fract((_3357.xy * _1120._m10.xy) + _1120._m10.zw);
            _3357 = vec3(_3437.x, _3437.y, _3357.z);
        }
        vec3 _3440 = _3159._m0;
        float _3443 = 1.0;
        float _3444 = 1.0;
        vec3 _3445 = vec3(0.0, 0.0, 1.0);
        vec3 _3446 = vec3(0.0, 0.0, 1.0);
        uint _3447 = _3159._m1;
        vec3 _3450 = (_3357 * 2.0) - vec3(1.0);
        vec2 _3455 = _3357.xy;
        vec3 _3458 = _3159._m10.xyz;
        if ((_3447 & 3u) == 2u)
        {
            _3465 = _3458;
        }
        else
        {
            _3465 = normalize(_3440 - _1087._m14);
        }
        _3445 = _3465;
        _3445 = _3445;
        float _3482 = dot(_1087._m6, _3445);
        float _3477 = _10(_3482);
        uvec2 _3485 = _3159._m7.zw;
        vec4 _3484 = _132(_3485);
        float _3491 = TEXTURE_LOD(_3492, vec4((_3455 * _3484.xy) + _3484.zw, 0.0, 0.0).xy, vec4((_3455 * _3484.xy) + _3484.zw, 0.0, 0.0).w).x;
        float _3518 = _3491 * _3491;
        uint _3522 = _3447 & 3u;
        bool _3527 = _3522 == 1u;
        bool _3539;
        if (!_3527)
        {
            bool _3532 = _3522 == 0u;
            bool _3538;
            if (_3532)
            {
                _3538 = _3159._m8.z != 0.0;
            }
            else
            {
                _3538 = _3532;
            }
            _3539 = _3538;
        }
        else
        {
            _3539 = _3527;
        }
        bool _3525 = _3539;
        if (_3525)
        {
            float _3545 = _3159._m8.w;
            _3542 = _10(_3545);
        }
        else
        {
            _3542 = 0.5;
        }
        float _3540 = _3542;
        bool _3553 = _3522 == 0u;
        bool _3559;
        if (_3553)
        {
            _3559 = _3159._m8.z != 0.0;
        }
        else
        {
            _3559 = _3553;
        }
        if (_3559)
        {
            float _3568 = sqrt(dot(_3450, _3450));
            _3560 = min(0.9921875, _10(_3568));
        }
        else
        {
            _3560 = _3357.z;
        }
        float _3551 = _3560;
        uvec2 _3576 = _3159._m7.xy;
        vec4 _3575 = _132(_3576);
        vec2 _3581 = vec2(_3551, _3540);
        float _3585 = TEXTURE_LOD(_3492, vec4((_3581 * _3575.xy) + _3575.zw, 0.0, 0.0).xy, vec4((_3581 * _3575.xy) + _3575.zw, 0.0, 0.0).w).x;
        _3585 *= _3585;
        _3443 = _3585 * _3518;
        if ((_3447 & 48u) != 0u)
        {
            vec4 _3623 = _3159._m10;
            vec4 _3626 = _3159._m8;
            vec4 _3629 = _3159._m9;
            float _3632 = dot(_1087._m14, _3623.xyz) + _3623.w;
            if (_3632 < 0.0)
            {
                continue;
            }
            float _3646 = length(_3623.xyz);
            float _3653 = _3632 * 50.0;
            float _3650 = _10(_3653);
            _3443 *= (_3650 * _3650);
            _3632 /= _3646;
            _3623 /= vec4(_3646);
            vec3 _3667 = reflect(-_1087._m13, _1087._m6);
            if (dot(_3667, _3623.xyz) > 0.0)
            {
                _3667 = reflect(_3667, _3623.xyz);
            }
            float _3685 = dot(_3667, _3623.xyz);
            float _3690 = _3632 / _3685;
            vec3 _3694 = _1087._m14 - (_3667 * _3690);
            vec3 _3701 = _3694 - _3440;
            float _3705 = dot(_3701, _3626.xyz) / _3626.w;
            float _3713 = dot(_3701, _3629.xyz) / _3629.w;
            if ((_3447 & 48u) == 32u)
            {
                vec2 _3727 = vec2(_3705, _3713);
                float _3731 = 1.0 / max(1.0, length(vec2(_3705, _3713)));
                _3705 *= (_3731 * _3626.w);
                _3713 *= (_3731 * _3629.w);
            }
            else
            {
                float _3753 = abs(_3705);
                float _3755 = _3705;
                _3705 = (_10(_3753) * _101(_3755)) * _3626.w;
                float _3764 = abs(_3713);
                float _3766 = _3713;
                _3713 = (_10(_3764) * _101(_3766)) * _3629.w;
            }
            vec3 _3773 = (_3626.xyz * _3705) + (_3629.xyz * _3713);
            _3440 += _3773;
            _3445 = normalize(_3440 - _1087._m14);
            _3445 = _3445;
        }
        else
        {
            uint _3793 = (_3159._m15 >> uint(16)) & 255u;
            if (_3793 == 0u)
            {
                vec4 _3802 = _3159._m9;
                if (dot(_3802.xyz, _1087._m14) < (_3802.w - _3343))
                {
                    continue;
                }
            }
            else
            {
                if (_3793 == 1u)
                {
                    vec3 _3823 = _3159._m9.xyz;
                    float _3828 = _3159._m9.w;
                    uint _3832 = _31(_3828);
                    vec3 _3827 = (((_126(_3832) * 2.0) - vec3(1.0)) * _3823) + _3440;
                    vec3 _3841 = abs((_1087._m14 - _3827) / _3823);
                    float _3849 = _3841.x;
                    float _3852 = _3841.y;
                    float _3855 = _3841.z;
                    if (_37(_3849, _3852, _3855) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3443 <= (_3343 / 256.0))
        {
            continue;
        }
        float _3871 = 1.0;
        if ((_3375 & 4u) != 0u)
        {
            float _3878 = float(_3159._m15 & 255u) / 255.0;
            float _3884 = 0.00999999977648258209228515625;
            vec3 _3886 = _1087._m14 + (_1087._m6 * _3884);
            if ((_3375 & 3u) == 0u)
            {
                vec3 _3899 = _3886 - _3159._m2.xyz;
                float _3906 = _3899.x;
                float _3909 = _3899.y;
                float _3912 = _3899.z;
                _3905 = _48(_3906, _3909, _3912);
            }
            else
            {
                if ((_3375 & 3u) == 2u)
                {
                    float _3922 = 0.0;
                    _3905 = 0u;
                    for (; _3905 < 3u; _3905++)
                    {
                        int _3930 = 5;
                        _3933._m0 = _3937._m0[(uint(_3930) * ((_3375 >> uint(22)) + _3905)) + 0u];
                        _3933._m1 = _3937._m0[(uint(_3930) * ((_3375 >> uint(22)) + _3905)) + 1u];
                        _3933._m2 = _3937._m0[(uint(_3930) * ((_3375 >> uint(22)) + _3905)) + 2u];
                        _3933._m3 = _3937._m0[(uint(_3930) * ((_3375 >> uint(22)) + _3905)) + 3u];
                        _3933._m4 = _3937._m0[(uint(_3930) * ((_3375 >> uint(22)) + _3905)) + 4u];
                        vec2 _3994 = vec2(dot(_3886, _3933._m0.xyz) + _3933._m0.w, dot(_3886, _3933._m1.xyz) + _3933._m1.w);
                        _3994 = abs((_3994 * 2.0) - vec2(1.0));
                        bool _4020 = _3994.x < 0.99500000476837158203125;
                        bool _4026;
                        if (_4020)
                        {
                            _4026 = _3994.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _4026 = _4020;
                        }
                        if (_4026)
                        {
                            _3922 = (1.0 - max(_3994.x, _3994.y)) * _1120._m11.w;
                            break;
                        }
                    }
                    _3905 = min(2u, _3905);
                    uint _4043 = uint(_1087._m16.x) ^ (uint(_1087._m16.y) << uint(1));
                    if (_1120._m12.w > 0.0)
                    {
                        _4055 = uint(_1120._m13.x);
                    }
                    else
                    {
                        _4055 = 0u;
                    }
                    _4043 ^= _4055;
                    _3905 += uint(int(((float(_4043 & 3u) * 0.25) + 0.125) > _3922));
                }
                else
                {
                    _3905 = 0u;
                }
            }
            int _4078 = 5;
            _4079._m0 = _3937._m0[(uint(_4078) * ((_3375 >> uint(22)) + _3905)) + 0u];
            _4079._m1 = _3937._m0[(uint(_4078) * ((_3375 >> uint(22)) + _3905)) + 1u];
            _4079._m2 = _3937._m0[(uint(_4078) * ((_3375 >> uint(22)) + _3905)) + 2u];
            _4079._m3 = _3937._m0[(uint(_4078) * ((_3375 >> uint(22)) + _3905)) + 3u];
            _4079._m4 = _3937._m0[(uint(_4078) * ((_3375 >> uint(22)) + _3905)) + 4u];
            vec4 _4135 = vec4((_3886.x * _4079._m0.x) + ((_3886.y * _4079._m0.y) + ((_3886.z * _4079._m0.z) + _4079._m0.w)), (_3886.x * _4079._m1.x) + ((_3886.y * _4079._m1.y) + ((_3886.z * _4079._m1.z) + _4079._m1.w)), (_3886.x * _4079._m2.x) + ((_3886.y * _4079._m2.y) + ((_3886.z * _4079._m2.z) + _4079._m2.w)), (_3886.x * _4079._m3.x) + ((_3886.y * _4079._m3.y) + ((_3886.z * _4079._m3.z) + _4079._m3.w)));
            vec3 _4222 = _4135.xyz / vec3(_4135.w);
            _4135 = vec4(_4222.x, _4222.y, _4222.z, _4135.w);
            bool _4230 = min(_4135.x, _4135.y) > 0.0;
            bool _4239;
            if (_4230)
            {
                _4239 = max(_4135.x, _4135.y) < 1.0;
            }
            else
            {
                _4239 = _4230;
            }
            if (_4239)
            {
                vec2 _4251 = (_4135.xy * _4079._m4.xy) + _4079._m4.zw;
                _4135 = vec4(_4251.x, _4251.y, _4135.z, _4135.w);
                if (false)
                {
                    _3871 = textureLod(_4259, vec3(_4135.xyz.xy, _4135.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4266 = (_4135.xy * _1120._m14.xy) + vec2(0.5);
                    vec2 _4275 = floor(_4266);
                    vec2 _4278 = _4266 - _4275;
                    _4275 -= vec2(0.5);
                    vec2 _4285 = vec2(4.0) - (_4278 * 3.0);
                    vec2 _4290 = vec2(7.0);
                    vec2 _4293 = vec2(1.0) + (_4278 * 3.0);
                    vec2 _4298 = (_4275 + (((vec2(3.0) - (_4278 * 2.0)) / _4285) - vec2(2.0))) * _1120._m14.zw;
                    vec2 _4313 = (_4275 + ((vec2(3.0) + _4278) / _4290)) * _1120._m14.zw;
                    vec2 _4325 = (_4275 + ((_4278 / _4293) + vec2(2.0))) * _1120._m14.zw;
                    vec3 _4349 = vec3(_4298.x, _4298.y, _4135.z);
                    _3871 = (_4285.x * _4285.y) * textureLod(_4259, vec3(_4349.xy, _4349.z), 0.0);
                    vec3 _4365 = vec3(_4313.x, _4298.y, _4135.z);
                    _3871 += ((_4290.x * _4285.y) * textureLod(_4259, vec3(_4365.xy, _4365.z), 0.0));
                    vec3 _4383 = vec3(_4325.x, _4298.y, _4135.z);
                    _3871 += ((_4293.x * _4285.y) * textureLod(_4259, vec3(_4383.xy, _4383.z), 0.0));
                    vec3 _4401 = vec3(_4298.x, _4313.y, _4135.z);
                    _3871 += ((_4285.x * _4290.y) * textureLod(_4259, vec3(_4401.xy, _4401.z), 0.0));
                    vec3 _4419 = vec3(_4313.x, _4313.y, _4135.z);
                    _3871 += ((_4290.x * _4290.y) * textureLod(_4259, vec3(_4419.xy, _4419.z), 0.0));
                    vec3 _4437 = vec3(_4325.x, _4313.y, _4135.z);
                    _3871 += ((_4293.x * _4290.y) * textureLod(_4259, vec3(_4437.xy, _4437.z), 0.0));
                    vec3 _4455 = vec3(_4298.x, _4325.y, _4135.z);
                    _3871 += ((_4285.x * _4293.y) * textureLod(_4259, vec3(_4455.xy, _4455.z), 0.0));
                    vec3 _4473 = vec3(_4313.x, _4325.y, _4135.z);
                    _3871 += ((_4290.x * _4293.y) * textureLod(_4259, vec3(_4473.xy, _4473.z), 0.0));
                    vec3 _4491 = vec3(_4325.x, _4325.y, _4135.z);
                    _3871 += ((_4293.x * _4293.y) * textureLod(_4259, vec3(_4491.xy, _4491.z), 0.0));
                    _3871 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3871 = float((_3375 & 3u) == 2u);
            }
            float _4505 = float((_3375 >> uint(16)) & 63u) / 63.0;
            float _4519 = ((_3871 * _4505) + 1.0) - _4505;
            _3871 = _10(_4519);
        }
        uint _4522 = _3159._m13;
        vec3 _4521 = (_145(_4522) * _3871) * _3443;
        _3444 *= _3159._m14;
        vec3 _4534 = _4521;
        vec3 _4536 = normalize(_3440 - _1087._m14);
        float _4542 = dot(_1087._m6, _4536);
        float _4548 = _4542;
        float _4547 = _101(_4548);
        if (_4547 >= 0.0)
        {
            _4553 = _4536;
        }
        else
        {
            _4553 = reflect(_4536, _1087._m6);
        }
        _4536 = _4553;
        if (_4547 >= 0.0)
        {
            _4566 = vec3(1.0);
        }
        else
        {
            _4566 = _1087._m0;
        }
        vec3 _4563 = _4566;
        float _4577 = dot(_1087._m6, _4536);
        float _4579 = _4542;
        _4542 = mix(_10(_4577), _10(_4579), _1087._m11);
        _1087._m19 += (_4534 * _4542);
        vec3 _4593 = _1087._m6;
        vec3 _4596 = _1087._m13;
        vec3 _4599 = _4536;
        vec3 _4601 = _1087._m2;
        float _4604 = _1087._m3;
        vec3 _4592 = _158(_4593, _4596, _4599, _4601, _4604);
        vec3 _4608 = ((((_4534 * _4542) * _4592) * _3444) * _4563) + _1087._m20;
        vec3 _4622 = vec3(40.0);
        _1087._m20 = min(_4608, _4622);
    }
    float _4629 = _1120._m15.x;
    if (_4629 > 0.00999999977648258209228515625)
    {
        float _4636 = float(int(_1120._m13.x) & 1023) / 1023.0;
        _4629 = max(0.0, _4629 + (((_4636 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4652 = _1087._m13;
        float _4660 = dot(_1087._m6, _4652);
        float _4655 = _10(_4660);
        float _4662 = _4655 * _4629;
        vec3 _4670 = _1087._m6;
        vec3 _4673 = _1087._m13;
        vec3 _4676 = _1087._m2;
        float _4679 = abs(_1087._m3);
        vec3 _4666 = _165(_4670, _4673, _4676, _4679) * _4629;
        _1087._m19 += vec3(_4662);
        _1087._m20 += vec3(_4666);
    }
    _1087._m19 = _1087._m19;
    _1087._m20 += _1087._m10;
    _1087._m19 *= _1087._m0;
    _1087._m21 = _1087._m19 + _1087._m20;
    if (_1120._m16.x > 0.0)
    {
        bool _4724 = gl_FrontFacing;
        vec3 _4730;
        if (_4724)
        {
            _4730 = _1087._m6;
        }
        else
        {
            _4730 = -_1087._m6;
        }
        vec3 _4739 = _4730;
        bool _4741 = false;
        vec2 _4742 = _201(_4739, _4741);
        vec2 _4728 = _4742;
        float _4744 = gl_FragCoord.z;
        vec4 _4748 = _1120._m7;
        float _4751 = 1.0;
        bool _4752 = false;
        float _4743 = _180(_4744, _4748, _4751, _4752);
        _4755 = vec4(_4728, _4743 * 0.00999999977648258209228515625, 1.0);
        vec2 _4762 = gl_FragCoord.xy * _1120._m6.zw;
        vec4 _4769 = TEXTURE_LOD(_4770, vec4(_4762, 0.0, 0.0).xy, vec4(_4762, 0.0, 0.0).w) + TEXTURE_LOD(_4783, vec4(_4762, 0.0, 0.0).xy, vec4(_4762, 0.0, 0.0).w);
        vec3 _4805 = mix(_1087._m27, _4769.xyz, vec3(min(_4769.w, 1.0)));
        _4769 = vec4(_4805.x, _4805.y, _4805.z, _4769.w);
        _1087._m20 += _4769.xyz;
    }
    float _4815 = _1087._m16.z;
    vec4 _4818 = _1120._m7;
    float _4821 = 1.0;
    bool _4822 = false;
    float _4814 = _180(_4815, _4818, _4821, _4822);
    float _4824 = 1.0;
    if (_1202._m6.y > 0.0)
    {
        float _4830 = max(0.0, _4814 - _1202._m6.x);
        _4824 = 1.0 - min(1.0, _4830 / _1202._m6.y);
    }
    float _4842 = 0.0;
    if (_1202._m6.w > 0.0)
    {
        float _4848 = max(0.0, _4814 - _1202._m6.z);
        _4842 = min(1.0, _4848 / _1202._m6.w);
    }
    float _4859 = 0.89999997615814208984375;
    float _4860 = 0.0076199998147785663604736328125 * _4824;
    vec3 _4864 = normalize(refract(_1087._m6, -_1087._m13, _4859));
    vec3 _4909 = _1087._m14 + (_4864 * _4860);
    mat4 _4910 = mat4(vec4(_1120._m17), vec4(_1120._m18), vec4(_1120._m19), vec4(_1120._m20));
    vec4 _4873 = _90(_4909, _4910);
    // FIX FOR GLASS    
    _4873.x += vk3d_params[VIEW].stereo.x * (_4873.w - vk3d_params[VIEW].stereo.y)* 0.5;
    vec2 _4917 = _4873.xy / vec2(_4873.w);

    _4873 = vec4(_4917.x, _4917.y, _4873.z, _4873.w);
    float _4920 = mix(min(_1087._m3, 0.99989998340606689453125), 1.0, _4842);
    float _4927 = fract(_4920 * 4.0);
    vec3 _4931 = vec3(0.0);
    if (_4920 > 0.97500002384185791015625)
    {
        _4931 = TEXTURE_LOD(_4937, vec4(_4873.xy, 0.0, 0.0).xy, vec4(_4873.xy, 0.0, 0.0).w).xyz;
    }
    else
    {
        if (_4920 > 0.75)
        {
            _4931 = mix(TEXTURE_LOD(_4959, vec4(_4873.xy, 0.0, 0.0).xy, vec4(_4873.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4937, vec4(_4873.xy, 0.0, 0.0).xy, vec4(_4873.xy, 0.0, 0.0).w).xyz, vec3(_4927));
        }
        else
        {
            if (_4920 > 0.5)
            {
                _4931 = mix(TEXTURE_LOD(_4998, vec4(_4873.xy, 0.0, 0.0).xy, vec4(_4873.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4959, vec4(_4873.xy, 0.0, 0.0).xy, vec4(_4873.xy, 0.0, 0.0).w).xyz, vec3(_4927));
            }
            else
            {
                if (_4920 > 0.25)
                {
                    _4931 = mix(TEXTURE_LOD(_5037, vec4(_4873.xy, 0.0, 0.0).xy, vec4(_4873.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4998, vec4(_4873.xy, 0.0, 0.0).xy, vec4(_4873.xy, 0.0, 0.0).w).xyz, vec3(_4927));
                }
                else
                {
                    _4931 = mix(TEXTURE_LOD(_5072, vec4(_4873.xy, 0.0, 0.0).xy, vec4(_4873.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_5037, vec4(_4873.xy, 0.0, 0.0).xy, vec4(_4873.xy, 0.0, 0.0).w).xyz, vec3(_4927));
                }
            }
        }
    }
    _1087._m21 = mix(_1087._m0 * _4931, _1087._m19, vec3(_1087._m11)) + _1087._m20;
    _5120 = vec4(_1087._m21, _1087._m11);
    vec2 _5129 = _1087._m16.xy * _1120._m6.zw;
    float _5137 = _1087._m16.z;
    vec4 _5140 = vec4(0.0);
    float _5141 = 1.0;
    float _5143 = _1120._m21.w;
    uint _5142 = _31(_5143);
    if ((_5142 & 6u) != 0u)
    {
        vec2 _5153 = _5129 + vec2(0.0);
        vec3 _5157 = _1120._m22.xyz;
        float _5161 = 0.100000001490116119384765625;
        float _5163 = _1120._m23.y;
        float _5167 = _1120._m22.z;
        float _5170 = 0.0;
        float _5172 = _5137;
        vec4 _5174 = _1120._m7;
        float _5177 = 1.0;
        bool _5178 = false;
        float _5171 = _180(_5172, _5174, _5177, _5178);
        _5170 = pow(max(0.0, (_5171 - _5161) / (_5163 - _5161)), 0.5);
        _5170 = (_5170 * (_5167 - 1.0)) / _5167;
        vec4 _5195 = vec4(_5153, _5170, 0.0);
        
        // Correction for Volumetrics on Glass - colour inversion
        _5195.x -= vk3d_params[VIEW].stereo.x* 0.5;
        
        vec3 _5221 = textureLod(_5204, vec4(_5195.xyz, 0.0).xyz, vec4(_5195.xyz, 0.0).w).xyz;
        _5140 = vec4(_5221.x, _5221.y, _5221.z, _5140.w);
        vec2 _5224 = textureLod(_5225, vec4(_5195.xyz, 0.0).xyz, vec4(_5195.xyz, 0.0).w).xy;
        _5140.w = _5224.x;
        _5141 = _5224.y;
    }
    if ((_5142 & 2u) != 0u)
    {
        vec4 _5253 = vec4(0.0);
        vec3 _5254 = _1120._m4.xyz;
        float _5259 = _5137;
        vec4 _5261 = _1120._m7;
        float _5264 = 1.0;
        bool _5265 = false;
        float _5258 = _180(_5259, _5261, _5264, _5265);
        vec3 _5267 = mix(_1120._m24.xyz, _1120._m25.xyz, vec3(_5129.x * _1120._m26.z));
        vec3 _5283 = mix(_1120._m27.xyz, _1120._m28.xyz, vec3(_5129.x * _1120._m26.z));
        vec3 _5298 = mix(_5283, _5267, vec3(1.0 - (_5129.y * _1120._m26.w)));
        vec4 _5309 = vec4(0.0);
        vec3 _5310 = normalize(_5298);
        float _5313 = _5310.z;
        _5309.x = clamp(_104(_5313) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _5322 = _5310.y;
        float _5325 = _5310.x;
        _5309.y = _114(_5322, _5325) / 6.283185482025146484375;
        _5309.z = sqrt(_5258 * _1120._m29.w);
        _5309.z = clamp(_5309.z, 0.015625, 0.984375);
        vec3 _5352 = textureLod(_5345, _5309.xyz, _5309.w).xyz;
        _5253 = vec4(_5352.x, _5352.y, _5352.z, _5253.w);
        vec3 _5361 = _5120.xyz + (_5253.xyz * _5141);
        _5120 = vec4(_5361.x, _5361.y, _5361.z, _5120.w);
    }
    if ((_5142 & 4u) != 0u)
    {
        vec3 _5376 = (_5120.xyz * _5140.w) + _5140.xyz;
        _5120 = vec4(_5376.x, _5376.y, _5376.z, _5120.w);
    }
    vec3 _5384 = _5120.xyz + _1108._m8.xyz;
    _5120 = vec4(_5384.x, _5384.y, _5384.z, _5120.w);
    _5120.w = 1.0;
}



