// Glass Shader & Decals
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _1013
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1291
{
    int _m0;
    int _m1;
};

struct _1294
{
    int _m0;
    int _m1;
};

struct _1405
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2417
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3860
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

layout(set = 1, binding = 0, std140) uniform _1034_1036
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
} _1036;

layout(set = 0, binding = 0, std140) uniform _1046_1048
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
} _1048;

layout(set = 2, binding = 0, std140) uniform _1128_1130
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _1130;

layout(set = 0, binding = 4, std430) restrict readonly buffer _1296_1298
{
    _1294 _m0[];
} _1298;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1380_1382
{
    uint _m0[];
} _1382;

layout(set = 0, binding = 6, std140) uniform _1410_1412
{
    vec4 _m0[4096];
} _1412;

layout(set = 0, binding = 7, std140) uniform _1430_1432
{
    vec4 _m0[4096];
} _1432;

layout(set = 0, binding = 8, std140) uniform _1482_1484
{
    vec4 _m0[4096];
} _1484;

layout(set = 0, binding = 10, std140) uniform _2421_2423
{
    vec4 _m0[4096];
} _2423;

layout(set = 0, binding = 11, std140) uniform _2460_2462
{
    vec4 _m0[4096];
} _2462;

layout(set = 0, binding = 12, std140) uniform _2528_2530
{
    vec4 _m0[4096];
} _2530;

layout(set = 0, binding = 15, std140) uniform _3864_3866
{
    vec4 _m0[4095];
} _3866;

layout(set = 0, binding = 1, std430) restrict readonly buffer _5275_5277
{
    vec4 _m0[];
} _5277;

layout(push_constant, std430) uniform _5271_5273
{
    int _m0;
    int _m1;
} _5273;

layout(set = 2, binding = 1) uniform SAMPLER_2D _1136;
layout(set = 2, binding = 2) uniform SAMPLER_2D _1144;
layout(set = 2, binding = 3) uniform SAMPLER_2D _1149;
layout(set = 0, binding = 9) uniform SAMPLER_2D _1705;
layout(set = 0, binding = 13) uniform samplerCubeArray _3013;
layout(set = 0, binding = 14) uniform SAMPLER_2D _3421;
layout(set = 0, binding = 16) uniform sampler2DShadow _4188;
layout(set = 0, binding = 17) uniform SAMPLER_2D _4770;
layout(set = 0, binding = 18) uniform SAMPLER_2D _4792;
layout(set = 0, binding = 19) uniform SAMPLER_2D _4831;
layout(set = 0, binding = 20) uniform SAMPLER_2D _4870;
layout(set = 0, binding = 21) uniform SAMPLER_2D _4905;
layout(set = 0, binding = 22) uniform sampler3D _5037;
layout(set = 0, binding = 23) uniform sampler3D _5058;
layout(set = 0, binding = 24) uniform sampler3D _5179;
layout(set = 0, binding = 25) uniform SAMPLER_2D _5242;
layout(set = 0, binding = 2) uniform sampler3D _5278;
layout(set = 0, binding = 3) uniform sampler3D _5279;

layout(location = 2) in vec4 _1027;
layout(location = 6) in vec4 _1053;
layout(location = 3) in vec4 _1065;
layout(location = 4) in vec4 _1068;
layout(location = 5) in vec4 _1071;
layout(location = 10) in vec4 _1089;
layout(location = 11) in vec4 _1093;
layout(location = 12) in vec4 _1097;
layout(location = 0) out vec4 _4954;
layout(location = 1) out vec4 _5223;
layout(location = 2) out vec4 _5224;

float _298;
float _355;

float _51(float _50)
{
    if (_50 <= 0.040449999272823333740234375)
    {
        return _50 / 12.9200000762939453125;
    }
    else
    {
        return pow((_50 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _54(vec3 _53)
{
    float _300 = _53.x;
    vec3 _299;
    _299.x = _51(_300);
    float _306 = _53.y;
    _299.y = _51(_306);
    float _312 = _53.z;
    _299.z = _51(_312);
    return _299;
}

vec4 _57(vec4 _56)
{
    vec3 _322 = _56.xyz;
    vec4 _321 = vec4(_54(_322), 1.0);
    float _330 = _56.w;
    _321.w = _51(_330);
    return _321;
}

vec4 _72(vec4 _71)
{
    vec4 _405 = _71;
    return _57(_405);
}

vec4 _142(SAMPLER_2D _140, vec2 _141)
{
    vec4 _705 = SAMPLE_TEXTURE(_140, _141);
    vec4 _709 = _705;
    _705 = _72(_709);
    return _705;
}

float _60(float _59)
{
    if (_59 > 0.003130800090730190277099609375)
    {
        return (pow(_59, 0.4166666567325592041015625) * 1.05499994754791259765625) - 0.054999999701976776123046875;
    }
    else
    {
        return _59 * 12.9200000762939453125;
    }
}

float _180(float _176, vec4 _177, float _178, bool _179)
{
    float _949 = _177.w / (_176 + _177.z);
    return _949 * _178;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _185(vec3 _183, bool _184)
{
    vec3 _962 = (_183 * 2.0) - vec3(1.0);
    float _979 = (1.0 - (_962.x * _962.x)) - (_962.y * _962.y);
    _962.z = sqrt(_10(_979));
    if (_184 == false)
    {
        _962.z = -_962.z;
    }
    return _962;
}

vec3 _192(vec3 _190, mat3 _191)
{
    return normalize(vec3(dot(_190, _191[0]), dot(_190, _191[1]), dot(_190, _191[2])));
}

uint _31(float _30)
{
    return floatBitsToUint(_30);
}

float _42(float _39, float _40, float _41)
{
    return min(_39, min(_40, _41));
}

float _37(float _34, float _35, float _36)
{
    return max(_34, max(_35, _36));
}

vec4 _119(uint _118)
{
    return unpackUnorm4x8(_118).wzyx;
}

vec4 _132(uvec2 _131)
{
    return vec4(float((_131.x >> uint(16)) & 65535u), float(_131.x & 65535u), float((_131.y >> uint(16)) & 65535u), float(_131.y & 65535u)) * 3.0518509447574615478515625e-05;
}

void _26(float _25)
{
    if (_25 < 0.0)
    {
        discard;
    }
}

float _63(float _62)
{
    return _62 * ((_62 * ((_62 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _122(uint _121)
{
    return vec4(float((_121 >> uint(24)) & 255u), float((_121 >> uint(16)) & 255u), float((_121 >> uint(8)) & 255u), float(_121 & 255u));
}

float _101(float _100)
{
    return (step(0.0, _100) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _66(vec3 _65)
{
    float _370 = _65.x;
    vec3 _369;
    _369.x = _63(_370);
    float _375 = _65.y;
    _369.y = _63(_375);
    float _380 = _65.z;
    _369.z = _63(_380);
    return _369;
}

vec4 _69(vec4 _68)
{
    vec3 _389 = _68.xyz;
    vec4 _388 = vec4(_66(_389), 1.0);
    float _397 = _68.w;
    _388.w = _63(_397);
    return _388;
}

float _78(float _77)
{
    return _77 * _77;
}

vec3 _75(vec3 _74)
{
    return _74 * _74;
}

float _83(float _80, float _81, float _82)
{
    float _427 = (_80 - _81) / (_82 - _81);
    return _10(_427);
}

float _93(float _92)
{
    return exp2(_92);
}

vec3 _145(uint _144)
{
    uint _716 = _144;
    vec4 _715 = _119(_716);
    float _727 = (_715.w * 255.0) - 128.0;
    return _715.xyz * _93(_727);
}

vec3 _126(uint _125)
{
    return vec3(float((_125 >> uint(21)) & 2047u), float((_125 >> uint(10)) & 2047u), float(_125 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

vec3 _171(float _168, float _169, vec3 _170)
{
    float _901 = 0.0949999988079071044921875 + (_169 * (0.60000002384185791015625 + (4.190000057220458984375 * _169)));
    float _911 = _168 + 0.02500000037252902984619140625;
    float _915 = (9.5 * _169) * _168;
    float _929 = 1.0 - (14.0 * _168);
    float _921 = (_901 * _911) * _93(_929);
    float _936 = -_915;
    float _932 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _93(_936)));
    return mix(vec3(_921), vec3(_932), _170);
}

uint _48(float _45, float _46, float _47)
{
    bool _239 = abs(_47) >= abs(_45);
    bool _247;
    if (_239)
    {
        _247 = abs(_47) >= abs(_46);
    }
    else
    {
        _247 = _239;
    }
    if (_247)
    {
        return uint((_47 < 0.0) ? 5 : 4);
    }
    if (abs(_46) >= abs(_45))
    {
        return uint((_46 < 0.0) ? 3 : 2);
    }
    return uint(int(_45 < 0.0));
}

float _98(float _96, float _97)
{
    return pow(_96, _97);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _150(vec3 _148, float _149)
{
    float _739 = 50.0 * dot(_148, vec3(0.33329999446868896484375));
    float _732 = _10(_739);
    float _748 = 1.0 - _149;
    float _751 = _10(_748);
    float _752 = 5.0;
    vec3 _756 = _148 + ((vec3(_732) - _148) * _98(_751, _752));
    return _16(_756);
}

vec3 _158(vec3 _153, vec3 _154, vec3 _155, vec3 _156, float _157)
{
    vec3 _760 = normalize(_154 + _155);
    float _765 = 1.0 - (_157 * 0.800000011920928955078125);
    _765 *= _765;
    _765 *= _765;
    float _776 = _765 * _765;
    float _784 = dot(_153, _760);
    float _780 = _10(_784);
    float _786 = ((_780 * _780) * (_776 - 1.0)) + 1.0;
    _786 = _776 / ((_786 * _786) + 9.9999999392252902907785028219223e-09);
    float _805 = dot(_153, _154);
    float _801 = (_10(_805) * (1.0 - _765)) + _765;
    float _816 = dot(_153, _155);
    float _812 = (_10(_816) * (1.0 - _765)) + _765;
    _786 /= (((4.0 * _801) * _812) + 9.9999999392252902907785028219223e-09);
    vec3 _834 = _156;
    float _836 = dot(_155, _760);
    return _150(_834, _836) * _786;
}

vec3 _165(vec3 _161, vec3 _162, vec3 _163, float _164)
{
    float _842 = 1.0 - (_164 * 0.800000011920928955078125);
    _842 *= _842;
    _842 *= _842;
    float _852 = _842 * _842;
    float _860 = dot(_161, _162);
    float _856 = _10(_860);
    float _862 = ((_856 * _856) * (_852 - 1.0)) + 1.0;
    _862 = _852 / ((_862 * _862) + 9.9999999392252902907785028219223e-09);
    float _880 = dot(_161, _162);
    float _876 = (_10(_880) * (1.0 - _842)) + _842;
    _862 /= (((4.0 * _876) * _876) + 9.9999999392252902907785028219223e-09);
    vec3 _894 = _163;
    return _16(_894) * _862;
}

vec4 _90(vec3 _88, mat4 _89)
{
    return vec4((_88.x * _89[0].x) + ((_88.y * _89[0].y) + ((_88.z * _89[0].z) + _89[0].w)), (_88.x * _89[1].x) + ((_88.y * _89[1].y) + ((_88.z * _89[1].z) + _89[1].w)), (_88.x * _89[2].x) + ((_88.y * _89[2].y) + ((_88.z * _89[2].z) + _89[2].w)), (_88.x * _89[3].x) + ((_88.y * _89[3].y) + ((_88.z * _89[3].z) + _89[3].w)));
}

float _104(float _103)
{
    float _530 = (((-0.15658299624919891357421875) * abs(_103)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_103));
    float _544;
    if (_103 >= 0.0)
    {
        _544 = _530;
    }
    else
    {
        _544 = 3.1415927410125732421875 - _530;
    }
    return _544;
}

float _107(float _106)
{
    float _558;
    if (_106 < 1.0)
    {
        _558 = _106;
    }
    else
    {
        _558 = 1.0 / _106;
    }
    float _555 = _558;
    float _566 = _555 * _555;
    float _570 = 0.087292902171611785888671875;
    _570 = (-0.3018949925899505615234375) + (_570 * _566);
    _570 = 1.0 + (_570 * _566);
    _570 *= _555;
    float _586;
    if (_106 < 1.0)
    {
        _586 = _570;
    }
    else
    {
        _586 = 1.57079637050628662109375 - _570;
    }
    return _586;
}

float _110(float _109)
{
    float _599 = abs(_109);
    float _596 = _107(_599);
    float _603;
    if (_109 < 0.0)
    {
        _603 = -_596;
    }
    else
    {
        _603 = _596;
    }
    return _603;
}

float _114(float _112, float _113)
{
    float _617 = _112 / _113;
    float _613 = _110(_617);
    if (_113 < 0.0)
    {
        _613 += ((_112 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _613;
}

void main()
{
    _1013 _1015 = _1013(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _1015._m15 = _1027;
    _1015._m16 = gl_FragCoord;
    _1015._m40 = (uint(_1036._m6.z) & 3u) << uint(4);
    _1015._m14 = _1048._m4.xyz + _1053.xyz;
    _1015._m13 = normalize(-_1053.xyz);
    _1015._m17 = mat3(vec3(_1065.xyz), vec3(_1068.xyz), vec3(_1071.xyz));
    _1015._m34 = _1089;
    _1015._m35 = _1093;
    _1015._m36 = _1097;
    uint _1100 = 0u;
    vec4 _1101 = vec4(0.0);
    vec4 _1102 = vec4(0.0);
    vec4 _1103 = vec4(0.0);
    vec4 _1104 = vec4(0.0);
    vec4 _1105 = vec4(0.0);
    _1015._m0 = _1103.xyz;
    _1015._m2 = _1104.xyz;
    _1015._m1 = _1102.xyz;
    _1015._m9 = _1101.xyz;
    _1015._m3 = _1101.w;
    _1015._m6 = _1105.wyz;
    vec2 _1125 = _1027.xy * _1130._m4.xy;
    vec2 _1137 = _1125;
    vec4 _1135 = _142(_1136, _1137);
    vec4 _1140 = vec4(0.07999999821186065673828125);
    vec4 _1143 = SAMPLE_TEXTURE(_1144, _1125);
    float _1148 = SAMPLE_TEXTURE(_1149, _1125).x;
    _1015._m0 = _1130._m5.xyz * _1135.xyz;
    float _1164 = _1135.w;
    _1015._m11 = _1130._m5.w * _60(_1164);
    _1015._m2 = _1140.xyz;
    _1015._m3 = _1148;
    _1015._m6 = _1143.xyz;
    uint _1178 = uint((_1036._m6.x > 0.0) ? 8 : 0);
    float _1184 = 16.0;
    float _1186 = 8.0;
    float _1188 = 24.0;
    vec2 _1197 = _1015._m16.xy * _1048._m6.xy;
    vec3 _1190;
    _1190 = vec3(_1197.x, _1197.y, _1190.z);
    _1190.y = 1.0 - _1190.y;
    
    // Fix for Decals
    _1190.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1210 = floor(_1190.xy * vec2(_1184, _1186));
    _1190 = vec3(_1210.x, _1210.y, _1190.z);
    float _1215 = _1015._m16.z;
    vec4 _1218 = _1048._m7;
    float _1221 = 1.0;
    bool _1222 = false;
    float _1213 = _180(_1215, _1218, _1221, _1222);
    float _1224 = log2(max(1.0, _1213 / _1048._m8.z)) * _1048._m8.w;
    _1190.z = min(_1188 - 1.0, floor(_1224));
    uint _1240 = uint((_1190.x + (_1190.y * _1184)) + ((_1190.z * _1184) * _1186));
    _1240 = min(_1240, uint(((_1184 * _1186) * _1188) - 1.0));
    bool _1265 = true;
    vec3 _1267 = _1015._m6;
    bool _1270 = _1265;
    _1015._m7 = _185(_1267, _1270);
    vec3 _1274 = _1015._m7;
    mat3 _1277 = _1015._m17;
    _1015._m6 = _192(_1274, _1277);
    uint _1282 = 0u;
    uint _1283 = 0u;
    uint _1284 = 0u;
    uint _1285 = 0u;
    uint _1286 = 0u;
    uint _1287 = 0u;
    int _1289 = 256;
    _1291 _1293;
    _1293._m0 = _1298._m0[_1240]._m0;
    _1293._m1 = _1298._m0[_1240]._m1;
    int _1307 = _1293._m0 & (~(_1293._m0 >> 31));
    int _1316 = _1293._m1 & (~(_1293._m1 >> 31));
    _1282 = uint((_1307 >> 16) * _1289);
    _1283 = _1282 + uint(_1316 & 255);
    _1284 = _1282;
    _1285 = _1284 + uint((_1316 >> 8) & 255);
    _1286 = _1282;
    _1287 = _1286 + uint((_1316 >> 16) & 255);
    vec3 _1349 = dFdx(_1015._m14);
    vec3 _1353 = dFdy(_1015._m14);
    bool _1358 = _1178 == 0u;
    bool _1364;
    if (_1358)
    {
        _1364 = _1036._m6.y == 0.0;
    }
    else
    {
        _1364 = _1358;
    }
    _1284 = _1364 ? _1285 : _1284;
    uint _1368 = _1284;
    _1405 _1407;
    vec3 _1769;
    float _1873;
    while (_1368 < _1285)
    {
        uint _1378 = _1382._m0[_1368];
        uint _1387 = (_1378 >> uint(12)) & 4095u;
        uint _1393 = _1387;
        if (_1393 >= _1387)
        {
            _1368++;
        }
        int _1402 = 2;
        int _1403 = 2;
        int _1404 = 2;
        _1407._m0 = _1412._m0[(uint(_1402) * _1393) + 0u];
        _1407._m1 = _1412._m0[(uint(_1402) * _1393) + 1u];
        _1407._m2 = _1432._m0[(uint(_1403) * _1393) + 0u];
        float _1446 = _1432._m0[(uint(_1403) * _1393) + 1u].x;
        _1407._m3.x = _31(_1446);
        float _1456 = _1432._m0[(uint(_1403) * _1393) + 1u].y;
        _1407._m3.y = _31(_1456);
        float _1466 = _1432._m0[(uint(_1403) * _1393) + 1u].z;
        _1407._m4.x = _31(_1466);
        float _1476 = _1432._m0[(uint(_1403) * _1393) + 1u].w;
        _1407._m4.y = _31(_1476);
        float _1490 = _1484._m0[(uint(_1404) * _1393) + 0u].x;
        _1407._m5.x = _31(_1490);
        float _1500 = _1484._m0[(uint(_1404) * _1393) + 0u].y;
        _1407._m5.y = _31(_1500);
        float _1510 = _1484._m0[(uint(_1404) * _1393) + 0u].z;
        _1407._m6 = _31(_1510);
        float _1520 = _1484._m0[(uint(_1404) * _1393) + 0u].w;
        _1407._m7 = _31(_1520);
        float _1530 = _1484._m0[(uint(_1404) * _1393) + 1u].x;
        _1407._m8 = _31(_1530);
        float _1540 = _1484._m0[(uint(_1404) * _1393) + 1u].y;
        _1407._m9 = _31(_1540);
        float _1550 = _1484._m0[(uint(_1404) * _1393) + 1u].z;
        _1407._m10 = _31(_1550);
        float _1560 = _1484._m0[(uint(_1404) * _1393) + 1u].w;
        _1407._m11 = _31(_1560);
        vec4 _1565 = vec4(_1015._m14, 1.0);
        vec3 _1572 = vec3(dot(_1565, _1407._m0), dot(_1565, _1407._m1), dot(_1565, _1407._m2));
        float _1586 = 0.0039215688593685626983642578125;
        float _1588 = _1572.x;
        float _1591 = _1572.y;
        float _1594 = _1572.z;
        bool _1599 = _42(_1588, _1591, _1594) <= _1586;
        bool _1616;
        if (!_1599)
        {
            float _1603 = _1572.x;
            float _1606 = _1572.y;
            float _1609 = _1572.z;
            _1616 = _37(_1603, _1606, _1609) >= (1.0 - _1586);
        }
        else
        {
            _1616 = _1599;
        }
        if (_1616)
        {
            continue;
        }
        uint _1620 = _1407._m11;
        bool _1624 = _1178 != 0u;
        bool _1631;
        if (_1624)
        {
            _1631 = (_1620 & 1024u) != 0u;
        }
        else
        {
            _1631 = _1624;
        }
        bool _1644;
        if (!_1631)
        {
            bool _1636 = _1178 == 0u;
            bool _1643;
            if (_1636)
            {
                _1643 = (_1620 & 2048u) != 0u;
            }
            else
            {
                _1643 = _1636;
            }
            _1644 = _1643;
        }
        else
        {
            _1644 = _1631;
        }
        if (_1644)
        {
            continue;
        }
        vec3 _1648 = _1407._m0.xyz;
        vec3 _1652 = _1407._m1.xyz;
        vec3 _1656 = _1407._m2.xyz;
        vec2 _1660 = vec2(dot(_1349, _1648), dot(_1349, _1652));
        vec2 _1668 = vec2(dot(_1353, _1648), dot(_1353, _1652));
        float _1676 = 1.0;
        float _1677 = 1.0;
        vec3 _1678 = vec3(0.5, 0.5, 1.0);
        uint _1681 = _1407._m7;
        uint _1685 = _1407._m9;
        vec4 _1684 = _119(_1685);
        uvec2 _1690 = _1407._m5;
        vec4 _1689 = _132(_1690);
        vec2 _1694 = _1660 * _1689.xy;
        vec2 _1699 = _1668 * _1689.xy;
        vec4 _1704 = TEXTURE_GRAD(_1705, (_1572.xy * _1689.xy) + _1689.zw, _1694, _1699);
        _1676 = _1704.z;
        if ((_1681 & 64u) == 0u)
        {
            float _1728 = _1676 - 0.5;
            _26(_1728);
        }
        float _1730 = _1704.w;
        _1677 = _63(_1730);
        bool _1737 = _1677 <= (4.0 * _1586);
        bool _1744;
        if (_1737)
        {
            _1744 = _1684.w <= _1586;
        }
        else
        {
            _1744 = _1737;
        }
        if (_1744)
        {
            continue;
        }
        vec2 _1748 = (_1704.xy * 2.0) - vec2(1.0);
        float _1759 = 1.0 - dot(_1748, _1748);
        _1678 = vec3(_1748, sqrt(_10(_1759)));
        if ((_1620 & 256u) != 0u)
        {
            _1769 = vec3(-_1678.x, -_1678.y, _1678.z);
        }
        else
        {
            _1769 = _1678;
        }
        _1678 = _1769;
        uint _1784 = _1407._m8;
        uint _1788 = _1784;
        float _1787 = 1.0 + (_122(_1788).w * 0.062745101749897003173828125);
        uint _1796 = _1681;
        float _1795 = _119(_1796).z;
        float _1809 = _1787 - (_1787 * abs((_1572.z * 2.0) - 1.0));
        _1677 *= _10(_1809);
        if ((_1681 & 64u) != 0u)
        {
            uint _1819 = _1681;
            float _1818 = _119(_1819).x;
            uint _1824 = _1681;
            float _1823 = _122(_1824).y;
            float _1830 = _1818;
            float _1828 = mix(_1823, 0.0, _10(_1830));
            float _1839 = _1676 - (_1828 / 255.0);
            float _1834 = float(_10(_1839) > 0.0);
            _1677 *= _1834;
        }
        vec3 _1846 = normalize(vec3(_1015._m17[0].z, _1015._m17[1].z, _1015._m17[2].z));
        float _1855 = dot(_1846, normalize(_1656));
        float _1860 = _1855;
        vec2 _1865 = _1678.xy * _101(_1860);
        _1678 = vec3(_1865.x, _1865.y, _1678.z);
        if ((_1620 & 32768u) != 0u)
        {
            float _1878 = abs(_1855);
            _1873 = _10(_1878);
        }
        else
        {
            float _1881 = _1855;
            _1873 = _10(_1881);
        }
        float _1868 = _1873;
        float _1885 = _1677 * _1868;
        uint _1889 = _1407._m6;
        uint _1893 = _1889;
        vec4 _1898 = _119(_1893) * _1885;
        vec4 _1892 = _22(_1898);
        _1015._m11 = max(_1015._m11, _1892.x);
        _1648 += (_1846 * dot(_1648, _1846));
        _1652 += (_1846 * dot(_1652, _1846));
        _1678 = ((normalize(_1648) * _1678.x) + (normalize(_1652) * _1678.y)) + (_1846 * _1678.z);
        if ((_1620 & 512u) != 0u)
        {
            vec3 _1942 = mix(_1846, _1678, _1892.www);
            float _1948 = dot(_1942, _1846);
            _1678 = (_1015._m6 * _1948) + ((_1942 - (_1846 * _1948)) * dot(_1015._m6, _1846));
        }
        else
        {
            if ((_1620 & 128u) != 0u)
            {
                _1678 = mix(mix(_1015._m6, _1846, vec3(_1885)), _1678, _1892.www);
            }
            else
            {
                _1678 = mix(_1015._m6, _1678, _1892.www);
            }
        }
        _1015._m6 = normalize(_1678);
        uint _1995 = _1784;
        vec3 _1994 = _119(_1995).xyz;
        float _1999 = _1677;
        if ((_1681 & 1u) != 0u)
        {
            uvec2 _2007 = _1407._m3;
            vec4 _2006 = _132(_2007);
            vec2 _2011 = _1660 * _2006.xy;
            vec2 _2016 = _1668 * _2006.xy;
            vec4 _2021 = TEXTURE_GRAD(_1705, (_1572.xy * _2006.xy) + _2006.zw, _2011, _2016);
            vec4 _2034 = _2021;
            _2021 = _69(_2034);
            float _2044 = (_2021.w - _1586) / (1.0 - _1586);
            _1999 = _10(_2044);
            _1994 *= _2021.xyz;
        }
        _1015._m0 = mix(_1015._m0, _1994, _1892.xxx);
        float _2057 = ((_1868 * _1999) * _1684.w) * _1795;
        _1015._m10 += (_1684.xyz * (_2057 * 64.0));
        uint _2076 = _1407._m10;
        uint _2080 = _2076;
        vec4 _2079 = _119(_2080);
        float _2083 = 0.0;
        if ((_1681 & 10u) != 0u)
        {
            uvec2 _2091 = _1407._m4;
            vec4 _2090 = _132(_2091);
            vec2 _2095 = _1660 * _2090.xy;
            vec2 _2100 = _1668 * _2090.xy;
            vec4 _2105 = TEXTURE_GRAD(_1705, (_1572.xy * _2090.xy) + _2090.zw, _2095, _2100);
            if ((_1681 & 2u) != 0u)
            {
                _2079 = _2105 * _2105;
            }
            else
            {
                _2083 = _2105.w;
            }
        }
        _1015._m2 = mix(_1015._m2, _2079.xyz, _1892.yyy);
        _1015._m3 = mix(_1015._m3, _2079.w, _1892.z);
        _1015._m37 = max(_1015._m37, _2083);
        float _2157 = (_1676 - 0.5) * 2.0;
        _1015._m38 = max(_1015._m38, _10(_2157));
    }
    float _2162 = _1015._m37;
    float _2161 = _78(_2162);
    float _2169 = _2161 - 0.5;
    float _2166 = _10(_2169) * 2.0;
    float _2180 = _2161 * 2.0;
    float _2172 = (_1015._m38 * _1015._m38) * _10(_2180);
    float _2187 = _2172 + _2166;
    float _2183 = _10(_2187);
    if (_2183 > 0.0039215688593685626983642578125)
    {
        vec3 _2195 = _1015._m0;
        float _2202 = _2183 * 1.0;
        float _2203 = 0.0;
        float _2204 = 0.3499999940395355224609375;
        _1015._m0 = mix(_1015._m0, _75(_2195), vec3(_83(_2202, _2203, _2204) * (1.0 - _1015._m3)));
        float _2220 = _2183 * 1.0;
        float _2221 = 0.25;
        float _2222 = 0.5;
        _1015._m2 = mix(_1015._m2, vec3(0.039999999105930328369140625), vec3(_83(_2220, _2221, _2222)));
        vec3 _2227 = vec3(_1015._m17[0].z, _1015._m17[1].z, _1015._m17[2].z);
        float _2241 = _2227.z + 0.0625;
        float _2235 = _2183 * _10(_2241);
        float _2250 = _2235 * 1.0;
        float _2251 = 0.20000000298023223876953125;
        float _2252 = 1.0;
        _1015._m3 = mix(_1015._m3, 0.89999997615814208984375, _83(_2250, _2251, _2252));
        float _2261 = _2235 * 1.0;
        float _2262 = 0.449999988079071044921875;
        float _2263 = 0.980000019073486328125;
        float _2256 = _83(_2261, _2262, _2263);
        _1015._m6 = normalize(mix(_1015._m6, vec3(0.0, 0.0, 1.0), vec3(_2256)));
        _1015._m7 = mix(_1015._m6, vec3(0.5, 0.5, 1.0), vec3(_2256));
        if (_2235 > 0.980000019073486328125)
        {
            float _2286 = _2235 * _2256;
            float _2287 = 0.980000019073486328125;
            float _2288 = 1.0;
            _2227 = normalize(mix(_2227, vec3(0.0, 0.0, 1.0), vec3(_83(_2286, _2287, _2288))));
            _1015._m17[0].z = _2227.x;
            _1015._m17[1].z = _2227.y;
            _1015._m17[2].z = _2227.z;
        }
    }
    vec3 _2302 = vec3(0.0);
    vec3 _2303 = vec3(_1015._m34.x, _1015._m34.y, _1015._m34.z);
    vec3 _2311 = vec3(_1015._m34.w, _1015._m35.x, _1015._m35.y);
    vec3 _2319 = vec3(_1015._m35.z, _1015._m35.w, _1015._m36.x);
    vec3 _2327 = vec3(_1015._m36.y, _1015._m36.z, _1015._m36.w);
    vec3 _2335 = ((_2303 - (_2311 * _1015._m6.y)) + (_2319 * _1015._m6.z)) - (_2327 * _1015._m6.x);
    float _2358 = _1036._m7.x * _1048._m9.x;
    _2302 += max(_2335 * _10(_2358), vec3(0.0));
    float _2369;
    if (dot(_1015._m10, vec3(1.0)) > 0.0)
    {
        _2369 = -_1015._m3;
    }
    else
    {
        _2369 = _1015._m3;
    }
    _1015._m3 = _2369;
    _1015._m18 = _2302;
    _1015._m19 = _2302;
    float _2386 = 1.0;
    uint _2387 = _1286;
    _2417 _2419;
    while (_2387 < _1287)
    {
        uint _2397 = _1382._m0[_2387];
        uint _2401 = (_2397 >> uint(24)) & 4095u;
        uint _2405 = _2401;
        if (_2405 >= _2401)
        {
            _2387++;
        }
        int _2414 = 4;
        int _2415 = 4;
        int _2416 = 4;
        _2419._m0 = _2423._m0[(uint(_2414) * _2405) + 0u].xyz;
        float _2438 = _2423._m0[(uint(_2414) * _2405) + 0u].w;
        _2419._m1 = _31(_2438);
        _2419._m2 = _2423._m0[(uint(_2414) * _2405) + 1u];
        _2419._m3 = _2423._m0[(uint(_2414) * _2405) + 2u];
        _2419._m4 = _2462._m0[(uint(_2415) * _2405) + 0u];
        _2419._m5 = _2462._m0[(uint(_2415) * _2405) + 1u];
        _2419._m6 = _2462._m0[(uint(_2415) * _2405) + 2u];
        float _2492 = _2423._m0[(uint(_2414) * _2405) + 3u].x;
        _2419._m7.x = _31(_2492);
        float _2502 = _2423._m0[(uint(_2414) * _2405) + 3u].y;
        _2419._m7.y = _31(_2502);
        float _2512 = _2423._m0[(uint(_2414) * _2405) + 3u].z;
        _2419._m7.z = _31(_2512);
        float _2522 = _2423._m0[(uint(_2414) * _2405) + 3u].w;
        _2419._m7.w = _31(_2522);
        _2419._m8 = _2530._m0[(uint(_2416) * _2405) + 0u];
        _2419._m9 = _2530._m0[(uint(_2416) * _2405) + 1u];
        _2419._m10 = _2530._m0[(uint(_2416) * _2405) + 2u];
        _2419._m11 = _2530._m0[(uint(_2416) * _2405) + 3u];
        float _2568 = _2462._m0[(uint(_2415) * _2405) + 3u].x;
        _2419._m12 = _31(_2568);
        float _2578 = _2462._m0[(uint(_2415) * _2405) + 3u].y;
        _2419._m13 = _31(_2578);
        _2419._m14 = _2462._m0[(uint(_2415) * _2405) + 3u].z;
        float _2596 = _2462._m0[(uint(_2415) * _2405) + 3u].w;
        _2419._m15 = _31(_2596);
        uint _2601 = (_2419._m12 >> uint(16)) & 3u;
        if (((_1015._m40 >> uint(4)) & 3u) != _2601)
        {
            continue;
        }
        vec3 _2615 = vec3((_1015._m14.x * _2419._m4.x) + ((_1015._m14.y * _2419._m4.y) + ((_1015._m14.z * _2419._m4.z) + _2419._m4.w)), (_1015._m14.x * _2419._m5.x) + ((_1015._m14.y * _2419._m5.y) + ((_1015._m14.z * _2419._m5.z) + _2419._m5.w)), (_1015._m14.x * _2419._m6.x) + ((_1015._m14.y * _2419._m6.y) + ((_1015._m14.z * _2419._m6.z) + _2419._m6.w)));
        vec2 _2682 = _2615.xy / vec2(_2615.z);
        _2615 = vec3(_2682.x, _2682.y, _2615.z);
        _2615.z = (_1015._m14.x * _2419._m3.x) + ((_1015._m14.y * _2419._m3.y) + ((_1015._m14.z * _2419._m3.z) + _2419._m3.w));
        float _2706 = 0.0039215688593685626983642578125;
        float _2707 = _2615.x;
        float _2710 = _2615.y;
        float _2713 = _2615.z;
        bool _2718 = _42(_2707, _2710, _2713) < _2706;
        bool _2735;
        if (!_2718)
        {
            float _2722 = _2615.x;
            float _2725 = _2615.y;
            float _2728 = _2615.z;
            _2735 = _37(_2722, _2725, _2728) >= (1.0 - _2706);
        }
        else
        {
            _2735 = _2718;
        }
        if (_2735)
        {
            continue;
        }
        uint _2739 = _2419._m1;
        uint _2743 = _2419._m13;
        vec3 _2742 = _145(_2743);
        float _2747 = _2419._m14;
        vec3 _2750 = _2419._m0;
        if (_2419._m9.w == 0.0)
        {
            if (dot(_2419._m11.xyz, _1015._m14) < (_2419._m11.w - _2706))
            {
                continue;
            }
        }
        else
        {
            if (_2419._m9.w == 1.0)
            {
                float _2779 = _2419._m11.w;
                uint _2783 = _31(_2779);
                vec3 _2778 = (((_126(_2783) * 2.0) - vec3(1.0)) * _2419._m11.xyz) + _2750;
                vec3 _2794 = abs(_1015._m14 - _2778) / _2419._m11.xyz;
                float _2804 = _2794.x;
                float _2807 = _2794.y;
                float _2810 = _2794.z;
                if (_37(_2804, _2807, _2810) > 1.0)
                {
                    continue;
                }
            }
        }
        uint _2819 = _2739;
        float _2818 = _119(_2819).y;
        vec3 _2823 = (_2615 * 2.0) - vec3(1.0);
        vec3 _2827 = _2823 * sqrt(((vec3(1.0) - ((_2823.yzx * _2823.yzx) * 0.5)) - ((_2823.zxy * _2823.zxy) * 0.5)) + ((((_2823.yzx * _2823.yzx) * _2823.zxy) * _2823.zxy) / vec3(3.0)));
        float _2871 = 1.0 - ((length(_2827) - _2818) / ((1.0 - _2818) + 9.9999999747524270787835121154785e-07));
        float _2860 = _10(_2871);
        _2860 *= _2860;
        _2860 *= (_2419._m8.w * _2386);
        _2386 *= (1.0 - _2860);
        if (_2860 <= (_2706 * 4.0))
        {
            continue;
        }
        vec3 _2893 = _2742;
        uint _2896 = _2739;
        float _2895 = _122(_2896).z;
        vec3 _2900 = vec3(0.0);
        vec3 _2901 = vec3(0.0);
        vec3 _2902 = _1015._m6;
        _2902.x = dot(_2419._m2.xy, _1015._m6.xy);
        _2902.y = dot(_2419._m2.zw, _1015._m6.xy);
        vec3 _2921 = reflect(-_1015._m13, _1015._m6);
        vec3 _2928 = (_2419._m9.xyz - _1015._m14) / _2921;
        vec3 _2937 = (_2419._m8.xyz - _1015._m14) / _2921;
        vec3 _2946 = max(_2928, _2937);
        float _2951 = _2946.x;
        float _2954 = _2946.y;
        float _2957 = _2946.z;
        float _2950 = _42(_2951, _2954, _2957);
        vec3 _2961 = _1015._m14 + (_2921 * _2950);
        vec3 _2968 = normalize(_2961 - _2750);
        vec3 _2973 = _2968;
        _2973.x = dot(_2419._m2.xy, _2968.xy);
        _2973.y = dot(_2419._m2.zw, _2968.xy);
        float _2995 = dot(_1015._m13, _1015._m6);
        float _2989 = _10(_2995);
        float _2997 = 0.0;
        float _2998 = 6.0;
        float _3000 = max(_2997, _2998 - (_2998 * abs(_1015._m3)));
        _2901 = textureLod(_3013, vec4(_2973, _2895), _3000).xyz * _2747;
        float _3030 = _2989;
        float _3032 = abs(_1015._m3);
        vec3 _3033 = _1015._m2;
        vec3 _3026 = _171(_3030, _3032, _3033);
        _2901 *= _3026;
        float _3044 = _2860;
        _1015._m20 += ((_2901 * _2893) * _10(_3044));
        if (_2386 <= (_2706 * 4.0))
        {
            break;
        }
    }
    uint _3059 = _1282;
    _2417 _3088;
    vec3 _3394;
    float _3471;
    float _3489;
    uint _3834;
    _3860 _3862;
    uint _3984;
    _3860 _4008;
    vec3 _4482;
    vec3 _4495;
    while (_3059 < _1283)
    {
        uint _3069 = _1382._m0[_3059];
        uint _3073 = _3069 & 4095u;
        uint _3076 = _3073;
        if (_3076 >= _3073)
        {
            _3059++;
        }
        int _3085 = 4;
        int _3086 = 4;
        int _3087 = 4;
        _3088._m0 = _2423._m0[(uint(_3085) * _3076) + 0u].xyz;
        float _3103 = _2423._m0[(uint(_3085) * _3076) + 0u].w;
        _3088._m1 = _31(_3103);
        _3088._m2 = _2423._m0[(uint(_3085) * _3076) + 1u];
        _3088._m3 = _2423._m0[(uint(_3085) * _3076) + 2u];
        _3088._m4 = _2462._m0[(uint(_3086) * _3076) + 0u];
        _3088._m5 = _2462._m0[(uint(_3086) * _3076) + 1u];
        _3088._m6 = _2462._m0[(uint(_3086) * _3076) + 2u];
        float _3153 = _2423._m0[(uint(_3085) * _3076) + 3u].x;
        _3088._m7.x = _31(_3153);
        float _3163 = _2423._m0[(uint(_3085) * _3076) + 3u].y;
        _3088._m7.y = _31(_3163);
        float _3173 = _2423._m0[(uint(_3085) * _3076) + 3u].z;
        _3088._m7.z = _31(_3173);
        float _3183 = _2423._m0[(uint(_3085) * _3076) + 3u].w;
        _3088._m7.w = _31(_3183);
        _3088._m8 = _2530._m0[(uint(_3087) * _3076) + 0u];
        _3088._m9 = _2530._m0[(uint(_3087) * _3076) + 1u];
        _3088._m10 = _2530._m0[(uint(_3087) * _3076) + 2u];
        _3088._m11 = _2530._m0[(uint(_3087) * _3076) + 3u];
        float _3225 = _2462._m0[(uint(_3086) * _3076) + 3u].x;
        _3088._m12 = _31(_3225);
        float _3235 = _2462._m0[(uint(_3086) * _3076) + 3u].y;
        _3088._m13 = _31(_3235);
        _3088._m14 = _2462._m0[(uint(_3086) * _3076) + 3u].z;
        float _3253 = _2462._m0[(uint(_3086) * _3076) + 3u].w;
        _3088._m15 = _31(_3253);
        uint _3258 = (_3088._m12 >> uint(16)) & 3u;
        if (((_1015._m40 >> uint(4)) & 3u) != _3258)
        {
            continue;
        }
        float _3272 = 0.0039215688593685626983642578125;
        vec4 _3273 = vec4(_1015._m14, 1.0);
        float _3280 = 1.0 / dot(_3273, _3088._m6);
        vec3 _3286 = vec3(dot(_3273, _3088._m4) * _3280, dot(_3273, _3088._m5) * _3280, dot(_3273, _3088._m3));
        uint _3304 = _3088._m1;
        uint _3307 = _1178;
        _3307 |= 64u;
        float _3311 = _3286.x;
        float _3314 = _3286.y;
        float _3317 = _3286.z;
        bool _3322 = _42(_3311, _3314, _3317) <= _3272;
        bool _3339;
        if (!_3322)
        {
            float _3326 = _3286.x;
            float _3329 = _3286.y;
            float _3332 = _3286.z;
            _3339 = _37(_3326, _3329, _3332) >= (1.0 - _3272);
        }
        else
        {
            _3339 = _3322;
        }
        bool _3347;
        if (!_3339)
        {
            _3347 = (_3304 & _3307) != 0u;
        }
        else
        {
            _3347 = _3339;
        }
        if (_3347)
        {
            continue;
        }
        if ((_3304 & 3u) == 2u)
        {
            vec2 _3366 = fract((_3286.xy * _1048._m10.xy) + _1048._m10.zw);
            _3286 = vec3(_3366.x, _3366.y, _3286.z);
        }
        vec3 _3369 = _3088._m0;
        float _3372 = 1.0;
        float _3373 = 1.0;
        vec3 _3374 = vec3(0.0, 0.0, 1.0);
        vec3 _3375 = vec3(0.0, 0.0, 1.0);
        uint _3376 = _3088._m1;
        vec3 _3379 = (_3286 * 2.0) - vec3(1.0);
        vec2 _3384 = _3286.xy;
        vec3 _3387 = _3088._m10.xyz;
        if ((_3376 & 3u) == 2u)
        {
            _3394 = _3387;
        }
        else
        {
            _3394 = normalize(_3369 - _1015._m14);
        }
        _3374 = _3394;
        _3374 = _3374;
        float _3411 = dot(_1015._m6, _3374);
        float _3406 = _10(_3411);
        uvec2 _3414 = _3088._m7.zw;
        vec4 _3413 = _132(_3414);
        float _3420 = TEXTURE_LOD(_3421, vec4((_3384 * _3413.xy) + _3413.zw, 0.0, 0.0).xy, vec4((_3384 * _3413.xy) + _3413.zw, 0.0, 0.0).w).x;
        float _3447 = _3420 * _3420;
        uint _3451 = _3376 & 3u;
        bool _3456 = _3451 == 1u;
        bool _3468;
        if (!_3456)
        {
            bool _3461 = _3451 == 0u;
            bool _3467;
            if (_3461)
            {
                _3467 = _3088._m8.z != 0.0;
            }
            else
            {
                _3467 = _3461;
            }
            _3468 = _3467;
        }
        else
        {
            _3468 = _3456;
        }
        bool _3454 = _3468;
        if (_3454)
        {
            float _3474 = _3088._m8.w;
            _3471 = _10(_3474);
        }
        else
        {
            _3471 = 0.5;
        }
        float _3469 = _3471;
        bool _3482 = _3451 == 0u;
        bool _3488;
        if (_3482)
        {
            _3488 = _3088._m8.z != 0.0;
        }
        else
        {
            _3488 = _3482;
        }
        if (_3488)
        {
            float _3497 = sqrt(dot(_3379, _3379));
            _3489 = min(0.9921875, _10(_3497));
        }
        else
        {
            _3489 = _3286.z;
        }
        float _3480 = _3489;
        uvec2 _3505 = _3088._m7.xy;
        vec4 _3504 = _132(_3505);
        vec2 _3510 = vec2(_3480, _3469);
        float _3514 = TEXTURE_LOD(_3421, vec4((_3510 * _3504.xy) + _3504.zw, 0.0, 0.0).xy, vec4((_3510 * _3504.xy) + _3504.zw, 0.0, 0.0).w).x;
        _3514 *= _3514;
        _3372 = _3514 * _3447;
        if ((_3376 & 48u) != 0u)
        {
            vec4 _3552 = _3088._m10;
            vec4 _3555 = _3088._m8;
            vec4 _3558 = _3088._m9;
            float _3561 = dot(_1015._m14, _3552.xyz) + _3552.w;
            if (_3561 < 0.0)
            {
                continue;
            }
            float _3575 = length(_3552.xyz);
            float _3582 = _3561 * 50.0;
            float _3579 = _10(_3582);
            _3372 *= (_3579 * _3579);
            _3561 /= _3575;
            _3552 /= vec4(_3575);
            vec3 _3596 = reflect(-_1015._m13, _1015._m6);
            if (dot(_3596, _3552.xyz) > 0.0)
            {
                _3596 = reflect(_3596, _3552.xyz);
            }
            float _3614 = dot(_3596, _3552.xyz);
            float _3619 = _3561 / _3614;
            vec3 _3623 = _1015._m14 - (_3596 * _3619);
            vec3 _3630 = _3623 - _3369;
            float _3634 = dot(_3630, _3555.xyz) / _3555.w;
            float _3642 = dot(_3630, _3558.xyz) / _3558.w;
            if ((_3376 & 48u) == 32u)
            {
                vec2 _3656 = vec2(_3634, _3642);
                float _3660 = 1.0 / max(1.0, length(vec2(_3634, _3642)));
                _3634 *= (_3660 * _3555.w);
                _3642 *= (_3660 * _3558.w);
            }
            else
            {
                float _3682 = abs(_3634);
                float _3684 = _3634;
                _3634 = (_10(_3682) * _101(_3684)) * _3555.w;
                float _3693 = abs(_3642);
                float _3695 = _3642;
                _3642 = (_10(_3693) * _101(_3695)) * _3558.w;
            }
            vec3 _3702 = (_3555.xyz * _3634) + (_3558.xyz * _3642);
            _3369 += _3702;
            _3374 = normalize(_3369 - _1015._m14);
            _3374 = _3374;
        }
        else
        {
            uint _3722 = (_3088._m15 >> uint(16)) & 255u;
            if (_3722 == 0u)
            {
                vec4 _3731 = _3088._m9;
                if (dot(_3731.xyz, _1015._m14) < (_3731.w - _3272))
                {
                    continue;
                }
            }
            else
            {
                if (_3722 == 1u)
                {
                    vec3 _3752 = _3088._m9.xyz;
                    float _3757 = _3088._m9.w;
                    uint _3761 = _31(_3757);
                    vec3 _3756 = (((_126(_3761) * 2.0) - vec3(1.0)) * _3752) + _3369;
                    vec3 _3770 = abs((_1015._m14 - _3756) / _3752);
                    float _3778 = _3770.x;
                    float _3781 = _3770.y;
                    float _3784 = _3770.z;
                    if (_37(_3778, _3781, _3784) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3372 <= (_3272 / 256.0))
        {
            continue;
        }
        float _3800 = 1.0;
        if ((_3304 & 4u) != 0u)
        {
            float _3807 = float(_3088._m15 & 255u) / 255.0;
            float _3813 = 0.00999999977648258209228515625;
            vec3 _3815 = _1015._m14 + (_1015._m6 * _3813);
            if ((_3304 & 3u) == 0u)
            {
                vec3 _3828 = _3815 - _3088._m2.xyz;
                float _3835 = _3828.x;
                float _3838 = _3828.y;
                float _3841 = _3828.z;
                _3834 = _48(_3835, _3838, _3841);
            }
            else
            {
                if ((_3304 & 3u) == 2u)
                {
                    float _3851 = 0.0;
                    _3834 = 0u;
                    for (; _3834 < 3u; _3834++)
                    {
                        int _3859 = 5;
                        _3862._m0 = _3866._m0[(uint(_3859) * ((_3304 >> uint(22)) + _3834)) + 0u];
                        _3862._m1 = _3866._m0[(uint(_3859) * ((_3304 >> uint(22)) + _3834)) + 1u];
                        _3862._m2 = _3866._m0[(uint(_3859) * ((_3304 >> uint(22)) + _3834)) + 2u];
                        _3862._m3 = _3866._m0[(uint(_3859) * ((_3304 >> uint(22)) + _3834)) + 3u];
                        _3862._m4 = _3866._m0[(uint(_3859) * ((_3304 >> uint(22)) + _3834)) + 4u];
                        vec2 _3923 = vec2(dot(_3815, _3862._m0.xyz) + _3862._m0.w, dot(_3815, _3862._m1.xyz) + _3862._m1.w);
                        _3923 = abs((_3923 * 2.0) - vec2(1.0));
                        bool _3949 = _3923.x < 0.99500000476837158203125;
                        bool _3955;
                        if (_3949)
                        {
                            _3955 = _3923.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _3955 = _3949;
                        }
                        if (_3955)
                        {
                            _3851 = (1.0 - max(_3923.x, _3923.y)) * _1048._m11.w;
                            break;
                        }
                    }
                    _3834 = min(2u, _3834);
                    uint _3972 = uint(_1015._m16.x) ^ (uint(_1015._m16.y) << uint(1));
                    if (_1048._m12.w > 0.0)
                    {
                        _3984 = uint(_1048._m13.x);
                    }
                    else
                    {
                        _3984 = 0u;
                    }
                    _3972 ^= _3984;
                    _3834 += uint(int(((float(_3972 & 3u) * 0.25) + 0.125) > _3851));
                }
                else
                {
                    _3834 = 0u;
                }
            }
            int _4007 = 5;
            _4008._m0 = _3866._m0[(uint(_4007) * ((_3304 >> uint(22)) + _3834)) + 0u];
            _4008._m1 = _3866._m0[(uint(_4007) * ((_3304 >> uint(22)) + _3834)) + 1u];
            _4008._m2 = _3866._m0[(uint(_4007) * ((_3304 >> uint(22)) + _3834)) + 2u];
            _4008._m3 = _3866._m0[(uint(_4007) * ((_3304 >> uint(22)) + _3834)) + 3u];
            _4008._m4 = _3866._m0[(uint(_4007) * ((_3304 >> uint(22)) + _3834)) + 4u];
            vec4 _4064 = vec4((_3815.x * _4008._m0.x) + ((_3815.y * _4008._m0.y) + ((_3815.z * _4008._m0.z) + _4008._m0.w)), (_3815.x * _4008._m1.x) + ((_3815.y * _4008._m1.y) + ((_3815.z * _4008._m1.z) + _4008._m1.w)), (_3815.x * _4008._m2.x) + ((_3815.y * _4008._m2.y) + ((_3815.z * _4008._m2.z) + _4008._m2.w)), (_3815.x * _4008._m3.x) + ((_3815.y * _4008._m3.y) + ((_3815.z * _4008._m3.z) + _4008._m3.w)));
            vec3 _4151 = _4064.xyz / vec3(_4064.w);
            _4064 = vec4(_4151.x, _4151.y, _4151.z, _4064.w);
            bool _4159 = min(_4064.x, _4064.y) > 0.0;
            bool _4168;
            if (_4159)
            {
                _4168 = max(_4064.x, _4064.y) < 1.0;
            }
            else
            {
                _4168 = _4159;
            }
            if (_4168)
            {
                vec2 _4180 = (_4064.xy * _4008._m4.xy) + _4008._m4.zw;
                _4064 = vec4(_4180.x, _4180.y, _4064.z, _4064.w);
                if (false)
                {
                    _3800 = textureLod(_4188, vec3(_4064.xyz.xy, _4064.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4195 = (_4064.xy * _1048._m14.xy) + vec2(0.5);
                    vec2 _4204 = floor(_4195);
                    vec2 _4207 = _4195 - _4204;
                    _4204 -= vec2(0.5);
                    vec2 _4214 = vec2(4.0) - (_4207 * 3.0);
                    vec2 _4219 = vec2(7.0);
                    vec2 _4222 = vec2(1.0) + (_4207 * 3.0);
                    vec2 _4227 = (_4204 + (((vec2(3.0) - (_4207 * 2.0)) / _4214) - vec2(2.0))) * _1048._m14.zw;
                    vec2 _4242 = (_4204 + ((vec2(3.0) + _4207) / _4219)) * _1048._m14.zw;
                    vec2 _4254 = (_4204 + ((_4207 / _4222) + vec2(2.0))) * _1048._m14.zw;
                    vec3 _4278 = vec3(_4227.x, _4227.y, _4064.z);
                    _3800 = (_4214.x * _4214.y) * textureLod(_4188, vec3(_4278.xy, _4278.z), 0.0);
                    vec3 _4294 = vec3(_4242.x, _4227.y, _4064.z);
                    _3800 += ((_4219.x * _4214.y) * textureLod(_4188, vec3(_4294.xy, _4294.z), 0.0));
                    vec3 _4312 = vec3(_4254.x, _4227.y, _4064.z);
                    _3800 += ((_4222.x * _4214.y) * textureLod(_4188, vec3(_4312.xy, _4312.z), 0.0));
                    vec3 _4330 = vec3(_4227.x, _4242.y, _4064.z);
                    _3800 += ((_4214.x * _4219.y) * textureLod(_4188, vec3(_4330.xy, _4330.z), 0.0));
                    vec3 _4348 = vec3(_4242.x, _4242.y, _4064.z);
                    _3800 += ((_4219.x * _4219.y) * textureLod(_4188, vec3(_4348.xy, _4348.z), 0.0));
                    vec3 _4366 = vec3(_4254.x, _4242.y, _4064.z);
                    _3800 += ((_4222.x * _4219.y) * textureLod(_4188, vec3(_4366.xy, _4366.z), 0.0));
                    vec3 _4384 = vec3(_4227.x, _4254.y, _4064.z);
                    _3800 += ((_4214.x * _4222.y) * textureLod(_4188, vec3(_4384.xy, _4384.z), 0.0));
                    vec3 _4402 = vec3(_4242.x, _4254.y, _4064.z);
                    _3800 += ((_4219.x * _4222.y) * textureLod(_4188, vec3(_4402.xy, _4402.z), 0.0));
                    vec3 _4420 = vec3(_4254.x, _4254.y, _4064.z);
                    _3800 += ((_4222.x * _4222.y) * textureLod(_4188, vec3(_4420.xy, _4420.z), 0.0));
                    _3800 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3800 = float((_3304 & 3u) == 2u);
            }
            float _4434 = float((_3304 >> uint(16)) & 63u) / 63.0;
            float _4448 = ((_3800 * _4434) + 1.0) - _4434;
            _3800 = _10(_4448);
        }
        uint _4451 = _3088._m13;
        vec3 _4450 = (_145(_4451) * _3800) * _3372;
        _3373 *= _3088._m14;
        vec3 _4463 = _4450;
        vec3 _4465 = normalize(_3369 - _1015._m14);
        float _4471 = dot(_1015._m6, _4465);
        float _4477 = _4471;
        float _4476 = _101(_4477);
        if (_4476 >= 0.0)
        {
            _4482 = _4465;
        }
        else
        {
            _4482 = reflect(_4465, _1015._m6);
        }
        _4465 = _4482;
        if (_4476 >= 0.0)
        {
            _4495 = vec3(1.0);
        }
        else
        {
            _4495 = _1015._m0;
        }
        vec3 _4492 = _4495;
        float _4506 = dot(_1015._m6, _4465);
        float _4508 = _4471;
        _4471 = mix(_10(_4506), _10(_4508), _1015._m11);
        _1015._m19 += (_4463 * _4471);
        vec3 _4522 = _1015._m6;
        vec3 _4525 = _1015._m13;
        vec3 _4528 = _4465;
        vec3 _4530 = _1015._m2;
        float _4533 = _1015._m3;
        vec3 _4521 = _158(_4522, _4525, _4528, _4530, _4533);
        vec3 _4537 = ((((_4463 * _4471) * _4521) * _3373) * _4492) + _1015._m20;
        vec3 _4550 = vec3(40.0);
        _1015._m20 = min(_4537, _4550);
    }
    float _4557 = _1048._m15.x;
    if (_4557 > 0.00999999977648258209228515625)
    {
        float _4564 = float(int(_1048._m13.x) & 1023) / 1023.0;
        _4557 = max(0.0, _4557 + (((_4564 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4580 = _1015._m13;
        float _4588 = dot(_1015._m6, _4580);
        float _4583 = _10(_4588);
        float _4590 = _4583 * _4557;
        vec3 _4598 = _1015._m6;
        vec3 _4601 = _1015._m13;
        vec3 _4604 = _1015._m2;
        float _4607 = abs(_1015._m3);
        vec3 _4594 = _165(_4598, _4601, _4604, _4607) * _4557;
        _1015._m19 += vec3(_4590);
        _1015._m20 += vec3(_4594);
    }
    _1015._m19 = _1015._m19;
    _1015._m20 += _1015._m10;
    _1015._m19 *= _1015._m0;
    _1015._m21 = _1015._m19 + _1015._m20;
    float _4648 = _1015._m16.z;
    vec4 _4651 = _1048._m7;
    float _4654 = 1.0;
    bool _4655 = false;
    float _4647 = _180(_4648, _4651, _4654, _4655);
    float _4657 = 1.0;
    if (_1130._m6.y > 0.0)
    {
        float _4663 = max(0.0, _4647 - _1130._m6.x);
        _4657 = 1.0 - min(1.0, _4663 / _1130._m6.y);
    }
    float _4675 = 0.0;
    if (_1130._m6.w > 0.0)
    {
        float _4681 = max(0.0, _4647 - _1130._m6.z);
        _4675 = min(1.0, _4681 / _1130._m6.w);
    }
    float _4692 = 0.89999997615814208984375;
    float _4693 = 0.0076199998147785663604736328125 * _4657;
    vec3 _4697 = normalize(refract(_1015._m6, -_1015._m13, _4692));
    vec3 _4742 = _1015._m14 + (_4697 * _4693);
    mat4 _4743 = mat4(vec4(_1048._m16), vec4(_1048._m17), vec4(_1048._m18), vec4(_1048._m19));
    vec4 _4706 = _90(_4742, _4743);
    
    // FIX FOR GLASS    
    _4706.x += vk3d_params[VIEW].stereo.x * (_4706.w - vk3d_params[VIEW].stereo.y)* 0.5;
    vec2 _4750 = _4706.xy / vec2(_4706.w);

    _4706 = vec4(_4750.x, _4750.y, _4706.z, _4706.w);
    float _4753 = mix(min(_1015._m3, 0.99989998340606689453125), 1.0, _4675);
    float _4760 = fract(_4753 * 4.0);
    vec3 _4764 = vec3(0.0);
    if (_4753 > 0.97500002384185791015625)
    {
        _4764 = TEXTURE_LOD(_4770, vec4(_4706.xy, 0.0, 0.0).xy, vec4(_4706.xy, 0.0, 0.0).w).xyz;
    }
    else
    {
        if (_4753 > 0.75)
        {
            _4764 = mix(TEXTURE_LOD(_4792, vec4(_4706.xy, 0.0, 0.0).xy, vec4(_4706.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4770, vec4(_4706.xy, 0.0, 0.0).xy, vec4(_4706.xy, 0.0, 0.0).w).xyz, vec3(_4760));
        }
        else
        {
            if (_4753 > 0.5)
            {
                _4764 = mix(TEXTURE_LOD(_4831, vec4(_4706.xy, 0.0, 0.0).xy, vec4(_4706.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4792, vec4(_4706.xy, 0.0, 0.0).xy, vec4(_4706.xy, 0.0, 0.0).w).xyz, vec3(_4760));
            }
            else
            {
                if (_4753 > 0.25)
                {
                    _4764 = mix(TEXTURE_LOD(_4870, vec4(_4706.xy, 0.0, 0.0).xy, vec4(_4706.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4831, vec4(_4706.xy, 0.0, 0.0).xy, vec4(_4706.xy, 0.0, 0.0).w).xyz, vec3(_4760));
                }
                else
                {
                    _4764 = mix(TEXTURE_LOD(_4905, vec4(_4706.xy, 0.0, 0.0).xy, vec4(_4706.xy, 0.0, 0.0).w).xyz, TEXTURE_LOD(_4870, vec4(_4706.xy, 0.0, 0.0).xy, vec4(_4706.xy, 0.0, 0.0).w).xyz, vec3(_4760));
                }
            }
        }
    }
    _1015._m21 = mix(_1015._m0 * _4764, _1015._m19, vec3(_1015._m11)) + _1015._m20;
    _4954 = vec4(_1015._m21, _1015._m11);
    vec2 _4963 = _1015._m16.xy * _1048._m6.zw;
    float _4971 = _1015._m16.z;
    vec4 _4974 = vec4(0.0);
    float _4975 = 1.0;
    float _4977 = _1048._m20.w;
    uint _4976 = _31(_4977);
    if ((_4976 & 6u) != 0u)
    {
        vec2 _4987 = _4963 + vec2(0.0);
        vec3 _4991 = _1048._m21.xyz;
        float _4995 = 0.100000001490116119384765625;
        float _4997 = _1048._m22.y;
        float _5000 = _1048._m21.z;
        float _5003 = 0.0;
        float _5005 = _4971;
        vec4 _5007 = _1048._m7;
        float _5010 = 1.0;
        bool _5011 = false;
        float _5004 = _180(_5005, _5007, _5010, _5011);
        _5003 = pow(max(0.0, (_5004 - _4995) / (_4997 - _4995)), 0.5);
        _5003 = (_5003 * (_5000 - 1.0)) / _5000;
        vec4 _5028 = vec4(_4987, _5003, 0.0);

        // Correction for Volumetrics on Glass - colour inversion
        _5028.x -= vk3d_params[VIEW].stereo.x* 0.5;

        vec3 _5054 = textureLod(_5037, vec4(_5028.xyz, 0.0).xyz, vec4(_5028.xyz, 0.0).w).xyz;
        _4974 = vec4(_5054.x, _5054.y, _5054.z, _4974.w);
        vec2 _5057 = textureLod(_5058, vec4(_5028.xyz, 0.0).xyz, vec4(_5028.xyz, 0.0).w).xy;
        _4974.w = _5057.x;
        _4975 = _5057.y;
    }
    if ((_4976 & 2u) != 0u)
    {
        vec4 _5086 = vec4(0.0);
        vec3 _5087 = _1048._m4.xyz;
        float _5092 = _4971;
        vec4 _5094 = _1048._m7;
        float _5097 = 1.0;
        bool _5098 = false;
        float _5091 = _180(_5092, _5094, _5097, _5098);
        vec3 _5100 = mix(_1048._m23.xyz, _1048._m24.xyz, vec3(_4963.x * _1048._m25.z));
        vec3 _5116 = mix(_1048._m26.xyz, _1048._m27.xyz, vec3(_4963.x * _1048._m25.z));
        vec3 _5132 = mix(_5116, _5100, vec3(1.0 - (_4963.y * _1048._m25.w)));
        vec4 _5143 = vec4(0.0);
        vec3 _5144 = normalize(_5132);
        float _5147 = _5144.z;
        _5143.x = clamp(_104(_5147) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _5156 = _5144.y;
        float _5159 = _5144.x;
        _5143.y = _114(_5156, _5159) / 6.283185482025146484375;
        _5143.z = sqrt(_5091 * _1048._m28.w);
        _5143.z = clamp(_5143.z, 0.015625, 0.984375);
        vec3 _5186 = textureLod(_5179, _5143.xyz, _5143.w).xyz;
        _5086 = vec4(_5186.x, _5186.y, _5186.z, _5086.w);
        vec3 _5195 = _4954.xyz + (_5086.xyz * _4975);
        _4954 = vec4(_5195.x, _5195.y, _5195.z, _4954.w);
    }
    if ((_4976 & 4u) != 0u)
    {
        vec3 _5210 = (_4954.xyz * _4974.w) + _4974.xyz;
        _4954 = vec4(_5210.x, _5210.y, _5210.z, _4954.w);
    }
    vec3 _5218 = _4954.xyz + _1036._m8.xyz;
    _4954 = vec4(_5218.x, _5218.y, _5218.z, _4954.w);
    _4954.w = 1.0;
    _5223 = vec4(0.0);
    _5224 = vec4(0.0);
    if (_1048._m29.w > 0.0)
    {
        vec2 _5231 = gl_FragCoord.xy * _1048._m6.xy;
        bool _5238 = (gl_FragCoord.z < TEXTURE_LOD(_5242, vec4(_5231, 0.0, 0.0).xy, vec4(_5231, 0.0, 0.0).w).x) ? true : false;
        if (_5238 == false)
        {
            _5223 = _4954;
        }
        _4954 *= float(_5238 == true);
        _5224.x = _4954.w;
    }
}


