#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _801
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1567
{
    int _m0;
    int _m1;
};

struct _1570
{
    int _m0;
    int _m1;
};

struct _1958
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3403
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4238
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 1, binding = 0, std140) uniform _822_824
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
} _824;

layout(set = 0, binding = 0, std140) uniform _834_836
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
} _836;

layout(set = 2, binding = 0, std140) uniform _936_938
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _938;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1572_1574
{
    _1570 _m0[];
} _1574;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1934_1936
{
    uint _m0[];
} _1936;

layout(set = 0, binding = 15, std140) uniform _1963_1965
{
    vec4 _m0[4096];
} _1965;

layout(set = 0, binding = 16, std140) uniform _2002_2004
{
    vec4 _m0[4096];
} _2004;

layout(set = 0, binding = 17, std140) uniform _2070_2072
{
    vec4 _m0[4096];
} _2072;

layout(set = 0, binding = 20, std140) uniform _3407_3409
{
    vec4 _m0[4095];
} _3409;

layout(set = 0, binding = 22, std140) uniform _4242_4244
{
    vec4 _m0[4096];
} _4244;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4680_4682
{
    vec4 _m0[];
} _4682;

layout(push_constant, std430) uniform _4676_4678
{
    int _m0;
    int _m1;
} _4678;

layout(set = 3, binding = 0) uniform texture2D _964[16384];
layout(set = 0, binding = 5) uniform sampler _972;
layout(set = 3, binding = 2) uniform texture2D _982[16384];
layout(set = 0, binding = 6) uniform sampler _987;
layout(set = 3, binding = 1) uniform texture2D _998[16384];
layout(set = 0, binding = 7) uniform sampler _1003;
layout(set = 3, binding = 3) uniform texture2D _1012[16384];
layout(set = 0, binding = 8) uniform sampler _1017;
layout(set = 3, binding = 5) uniform texture2D _1026[16384];
layout(set = 0, binding = 9) uniform sampler _1031;
layout(set = 3, binding = 7) uniform texture2D _1040[16384];
layout(set = 0, binding = 10) uniform sampler _1045;
layout(set = 3, binding = 4) uniform texture2D _1054[16384];
layout(set = 0, binding = 11) uniform sampler _1059;
layout(set = 3, binding = 6) uniform texture2D _1068[16384];
layout(set = 0, binding = 12) uniform sampler _1073;
layout(set = 1, binding = 1) uniform SAMPLER_2D _1374;
layout(set = 1, binding = 2) uniform SAMPLER_2D _1379;
layout(set = 0, binding = 18) uniform samplerCubeArray _2556;
layout(set = 0, binding = 19) uniform SAMPLER_2D _2964;
layout(set = 0, binding = 21) uniform sampler2DShadow _3731;
layout(set = 0, binding = 23) uniform SAMPLER_2D _4383;
layout(set = 1, binding = 3) uniform SAMPLER_2D _4547;
layout(set = 0, binding = 3) uniform sampler3D _4686;
layout(set = 0, binding = 4) uniform sampler3D _4687;

layout(location = 2) in vec4 _815;
layout(location = 6) in vec4 _841;
layout(location = 3) in vec4 _853;
layout(location = 4) in vec4 _856;
layout(location = 5) in vec4 _859;
layout(location = 10) in vec4 _877;
layout(location = 11) in vec4 _881;
layout(location = 12) in vec4 _885;
layout(location = 14) flat in uvec3 _898;
layout(location = 15) in vec4 _901;
layout(location = 8) in vec4 _1384;
layout(location = 0) out vec4 _4593;
layout(location = 1) out vec4 _4601;
layout(location = 2) out vec4 _4609;
layout(location = 3) out vec4 _4627;

float _266;

uvec4 _28(vec4 _27)
{
    return floatBitsToUint(_27);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _48(float _47)
{
    if (_47 <= 0.040449999272823333740234375)
    {
        return _47 / 12.9200000762939453125;
    }
    else
    {
        return pow((_47 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _51(vec3 _50)
{
    float _268 = _50.x;
    vec3 _267;
    _267.x = _48(_268);
    float _274 = _50.y;
    _267.y = _48(_274);
    float _280 = _50.z;
    _267.z = _48(_280);
    return _267;
}

vec3 _54(vec3 _53)
{
    vec3 _289 = _53;
    return _51(_289);
}

float _135(float _131, vec4 _132, float _133, bool _134)
{
    float _643 = _132.w / (_131 + _132.z);
    return _643 * _133;
}

vec3 _140(vec3 _138, bool _139)
{
    vec3 _656 = (_138 * 2.0) - vec3(1.0);
    float _673 = (1.0 - (_656.x * _656.x)) - (_656.y * _656.y);
    _656.z = sqrt(_10(_673));
    if (_139 == false)
    {
        _656.z = -_656.z;
    }
    return _656;
}

vec3 _147(vec3 _145, mat3 _146)
{
    return normalize(vec3(dot(_145, _146[0]), dot(_145, _146[1]), dot(_145, _146[2])));
}

vec3 _153(vec3 _150, mat3 _151, bool _152)
{
    vec3 _706 = _150;
    bool _708 = _152;
    vec3 _705 = _140(_706, _708);
    vec3 _711 = _705;
    mat3 _713 = _151;
    return _147(_711, _713);
}

float _60(float _59)
{
    return _59 * _59;
}

vec3 _57(vec3 _56)
{
    return _56 * _56;
}

float _65(float _62, float _63, float _64)
{
    float _311 = (_62 - _63) / (_64 - _63);
    return _10(_311);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

float _39(float _36, float _37, float _38)
{
    return min(_36, min(_37, _38));
}

float _34(float _31, float _32, float _33)
{
    return max(_31, max(_32, _33));
}

vec4 _84(uint _83)
{
    return unpackUnorm4x8(_83).wzyx;
}

float _68(float _67)
{
    return exp2(_67);
}

vec3 _100(uint _99)
{
    uint _409 = _99;
    vec4 _408 = _84(_409);
    float _421 = (_408.w * 255.0) - 128.0;
    return _408.xyz * _68(_421);
}

vec3 _91(uint _90)
{
    return vec3(float((_90 >> uint(21)) & 2047u), float((_90 >> uint(10)) & 2047u), float(_90 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

vec4 _87(uint _86)
{
    return vec4(float((_86 >> uint(24)) & 255u), float((_86 >> uint(16)) & 255u), float((_86 >> uint(8)) & 255u), float(_86 & 255u));
}

vec3 _126(float _123, float _124, vec3 _125)
{
    float _595 = 0.0949999988079071044921875 + (_124 * (0.60000002384185791015625 + (4.190000057220458984375 * _124)));
    float _605 = _123 + 0.02500000037252902984619140625;
    float _609 = (9.5 * _124) * _123;
    float _623 = 1.0 - (14.0 * _123);
    float _615 = (_595 * _605) * _68(_623);
    float _630 = -_609;
    float _626 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _68(_630)));
    return mix(vec3(_615), vec3(_626), _125);
}

vec4 _97(uvec2 _96)
{
    return vec4(float((_96.x >> uint(16)) & 65535u), float(_96.x & 65535u), float((_96.y >> uint(16)) & 65535u), float(_96.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _76(float _75)
{
    return (step(0.0, _75) * 2.0) - 1.0;
}

uint _45(float _42, float _43, float _44)
{
    bool _207 = abs(_44) >= abs(_42);
    bool _215;
    if (_207)
    {
        _215 = abs(_44) >= abs(_43);
    }
    else
    {
        _215 = _207;
    }
    if (_215)
    {
        return uint((_44 < 0.0) ? 5 : 4);
    }
    if (abs(_43) >= abs(_42))
    {
        return uint((_43 < 0.0) ? 3 : 2);
    }
    return uint(int(_42 < 0.0));
}

float _73(float _71, float _72)
{
    return pow(_71, _72);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _105(vec3 _103, float _104)
{
    float _433 = 50.0 * dot(_103, vec3(0.33329999446868896484375));
    float _426 = _10(_433);
    float _442 = 1.0 - _104;
    float _445 = _10(_442);
    float _446 = 5.0;
    vec3 _450 = _103 + ((vec3(_426) - _103) * _73(_445, _446));
    return _16(_450);
}

vec3 _113(vec3 _108, vec3 _109, vec3 _110, vec3 _111, float _112)
{
    vec3 _454 = normalize(_109 + _110);
    float _459 = 1.0 - (_112 * 0.800000011920928955078125);
    _459 *= _459;
    _459 *= _459;
    float _470 = _459 * _459;
    float _478 = dot(_108, _454);
    float _474 = _10(_478);
    float _480 = ((_474 * _474) * (_470 - 1.0)) + 1.0;
    _480 = _470 / ((_480 * _480) + 9.9999999392252902907785028219223e-09);
    float _499 = dot(_108, _109);
    float _495 = (_10(_499) * (1.0 - _459)) + _459;
    float _510 = dot(_108, _110);
    float _506 = (_10(_510) * (1.0 - _459)) + _459;
    _480 /= (((4.0 * _495) * _506) + 9.9999999392252902907785028219223e-09);
    vec3 _528 = _111;
    float _530 = dot(_110, _454);
    return _105(_528, _530) * _480;
}

vec3 _120(vec3 _116, vec3 _117, vec3 _118, float _119)
{
    float _536 = 1.0 - (_119 * 0.800000011920928955078125);
    _536 *= _536;
    _536 *= _536;
    float _546 = _536 * _536;
    float _554 = dot(_116, _117);
    float _550 = _10(_554);
    float _556 = ((_550 * _550) * (_546 - 1.0)) + 1.0;
    _556 = _546 / ((_556 * _556) + 9.9999999392252902907785028219223e-09);
    float _574 = dot(_116, _117);
    float _570 = (_10(_574) * (1.0 - _536)) + _536;
    _556 /= (((4.0 * _570) * _570) + 9.9999999392252902907785028219223e-09);
    vec3 _588 = _118;
    return _16(_588) * _556;
}

vec2 _159(vec2 _158)
{
    return (vec2(1.0) - abs(_158.yx)) * vec2((_158.x >= 0.0) ? 1.0 : (-1.0), (_158.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _164(inout vec3 _162, bool _163)
{
    _162 /= vec3((abs(_162.x) + abs(_162.y)) + abs(_162.z));
    vec2 _753;
    if (_162.z >= 0.0)
    {
        _753 = _162.xy;
    }
    else
    {
        vec2 _759 = _162.xy;
        _753 = _159(_759);
    }
    _162 = vec3(_753.x, _753.y, _162.z);
    if (_163)
    {
        vec2 _774 = (_162.xy * 0.5) + vec2(0.5);
        _162 = vec3(_774.x, _774.y, _162.z);
    }
    return _162.xy;
}

float _79(float _78)
{
    return sqrt(_78);
}

float _167(float _166)
{
    float _784 = abs(_166);
    float _781 = _79(_784);
    float _788;
    if (_166 > 0.0)
    {
        _788 = _781;
    }
    else
    {
        _788 = -_781;
    }
    return (_788 * 0.5) + 0.5;
}

void main()
{
    _801 _803 = _801(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _803._m15 = _815;
    _803._m16 = gl_FragCoord;
    _803._m40 = (uint(_824._m25.z) & 3u) << uint(4);
    _803._m14 = _836._m0.xyz + _841.xyz;
    _803._m13 = normalize(-_841.xyz);
    _803._m17 = mat3(vec3(_853.xyz), vec3(_856.xyz), vec3(_859.xyz));
    _803._m34 = _877;
    _803._m35 = _881;
    _803._m36 = _885;
    uint _888 = 0u;
    vec4 _889 = vec4(0.0);
    vec4 _890 = vec4(0.0);
    vec4 _891 = vec4(0.0);
    vec4 _892 = vec4(0.0);
    vec4 _893 = vec4(0.0);
    uvec3 _896 = _898;
    vec3 _900 = _901.xyz;
    bool _907 = _896.y == 65535u;
    bool _913;
    if (_907)
    {
        _913 = _896.z == 65535u;
    }
    else
    {
        _913 = _907;
    }
    bool _904 = _913;
    bool _914 = !_904;
    bool _917 = _896.z != 65535u;
    uint _921 = _896.x & 7u;
    uint _931;
    if (_836._m2.x == 0.0)
    {
        _931 = _921;
    }
    else
    {
        vec4 _939 = _938._m4;
        uvec4 _935 = _28(_939);
        uint _943 = _935[_921 / 2u];
        uint _948 = 16u * (_921 & 1u);
        _931 = (_943 >> _948) & 65535u;
    }
    uint _957 = _931;
    uint _966 = _957;
    vec3 _959 = texture(sampler2D(_964[nonuniformEXT(_966)], _972), _803._m15.zw).xyz;
    uint _984 = _957;
    vec2 _981 = texture(sampler2D(_982[nonuniformEXT(_984)], _987), _803._m15.zw).yx;
    vec3 _995 = vec3(0.039999999105930328369140625);
    uint _1000 = _957;
    _995 = texture(sampler2D(_998[nonuniformEXT(_1000)], _1003), _803._m15.zw).xyz;
    uint _1014 = _957;
    float _1011 = texture(sampler2D(_1012[nonuniformEXT(_1014)], _1017), _803._m15.zw).x;
    float _1025 = 1.0;
    uint _1028 = _957;
    _1025 = texture(sampler2D(_1026[nonuniformEXT(_1028)], _1031), _803._m15.zw).x;
    uint _1042 = _957;
    float _1039 = texture(sampler2D(_1040[nonuniformEXT(_1042)], _1045), _803._m15.zw).x;
    uint _1056 = _957;
    float _1053 = texture(sampler2D(_1054[nonuniformEXT(_1056)], _1059), _803._m15.zw).x;
    uint _1070 = _957;
    vec3 _1067 = texture(sampler2D(_1068[nonuniformEXT(_1070)], _1073), _803._m15.zw).xyz;
    _891 = vec4(_959.x, _959.y, _959.z, _891.w);
    _891.w = _981.y;
    _892 = vec4(_995.x, _995.y, _995.z, _892.w);
    _892.w = _1053;
    _893 = vec4(_893.x, _981.x, _893.z, _981.y);
    _889.x = _1039;
    _889.y = _1025;
    _889.z = _1053;
    _889.w = _1011;
    _890 = vec4(_1067.x, _1067.y, _1067.z, _890.w);
    uint _1106 = 0u;
    vec4 _1107 = vec4(0.0);
    vec4 _1108 = vec4(0.0);
    vec4 _1109 = vec4(0.0);
    vec4 _1110 = vec4(0.0);
    vec4 _1111 = vec4(0.0);
    uint _1112 = _898.x & 7u;
    uint _1122;
    if (_836._m2.x == 0.0)
    {
        _1122 = _1112;
    }
    else
    {
        vec4 _1126 = _938._m4;
        uvec4 _1125 = _28(_1126);
        uint _1130 = _1125[_1112 / 2u];
        uint _1135 = 16u * (_1112 & 1u);
        _1122 = (_1130 >> _1135) & 65535u;
    }
    uint _1143 = _1122;
    vec4 _1145 = vec4(_803._m15.xy, 0.0, _938._m5.x);
    uint _1156 = _1143;
    vec3 _1154 = texture(sampler2D(_964[nonuniformEXT(_1156)], _972), _1145.xy, _1145.w).xyz;
    uint _1169 = _1143;
    vec2 _1167 = texture(sampler2D(_982[nonuniformEXT(_1169)], _987), _1145.xy, _1145.w).yx;
    vec3 _1180 = vec3(0.039999999105930328369140625);
    uint _1182 = _1143;
    _1180 = texture(sampler2D(_998[nonuniformEXT(_1182)], _1003), _1145.xy, _1145.w).xyz;
    uint _1195 = _1143;
    float _1193 = texture(sampler2D(_1012[nonuniformEXT(_1195)], _1017), _1145.xy, _1145.w).x;
    float _1206 = 1.0;
    uint _1208 = _1143;
    _1206 = texture(sampler2D(_1026[nonuniformEXT(_1208)], _1031), _1145.xy, _1145.w).x;
    uint _1221 = _1143;
    float _1219 = texture(sampler2D(_1040[nonuniformEXT(_1221)], _1045), _1145.xy, _1145.w).x;
    uint _1234 = _1143;
    float _1232 = texture(sampler2D(_1054[nonuniformEXT(_1234)], _1059), _1145.xy, _1145.w).x;
    uint _1247 = _1143;
    vec3 _1245 = texture(sampler2D(_1068[nonuniformEXT(_1247)], _1073), _1145.xy, _1145.w).xyz;
    _1107 = vec4(_1154.x, _1154.y, _1154.z, _1107.w);
    _1107.w = _1167.y;
    _1108 = vec4(_1180.x, _1180.y, _1180.z, _1108.w);
    _1108.w = _1232;
    _1109 = vec4(_1109.x, _1167.x, _1109.z, _1167.y);
    _1110.x = _1219;
    _1110.y = _1206;
    _1110.z = _1232;
    _1110.w = _1193;
    _1111 = vec4(_1245.x, _1245.y, _1245.z, _1111.w);
    _803._m8 = _1109.wyz;
    float _1292 = _889.y * _938._m6.x;
    _803._m4 = _10(_1292);
    float _1299;
    if (_938._m7.x > 0.0)
    {
        _1299 = _892.x;
    }
    else
    {
        _1299 = 0.0;
    }
    _803._m5 = _1299;
    vec3 _1310;
    if (_938._m7.x > 0.0)
    {
        _1310 = vec3(_892.y);
    }
    else
    {
        _1310 = _892.xyz;
    }
    _892 = vec4(_1310.x, _1310.y, _1310.z, _892.w);
    float _1329 = (1.0 - _803._m4) * _938._m8.x;
    _803._m12 = _10(_1329);
    _803._m10 = vec3(_889.x) * _900;
    _803._m10 *= vec3(_836._m3.x);
    _803._m0 = _891.xyz;
    _803._m2 = _892.xyz;
    _803._m1 = _890.xyz;
    _803._m9 = _889.xyz;
    _803._m3 = _889.w;
    _803._m6 = _893.wyz;
    vec2 _1364 = _815.xy * _824._m26.xy;
    vec4 _1372 = SAMPLE_TEXTURE(_1374, _1364);
    vec4 _1378 = SAMPLE_TEXTURE(_1379, _1364);
    float _1389 = _1384.x * 0.5;
    float _1383 = 1.0 - _10(_1389);
    float _1395 = _1383 * 2.0;
    float _1402 = (_10(_1395) - (1.0 - _1372.w)) * 1.0;
    float _1392 = _10(_1402);
    float _1411 = (_1383 - (1.0 - _1378.w)) * 1.0;
    float _1404 = _10(_1411);
    vec3 _1415 = _1372.xyz;
    _803._m0 = mix(_803._m0, _54(_1415), vec3(_1392));
    _803._m2 = mix(_803._m2, vec3(0.0199999995529651641845703125), vec3(_1392));
    _803._m3 = mix(_803._m3, 0.64999997615814208984375, _1392);
    _803._m6 = mix(_803._m6, _1378.xyz, vec3(_1404));
    uint _1445 = uint((_824._m25.x > 0.0) ? 8 : 0);
    float _1451 = 16.0;
    float _1453 = 8.0;
    float _1455 = 24.0;
    vec2 _1464 = _803._m16.xy * _836._m4.xy;
    vec3 _1457;
    _1457 = vec3(_1464.x, _1464.y, _1457.z);
    _1457.y = 1.0 - _1457.y;
    
           // DECALS
    _1457.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1477 = floor(_1457.xy * vec2(_1451, _1453));
    _1457 = vec3(_1477.x, _1477.y, _1457.z);
    float _1481 = _803._m16.z;
    vec4 _1484 = _836._m5;
    float _1487 = 1.0;
    bool _1488 = false;
    float _1480 = _135(_1481, _1484, _1487, _1488);
    float _1490 = log2(max(1.0, _1480 / _836._m6.z)) * _836._m6.w;
    _1457.z = min(_1455 - 1.0, floor(_1490));
    uint _1506 = uint((_1457.x + (_1457.y * _1451)) + ((_1457.z * _1451) * _1453));
    _1506 = min(_1506, uint(((_1451 * _1453) * _1455) - 1.0));
    bool _1531 = true;
    vec3 _1533 = _803._m6;
    bool _1536 = _1531;
    _803._m7 = _140(_1533, _1536);
    vec3 _1540 = _803._m7;
    mat3 _1543 = _803._m17;
    _803._m6 = _147(_1540, _1543);
    vec3 _1548 = _803._m8;
    mat3 _1551 = _803._m17;
    bool _1554 = _1531;
    _803._m8 = _153(_1548, _1551, _1554);
    uint _1558 = 0u;
    uint _1559 = 0u;
    uint _1560 = 0u;
    uint _1561 = 0u;
    uint _1562 = 0u;
    uint _1563 = 0u;
    int _1565 = 256;
    _1567 _1569;
    _1569._m0 = _1574._m0[_1506]._m0;
    _1569._m1 = _1574._m0[_1506]._m1;
    int _1583 = _1569._m0 & (~(_1569._m0 >> 31));
    int _1592 = _1569._m1 & (~(_1569._m1 >> 31));
    _1558 = uint((_1583 >> 16) * _1565);
    _1559 = _1558 + uint(_1592 & 255);
    _1560 = _1558;
    _1561 = _1560 + uint((_1592 >> 8) & 255);
    _1562 = _1558;
    _1563 = _1562 + uint((_1592 >> 16) & 255);
    float _1627 = _803._m37;
    float _1625 = _60(_1627);
    float _1634 = _1625 - 0.5;
    float _1631 = _10(_1634) * 2.0;
    float _1646 = _1625 * 2.0;
    float _1637 = (_803._m38 * _803._m38) * _10(_1646);
    float _1653 = _1637 + _1631;
    float _1649 = _10(_1653);
    if (_1649 > 0.0039215688593685626983642578125)
    {
        vec3 _1662 = _803._m0;
        float _1669 = _1649 * 1.0;
        float _1670 = 0.0;
        float _1671 = 0.3499999940395355224609375;
        _803._m0 = mix(_803._m0, _57(_1662), vec3(_65(_1669, _1670, _1671) * (1.0 - _803._m3)));
        float _1685 = _1649 * 1.0;
        float _1686 = 0.25;
        float _1687 = 0.5;
        _803._m2 = mix(_803._m2, vec3(0.039999999105930328369140625), vec3(_65(_1685, _1686, _1687)));
        vec3 _1692 = vec3(_803._m17[0].z, _803._m17[1].z, _803._m17[2].z);
        float _1706 = _1692.z + 0.0625;
        float _1700 = _1649 * _10(_1706);
        float _1715 = _1700 * 1.0;
        float _1716 = 0.20000000298023223876953125;
        float _1717 = 1.0;
        _803._m3 = mix(_803._m3, 0.89999997615814208984375, _65(_1715, _1716, _1717));
        float _1726 = _1700 * 1.0;
        float _1727 = 0.449999988079071044921875;
        float _1728 = 0.980000019073486328125;
        float _1721 = _65(_1726, _1727, _1728);
        _803._m6 = normalize(mix(_803._m6, vec3(0.0, 0.0, 1.0), vec3(_1721)));
        _803._m7 = mix(_803._m6, vec3(0.5, 0.5, 1.0), vec3(_1721));
        if (_1700 > 0.980000019073486328125)
        {
            float _1752 = _1700 * _1721;
            float _1753 = 0.980000019073486328125;
            float _1754 = 1.0;
            _1692 = normalize(mix(_1692, vec3(0.0, 0.0, 1.0), vec3(_65(_1752, _1753, _1754))));
            _803._m17[0].z = _1692.x;
            _803._m17[1].z = _1692.y;
            _803._m17[2].z = _1692.z;
        }
    }
    vec3 _1768 = vec3(0.0);
    vec3 _1769 = vec3(_803._m34.x, _803._m34.y, _803._m34.z);
    vec3 _1777 = vec3(_803._m34.w, _803._m35.x, _803._m35.y);
    vec3 _1785 = vec3(_803._m35.z, _803._m35.w, _803._m36.x);
    vec3 _1793 = vec3(_803._m36.y, _803._m36.z, _803._m36.w);
    vec3 _1801 = ((_1769 - (_1777 * _803._m6.y)) + (_1785 * _803._m6.z)) - (_1793 * _803._m6.x);
    float _1825 = _824._m27.x * _836._m7.x;
    _1768 += max(_1801 * _10(_1825), vec3(0.0));
    vec3 _1831 = vec3(0.0);
    vec3 _1832 = vec3(_803._m34.x, _803._m34.y, _803._m34.z);
    vec3 _1840 = vec3(_803._m34.w, _803._m35.x, _803._m35.y);
    vec3 _1848 = vec3(_803._m35.z, _803._m35.w, _803._m36.x);
    vec3 _1856 = vec3(_803._m36.y, _803._m36.z, _803._m36.w);
    vec3 _1864 = ((_1832 - (_1840 * _803._m8.y)) + (_1848 * _803._m8.z)) - (_1856 * _803._m8.x);
    float _1887 = _824._m27.x * _836._m7.x;
    _1831 += max(_1864 * _10(_1887), vec3(0.0));
    _1768 = mix(_1768, _1831, vec3(_803._m4));
    float _1904;
    if (dot(_803._m10, vec3(1.0)) > 0.0)
    {
        _1904 = -_803._m3;
    }
    else
    {
        _1904 = _803._m3;
    }
    _803._m3 = _1904;
    _803._m18 = _1768;
    _803._m19 = _1768;
    float _1921 = 1.0;
    uint _1922 = _1562;
    _1958 _1960;
    while (_1922 < _1563)
    {
        uint _1932 = _1936._m0[_1922];
        uint _1941 = (_1932 >> uint(24)) & 4095u;
        uint _1946 = _1941;
        if (_1946 >= _1941)
        {
            _1922++;
        }
        int _1955 = 4;
        int _1956 = 4;
        int _1957 = 4;
        _1960._m0 = _1965._m0[(uint(_1955) * _1946) + 0u].xyz;
        float _1980 = _1965._m0[(uint(_1955) * _1946) + 0u].w;
        _1960._m1 = _21(_1980);
        _1960._m2 = _1965._m0[(uint(_1955) * _1946) + 1u];
        _1960._m3 = _1965._m0[(uint(_1955) * _1946) + 2u];
        _1960._m4 = _2004._m0[(uint(_1956) * _1946) + 0u];
        _1960._m5 = _2004._m0[(uint(_1956) * _1946) + 1u];
        _1960._m6 = _2004._m0[(uint(_1956) * _1946) + 2u];
        float _2034 = _1965._m0[(uint(_1955) * _1946) + 3u].x;
        _1960._m7.x = _21(_2034);
        float _2044 = _1965._m0[(uint(_1955) * _1946) + 3u].y;
        _1960._m7.y = _21(_2044);
        float _2054 = _1965._m0[(uint(_1955) * _1946) + 3u].z;
        _1960._m7.z = _21(_2054);
        float _2064 = _1965._m0[(uint(_1955) * _1946) + 3u].w;
        _1960._m7.w = _21(_2064);
        _1960._m8 = _2072._m0[(uint(_1957) * _1946) + 0u];
        _1960._m9 = _2072._m0[(uint(_1957) * _1946) + 1u];
        _1960._m10 = _2072._m0[(uint(_1957) * _1946) + 2u];
        _1960._m11 = _2072._m0[(uint(_1957) * _1946) + 3u];
        float _2111 = _2004._m0[(uint(_1956) * _1946) + 3u].x;
        _1960._m12 = _21(_2111);
        float _2121 = _2004._m0[(uint(_1956) * _1946) + 3u].y;
        _1960._m13 = _21(_2121);
        _1960._m14 = _2004._m0[(uint(_1956) * _1946) + 3u].z;
        float _2139 = _2004._m0[(uint(_1956) * _1946) + 3u].w;
        _1960._m15 = _21(_2139);
        uint _2144 = (_1960._m12 >> uint(16)) & 3u;
        if (((_803._m40 >> uint(4)) & 3u) != _2144)
        {
            continue;
        }
        vec3 _2158 = vec3((_803._m14.x * _1960._m4.x) + ((_803._m14.y * _1960._m4.y) + ((_803._m14.z * _1960._m4.z) + _1960._m4.w)), (_803._m14.x * _1960._m5.x) + ((_803._m14.y * _1960._m5.y) + ((_803._m14.z * _1960._m5.z) + _1960._m5.w)), (_803._m14.x * _1960._m6.x) + ((_803._m14.y * _1960._m6.y) + ((_803._m14.z * _1960._m6.z) + _1960._m6.w)));
        vec2 _2225 = _2158.xy / vec2(_2158.z);
        _2158 = vec3(_2225.x, _2225.y, _2158.z);
        _2158.z = (_803._m14.x * _1960._m3.x) + ((_803._m14.y * _1960._m3.y) + ((_803._m14.z * _1960._m3.z) + _1960._m3.w));
        float _2249 = 0.0039215688593685626983642578125;
        float _2250 = _2158.x;
        float _2253 = _2158.y;
        float _2256 = _2158.z;
        bool _2261 = _39(_2250, _2253, _2256) < _2249;
        bool _2278;
        if (!_2261)
        {
            float _2265 = _2158.x;
            float _2268 = _2158.y;
            float _2271 = _2158.z;
            _2278 = _34(_2265, _2268, _2271) >= (1.0 - _2249);
        }
        else
        {
            _2278 = _2261;
        }
        if (_2278)
        {
            continue;
        }
        uint _2282 = _1960._m1;
        uint _2286 = _1960._m13;
        vec3 _2285 = _100(_2286);
        float _2290 = _1960._m14;
        vec3 _2293 = _1960._m0;
        if (_1960._m9.w == 0.0)
        {
            if (dot(_1960._m11.xyz, _803._m14) < (_1960._m11.w - _2249))
            {
                continue;
            }
        }
        else
        {
            if (_1960._m9.w == 1.0)
            {
                float _2322 = _1960._m11.w;
                uint _2326 = _21(_2322);
                vec3 _2321 = (((_91(_2326) * 2.0) - vec3(1.0)) * _1960._m11.xyz) + _2293;
                vec3 _2337 = abs(_803._m14 - _2321) / _1960._m11.xyz;
                float _2347 = _2337.x;
                float _2350 = _2337.y;
                float _2353 = _2337.z;
                if (_34(_2347, _2350, _2353) > 1.0)
                {
                    continue;
                }
            }
        }
        uint _2362 = _2282;
        float _2361 = _84(_2362).y;
        vec3 _2366 = (_2158 * 2.0) - vec3(1.0);
        vec3 _2370 = _2366 * sqrt(((vec3(1.0) - ((_2366.yzx * _2366.yzx) * 0.5)) - ((_2366.zxy * _2366.zxy) * 0.5)) + ((((_2366.yzx * _2366.yzx) * _2366.zxy) * _2366.zxy) / vec3(3.0)));
        float _2414 = 1.0 - ((length(_2370) - _2361) / ((1.0 - _2361) + 9.9999999747524270787835121154785e-07));
        float _2403 = _10(_2414);
        _2403 *= _2403;
        _2403 *= (_1960._m8.w * _1921);
        _1921 *= (1.0 - _2403);
        if (_2403 <= (_2249 * 4.0))
        {
            continue;
        }
        vec3 _2436 = _2285;
        uint _2439 = _2282;
        float _2438 = _87(_2439).z;
        vec3 _2443 = vec3(0.0);
        vec3 _2444 = vec3(0.0);
        vec3 _2445 = _803._m6;
        _2445.x = dot(_1960._m2.xy, _803._m6.xy);
        _2445.y = dot(_1960._m2.zw, _803._m6.xy);
        vec3 _2464 = reflect(-_803._m13, _803._m6);
        vec3 _2471 = (_1960._m9.xyz - _803._m14) / _2464;
        vec3 _2480 = (_1960._m8.xyz - _803._m14) / _2464;
        vec3 _2489 = max(_2471, _2480);
        float _2494 = _2489.x;
        float _2497 = _2489.y;
        float _2500 = _2489.z;
        float _2493 = _39(_2494, _2497, _2500);
        vec3 _2504 = _803._m14 + (_2464 * _2493);
        vec3 _2511 = normalize(_2504 - _2293);
        vec3 _2516 = _2511;
        _2516.x = dot(_1960._m2.xy, _2511.xy);
        _2516.y = dot(_1960._m2.zw, _2511.xy);
        float _2538 = dot(_803._m13, _803._m6);
        float _2532 = _10(_2538);
        float _2540 = 0.0;
        float _2541 = 6.0;
        float _2543 = max(_2540, _2541 - (_2541 * abs(_803._m3)));
        _2444 = textureLod(_2556, vec4(_2516, _2438), _2543).xyz * _2290;
        float _2573 = _2532;
        float _2575 = abs(_803._m3);
        vec3 _2576 = _803._m2;
        vec3 _2569 = _126(_2573, _2575, _2576);
        _2444 *= _2569;
        float _2587 = _2403;
        _803._m20 += ((_2444 * _2436) * _10(_2587));
        if (_1921 <= (_2249 * 4.0))
        {
            break;
        }
    }
    uint _2602 = _1558;
    _1958 _2631;
    vec3 _2938;
    float _3014;
    float _3032;
    uint _3377;
    _3403 _3405;
    uint _3527;
    _3403 _3551;
    while (_2602 < _1559)
    {
        uint _2612 = _1936._m0[_2602];
        uint _2616 = _2612 & 4095u;
        uint _2619 = _2616;
        if (_2619 >= _2616)
        {
            _2602++;
        }
        int _2628 = 4;
        int _2629 = 4;
        int _2630 = 4;
        _2631._m0 = _1965._m0[(uint(_2628) * _2619) + 0u].xyz;
        float _2646 = _1965._m0[(uint(_2628) * _2619) + 0u].w;
        _2631._m1 = _21(_2646);
        _2631._m2 = _1965._m0[(uint(_2628) * _2619) + 1u];
        _2631._m3 = _1965._m0[(uint(_2628) * _2619) + 2u];
        _2631._m4 = _2004._m0[(uint(_2629) * _2619) + 0u];
        _2631._m5 = _2004._m0[(uint(_2629) * _2619) + 1u];
        _2631._m6 = _2004._m0[(uint(_2629) * _2619) + 2u];
        float _2696 = _1965._m0[(uint(_2628) * _2619) + 3u].x;
        _2631._m7.x = _21(_2696);
        float _2706 = _1965._m0[(uint(_2628) * _2619) + 3u].y;
        _2631._m7.y = _21(_2706);
        float _2716 = _1965._m0[(uint(_2628) * _2619) + 3u].z;
        _2631._m7.z = _21(_2716);
        float _2726 = _1965._m0[(uint(_2628) * _2619) + 3u].w;
        _2631._m7.w = _21(_2726);
        _2631._m8 = _2072._m0[(uint(_2630) * _2619) + 0u];
        _2631._m9 = _2072._m0[(uint(_2630) * _2619) + 1u];
        _2631._m10 = _2072._m0[(uint(_2630) * _2619) + 2u];
        _2631._m11 = _2072._m0[(uint(_2630) * _2619) + 3u];
        float _2768 = _2004._m0[(uint(_2629) * _2619) + 3u].x;
        _2631._m12 = _21(_2768);
        float _2778 = _2004._m0[(uint(_2629) * _2619) + 3u].y;
        _2631._m13 = _21(_2778);
        _2631._m14 = _2004._m0[(uint(_2629) * _2619) + 3u].z;
        float _2796 = _2004._m0[(uint(_2629) * _2619) + 3u].w;
        _2631._m15 = _21(_2796);
        uint _2801 = (_2631._m12 >> uint(16)) & 3u;
        if (((_803._m40 >> uint(4)) & 3u) != _2801)
        {
            continue;
        }
        float _2815 = 0.0039215688593685626983642578125;
        vec4 _2816 = vec4(_803._m14, 1.0);
        float _2823 = 1.0 / dot(_2816, _2631._m6);
        vec3 _2829 = vec3(dot(_2816, _2631._m4) * _2823, dot(_2816, _2631._m5) * _2823, dot(_2816, _2631._m3));
        uint _2847 = _2631._m1;
        uint _2850 = _1445;
        _2850 |= 64u;
        float _2855 = _2829.x;
        float _2858 = _2829.y;
        float _2861 = _2829.z;
        bool _2866 = _39(_2855, _2858, _2861) <= _2815;
        bool _2883;
        if (!_2866)
        {
            float _2870 = _2829.x;
            float _2873 = _2829.y;
            float _2876 = _2829.z;
            _2883 = _34(_2870, _2873, _2876) >= (1.0 - _2815);
        }
        else
        {
            _2883 = _2866;
        }
        bool _2891;
        if (!_2883)
        {
            _2891 = (_2847 & _2850) != 0u;
        }
        else
        {
            _2891 = _2883;
        }
        if (_2891)
        {
            continue;
        }
        if ((_2847 & 3u) == 2u)
        {
            vec2 _2910 = fract((_2829.xy * _836._m8.xy) + _836._m8.zw);
            _2829 = vec3(_2910.x, _2910.y, _2829.z);
        }
        vec3 _2913 = _2631._m0;
        float _2916 = 1.0;
        float _2917 = 1.0;
        vec3 _2918 = vec3(0.0, 0.0, 1.0);
        vec3 _2919 = vec3(0.0, 0.0, 1.0);
        uint _2920 = _2631._m1;
        vec3 _2923 = (_2829 * 2.0) - vec3(1.0);
        vec2 _2928 = _2829.xy;
        vec3 _2931 = _2631._m10.xyz;
        if ((_2920 & 3u) == 2u)
        {
            _2938 = _2931;
        }
        else
        {
            _2938 = normalize(_2913 - _803._m14);
        }
        _2918 = _2938;
        _2918 = _2918;
        float _2955 = dot(_803._m6, _2918);
        float _2950 = _10(_2955);
        uvec2 _2958 = _2631._m7.zw;
        vec4 _2957 = _97(_2958);
        float _2963 = TEXTURE_LOD(_2964, vec4((_2928 * _2957.xy) + _2957.zw, 0.0, 0.0).xy, vec4((_2928 * _2957.xy) + _2957.zw, 0.0, 0.0).w).x;
        float _2990 = _2963 * _2963;
        uint _2994 = _2920 & 3u;
        bool _2999 = _2994 == 1u;
        bool _3011;
        if (!_2999)
        {
            bool _3004 = _2994 == 0u;
            bool _3010;
            if (_3004)
            {
                _3010 = _2631._m8.z != 0.0;
            }
            else
            {
                _3010 = _3004;
            }
            _3011 = _3010;
        }
        else
        {
            _3011 = _2999;
        }
        bool _2997 = _3011;
        if (_2997)
        {
            float _3017 = _2631._m8.w;
            _3014 = _10(_3017);
        }
        else
        {
            _3014 = 0.5;
        }
        float _3012 = _3014;
        bool _3025 = _2994 == 0u;
        bool _3031;
        if (_3025)
        {
            _3031 = _2631._m8.z != 0.0;
        }
        else
        {
            _3031 = _3025;
        }
        if (_3031)
        {
            float _3040 = sqrt(dot(_2923, _2923));
            _3032 = min(0.9921875, _10(_3040));
        }
        else
        {
            _3032 = _2829.z;
        }
        float _3023 = _3032;
        uvec2 _3048 = _2631._m7.xy;
        vec4 _3047 = _97(_3048);
        vec2 _3053 = vec2(_3023, _3012);
        float _3057 = TEXTURE_LOD(_2964, vec4((_3053 * _3047.xy) + _3047.zw, 0.0, 0.0).xy, vec4((_3053 * _3047.xy) + _3047.zw, 0.0, 0.0).w).x;
        _3057 *= _3057;
        _2916 = _3057 * _2990;
        if ((_2920 & 48u) != 0u)
        {
            vec4 _3095 = _2631._m10;
            vec4 _3098 = _2631._m8;
            vec4 _3101 = _2631._m9;
            float _3104 = dot(_803._m14, _3095.xyz) + _3095.w;
            if (_3104 < 0.0)
            {
                continue;
            }
            float _3118 = length(_3095.xyz);
            float _3125 = _3104 * 50.0;
            float _3122 = _10(_3125);
            _2916 *= (_3122 * _3122);
            _3104 /= _3118;
            _3095 /= vec4(_3118);
            vec3 _3139 = reflect(-_803._m13, _803._m6);
            if (dot(_3139, _3095.xyz) > 0.0)
            {
                _3139 = reflect(_3139, _3095.xyz);
            }
            float _3157 = dot(_3139, _3095.xyz);
            float _3162 = _3104 / _3157;
            vec3 _3166 = _803._m14 - (_3139 * _3162);
            vec3 _3173 = _3166 - _2913;
            float _3177 = dot(_3173, _3098.xyz) / _3098.w;
            float _3185 = dot(_3173, _3101.xyz) / _3101.w;
            if ((_2920 & 48u) == 32u)
            {
                vec2 _3199 = vec2(_3177, _3185);
                float _3203 = 1.0 / max(1.0, length(vec2(_3177, _3185)));
                _3177 *= (_3203 * _3098.w);
                _3185 *= (_3203 * _3101.w);
            }
            else
            {
                float _3225 = abs(_3177);
                float _3227 = _3177;
                _3177 = (_10(_3225) * _76(_3227)) * _3098.w;
                float _3236 = abs(_3185);
                float _3238 = _3185;
                _3185 = (_10(_3236) * _76(_3238)) * _3101.w;
            }
            vec3 _3245 = (_3098.xyz * _3177) + (_3101.xyz * _3185);
            _2913 += _3245;
            _2918 = normalize(_2913 - _803._m14);
            _2918 = _2918;
        }
        else
        {
            uint _3265 = (_2631._m15 >> uint(16)) & 255u;
            if (_3265 == 0u)
            {
                vec4 _3274 = _2631._m9;
                if (dot(_3274.xyz, _803._m14) < (_3274.w - _2815))
                {
                    continue;
                }
            }
            else
            {
                if (_3265 == 1u)
                {
                    vec3 _3295 = _2631._m9.xyz;
                    float _3300 = _2631._m9.w;
                    uint _3304 = _21(_3300);
                    vec3 _3299 = (((_91(_3304) * 2.0) - vec3(1.0)) * _3295) + _2913;
                    vec3 _3313 = abs((_803._m14 - _3299) / _3295);
                    float _3321 = _3313.x;
                    float _3324 = _3313.y;
                    float _3327 = _3313.z;
                    if (_34(_3321, _3324, _3327) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2916 <= (_2815 / 256.0))
        {
            continue;
        }
        float _3343 = 1.0;
        if ((_2847 & 4u) != 0u)
        {
            float _3350 = float(_2631._m15 & 255u) / 255.0;
            float _3356 = 0.00200000009499490261077880859375;
            vec3 _3358 = _803._m14 + (_803._m6 * _3356);
            if ((_2847 & 3u) == 0u)
            {
                vec3 _3371 = _3358 - _2631._m2.xyz;
                float _3378 = _3371.x;
                float _3381 = _3371.y;
                float _3384 = _3371.z;
                _3377 = _45(_3378, _3381, _3384);
            }
            else
            {
                if ((_2847 & 3u) == 2u)
                {
                    float _3394 = 0.0;
                    _3377 = 0u;
                    for (; _3377 < 3u; _3377++)
                    {
                        int _3402 = 5;
                        _3405._m0 = _3409._m0[(uint(_3402) * ((_2847 >> uint(22)) + _3377)) + 0u];
                        _3405._m1 = _3409._m0[(uint(_3402) * ((_2847 >> uint(22)) + _3377)) + 1u];
                        _3405._m2 = _3409._m0[(uint(_3402) * ((_2847 >> uint(22)) + _3377)) + 2u];
                        _3405._m3 = _3409._m0[(uint(_3402) * ((_2847 >> uint(22)) + _3377)) + 3u];
                        _3405._m4 = _3409._m0[(uint(_3402) * ((_2847 >> uint(22)) + _3377)) + 4u];
                        vec2 _3466 = vec2(dot(_3358, _3405._m0.xyz) + _3405._m0.w, dot(_3358, _3405._m1.xyz) + _3405._m1.w);
                        _3466 = abs((_3466 * 2.0) - vec2(1.0));
                        bool _3492 = _3466.x < 0.99500000476837158203125;
                        bool _3498;
                        if (_3492)
                        {
                            _3498 = _3466.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _3498 = _3492;
                        }
                        if (_3498)
                        {
                            _3394 = (1.0 - max(_3466.x, _3466.y)) * _836._m9.w;
                            break;
                        }
                    }
                    _3377 = min(2u, _3377);
                    uint _3515 = uint(_803._m16.x) ^ (uint(_803._m16.y) << uint(1));
                    if (_836._m10.w > 0.0)
                    {
                        _3527 = uint(_836._m11.x);
                    }
                    else
                    {
                        _3527 = 0u;
                    }
                    _3515 ^= _3527;
                    _3377 += uint(int(((float(_3515 & 3u) * 0.25) + 0.125) > _3394));
                }
                else
                {
                    _3377 = 0u;
                }
            }
            int _3550 = 5;
            _3551._m0 = _3409._m0[(uint(_3550) * ((_2847 >> uint(22)) + _3377)) + 0u];
            _3551._m1 = _3409._m0[(uint(_3550) * ((_2847 >> uint(22)) + _3377)) + 1u];
            _3551._m2 = _3409._m0[(uint(_3550) * ((_2847 >> uint(22)) + _3377)) + 2u];
            _3551._m3 = _3409._m0[(uint(_3550) * ((_2847 >> uint(22)) + _3377)) + 3u];
            _3551._m4 = _3409._m0[(uint(_3550) * ((_2847 >> uint(22)) + _3377)) + 4u];
            vec4 _3607 = vec4((_3358.x * _3551._m0.x) + ((_3358.y * _3551._m0.y) + ((_3358.z * _3551._m0.z) + _3551._m0.w)), (_3358.x * _3551._m1.x) + ((_3358.y * _3551._m1.y) + ((_3358.z * _3551._m1.z) + _3551._m1.w)), (_3358.x * _3551._m2.x) + ((_3358.y * _3551._m2.y) + ((_3358.z * _3551._m2.z) + _3551._m2.w)), (_3358.x * _3551._m3.x) + ((_3358.y * _3551._m3.y) + ((_3358.z * _3551._m3.z) + _3551._m3.w)));
            vec3 _3694 = _3607.xyz / vec3(_3607.w);
            _3607 = vec4(_3694.x, _3694.y, _3694.z, _3607.w);
            bool _3702 = min(_3607.x, _3607.y) > 0.0;
            bool _3711;
            if (_3702)
            {
                _3711 = max(_3607.x, _3607.y) < 1.0;
            }
            else
            {
                _3711 = _3702;
            }
            if (_3711)
            {
                vec2 _3723 = (_3607.xy * _3551._m4.xy) + _3551._m4.zw;
                _3607 = vec4(_3723.x, _3723.y, _3607.z, _3607.w);
                if (false)
                {
                    _3343 = textureLod(_3731, vec3(_3607.xyz.xy, _3607.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3738 = (_3607.xy * _836._m12.xy) + vec2(0.5);
                    vec2 _3747 = floor(_3738);
                    vec2 _3750 = _3738 - _3747;
                    _3747 -= vec2(0.5);
                    vec2 _3757 = vec2(4.0) - (_3750 * 3.0);
                    vec2 _3762 = vec2(7.0);
                    vec2 _3765 = vec2(1.0) + (_3750 * 3.0);
                    vec2 _3770 = (_3747 + (((vec2(3.0) - (_3750 * 2.0)) / _3757) - vec2(2.0))) * _836._m12.zw;
                    vec2 _3785 = (_3747 + ((vec2(3.0) + _3750) / _3762)) * _836._m12.zw;
                    vec2 _3797 = (_3747 + ((_3750 / _3765) + vec2(2.0))) * _836._m12.zw;
                    vec3 _3821 = vec3(_3770.x, _3770.y, _3607.z);
                    _3343 = (_3757.x * _3757.y) * textureLod(_3731, vec3(_3821.xy, _3821.z), 0.0);
                    vec3 _3837 = vec3(_3785.x, _3770.y, _3607.z);
                    _3343 += ((_3762.x * _3757.y) * textureLod(_3731, vec3(_3837.xy, _3837.z), 0.0));
                    vec3 _3855 = vec3(_3797.x, _3770.y, _3607.z);
                    _3343 += ((_3765.x * _3757.y) * textureLod(_3731, vec3(_3855.xy, _3855.z), 0.0));
                    vec3 _3873 = vec3(_3770.x, _3785.y, _3607.z);
                    _3343 += ((_3757.x * _3762.y) * textureLod(_3731, vec3(_3873.xy, _3873.z), 0.0));
                    vec3 _3891 = vec3(_3785.x, _3785.y, _3607.z);
                    _3343 += ((_3762.x * _3762.y) * textureLod(_3731, vec3(_3891.xy, _3891.z), 0.0));
                    vec3 _3909 = vec3(_3797.x, _3785.y, _3607.z);
                    _3343 += ((_3765.x * _3762.y) * textureLod(_3731, vec3(_3909.xy, _3909.z), 0.0));
                    vec3 _3927 = vec3(_3770.x, _3797.y, _3607.z);
                    _3343 += ((_3757.x * _3765.y) * textureLod(_3731, vec3(_3927.xy, _3927.z), 0.0));
                    vec3 _3945 = vec3(_3785.x, _3797.y, _3607.z);
                    _3343 += ((_3762.x * _3765.y) * textureLod(_3731, vec3(_3945.xy, _3945.z), 0.0));
                    vec3 _3963 = vec3(_3797.x, _3797.y, _3607.z);
                    _3343 += ((_3765.x * _3765.y) * textureLod(_3731, vec3(_3963.xy, _3963.z), 0.0));
                    _3343 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3343 = float((_2847 & 3u) == 2u);
            }
            float _3977 = float((_2847 >> uint(16)) & 63u) / 63.0;
            float _3991 = ((_3343 * _3977) + 1.0) - _3977;
            _3343 = _10(_3991);
        }
        uint _3994 = _2631._m13;
        vec3 _3993 = (_100(_3994) * _3343) * _2916;
        _2917 *= _2631._m14;
        vec3 _4006 = _3993;
        vec3 _4008 = _2918;
        float _4015 = dot(_803._m6, _4008);
        float _4010 = _10(_4015);
        vec3 _4021 = _803._m6;
        vec3 _4024 = _803._m13;
        vec3 _4027 = _2918;
        vec3 _4029 = _803._m2;
        float _4032 = abs(_803._m3);
        vec3 _4017 = _113(_4021, _4024, _4027, _4029, _4032);
        _803._m20 += (((_4017 * _2917) * _4006) * _4010);
        vec3 _4045 = mix(_4006, vec3(0.0), bvec3((_2847 & 256u) > 0u));
        vec3 _4054 = -_2918;
        vec3 _4057 = mix(_803._m6, _803._m8, _938._m9.xxx);
        vec3 _4066 = mix(_803._m6, _803._m8, _938._m9.yyy);
        vec3 _4075 = mix(_803._m6, _803._m8, _938._m9.zzz);
        vec3 _4095 = vec3(dot(_4057, _4008), dot(_4066, _4008), dot(_4075, _4008));
        vec3 _4084 = _16(_4095);
        float _4104 = dot(_803._m13, _4054);
        vec3 _4113 = (_938._m10.xyz * pow(_10(_4104), _938._m10.w)) * _803._m5;
        _4084 += _16(_4113);
        _4084 = mix(vec3(_4010), _4084, vec3(_803._m4));
        _803._m19 += (_4045 * _4084);
    }
    float _4131 = _836._m13.x;
    if (_4131 > 0.00999999977648258209228515625)
    {
        float _4139 = float(int(_836._m11.x) & 1023) / 1023.0;
        _4131 = max(0.0, _4131 + (((_4139 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4155 = _803._m13;
        float _4163 = dot(_803._m6, _4155);
        float _4158 = _10(_4163);
        float _4165 = _4158 * _4131;
        vec3 _4173 = _803._m6;
        vec3 _4176 = _803._m13;
        vec3 _4179 = _803._m2;
        float _4182 = abs(_803._m3);
        vec3 _4169 = _120(_4173, _4176, _4179, _4182) * _4131;
        _803._m19 += vec3(_4165);
        _803._m20 += vec3(_4169);
    }
    _803._m19 = _803._m19;
    _803._m20 += _803._m10;
    float _4210 = 0.064999997615814208984375;
    float _4212 = 1.0 + _4210;
    bool _4215 = false;
    uint _4220;
    if (_836._m14.w > 0.00999999977648258209228515625)
    {
        _4220 = uint(_836._m14.x);
    }
    else
    {
        _4220 = 0u;
    }
    uint _4216 = _4220;
    _4238 _4240;
    for (uint _4228 = 0u; _4228 < _4216; _4228++)
    {
        int _4237 = 4;
        _4240._m0 = _4244._m0[(uint(_4237) * _4228) + 0u];
        _4240._m1 = _4244._m0[(uint(_4237) * _4228) + 1u];
        _4240._m2 = _4244._m0[(uint(_4237) * _4228) + 2u];
        float _4274 = _4244._m0[(uint(_4237) * _4228) + 3u].x;
        _4240._m3 = _21(_4274);
        float _4284 = _4244._m0[(uint(_4237) * _4228) + 3u].y;
        _4240._m4 = _21(_4284);
        float _4294 = _4244._m0[(uint(_4237) * _4228) + 3u].z;
        _4240._m5 = _21(_4294);
        vec4 _4299 = vec4(_803._m14, 1.0);
        vec3 _4306 = vec3(dot(_4299, _4240._m1), dot(_4299, _4240._m2), dot(_4299, _4240._m0));
        float _4320 = _4306.x;
        float _4323 = _4306.y;
        float _4326 = _4306.z;
        bool _4330 = _39(_4320, _4323, _4326) >= 0.0;
        bool _4339;
        if (_4330)
        {
            _4339 = max(_4306.x, _4306.y) < 1.0;
        }
        else
        {
            _4339 = _4330;
        }
        bool _4346;
        if (_4339)
        {
            _4346 = _4306.z < _4212;
        }
        else
        {
            _4346 = _4339;
        }
        if (_4346)
        {
            float _4349 = _4306.z;
            vec4 _4352 = vec4(_803._m14, 1.0);
            vec2 _4359 = vec2(0.0);
            _4359 = (((_4352.xy - _836._m15.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4372 = 0.000244140625;
            float _4378 = abs(_803._m6.z) * 2.0;
            _4372 *= _10(_4378);
            vec3 _4382 = vec3(TEXTURE_LOD(_4383, vec4(_4359 + vec2(_4372), 0.0, 0.0).xy, vec4(_4359 + vec2(_4372), 0.0, 0.0).w).x, TEXTURE_LOD(_4383, vec4(_4359, 0.0, 0.0).xy, vec4(_4359, 0.0, 0.0).w).x, TEXTURE_LOD(_4383, vec4(_4359 - vec2(_4372), 0.0, 0.0).xy, vec4(_4359 - vec2(_4372), 0.0, 0.0).w).x);
            float _4446 = 2.0 - (2.0 * (length(_4352.xy - _836._m15.zw) / 16.0));
            _4382 *= _10(_4446);
            float _4453 = 1.0 - _4349;
            float _4450 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4453));
            float _4464 = (_803._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4456 = (_4382 * _4450) * _10(_4464);
            float _4473 = _4212 - _4349;
            float _4467 = (1.0 - _4450) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4473));
            float _4487 = ((-_803._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4477 = (_4382 * _4467) * _10(_4487);
            _4382 = _4456 + _4477;
            float _4498 = 1.02499997615814208984375 - _4349;
            float _4493 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4498));
            float _4501 = _836._m14.w;
            _803._m19 = mix(_803._m19, (_803._m19 * _4382) + (_803._m19 * mix(1.0, 0.5, _4493)), vec3(_4501));
            break;
        }
    }
    _803._m19 *= _803._m0;
    _803._m21 = _803._m19 + _803._m20;
    if (_824._m28.x < 1.0)
    {
        vec2 _4541 = gl_FragCoord.xy * 0.00390625;
        float _4546 = TEXTURE_LOD(_4547, vec4(_815.xy * _938._m11.xy, 0.0, 0.0).xy, vec4(_815.xy * _938._m11.xy, 0.0, 0.0).w).x;
        float _4579 = abs(clamp((_824._m28.x - (_4546 * 0.5)) - 0.100000001490116119384765625, -1.0, 0.0));
        _4546 = _10(_4579);
        _4546 *= 600.0;
        _803._m19 += (vec3(_4546) * vec3(1.0, 0.00999999977648258209228515625, 0.0));
    }
    vec3 _4598 = _803._m19 + _803._m20;
    _4593 = vec4(_4598.x, _4598.y, _4598.z, _4593.w);
    vec3 _4602 = _803._m6;
    bool _4605 = false;
    vec2 _4606 = _164(_4602, _4605);
    _4601 = vec4(_4606.x, _4606.y, _4601.z, _4601.w);
    float _4610 = _803._m2.x;
    float _4614 = _803._m2.y;
    float _4618 = _803._m2.z;
    float _4622 = _803._m3;
    _4609 = vec4(_79(_4610), _79(_4614), _79(_4618), _167(_4622));
    _4627 = vec4(0.0, 0.0, 0.0, float((uint(_824._m25.z) & 3u) << uint(4)) / 255.0);
    vec3 _4640 = _803._m19 + _803._m20;
    _4593 = vec4(_4640.x, _4640.y, _4640.z, _4593.w);
    vec3 _4643 = _803._m6;
    bool _4646 = false;
    vec2 _4647 = _164(_4643, _4646);
    _4601 = vec4(_4647.x, _4647.y, _4601.z, _4601.w);
    float _4650 = _803._m2.x;
    float _4654 = _803._m2.y;
    float _4658 = _803._m2.z;
    float _4662 = _803._m3;
    _4609 = vec4(_79(_4650), _79(_4654), _79(_4658), _167(_4662));
    vec3 _4673 = _4593.xyz + _824._m29.xyz;
    _4593 = vec4(_4673.x, _4673.y, _4673.z, _4593.w);
}


