// DECALS
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _774
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1068
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _1785
{
    int _m0;
    int _m1;
};

struct _1788
{
    int _m0;
    int _m1;
};

struct _1899
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2897
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3694
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4459
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 1, binding = 0, std140) uniform _795_797
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _797;

layout(set = 0, binding = 0, std140) uniform _806_808
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _808;

layout(set = 2, binding = 0, std140) uniform _908_910
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _910;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1790_1792
{
    _1788 _m0[];
} _1792;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1874_1876
{
    uint _m0[];
} _1876;

layout(set = 0, binding = 15, std140) uniform _1904_1906
{
    vec4 _m0[4096];
} _1906;

layout(set = 0, binding = 16, std140) uniform _1924_1926
{
    vec4 _m0[4096];
} _1926;

layout(set = 0, binding = 17, std140) uniform _1976_1978
{
    vec4 _m0[4096];
} _1978;

layout(set = 0, binding = 19, std140) uniform _2901_2903
{
    vec4 _m0[4096];
} _2903;

layout(set = 0, binding = 20, std140) uniform _2940_2942
{
    vec4 _m0[4096];
} _2942;

layout(set = 0, binding = 21, std140) uniform _3008_3010
{
    vec4 _m0[4096];
} _3010;

layout(set = 0, binding = 23, std140) uniform _3698_3700
{
    vec4 _m0[4095];
} _3700;

layout(set = 0, binding = 25, std140) uniform _4463_4465
{
    vec4 _m0[4096];
} _4465;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4850_4852
{
    uint _m0[];
} _4852;

layout(set = 0, binding = 2, std430) restrict readonly buffer _4854_4856
{
    vec4 _m0[];
} _4856;

layout(push_constant, std430) uniform _4846_4848
{
    int _m0;
    int _m1;
} _4848;

layout(set = 3, binding = 0) uniform texture2D _936[16384];
layout(set = 0, binding = 6) uniform sampler _944;
layout(set = 3, binding = 2) uniform texture2D _954[16384];
layout(set = 0, binding = 7) uniform sampler _959;
layout(set = 3, binding = 1) uniform texture2D _970[16384];
layout(set = 0, binding = 8) uniform sampler _975;
layout(set = 3, binding = 3) uniform texture2D _984[16384];
layout(set = 0, binding = 9) uniform sampler _989;
layout(set = 3, binding = 7) uniform texture2D _999[16384];
layout(set = 0, binding = 10) uniform sampler _1004;
layout(set = 3, binding = 4) uniform texture2D _1013[16384];
layout(set = 0, binding = 11) uniform sampler _1018;
layout(set = 3, binding = 6) uniform texture2D _1027[16384];
layout(set = 0, binding = 12) uniform sampler _1032;
layout(set = 0, binding = 18) uniform SAMPLER_2D _2200;
layout(set = 0, binding = 22) uniform SAMPLER_2D _3256;
layout(set = 0, binding = 24) uniform sampler2DShadow _4022;
layout(set = 0, binding = 26) uniform SAMPLER_2D _4604;
layout(set = 3, binding = 5) uniform texture2D _4845[16384];
layout(set = 0, binding = 4) uniform sampler3D _4860;
layout(set = 0, binding = 5) uniform sampler3D _4861;

layout(location = 2) in vec4 _788;
layout(location = 6) in vec4 _813;
layout(location = 3) in vec4 _825;
layout(location = 4) in vec4 _828;
layout(location = 5) in vec4 _831;
layout(location = 10) in vec4 _849;
layout(location = 11) in vec4 _853;
layout(location = 12) in vec4 _857;
layout(location = 14) flat in uvec3 _870;
layout(location = 15) in vec4 _873;
layout(location = 0) out vec4 _4763;
layout(location = 1) out vec4 _4771;
layout(location = 2) out vec4 _4779;
layout(location = 3) out vec4 _4797;

float _270;

uvec4 _32(vec4 _31)
{
    return floatBitsToUint(_31);
}

float _52(float _51)
{
    if (_51 <= 0.040449999272823333740234375)
    {
        return _51 / 12.9200000762939453125;
    }
    else
    {
        return pow((_51 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _64(float _63)
{
    float _324 = _63;
    return _52(_324);
}

float _55(float _54)
{
    return _54 * ((_54 * ((_54 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _139(float _135, vec4 _136, float _137, bool _138)
{
    float _629 = _136.w / (_135 + _136.z);
    return _629 * _137;
}

vec3 _144(vec3 _142, bool _143)
{
    vec3 _642 = (_142 * 2.0) - vec3(1.0);
    float _659 = (1.0 - (_642.x * _642.x)) - (_642.y * _642.y);
    _642.z = sqrt(_10(_659));
    if (_143 == false)
    {
        _642.z = -_642.z;
    }
    return _642;
}

vec3 _151(vec3 _149, mat3 _150)
{
    return normalize(vec3(dot(_149, _150[0]), dot(_149, _150[1]), dot(_149, _150[2])));
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _94(uint _93)
{
    return unpackUnorm4x8(_93).wzyx;
}

vec4 _107(uvec2 _106)
{
    return vec4(float((_106.x >> uint(16)) & 65535u), float(_106.x & 65535u), float((_106.y >> uint(16)) & 65535u), float(_106.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _97(uint _96)
{
    return vec4(float((_96 >> uint(24)) & 255u), float((_96 >> uint(16)) & 255u), float((_96 >> uint(8)) & 255u), float(_96 & 255u));
}

float _86(float _85)
{
    return (step(0.0, _85) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _58(vec3 _57)
{
    float _285 = _57.x;
    vec3 _284;
    _284.x = _55(_285);
    float _291 = _57.y;
    _284.y = _55(_291);
    float _297 = _57.z;
    _284.z = _55(_297);
    return _284;
}

vec4 _61(vec4 _60)
{
    vec3 _307 = _60.xyz;
    vec4 _306 = vec4(_58(_307), 1.0);
    float _315 = _60.w;
    _306.w = _55(_315);
    return _306;
}

float _70(float _69)
{
    return _69 * _69;
}

vec3 _67(vec3 _66)
{
    return _66 * _66;
}

float _75(float _72, float _73, float _74)
{
    float _346 = (_72 - _73) / (_74 - _73);
    return _10(_346);
}

vec3 _101(uint _100)
{
    return vec3(float((_100 >> uint(21)) & 2047u), float((_100 >> uint(10)) & 2047u), float(_100 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _211 = abs(_48) >= abs(_46);
    bool _219;
    if (_211)
    {
        _219 = abs(_48) >= abs(_47);
    }
    else
    {
        _219 = _211;
    }
    if (_219)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _78(float _77)
{
    return exp2(_77);
}

vec3 _110(uint _109)
{
    uint _444 = _109;
    vec4 _443 = _94(_444);
    float _455 = (_443.w * 255.0) - 128.0;
    return _443.xyz * _78(_455);
}

float _83(float _81, float _82)
{
    return pow(_81, _82);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _115(vec3 _113, float _114)
{
    float _467 = 50.0 * dot(_113, vec3(0.33329999446868896484375));
    float _460 = _10(_467);
    float _476 = 1.0 - _114;
    float _479 = _10(_476);
    float _480 = 5.0;
    vec3 _484 = _113 + ((vec3(_460) - _113) * _83(_479, _480));
    return _16(_484);
}

vec3 _123(vec3 _118, vec3 _119, vec3 _120, vec3 _121, float _122)
{
    vec3 _488 = normalize(_119 + _120);
    float _493 = 1.0 - (_122 * 0.800000011920928955078125);
    _493 *= _493;
    _493 *= _493;
    float _504 = _493 * _493;
    float _512 = dot(_118, _488);
    float _508 = _10(_512);
    float _514 = ((_508 * _508) * (_504 - 1.0)) + 1.0;
    _514 = _504 / ((_514 * _514) + 9.9999999392252902907785028219223e-09);
    float _533 = dot(_118, _119);
    float _529 = (_10(_533) * (1.0 - _493)) + _493;
    float _544 = dot(_118, _120);
    float _540 = (_10(_544) * (1.0 - _493)) + _493;
    _514 /= (((4.0 * _529) * _540) + 9.9999999392252902907785028219223e-09);
    vec3 _562 = _121;
    float _564 = dot(_120, _488);
    return _115(_562, _564) * _514;
}

vec3 _130(vec3 _126, vec3 _127, vec3 _128, float _129)
{
    float _570 = 1.0 - (_129 * 0.800000011920928955078125);
    _570 *= _570;
    _570 *= _570;
    float _580 = _570 * _570;
    float _588 = dot(_126, _127);
    float _584 = _10(_588);
    float _590 = ((_584 * _584) * (_580 - 1.0)) + 1.0;
    _590 = _580 / ((_590 * _590) + 9.9999999392252902907785028219223e-09);
    float _608 = dot(_126, _127);
    float _604 = (_10(_608) * (1.0 - _570)) + _570;
    _590 /= (((4.0 * _604) * _604) + 9.9999999392252902907785028219223e-09);
    vec3 _622 = _128;
    return _16(_622) * _590;
}

vec2 _157(vec2 _156)
{
    return (vec2(1.0) - abs(_156.yx)) * vec2((_156.x >= 0.0) ? 1.0 : (-1.0), (_156.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _162(inout vec3 _160, bool _161)
{
    _160 /= vec3((abs(_160.x) + abs(_160.y)) + abs(_160.z));
    vec2 _726;
    if (_160.z >= 0.0)
    {
        _726 = _160.xy;
    }
    else
    {
        vec2 _732 = _160.xy;
        _726 = _157(_732);
    }
    _160 = vec3(_726.x, _726.y, _160.z);
    if (_161)
    {
        vec2 _747 = (_160.xy * 0.5) + vec2(0.5);
        _160 = vec3(_747.x, _747.y, _160.z);
    }
    return _160.xy;
}

float _89(float _88)
{
    return sqrt(_88);
}

float _165(float _164)
{
    float _757 = abs(_164);
    float _754 = _89(_757);
    float _761;
    if (_164 > 0.0)
    {
        _761 = _754;
    }
    else
    {
        _761 = -_754;
    }
    return (_761 * 0.5) + 0.5;
}

void main()
{
    _774 _776 = _774(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _776._m15 = _788;
    _776._m16 = gl_FragCoord;
    _776._m40 = (uint(_797._m16.z) & 3u) << uint(4);
    _776._m14 = _808._m2.xyz + _813.xyz;
    _776._m13 = normalize(-_813.xyz);
    _776._m17 = mat3(vec3(_825.xyz), vec3(_828.xyz), vec3(_831.xyz));
    _776._m34 = _849;
    _776._m35 = _853;
    _776._m36 = _857;
    uint _860 = 0u;
    vec4 _861 = vec4(0.0);
    vec4 _862 = vec4(0.0);
    vec4 _863 = vec4(0.0);
    vec4 _864 = vec4(0.0);
    vec4 _865 = vec4(0.0);
    uvec3 _868 = _870;
    vec3 _872 = _873.xyz;
    bool _879 = _868.y == 65535u;
    bool _885;
    if (_879)
    {
        _885 = _868.z == 65535u;
    }
    else
    {
        _885 = _879;
    }
    bool _876 = _885;
    bool _886 = !_876;
    bool _889 = _868.z != 65535u;
    uint _893 = _868.x & 7u;
    uint _903;
    if (_808._m4.x == 0.0)
    {
        _903 = _893;
    }
    else
    {
        vec4 _911 = _910._m3;
        uvec4 _907 = _32(_911);
        uint _915 = _907[_893 / 2u];
        uint _920 = 16u * (_893 & 1u);
        _903 = (_915 >> _920) & 65535u;
    }
    uint _929 = _903;
    uint _938 = _929;
    vec3 _931 = texture(sampler2D(_936[nonuniformEXT(_938)], _944), _776._m15.zw).xyz;
    uint _956 = _929;
    vec2 _953 = texture(sampler2D(_954[nonuniformEXT(_956)], _959), _776._m15.zw).yx;
    vec3 _967 = vec3(0.039999999105930328369140625);
    uint _972 = _929;
    _967 = texture(sampler2D(_970[nonuniformEXT(_972)], _975), _776._m15.zw).xyz;
    uint _986 = _929;
    float _983 = texture(sampler2D(_984[nonuniformEXT(_986)], _989), _776._m15.zw).x;
    float _997 = 1.0;
    uint _1001 = _929;
    float _998 = texture(sampler2D(_999[nonuniformEXT(_1001)], _1004), _776._m15.zw).x;
    uint _1015 = _929;
    float _1012 = texture(sampler2D(_1013[nonuniformEXT(_1015)], _1018), _776._m15.zw).x;
    uint _1029 = _929;
    vec3 _1026 = texture(sampler2D(_1027[nonuniformEXT(_1029)], _1032), _776._m15.zw).xyz;
    _863 = vec4(_931.x, _931.y, _931.z, _863.w);
    _863.w = _953.y;
    _864 = vec4(_967.x, _967.y, _967.z, _864.w);
    _864.w = _1012;
    _865 = vec4(_865.x, _953.x, _865.z, _953.y);
    _861.x = _998;
    _861.y = _997;
    _861.z = _1012;
    _861.w = _983;
    _862 = vec4(_1026.x, _1026.y, _1026.z, _862.w);
    vec2 _1065 = _788.zw;
    _1068 _1070;
    _1070._m0 = _863;
    _1070._m1 = _864;
    float _1075 = _861.x;
    _1070._m2.x = _64(_1075);
    _1070._m2 = vec4(_1070._m2.x, _861.yzw.x, _861.yzw.y, _861.yzw.z);
    _1070._m3 = _865;
    _1070._m4 = _862;
    _1068 _1089 = _1070;
    vec3 _1091 = vec3(0.0);
    bool _1099;
    if (_886)
    {
        _1099 = _872.x < 65534.0;
    }
    else
    {
        _1099 = _886;
    }
    bool _1105;
    if (_1099)
    {
        _1105 = _872.x > 0.0;
    }
    else
    {
        _1105 = _1099;
    }
    if (_1105)
    {
        uint _1108 = 0u;
        _1068 _1109 = _1068(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1111 = _868.y & 7u;
        uint _1120;
        if (_808._m4.x == 0.0)
        {
            _1120 = _1111;
        }
        else
        {
            vec4 _1124 = _910._m3;
            uvec4 _1123 = _32(_1124);
            uint _1128 = _1123[_1111 / 2u];
            uint _1133 = 16u * (_1111 & 1u);
            _1120 = (_1128 >> _1133) & 65535u;
        }
        uint _1141 = _1120;
        uint _1145 = _1141;
        vec3 _1143 = texture(sampler2D(_936[nonuniformEXT(_1145)], _944), _1065).xyz;
        uint _1155 = _1141;
        vec2 _1153 = texture(sampler2D(_954[nonuniformEXT(_1155)], _959), _1065).yx;
        vec3 _1163 = vec3(0.039999999105930328369140625);
        uint _1165 = _1141;
        _1163 = texture(sampler2D(_970[nonuniformEXT(_1165)], _975), _1065).xyz;
        uint _1175 = _1141;
        float _1173 = texture(sampler2D(_984[nonuniformEXT(_1175)], _989), _1065).x;
        float _1183 = 1.0;
        uint _1186 = _1141;
        float _1184 = texture(sampler2D(_999[nonuniformEXT(_1186)], _1004), _1065).x;
        uint _1196 = _1141;
        float _1194 = texture(sampler2D(_1013[nonuniformEXT(_1196)], _1018), _1065).x;
        uint _1206 = _1141;
        vec3 _1204 = texture(sampler2D(_1027[nonuniformEXT(_1206)], _1032), _1065).xyz;
        _1109._m0 = vec4(_1143.x, _1143.y, _1143.z, _1109._m0.w);
        _1109._m0.w = _1153.y;
        _1109._m1 = vec4(_1163.x, _1163.y, _1163.z, _1109._m1.w);
        _1109._m1.w = _1194;
        _1109._m3 = vec4(_1109._m3.x, _1153.x, _1109._m3.z, _1153.y);
        _1109._m2.x = _1184;
        _1109._m2.y = _1183;
        _1109._m2.z = _1194;
        _1109._m2.w = _1173;
        _1109._m4 = vec4(_1204.x, _1204.y, _1204.z, _1109._m4.w);
        float _1243 = _1109._m2.x;
        _1109._m2.x = _55(_1243);
        float _1248 = _1109._m1.w;
        float _1251 = _872.x * _1248;
        float _1256 = _1070._m2.x;
        float _1259 = 0.0;
        float _1260 = 0.0;
        float _1261 = (_1251 * 1.5) - 0.5;
        float _1269 = 1.0 - _1256;
        float _1266 = _10(_1269);
        float _1278 = ((_1266 + _1261) - 0.5) * 10.0;
        float _1271 = _10(_1278);
        _1259 = _1271;
        float _1281 = (_872.x * 1.5) - 0.5;
        float _1289 = 1.0 - _1256;
        float _1286 = _10(_1289);
        float _1297 = ((_1286 + _1281) - 0.5) * 10.0;
        float _1291 = _10(_1297);
        _1260 = _1291;
        _1089._m0 = mix(_1089._m0, _1109._m0, vec4(_1259));
        _1089._m1 = mix(_1089._m1, _1109._m1, vec4(_1259));
        _1089._m2 = mix(_1089._m2, _1109._m2, vec4(_1259));
        _1089._m3 = mix(_1089._m3, _1109._m3, vec4(_1259));
        _1089._m4 = mix(_1089._m4, _1109._m4, vec4(_1259));
        _860 = (_1259 > 0.5) ? _1108 : _860;
        _1091.x = _1259;
    }
    bool _1353;
    if (_889)
    {
        _1353 = _872.y < 65534.0;
    }
    else
    {
        _1353 = _889;
    }
    bool _1359;
    if (_1353)
    {
        _1359 = _872.y > 0.0;
    }
    else
    {
        _1359 = _1353;
    }
    if (_1359)
    {
        uint _1362 = 0u;
        _1068 _1363 = _1068(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1364 = _868.z & 7u;
        uint _1373;
        if (_808._m4.x == 0.0)
        {
            _1373 = _1364;
        }
        else
        {
            vec4 _1377 = _910._m3;
            uvec4 _1376 = _32(_1377);
            uint _1381 = _1376[_1364 / 2u];
            uint _1386 = 16u * (_1364 & 1u);
            _1373 = (_1381 >> _1386) & 65535u;
        }
        uint _1394 = _1373;
        uint _1398 = _1394;
        vec3 _1396 = texture(sampler2D(_936[nonuniformEXT(_1398)], _944), _1065).xyz;
        uint _1408 = _1394;
        vec2 _1406 = texture(sampler2D(_954[nonuniformEXT(_1408)], _959), _1065).yx;
        vec3 _1416 = vec3(0.039999999105930328369140625);
        uint _1418 = _1394;
        _1416 = texture(sampler2D(_970[nonuniformEXT(_1418)], _975), _1065).xyz;
        uint _1428 = _1394;
        float _1426 = texture(sampler2D(_984[nonuniformEXT(_1428)], _989), _1065).x;
        float _1436 = 1.0;
        uint _1439 = _1394;
        float _1437 = texture(sampler2D(_999[nonuniformEXT(_1439)], _1004), _1065).x;
        uint _1449 = _1394;
        float _1447 = texture(sampler2D(_1013[nonuniformEXT(_1449)], _1018), _1065).x;
        uint _1459 = _1394;
        vec3 _1457 = texture(sampler2D(_1027[nonuniformEXT(_1459)], _1032), _1065).xyz;
        _1363._m0 = vec4(_1396.x, _1396.y, _1396.z, _1363._m0.w);
        _1363._m0.w = _1406.y;
        _1363._m1 = vec4(_1416.x, _1416.y, _1416.z, _1363._m1.w);
        _1363._m1.w = _1447;
        _1363._m3 = vec4(_1363._m3.x, _1406.x, _1363._m3.z, _1406.y);
        _1363._m2.x = _1437;
        _1363._m2.y = _1436;
        _1363._m2.z = _1447;
        _1363._m2.w = _1426;
        _1363._m4 = vec4(_1457.x, _1457.y, _1457.z, _1363._m4.w);
        float _1496 = _1363._m2.x;
        _1363._m2.x = _55(_1496);
        float _1501 = _1363._m1.w;
        float _1504 = _872.y * _1501;
        float _1509 = _1089._m2.x;
        float _1512 = 0.0;
        float _1513 = 0.0;
        float _1514 = (_1504 * 1.5) - 0.5;
        float _1521 = 1.0 - _1509;
        float _1518 = _10(_1521);
        float _1529 = ((_1518 + _1514) - 0.5) * 10.0;
        float _1523 = _10(_1529);
        _1512 = _1523;
        float _1532 = (_872.y * 1.5) - 0.5;
        float _1540 = 1.0 - _1509;
        float _1537 = _10(_1540);
        float _1548 = ((_1537 + _1532) - 0.5) * 10.0;
        float _1542 = _10(_1548);
        _1513 = _1542;
        _1089._m0 = mix(_1089._m0, _1363._m0, vec4(_1512));
        _1089._m1 = mix(_1089._m1, _1363._m1, vec4(_1512));
        _1089._m2 = mix(_1089._m2, _1363._m2, vec4(_1512));
        _1089._m3 = mix(_1089._m3, _1363._m3, vec4(_1512));
        _1089._m4 = mix(_1089._m4, _1363._m4, vec4(_1512));
        _860 = (_1512 > 0.5) ? _1362 : _860;
        _1091.y = _1512;
    }
    bool _1604;
    if (_886)
    {
        _1604 = _872.z > 0.0;
    }
    else
    {
        _1604 = _886;
    }
    if (_1604)
    {
        _776._m37 = _872.z;
        float _1615 = 1.0 - _1089._m2.x;
        _776._m38 = _10(_1615);
    }
    _863 = _1089._m0;
    _864 = _1089._m1;
    vec3 _1623;
    if (_886)
    {
        _1623 = vec3(0.0);
    }
    else
    {
        _1623 = _861.xyz;
    }
    _861 = vec4(_1623.x, _1623.y, _1623.z, _861.w);
    _861.w = _1089._m2.w;
    _865 = _1089._m3;
    _862 = _1089._m4;
    _776._m10 = vec3(_861.x) * _872;
    _776._m10 *= vec3(_808._m5.x);
    _776._m0 = _863.xyz;
    _776._m2 = _864.xyz;
    _776._m1 = _862.xyz;
    _776._m9 = _861.xyz;
    _776._m3 = _861.w;
    _776._m6 = _865.wyz;
    uint _1672 = uint((_797._m16.x > 0.0) ? 8 : 0);
    float _1678 = 16.0;
    float _1680 = 8.0;
    float _1682 = 24.0;
    vec2 _1691 = _776._m16.xy * _808._m6.xy;
    vec3 _1684;
    _1684 = vec3(_1691.x, _1691.y, _1684.z);
    _1684.y = 1.0 - _1684.y;
    
    // FIx for Decals
    _1684.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1704 = floor(_1684.xy * vec2(_1678, _1680));
    _1684 = vec3(_1704.x, _1704.y, _1684.z);
    float _1709 = _776._m16.z;
    vec4 _1712 = _808._m7;
    float _1715 = 1.0;
    bool _1716 = false;
    float _1707 = _139(_1709, _1712, _1715, _1716);
    float _1718 = log2(max(1.0, _1707 / _808._m8.z)) * _808._m8.w;
    _1684.z = min(_1682 - 1.0, floor(_1718));
    uint _1734 = uint((_1684.x + (_1684.y * _1678)) + ((_1684.z * _1678) * _1680));
    _1734 = min(_1734, uint(((_1678 * _1680) * _1682) - 1.0));
    bool _1759 = true;
    vec3 _1761 = _776._m6;
    bool _1764 = _1759;
    _776._m7 = _144(_1761, _1764);
    vec3 _1768 = _776._m7;
    mat3 _1771 = _776._m17;
    _776._m6 = _151(_1768, _1771);
    uint _1776 = 0u;
    uint _1777 = 0u;
    uint _1778 = 0u;
    uint _1779 = 0u;
    uint _1780 = 0u;
    uint _1781 = 0u;
    int _1783 = 256;
    _1785 _1787;
    _1787._m0 = _1792._m0[_1734]._m0;
    _1787._m1 = _1792._m0[_1734]._m1;
    int _1801 = _1787._m0 & (~(_1787._m0 >> 31));
    int _1810 = _1787._m1 & (~(_1787._m1 >> 31));
    _1776 = uint((_1801 >> 16) * _1783);
    _1777 = _1776 + uint(_1810 & 255);
    _1778 = _1776;
    _1779 = _1778 + uint((_1810 >> 8) & 255);
    _1780 = _1776;
    _1781 = _1780 + uint((_1810 >> 16) & 255);
    vec3 _1843 = dFdx(_776._m14);
    vec3 _1847 = dFdy(_776._m14);
    bool _1852 = _1672 == 0u;
    bool _1858;
    if (_1852)
    {
        _1858 = _797._m16.y == 0.0;
    }
    else
    {
        _1858 = _1852;
    }
    _1778 = _1858 ? _1779 : _1778;
    uint _1862 = _1778;
    _1899 _1901;
    vec3 _2254;
    float _2359;
    while (_1862 < _1779)
    {
        uint _1872 = _1876._m0[_1862];
        uint _1881 = (_1872 >> uint(12)) & 4095u;
        uint _1887 = _1881;
        if (_1887 >= _1881)
        {
            _1862++;
        }
        int _1896 = 2;
        int _1897 = 2;
        int _1898 = 2;
        _1901._m0 = _1906._m0[(uint(_1896) * _1887) + 0u];
        _1901._m1 = _1906._m0[(uint(_1896) * _1887) + 1u];
        _1901._m2 = _1926._m0[(uint(_1897) * _1887) + 0u];
        float _1940 = _1926._m0[(uint(_1897) * _1887) + 1u].x;
        _1901._m3.x = _27(_1940);
        float _1950 = _1926._m0[(uint(_1897) * _1887) + 1u].y;
        _1901._m3.y = _27(_1950);
        float _1960 = _1926._m0[(uint(_1897) * _1887) + 1u].z;
        _1901._m4.x = _27(_1960);
        float _1970 = _1926._m0[(uint(_1897) * _1887) + 1u].w;
        _1901._m4.y = _27(_1970);
        float _1984 = _1978._m0[(uint(_1898) * _1887) + 0u].x;
        _1901._m5.x = _27(_1984);
        float _1994 = _1978._m0[(uint(_1898) * _1887) + 0u].y;
        _1901._m5.y = _27(_1994);
        float _2004 = _1978._m0[(uint(_1898) * _1887) + 0u].z;
        _1901._m6 = _27(_2004);
        float _2014 = _1978._m0[(uint(_1898) * _1887) + 0u].w;
        _1901._m7 = _27(_2014);
        float _2024 = _1978._m0[(uint(_1898) * _1887) + 1u].x;
        _1901._m8 = _27(_2024);
        float _2034 = _1978._m0[(uint(_1898) * _1887) + 1u].y;
        _1901._m9 = _27(_2034);
        float _2044 = _1978._m0[(uint(_1898) * _1887) + 1u].z;
        _1901._m10 = _27(_2044);
        float _2055 = _1978._m0[(uint(_1898) * _1887) + 1u].w;
        _1901._m11 = _27(_2055);
        vec4 _2060 = vec4(_776._m14, 1.0);
        vec3 _2067 = vec3(dot(_2060, _1901._m0), dot(_2060, _1901._m1), dot(_2060, _1901._m2));
        float _2081 = 0.0039215688593685626983642578125;
        float _2083 = _2067.x;
        float _2086 = _2067.y;
        float _2089 = _2067.z;
        bool _2094 = _43(_2083, _2086, _2089) <= _2081;
        bool _2111;
        if (!_2094)
        {
            float _2098 = _2067.x;
            float _2101 = _2067.y;
            float _2104 = _2067.z;
            _2111 = _38(_2098, _2101, _2104) >= (1.0 - _2081);
        }
        else
        {
            _2111 = _2094;
        }
        if (_2111)
        {
            continue;
        }
        uint _2115 = _1901._m11;
        bool _2119 = _1672 != 0u;
        bool _2126;
        if (_2119)
        {
            _2126 = (_2115 & 1024u) != 0u;
        }
        else
        {
            _2126 = _2119;
        }
        bool _2139;
        if (!_2126)
        {
            bool _2131 = _1672 == 0u;
            bool _2138;
            if (_2131)
            {
                _2138 = (_2115 & 2048u) != 0u;
            }
            else
            {
                _2138 = _2131;
            }
            _2139 = _2138;
        }
        else
        {
            _2139 = _2126;
        }
        if (_2139)
        {
            continue;
        }
        vec3 _2143 = _1901._m0.xyz;
        vec3 _2147 = _1901._m1.xyz;
        vec3 _2151 = _1901._m2.xyz;
        vec2 _2155 = vec2(dot(_1843, _2143), dot(_1843, _2147));
        vec2 _2163 = vec2(dot(_1847, _2143), dot(_1847, _2147));
        float _2171 = 1.0;
        float _2172 = 1.0;
        vec3 _2173 = vec3(0.5, 0.5, 1.0);
        uint _2175 = _1901._m7;
        uint _2179 = _1901._m9;
        vec4 _2178 = _94(_2179);
        uvec2 _2184 = _1901._m5;
        vec4 _2183 = _107(_2184);
        vec2 _2188 = _2155 * _2183.xy;
        vec2 _2193 = _2163 * _2183.xy;
        vec4 _2198 = TEXTURE_GRAD(_2200, (_2067.xy * _2183.xy) + _2183.zw, _2188, _2193);
        _2171 = _2198.z;
        float _2215 = _2198.w;
        _2172 = _55(_2215);
        bool _2222 = _2172 <= (4.0 * _2081);
        bool _2229;
        if (_2222)
        {
            _2229 = _2178.w <= _2081;
        }
        else
        {
            _2229 = _2222;
        }
        if (_2229)
        {
            continue;
        }
        vec2 _2233 = (_2198.xy * 2.0) - vec2(1.0);
        float _2244 = 1.0 - dot(_2233, _2233);
        _2173 = vec3(_2233, sqrt(_10(_2244)));
        if ((_2115 & 256u) != 0u)
        {
            _2254 = vec3(-_2173.x, -_2173.y, _2173.z);
        }
        else
        {
            _2254 = _2173;
        }
        _2173 = _2254;
        uint _2269 = _1901._m8;
        uint _2273 = _2269;
        float _2272 = 1.0 + (_97(_2273).w * 0.062745101749897003173828125);
        uint _2281 = _2175;
        float _2280 = _94(_2281).z;
        float _2294 = _2272 - (_2272 * abs((_2067.z * 2.0) - 1.0));
        _2172 *= _10(_2294);
        if ((_2175 & 64u) != 0u)
        {
            uint _2305 = _2175;
            float _2304 = _94(_2305).x;
            uint _2310 = _2175;
            float _2309 = _97(_2310).y;
            float _2316 = _2304;
            float _2314 = mix(_2309, 0.0, _10(_2316));
            float _2325 = _2171 - (_2314 / 255.0);
            float _2320 = float(_10(_2325) > 0.0);
            _2172 *= _2320;
        }
        vec3 _2332 = normalize(vec3(_776._m17[0].z, _776._m17[1].z, _776._m17[2].z));
        float _2341 = dot(_2332, normalize(_2151));
        float _2346 = _2341;
        vec2 _2351 = _2173.xy * _86(_2346);
        _2173 = vec3(_2351.x, _2351.y, _2173.z);
        if ((_2115 & 32768u) != 0u)
        {
            float _2364 = abs(_2341);
            _2359 = _10(_2364);
        }
        else
        {
            float _2367 = _2341;
            _2359 = _10(_2367);
        }
        float _2354 = _2359;
        float _2371 = _2172 * _2354;
        uint _2375 = _1901._m6;
        uint _2379 = _2375;
        vec4 _2384 = _94(_2379) * _2371;
        vec4 _2378 = _22(_2384);
        _776._m11 = max(_776._m11, _2378.x);
        _2143 += (_2332 * dot(_2143, _2332));
        _2147 += (_2332 * dot(_2147, _2332));
        _2173 = ((normalize(_2143) * _2173.x) + (normalize(_2147) * _2173.y)) + (_2332 * _2173.z);
        if ((_2115 & 512u) != 0u)
        {
            vec3 _2428 = mix(_2332, _2173, _2378.www);
            float _2434 = dot(_2428, _2332);
            _2173 = (_776._m6 * _2434) + ((_2428 - (_2332 * _2434)) * dot(_776._m6, _2332));
        }
        else
        {
            if ((_2115 & 128u) != 0u)
            {
                _2173 = mix(mix(_776._m6, _2332, vec3(_2371)), _2173, _2378.www);
            }
            else
            {
                _2173 = mix(_776._m6, _2173, _2378.www);
            }
        }
        _776._m6 = normalize(_2173);
        uint _2481 = _2269;
        vec3 _2480 = _94(_2481).xyz;
        float _2485 = _2172;
        if ((_2175 & 1u) != 0u)
        {
            uvec2 _2493 = _1901._m3;
            vec4 _2492 = _107(_2493);
            vec2 _2497 = _2155 * _2492.xy;
            vec2 _2502 = _2163 * _2492.xy;
            vec4 _2507 = TEXTURE_GRAD(_2200, (_2067.xy * _2492.xy) + _2492.zw, _2497, _2502);
            vec4 _2520 = _2507;
            _2507 = _61(_2520);
            float _2530 = (_2507.w - _2081) / (1.0 - _2081);
            _2485 = _10(_2530);
            _2480 *= _2507.xyz;
        }
        _776._m0 = mix(_776._m0, _2480, _2378.xxx);
        float _2543 = ((_2354 * _2485) * _2178.w) * _2280;
        _776._m10 += (_2178.xyz * (_2543 * 64.0));
        uint _2562 = _1901._m10;
        uint _2566 = _2562;
        vec4 _2565 = _94(_2566);
        float _2569 = 0.0;
        if ((_2175 & 10u) != 0u)
        {
            uvec2 _2577 = _1901._m4;
            vec4 _2576 = _107(_2577);
            vec2 _2581 = _2155 * _2576.xy;
            vec2 _2586 = _2163 * _2576.xy;
            vec4 _2591 = TEXTURE_GRAD(_2200, (_2067.xy * _2576.xy) + _2576.zw, _2581, _2586);
            if ((_2175 & 2u) != 0u)
            {
                _2565 = _2591 * _2591;
            }
            else
            {
                _2569 = _2591.w;
            }
        }
        _776._m2 = mix(_776._m2, _2565.xyz, _2378.yyy);
        _776._m3 = mix(_776._m3, _2565.w, _2378.z);
        _776._m37 = max(_776._m37, _2569);
        float _2641 = (_2171 - 0.5) * 2.0;
        _776._m38 = max(_776._m38, _10(_2641));
    }
    float _2646 = _776._m37;
    float _2645 = _70(_2646);
    float _2653 = _2645 - 0.5;
    float _2650 = _10(_2653) * 2.0;
    float _2664 = _2645 * 2.0;
    float _2656 = (_776._m38 * _776._m38) * _10(_2664);
    float _2671 = _2656 + _2650;
    float _2667 = _10(_2671);
    if (_2667 > 0.0039215688593685626983642578125)
    {
        vec3 _2679 = _776._m0;
        float _2686 = _2667 * 1.0;
        float _2687 = 0.0;
        float _2688 = 0.3499999940395355224609375;
        _776._m0 = mix(_776._m0, _67(_2679), vec3(_75(_2686, _2687, _2688) * (1.0 - _776._m3)));
        float _2702 = _2667 * 1.0;
        float _2703 = 0.25;
        float _2704 = 0.5;
        _776._m2 = mix(_776._m2, vec3(0.039999999105930328369140625), vec3(_75(_2702, _2703, _2704)));
        vec3 _2709 = vec3(_776._m17[0].z, _776._m17[1].z, _776._m17[2].z);
        float _2723 = _2709.z + 0.0625;
        float _2717 = _2667 * _10(_2723);
        float _2732 = _2717 * 1.0;
        float _2733 = 0.20000000298023223876953125;
        float _2734 = 1.0;
        _776._m3 = mix(_776._m3, 0.89999997615814208984375, _75(_2732, _2733, _2734));
        float _2743 = _2717 * 1.0;
        float _2744 = 0.449999988079071044921875;
        float _2745 = 0.980000019073486328125;
        float _2738 = _75(_2743, _2744, _2745);
        _776._m6 = normalize(mix(_776._m6, vec3(0.0, 0.0, 1.0), vec3(_2738)));
        _776._m7 = mix(_776._m6, vec3(0.5, 0.5, 1.0), vec3(_2738));
        if (_2717 > 0.980000019073486328125)
        {
            float _2768 = _2717 * _2738;
            float _2769 = 0.980000019073486328125;
            float _2770 = 1.0;
            _2709 = normalize(mix(_2709, vec3(0.0, 0.0, 1.0), vec3(_75(_2768, _2769, _2770))));
            _776._m17[0].z = _2709.x;
            _776._m17[1].z = _2709.y;
            _776._m17[2].z = _2709.z;
        }
    }
    vec3 _2784 = vec3(0.0);
    vec3 _2785 = vec3(_776._m34.x, _776._m34.y, _776._m34.z);
    vec3 _2793 = vec3(_776._m34.w, _776._m35.x, _776._m35.y);
    vec3 _2801 = vec3(_776._m35.z, _776._m35.w, _776._m36.x);
    vec3 _2809 = vec3(_776._m36.y, _776._m36.z, _776._m36.w);
    vec3 _2817 = ((_2785 - (_2793 * _776._m6.y)) + (_2801 * _776._m6.z)) - (_2809 * _776._m6.x);
    float _2840 = _797._m17.x * _808._m9.x;
    _2784 += max(_2817 * _10(_2840), vec3(0.0));
    float _2851;
    if (dot(_776._m10, vec3(1.0)) > 0.0)
    {
        _2851 = -_776._m3;
    }
    else
    {
        _2851 = _776._m3;
    }
    _776._m3 = _2851;
    _776._m18 = _2784;
    _776._m19 = _2784;
    uint _2868 = _1776;
    _2897 _2899;
    vec3 _3217;
    float _3306;
    float _3324;
    uint _3668;
    _3694 _3696;
    uint _3818;
    _3694 _3842;
    while (_2868 < _1777)
    {
        uint _2878 = _1876._m0[_2868];
        uint _2882 = _2878 & 4095u;
        uint _2885 = _2882;
        if (_2885 >= _2882)
        {
            _2868++;
        }
        int _2894 = 4;
        int _2895 = 4;
        int _2896 = 4;
        _2899._m0 = _2903._m0[(uint(_2894) * _2885) + 0u].xyz;
        float _2918 = _2903._m0[(uint(_2894) * _2885) + 0u].w;
        _2899._m1 = _27(_2918);
        _2899._m2 = _2903._m0[(uint(_2894) * _2885) + 1u];
        _2899._m3 = _2903._m0[(uint(_2894) * _2885) + 2u];
        _2899._m4 = _2942._m0[(uint(_2895) * _2885) + 0u];
        _2899._m5 = _2942._m0[(uint(_2895) * _2885) + 1u];
        _2899._m6 = _2942._m0[(uint(_2895) * _2885) + 2u];
        float _2972 = _2903._m0[(uint(_2894) * _2885) + 3u].x;
        _2899._m7.x = _27(_2972);
        float _2982 = _2903._m0[(uint(_2894) * _2885) + 3u].y;
        _2899._m7.y = _27(_2982);
        float _2992 = _2903._m0[(uint(_2894) * _2885) + 3u].z;
        _2899._m7.z = _27(_2992);
        float _3002 = _2903._m0[(uint(_2894) * _2885) + 3u].w;
        _2899._m7.w = _27(_3002);
        _2899._m8 = _3010._m0[(uint(_2896) * _2885) + 0u];
        _2899._m9 = _3010._m0[(uint(_2896) * _2885) + 1u];
        _2899._m10 = _3010._m0[(uint(_2896) * _2885) + 2u];
        _2899._m11 = _3010._m0[(uint(_2896) * _2885) + 3u];
        float _3048 = _2942._m0[(uint(_2895) * _2885) + 3u].x;
        _2899._m12 = _27(_3048);
        float _3058 = _2942._m0[(uint(_2895) * _2885) + 3u].y;
        _2899._m13 = _27(_3058);
        _2899._m14 = _2942._m0[(uint(_2895) * _2885) + 3u].z;
        float _3076 = _2942._m0[(uint(_2895) * _2885) + 3u].w;
        _2899._m15 = _27(_3076);
        uint _3081 = (_2899._m12 >> uint(16)) & 3u;
        if (((_776._m40 >> uint(4)) & 3u) != _3081)
        {
            continue;
        }
        float _3095 = 0.0039215688593685626983642578125;
        vec4 _3096 = vec4(_776._m14, 1.0);
        float _3103 = 1.0 / dot(_3096, _2899._m6);
        vec3 _3109 = vec3(dot(_3096, _2899._m4) * _3103, dot(_3096, _2899._m5) * _3103, dot(_3096, _2899._m3));
        uint _3127 = _2899._m1;
        uint _3130 = _1672;
        _3130 |= 64u;
        float _3134 = _3109.x;
        float _3137 = _3109.y;
        float _3140 = _3109.z;
        bool _3145 = _43(_3134, _3137, _3140) <= _3095;
        bool _3162;
        if (!_3145)
        {
            float _3149 = _3109.x;
            float _3152 = _3109.y;
            float _3155 = _3109.z;
            _3162 = _38(_3149, _3152, _3155) >= (1.0 - _3095);
        }
        else
        {
            _3162 = _3145;
        }
        bool _3170;
        if (!_3162)
        {
            _3170 = (_3127 & _3130) != 0u;
        }
        else
        {
            _3170 = _3162;
        }
        if (_3170)
        {
            continue;
        }
        if ((_3127 & 3u) == 2u)
        {
            vec2 _3189 = fract((_3109.xy * _808._m10.xy) + _808._m10.zw);
            _3109 = vec3(_3189.x, _3189.y, _3109.z);
        }
        vec3 _3192 = _2899._m0;
        float _3195 = 1.0;
        float _3196 = 1.0;
        vec3 _3197 = vec3(0.0, 0.0, 1.0);
        vec3 _3198 = vec3(0.0, 0.0, 1.0);
        uint _3199 = _2899._m1;
        vec3 _3202 = (_3109 * 2.0) - vec3(1.0);
        vec2 _3207 = _3109.xy;
        vec3 _3210 = _2899._m10.xyz;
        if ((_3199 & 3u) == 2u)
        {
            _3217 = _3210;
        }
        else
        {
            _3217 = normalize(_3192 - _776._m14);
        }
        _3197 = _3217;
        _3197 = _3197;
        float _3234 = dot(_776._m6, _3197);
        float _3229 = _10(_3234);
        bool _3238 = _3229 <= _3095;
        bool _3245;
        if (_3238)
        {
            _3245 = (_3199 & 48u) == 0u;
        }
        else
        {
            _3245 = _3238;
        }
        if (_3245)
        {
            continue;
        }
        uvec2 _3250 = _2899._m7.zw;
        vec4 _3249 = _107(_3250);
        float _3255 = TEXTURE_LOD(_3256, vec4((_3207 * _3249.xy) + _3249.zw, 0.0, 0.0).xy, vec4((_3207 * _3249.xy) + _3249.zw, 0.0, 0.0).w).x;
        float _3282 = _3255 * _3255;
        uint _3286 = _3199 & 3u;
        bool _3291 = _3286 == 1u;
        bool _3303;
        if (!_3291)
        {
            bool _3296 = _3286 == 0u;
            bool _3302;
            if (_3296)
            {
                _3302 = _2899._m8.z != 0.0;
            }
            else
            {
                _3302 = _3296;
            }
            _3303 = _3302;
        }
        else
        {
            _3303 = _3291;
        }
        bool _3289 = _3303;
        if (_3289)
        {
            float _3309 = _2899._m8.w;
            _3306 = _10(_3309);
        }
        else
        {
            _3306 = 0.5;
        }
        float _3304 = _3306;
        bool _3317 = _3286 == 0u;
        bool _3323;
        if (_3317)
        {
            _3323 = _2899._m8.z != 0.0;
        }
        else
        {
            _3323 = _3317;
        }
        if (_3323)
        {
            float _3332 = sqrt(dot(_3202, _3202));
            _3324 = min(0.9921875, _10(_3332));
        }
        else
        {
            _3324 = _3109.z;
        }
        float _3315 = _3324;
        uvec2 _3340 = _2899._m7.xy;
        vec4 _3339 = _107(_3340);
        vec2 _3345 = vec2(_3315, _3304);
        float _3349 = TEXTURE_LOD(_3256, vec4((_3345 * _3339.xy) + _3339.zw, 0.0, 0.0).xy, vec4((_3345 * _3339.xy) + _3339.zw, 0.0, 0.0).w).x;
        _3349 *= _3349;
        _3195 = _3349 * _3282;
        if ((_3199 & 48u) != 0u)
        {
            vec4 _3386 = _2899._m10;
            vec4 _3389 = _2899._m8;
            vec4 _3392 = _2899._m9;
            float _3395 = dot(_776._m14, _3386.xyz) + _3386.w;
            if (_3395 < 0.0)
            {
                continue;
            }
            float _3409 = length(_3386.xyz);
            float _3416 = _3395 * 50.0;
            float _3413 = _10(_3416);
            _3195 *= (_3413 * _3413);
            _3395 /= _3409;
            _3386 /= vec4(_3409);
            vec3 _3430 = reflect(-_776._m13, _776._m6);
            if (dot(_3430, _3386.xyz) > 0.0)
            {
                _3430 = reflect(_3430, _3386.xyz);
            }
            float _3448 = dot(_3430, _3386.xyz);
            float _3453 = _3395 / _3448;
            vec3 _3457 = _776._m14 - (_3430 * _3453);
            vec3 _3464 = _3457 - _3192;
            float _3468 = dot(_3464, _3389.xyz) / _3389.w;
            float _3476 = dot(_3464, _3392.xyz) / _3392.w;
            if ((_3199 & 48u) == 32u)
            {
                vec2 _3490 = vec2(_3468, _3476);
                float _3494 = 1.0 / max(1.0, length(vec2(_3468, _3476)));
                _3468 *= (_3494 * _3389.w);
                _3476 *= (_3494 * _3392.w);
            }
            else
            {
                float _3516 = abs(_3468);
                float _3518 = _3468;
                _3468 = (_10(_3516) * _86(_3518)) * _3389.w;
                float _3527 = abs(_3476);
                float _3529 = _3476;
                _3476 = (_10(_3527) * _86(_3529)) * _3392.w;
            }
            vec3 _3536 = (_3389.xyz * _3468) + (_3392.xyz * _3476);
            _3192 += _3536;
            _3197 = normalize(_3192 - _776._m14);
            _3197 = _3197;
        }
        else
        {
            uint _3556 = (_2899._m15 >> uint(16)) & 255u;
            if (_3556 == 0u)
            {
                vec4 _3565 = _2899._m9;
                if (dot(_3565.xyz, _776._m14) < (_3565.w - _3095))
                {
                    continue;
                }
            }
            else
            {
                if (_3556 == 1u)
                {
                    vec3 _3586 = _2899._m9.xyz;
                    float _3591 = _2899._m9.w;
                    uint _3595 = _27(_3591);
                    vec3 _3590 = (((_101(_3595) * 2.0) - vec3(1.0)) * _3586) + _3192;
                    vec3 _3604 = abs((_776._m14 - _3590) / _3586);
                    float _3612 = _3604.x;
                    float _3615 = _3604.y;
                    float _3618 = _3604.z;
                    if (_38(_3612, _3615, _3618) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3195 <= (_3095 / 256.0))
        {
            continue;
        }
        float _3634 = 1.0;
        if ((_3127 & 4u) != 0u)
        {
            float _3641 = float(_2899._m15 & 255u) / 255.0;
            float _3647 = 0.00999999977648258209228515625;
            vec3 _3649 = _776._m14 + (_776._m6 * _3647);
            if ((_3127 & 3u) == 0u)
            {
                vec3 _3662 = _3649 - _2899._m2.xyz;
                float _3669 = _3662.x;
                float _3672 = _3662.y;
                float _3675 = _3662.z;
                _3668 = _49(_3669, _3672, _3675);
            }
            else
            {
                if ((_3127 & 3u) == 2u)
                {
                    float _3685 = 0.0;
                    _3668 = 0u;
                    for (; _3668 < 3u; _3668++)
                    {
                        int _3693 = 5;
                        _3696._m0 = _3700._m0[(uint(_3693) * ((_3127 >> uint(22)) + _3668)) + 0u];
                        _3696._m1 = _3700._m0[(uint(_3693) * ((_3127 >> uint(22)) + _3668)) + 1u];
                        _3696._m2 = _3700._m0[(uint(_3693) * ((_3127 >> uint(22)) + _3668)) + 2u];
                        _3696._m3 = _3700._m0[(uint(_3693) * ((_3127 >> uint(22)) + _3668)) + 3u];
                        _3696._m4 = _3700._m0[(uint(_3693) * ((_3127 >> uint(22)) + _3668)) + 4u];
                        vec2 _3757 = vec2(dot(_3649, _3696._m0.xyz) + _3696._m0.w, dot(_3649, _3696._m1.xyz) + _3696._m1.w);
                        _3757 = abs((_3757 * 2.0) - vec2(1.0));
                        bool _3783 = _3757.x < 0.99500000476837158203125;
                        bool _3789;
                        if (_3783)
                        {
                            _3789 = _3757.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _3789 = _3783;
                        }
                        if (_3789)
                        {
                            _3685 = (1.0 - max(_3757.x, _3757.y)) * _808._m11.w;
                            break;
                        }
                    }
                    _3668 = min(2u, _3668);
                    uint _3806 = uint(_776._m16.x) ^ (uint(_776._m16.y) << uint(1));
                    if (_808._m12.w > 0.0)
                    {
                        _3818 = uint(_808._m13.x);
                    }
                    else
                    {
                        _3818 = 0u;
                    }
                    _3806 ^= _3818;
                    _3668 += uint(int(((float(_3806 & 3u) * 0.25) + 0.125) > _3685));
                }
                else
                {
                    _3668 = 0u;
                }
            }
            int _3841 = 5;
            _3842._m0 = _3700._m0[(uint(_3841) * ((_3127 >> uint(22)) + _3668)) + 0u];
            _3842._m1 = _3700._m0[(uint(_3841) * ((_3127 >> uint(22)) + _3668)) + 1u];
            _3842._m2 = _3700._m0[(uint(_3841) * ((_3127 >> uint(22)) + _3668)) + 2u];
            _3842._m3 = _3700._m0[(uint(_3841) * ((_3127 >> uint(22)) + _3668)) + 3u];
            _3842._m4 = _3700._m0[(uint(_3841) * ((_3127 >> uint(22)) + _3668)) + 4u];
            vec4 _3898 = vec4((_3649.x * _3842._m0.x) + ((_3649.y * _3842._m0.y) + ((_3649.z * _3842._m0.z) + _3842._m0.w)), (_3649.x * _3842._m1.x) + ((_3649.y * _3842._m1.y) + ((_3649.z * _3842._m1.z) + _3842._m1.w)), (_3649.x * _3842._m2.x) + ((_3649.y * _3842._m2.y) + ((_3649.z * _3842._m2.z) + _3842._m2.w)), (_3649.x * _3842._m3.x) + ((_3649.y * _3842._m3.y) + ((_3649.z * _3842._m3.z) + _3842._m3.w)));
            vec3 _3985 = _3898.xyz / vec3(_3898.w);
            _3898 = vec4(_3985.x, _3985.y, _3985.z, _3898.w);
            bool _3993 = min(_3898.x, _3898.y) > 0.0;
            bool _4002;
            if (_3993)
            {
                _4002 = max(_3898.x, _3898.y) < 1.0;
            }
            else
            {
                _4002 = _3993;
            }
            if (_4002)
            {
                vec2 _4014 = (_3898.xy * _3842._m4.xy) + _3842._m4.zw;
                _3898 = vec4(_4014.x, _4014.y, _3898.z, _3898.w);
                if (false)
                {
                    _3634 = textureLod(_4022, vec3(_3898.xyz.xy, _3898.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4029 = (_3898.xy * _808._m14.xy) + vec2(0.5);
                    vec2 _4038 = floor(_4029);
                    vec2 _4041 = _4029 - _4038;
                    _4038 -= vec2(0.5);
                    vec2 _4048 = vec2(4.0) - (_4041 * 3.0);
                    vec2 _4054 = vec2(7.0);
                    vec2 _4057 = vec2(1.0) + (_4041 * 3.0);
                    vec2 _4062 = (_4038 + (((vec2(3.0) - (_4041 * 2.0)) / _4048) - vec2(2.0))) * _808._m14.zw;
                    vec2 _4077 = (_4038 + ((vec2(3.0) + _4041) / _4054)) * _808._m14.zw;
                    vec2 _4089 = (_4038 + ((_4041 / _4057) + vec2(2.0))) * _808._m14.zw;
                    vec3 _4113 = vec3(_4062.x, _4062.y, _3898.z);
                    _3634 = (_4048.x * _4048.y) * textureLod(_4022, vec3(_4113.xy, _4113.z), 0.0);
                    vec3 _4129 = vec3(_4077.x, _4062.y, _3898.z);
                    _3634 += ((_4054.x * _4048.y) * textureLod(_4022, vec3(_4129.xy, _4129.z), 0.0));
                    vec3 _4147 = vec3(_4089.x, _4062.y, _3898.z);
                    _3634 += ((_4057.x * _4048.y) * textureLod(_4022, vec3(_4147.xy, _4147.z), 0.0));
                    vec3 _4165 = vec3(_4062.x, _4077.y, _3898.z);
                    _3634 += ((_4048.x * _4054.y) * textureLod(_4022, vec3(_4165.xy, _4165.z), 0.0));
                    vec3 _4183 = vec3(_4077.x, _4077.y, _3898.z);
                    _3634 += ((_4054.x * _4054.y) * textureLod(_4022, vec3(_4183.xy, _4183.z), 0.0));
                    vec3 _4201 = vec3(_4089.x, _4077.y, _3898.z);
                    _3634 += ((_4057.x * _4054.y) * textureLod(_4022, vec3(_4201.xy, _4201.z), 0.0));
                    vec3 _4219 = vec3(_4062.x, _4089.y, _3898.z);
                    _3634 += ((_4048.x * _4057.y) * textureLod(_4022, vec3(_4219.xy, _4219.z), 0.0));
                    vec3 _4237 = vec3(_4077.x, _4089.y, _3898.z);
                    _3634 += ((_4054.x * _4057.y) * textureLod(_4022, vec3(_4237.xy, _4237.z), 0.0));
                    vec3 _4255 = vec3(_4089.x, _4089.y, _3898.z);
                    _3634 += ((_4057.x * _4057.y) * textureLod(_4022, vec3(_4255.xy, _4255.z), 0.0));
                    _3634 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3634 = float((_3127 & 3u) == 2u);
            }
            float _4269 = float((_3127 >> uint(16)) & 63u) / 63.0;
            float _4283 = ((_3634 * _4269) + 1.0) - _4269;
            _3634 = _10(_4283);
        }
        uint _4286 = _2899._m13;
        vec3 _4285 = (_110(_4286) * _3634) * _3195;
        _3196 *= _2899._m14;
        vec3 _4298 = _4285;
        vec3 _4300 = _3197;
        float _4307 = dot(_776._m6, _4300);
        float _4302 = _10(_4307);
        vec3 _4313 = _776._m6;
        vec3 _4316 = _776._m13;
        vec3 _4319 = _3197;
        vec3 _4321 = _776._m2;
        float _4324 = abs(_776._m3);
        vec3 _4309 = _123(_4313, _4316, _4319, _4321, _4324);
        _776._m20 += (((_4309 * _3196) * _4298) * _4302);
        vec3 _4338 = mix(_4298, vec3(0.0), bvec3((_3127 & 256u) > 0u));
        _776._m19 += (_4338 * _4302);
    }
    float _4353 = _808._m15.x;
    if (_4353 > 0.00999999977648258209228515625)
    {
        float _4360 = float(int(_808._m13.x) & 1023) / 1023.0;
        _4353 = max(0.0, _4353 + (((_4360 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4376 = _776._m13;
        float _4384 = dot(_776._m6, _4376);
        float _4379 = _10(_4384);
        float _4386 = _4379 * _4353;
        vec3 _4394 = _776._m6;
        vec3 _4397 = _776._m13;
        vec3 _4400 = _776._m2;
        float _4403 = abs(_776._m3);
        vec3 _4390 = _130(_4394, _4397, _4400, _4403) * _4353;
        _776._m19 += vec3(_4386);
        _776._m20 += vec3(_4390);
    }
    _776._m19 = _776._m19;
    _776._m20 += _776._m10;
    float _4431 = 0.064999997615814208984375;
    float _4433 = 1.0 + _4431;
    bool _4436 = false;
    uint _4441;
    if (_808._m16.w > 0.00999999977648258209228515625)
    {
        _4441 = uint(_808._m16.x);
    }
    else
    {
        _4441 = 0u;
    }
    uint _4437 = _4441;
    _4459 _4461;
    for (uint _4449 = 0u; _4449 < _4437; _4449++)
    {
        int _4458 = 4;
        _4461._m0 = _4465._m0[(uint(_4458) * _4449) + 0u];
        _4461._m1 = _4465._m0[(uint(_4458) * _4449) + 1u];
        _4461._m2 = _4465._m0[(uint(_4458) * _4449) + 2u];
        float _4495 = _4465._m0[(uint(_4458) * _4449) + 3u].x;
        _4461._m3 = _27(_4495);
        float _4505 = _4465._m0[(uint(_4458) * _4449) + 3u].y;
        _4461._m4 = _27(_4505);
        float _4515 = _4465._m0[(uint(_4458) * _4449) + 3u].z;
        _4461._m5 = _27(_4515);
        vec4 _4520 = vec4(_776._m14, 1.0);
        vec3 _4527 = vec3(dot(_4520, _4461._m1), dot(_4520, _4461._m2), dot(_4520, _4461._m0));
        float _4541 = _4527.x;
        float _4544 = _4527.y;
        float _4547 = _4527.z;
        bool _4551 = _43(_4541, _4544, _4547) >= 0.0;
        bool _4560;
        if (_4551)
        {
            _4560 = max(_4527.x, _4527.y) < 1.0;
        }
        else
        {
            _4560 = _4551;
        }
        bool _4567;
        if (_4560)
        {
            _4567 = _4527.z < _4433;
        }
        else
        {
            _4567 = _4560;
        }
        if (_4567)
        {
            float _4570 = _4527.z;
            vec4 _4573 = vec4(_776._m14, 1.0);
            vec2 _4580 = vec2(0.0);
            _4580 = (((_4573.xy - _808._m17.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4593 = 0.000244140625;
            float _4599 = abs(_776._m6.z) * 2.0;
            _4593 *= _10(_4599);
            vec3 _4603 = vec3(TEXTURE_LOD(_4604, vec4(_4580 + vec2(_4593), 0.0, 0.0).xy, vec4(_4580 + vec2(_4593), 0.0, 0.0).w).x, TEXTURE_LOD(_4604, vec4(_4580, 0.0, 0.0).xy, vec4(_4580, 0.0, 0.0).w).x, TEXTURE_LOD(_4604, vec4(_4580 - vec2(_4593), 0.0, 0.0).xy, vec4(_4580 - vec2(_4593), 0.0, 0.0).w).x);
            float _4667 = 2.0 - (2.0 * (length(_4573.xy - _808._m17.zw) / 16.0));
            _4603 *= _10(_4667);
            float _4674 = 1.0 - _4570;
            float _4671 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4674));
            float _4685 = (_776._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4677 = (_4603 * _4671) * _10(_4685);
            float _4694 = _4433 - _4570;
            float _4688 = (1.0 - _4671) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4694));
            float _4708 = ((-_776._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4698 = (_4603 * _4688) * _10(_4708);
            _4603 = _4677 + _4698;
            float _4719 = 1.02499997615814208984375 - _4570;
            float _4714 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4719));
            float _4722 = _808._m16.w;
            _776._m19 = mix(_776._m19, (_776._m19 * _4603) + (_776._m19 * mix(1.0, 0.5, _4714)), vec3(_4722));
            break;
        }
    }
    _776._m19 *= _776._m0;
    _776._m21 = _776._m19 + _776._m20;
    vec3 _4756 = vec3(0.0);
    _776._m19 += _4756;
    vec3 _4768 = _776._m19 + _776._m20;
    _4763 = vec4(_4768.x, _4768.y, _4768.z, _4763.w);
    vec3 _4772 = _776._m6;
    bool _4775 = false;
    vec2 _4776 = _162(_4772, _4775);
    _4771 = vec4(_4776.x, _4776.y, _4771.z, _4771.w);
    float _4780 = _776._m2.x;
    float _4784 = _776._m2.y;
    float _4788 = _776._m2.z;
    float _4792 = _776._m3;
    _4779 = vec4(_89(_4780), _89(_4784), _89(_4788), _165(_4792));
    _4797 = vec4(0.0, 0.0, 0.0, float((uint(_797._m16.z) & 3u) << uint(4)) / 255.0);
    vec3 _4810 = _776._m19 + _776._m20;
    _4763 = vec4(_4810.x, _4810.y, _4810.z, _4763.w);
    vec3 _4813 = _776._m6;
    bool _4816 = false;
    vec2 _4817 = _162(_4813, _4816);
    _4771 = vec4(_4817.x, _4817.y, _4771.z, _4771.w);
    float _4820 = _776._m2.x;
    float _4824 = _776._m2.y;
    float _4828 = _776._m2.z;
    float _4832 = _776._m3;
    _4779 = vec4(_89(_4820), _89(_4824), _89(_4828), _165(_4832));
    vec3 _4842 = _4763.xyz + _797._m18.xyz;
    _4763 = vec4(_4842.x, _4842.y, _4842.z, _4763.w);
}


