// DECALS
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require
#extension GL_EXT_nonuniform_qualifier : require
layout(early_fragment_tests) in;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _762
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1717
{
    int _m0;
    int _m1;
};

struct _1720
{
    int _m0;
    int _m1;
};

struct _1820
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2761
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3558
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4323
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 1, binding = 0, std140) uniform _783_785
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _785;

layout(set = 0, binding = 0, std140) uniform _805_807
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
} _807;

layout(set = 2, binding = 0, std140) uniform _910_912
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
} _912;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1722_1724
{
    _1720 _m0[];
} _1724;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1795_1797
{
    uint _m0[];
} _1797;

layout(set = 0, binding = 15, std140) uniform _1825_1827
{
    vec4 _m0[4096];
} _1827;

layout(set = 0, binding = 16, std140) uniform _1845_1847
{
    vec4 _m0[4096];
} _1847;

layout(set = 0, binding = 17, std140) uniform _1897_1899
{
    vec4 _m0[4096];
} _1899;

layout(set = 0, binding = 19, std140) uniform _2765_2767
{
    vec4 _m0[4096];
} _2767;

layout(set = 0, binding = 20, std140) uniform _2804_2806
{
    vec4 _m0[4096];
} _2806;

layout(set = 0, binding = 21, std140) uniform _2872_2874
{
    vec4 _m0[4096];
} _2874;

layout(set = 0, binding = 23, std140) uniform _3562_3564
{
    vec4 _m0[4095];
} _3564;

layout(set = 0, binding = 25, std140) uniform _4327_4329
{
    vec4 _m0[4096];
} _4329;

layout(push_constant, std430) uniform _4704_4706
{
    int _m0;
    int _m1;
} _4706;

layout(set = 3, binding = 0) uniform texture2D _938[16384];
layout(set = 0, binding = 2) uniform sampler _946;
layout(set = 3, binding = 2) uniform texture2D _955[16384];
layout(set = 0, binding = 3) uniform sampler _960;
layout(set = 3, binding = 1) uniform texture2D _970[16384];
layout(set = 0, binding = 4) uniform sampler _975;
layout(set = 3, binding = 3) uniform texture2D _983[16384];
layout(set = 0, binding = 5) uniform sampler _988;
layout(set = 3, binding = 7) uniform texture2D _997[16384];
layout(set = 0, binding = 6) uniform sampler _1002;
layout(set = 3, binding = 4) uniform texture2D _1010[16384];
layout(set = 0, binding = 7) uniform sampler _1015;
layout(set = 3, binding = 6) uniform texture2D _1023[16384];
layout(set = 0, binding = 8) uniform sampler _1028;
layout(set = 0, binding = 9) uniform SAMPLER_2D _1289;
layout(set = 0, binding = 10) uniform SAMPLER_2D _1298;
layout(set = 0, binding = 11) uniform SAMPLER_2D _1354;
layout(set = 0, binding = 12, r32f) uniform writeonly image2D _1582;
layout(set = 0, binding = 18) uniform SAMPLER_2D _2120;
layout(set = 0, binding = 22) uniform SAMPLER_2D _3120;
layout(set = 0, binding = 24) uniform sampler2DShadow _3886;
layout(set = 0, binding = 26) uniform SAMPLER_2D _4468;
layout(set = 3, binding = 5) uniform texture2D _4703[16384];

layout(location = 2) in vec4 _776;
layout(location = 5) in vec4 _794;
layout(location = 3) in vec4 _797;
layout(location = 4) in vec4 _820;
layout(location = 14) flat in uvec3 _872;
layout(location = 15) in vec4 _875;
layout(location = 6) in vec4 _1061;
layout(location = 0) out vec4 _4621;
layout(location = 1) out vec4 _4629;
layout(location = 2) out vec4 _4637;
layout(location = 3) out vec4 _4655;

uvec4 _44(vec4 _43)
{
    return floatBitsToUint(_43);
}

float _29(vec2 _27, vec2 _28)
{
    return dot(_27, _28);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _35(uint _34)
{
    return uintBitsToFloat(_34);
}

float _144(float _140, vec4 _141, float _142, bool _143)
{
    float _617 = _141.w / (_140 + _141.z);
    return _617 * _142;
}

vec3 _149(vec3 _147, bool _148)
{
    vec3 _630 = (_147 * 2.0) - vec3(1.0);
    float _647 = (1.0 - (_630.x * _630.x)) - (_630.y * _630.y);
    _630.z = sqrt(_10(_647));
    if (_148 == false)
    {
        _630.z = -_630.z;
    }
    return _630;
}

vec3 _156(vec3 _154, mat3 _155)
{
    return normalize(vec3(dot(_154, _155[0]), dot(_154, _155[1]), dot(_154, _155[2])));
}

uint _39(float _38)
{
    return floatBitsToUint(_38);
}

float _55(float _52, float _53, float _54)
{
    return min(_52, min(_53, _54));
}

float _50(float _47, float _48, float _49)
{
    return max(_47, max(_48, _49));
}

vec4 _99(uint _98)
{
    return unpackUnorm4x8(_98).wzyx;
}

vec4 _112(uvec2 _111)
{
    return vec4(float((_111.x >> uint(16)) & 65535u), float(_111.x & 65535u), float((_111.y >> uint(16)) & 65535u), float(_111.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _64(float _63)
{
    return _63 * ((_63 * ((_63 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _102(uint _101)
{
    return vec4(float((_101 >> uint(24)) & 255u), float((_101 >> uint(16)) & 255u), float((_101 >> uint(8)) & 255u), float(_101 & 255u));
}

float _92(float _91)
{
    return (step(0.0, _91) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _67(vec3 _66)
{
    float _278 = _66.x;
    vec3 _277;
    _277.x = _64(_278);
    float _284 = _66.y;
    _277.y = _64(_284);
    float _290 = _66.z;
    _277.z = _64(_290);
    return _277;
}

vec4 _70(vec4 _69)
{
    vec3 _300 = _69.xyz;
    vec4 _299 = vec4(_67(_300), 1.0);
    float _308 = _69.w;
    _299.w = _64(_308);
    return _299;
}

float _76(float _75)
{
    return _75 * _75;
}

vec3 _73(vec3 _72)
{
    return _72 * _72;
}

float _81(float _78, float _79, float _80)
{
    float _334 = (_78 - _79) / (_80 - _79);
    return _10(_334);
}

vec3 _106(uint _105)
{
    return vec3(float((_105 >> uint(21)) & 2047u), float((_105 >> uint(10)) & 2047u), float(_105 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _61(float _58, float _59, float _60)
{
    bool _223 = abs(_60) >= abs(_58);
    bool _231;
    if (_223)
    {
        _231 = abs(_60) >= abs(_59);
    }
    else
    {
        _231 = _223;
    }
    if (_231)
    {
        return uint((_60 < 0.0) ? 5 : 4);
    }
    if (abs(_59) >= abs(_58))
    {
        return uint((_59 < 0.0) ? 3 : 2);
    }
    return uint(int(_58 < 0.0));
}

float _84(float _83)
{
    return exp2(_83);
}

vec3 _115(uint _114)
{
    uint _432 = _114;
    vec4 _431 = _99(_432);
    float _443 = (_431.w * 255.0) - 128.0;
    return _431.xyz * _84(_443);
}

float _89(float _87, float _88)
{
    return pow(_87, _88);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _120(vec3 _118, float _119)
{
    float _455 = 50.0 * dot(_118, vec3(0.33329999446868896484375));
    float _448 = _10(_455);
    float _464 = 1.0 - _119;
    float _467 = _10(_464);
    float _468 = 5.0;
    vec3 _472 = _118 + ((vec3(_448) - _118) * _89(_467, _468));
    return _16(_472);
}

vec3 _128(vec3 _123, vec3 _124, vec3 _125, vec3 _126, float _127)
{
    vec3 _476 = normalize(_124 + _125);
    float _481 = 1.0 - (_127 * 0.800000011920928955078125);
    _481 *= _481;
    _481 *= _481;
    float _492 = _481 * _481;
    float _500 = dot(_123, _476);
    float _496 = _10(_500);
    float _502 = ((_496 * _496) * (_492 - 1.0)) + 1.0;
    _502 = _492 / ((_502 * _502) + 9.9999999392252902907785028219223e-09);
    float _521 = dot(_123, _124);
    float _517 = (_10(_521) * (1.0 - _481)) + _481;
    float _532 = dot(_123, _125);
    float _528 = (_10(_532) * (1.0 - _481)) + _481;
    _502 /= (((4.0 * _517) * _528) + 9.9999999392252902907785028219223e-09);
    vec3 _550 = _126;
    float _552 = dot(_125, _476);
    return _120(_550, _552) * _502;
}

vec3 _135(vec3 _131, vec3 _132, vec3 _133, float _134)
{
    float _558 = 1.0 - (_134 * 0.800000011920928955078125);
    _558 *= _558;
    _558 *= _558;
    float _568 = _558 * _558;
    float _576 = dot(_131, _132);
    float _572 = _10(_576);
    float _578 = ((_572 * _572) * (_568 - 1.0)) + 1.0;
    _578 = _568 / ((_578 * _578) + 9.9999999392252902907785028219223e-09);
    float _596 = dot(_131, _132);
    float _592 = (_10(_596) * (1.0 - _558)) + _558;
    _578 /= (((4.0 * _592) * _592) + 9.9999999392252902907785028219223e-09);
    vec3 _610 = _133;
    return _16(_610) * _578;
}

vec2 _160(vec2 _159)
{
    return (vec2(1.0) - abs(_159.yx)) * vec2((_159.x >= 0.0) ? 1.0 : (-1.0), (_159.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _165(inout vec3 _163, bool _164)
{
    _163 /= vec3((abs(_163.x) + abs(_163.y)) + abs(_163.z));
    vec2 _714;
    if (_163.z >= 0.0)
    {
        _714 = _163.xy;
    }
    else
    {
        vec2 _720 = _163.xy;
        _714 = _160(_720);
    }
    _163 = vec3(_714.x, _714.y, _163.z);
    if (_164)
    {
        vec2 _735 = (_163.xy * 0.5) + vec2(0.5);
        _163 = vec3(_735.x, _735.y, _163.z);
    }
    return _163.xy;
}

float _95(float _94)
{
    return sqrt(_94);
}

float _168(float _167)
{
    float _745 = abs(_167);
    float _742 = _95(_745);
    float _749;
    if (_167 > 0.0)
    {
        _749 = _742;
    }
    else
    {
        _749 = -_742;
    }
    return (_749 * 0.5) + 0.5;
}

void main()
{
    _762 _764 = _762(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _764._m15 = _776;
    _764._m16 = gl_FragCoord;
    _764._m40 = (uint(_785._m16.z) & 3u) << uint(4);
    vec3 _793 = vec3(_794.zw, _797.w);
    _764._m14 = _807._m0.xyz + _793;
    vec3 _815 = normalize(_797.xyz);
    vec3 _819 = normalize(_820.xyz);
    vec3 _824 = normalize(cross(_815, _819) * sign(_820.w));
    _764._m17 = mat3(vec3(_819.x, _824.x, _815.x), vec3(_819.y, _824.y, _815.y), vec3(_819.z, _824.z, _815.z));
    _764._m13 = normalize(-_793);
    uint _862 = 0u;
    vec4 _863 = vec4(0.0);
    vec4 _864 = vec4(0.0);
    vec4 _865 = vec4(0.0);
    vec4 _866 = vec4(0.0);
    vec4 _867 = vec4(0.0);
    uvec3 _870 = _872;
    vec3 _874 = _875.xyz;
    bool _881 = _870.y == 65535u;
    bool _887;
    if (_881)
    {
        _887 = _870.z == 65535u;
    }
    else
    {
        _887 = _881;
    }
    bool _878 = _887;
    bool _888 = !_878;
    bool _891 = _870.z != 65535u;
    uint _895 = _870.x & 7u;
    uint _905;
    if (_807._m1.x == 0.0)
    {
        _905 = _895;
    }
    else
    {
        vec4 _913 = _912._m3;
        uvec4 _909 = _44(_913);
        uint _917 = _909[_895 / 2u];
        uint _922 = 16u * (_895 & 1u);
        _905 = (_917 >> _922) & 65535u;
    }
    uint _931 = _905;
    uint _940 = _931;
    vec3 _933 = texture(sampler2D(_938[nonuniformEXT(_940)], _946), _776.zw).xyz;
    uint _957 = _931;
    vec2 _954 = texture(sampler2D(_955[nonuniformEXT(_957)], _960), _776.zw).yx;
    vec3 _967 = vec3(0.039999999105930328369140625);
    uint _972 = _931;
    _967 = texture(sampler2D(_970[nonuniformEXT(_972)], _975), _776.zw).xyz;
    uint _985 = _931;
    float _982 = texture(sampler2D(_983[nonuniformEXT(_985)], _988), _776.zw).x;
    float _995 = 1.0;
    uint _999 = _931;
    float _996 = texture(sampler2D(_997[nonuniformEXT(_999)], _1002), _776.zw).x;
    uint _1012 = _931;
    float _1009 = texture(sampler2D(_1010[nonuniformEXT(_1012)], _1015), _776.zw).x;
    uint _1025 = _931;
    vec3 _1022 = texture(sampler2D(_1023[nonuniformEXT(_1025)], _1028), _776.zw).xyz;
    _865 = vec4(_933.x, _933.y, _933.z, _865.w);
    _865.w = _954.y;
    _866 = vec4(_967.x, _967.y, _967.z, _866.w);
    _866.w = _1009;
    _867 = vec4(_867.x, _954.x, _867.z, _954.y);
    _863.x = _996;
    _863.y = _995;
    _863.z = _1009;
    _863.w = _982;
    _864 = vec4(_1022.x, _1022.y, _1022.z, _864.w);
    vec3 _1060 = _1061.xyz;
    vec3 _1064 = (_785._m0.xyz * _912._m13.xyz) * mix(_865.xyz, vec3(1.0), vec3(_785._m0.w));
    _764._m10 = vec3(((_912._m14.x * _863.x) * _863.x) * _785._m1.x) * _1064;
    _764._m10 *= vec3(_807._m2.x);
    uint _1102 = 0u;
    _764._m15.x = (_764._m15.x * _785._m2.x) + _785._m2.z;
    _764._m15.y = (_764._m15.y * _785._m2.y) + _785._m2.w;
    float _1121 = _807._m3.z;
    float _1124 = _807._m4.z;
    vec2 _1127 = _764._m15.xy * _1121;
    vec2 _1133 = dFdx(_1127) / vec2(float(gl_FragmentSizeNV.x));
    vec2 _1145 = dFdy(_1127) / vec2(float(gl_FragmentSizeNV.y));
    vec2 _1154 = _1133;
    vec2 _1156 = _1133;
    float _1153 = _29(_1154, _1156);
    vec2 _1160 = _1145;
    vec2 _1162 = _1145;
    float _1159 = _29(_1160, _1162);
    float _1165 = 0.5 * log2(max(_1153, _1159));
    float _1171 = 0.5 * log2(min(_1153, _1159));
    float _1177 = _1165 - min(_1124, _1165 - _1171);
    float _1185 = _1177;
    float _1187 = _807._m3.y;
    float _1190 = _807._m4.y;
    uvec2 _1193 = uvec2(_764._m15.xy * _1187);
    uint _1200 = uint(min(_807._m4.w, max(0.0, _1177) + _1190));
    uint _1209 = uint(_807._m3.x);
    _1102 = _1193.x & 255u;
    _1102 |= ((_1193.y & 255u) << uint(8));
    _1102 |= ((_1193.x >> uint(8)) << uint(16));
    _1102 |= ((_1193.y >> uint(8)) << uint(24));
    _1102 |= (_1200 << uint(19));
    _1102 |= (_1209 << uint(27));
    vec3 _1302;
    if (_807._m5.y != 0.0)
    {
        float _1249 = fract(_1185);
        float _1252 = 0.375;
        float _1254 = 0.625;
        bool _1261;
        float _1262;
        float _1265;
        if (_1249 <= _1252)
        {
            _1261 = false;
            _1262 = _1185 - 0.5;
            _1265 = 0.0;
        }
        else
        {
            if (_1249 >= _1254)
            {
                _1261 = false;
                _1262 = _1185 + 0.5;
                _1265 = 0.0;
            }
            else
            {
                _1261 = true;
                _1262 = _1185 - 0.5;
                _1265 = _1185 + 0.5;
            }
        }
        vec4 _1280 = vec4(_764._m15.x, _764._m15.y, 0.0, _1262);
        vec2 _1287 = TEXTURE_LOD(_1289, _1280.xy, _1280.w).xy;
        vec4 _1297 = SAMPLE_TEXTURE(_1298, _1287);
        _1302.x = (_764._m15.x * _1297.x) + _1297.z;
        _1302.y = (_764._m15.y * (_1297.x * _807._m6.x)) + _1297.w;
        _1302.z = _1297.y;
        vec2 _1328 = (dFdx(_764._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1302.z;
        vec2 _1341 = (dFdy(_764._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1302.z;
        vec3 _1361 = TEXTURE_GRAD(_1354, _1302.xy, _1328, _1341).xyz;
        _863 = vec4(_1361.x, _1361.y, _1361.z, _863.w);
        if (_1261)
        {
            vec4 _1367 = vec4(_764._m15.x, _764._m15.y, 0.0, _1265);
            vec2 _1374 = TEXTURE_LOD(_1289, _1367.xy, _1367.w).xy;
            vec4 _1382 = SAMPLE_TEXTURE(_1298, _1374);
            _1302.x = (_764._m15.x * _1382.x) + _1382.z;
            _1302.y = (_764._m15.y * (_1382.x * _807._m6.x)) + _1382.w;
            _1302.z = _1382.y;
            vec2 _1410 = (dFdx(_764._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1302.z;
            vec2 _1423 = (dFdy(_764._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1302.z;
            vec3 _1443 = TEXTURE_GRAD(_1354, _1302.xy, _1410, _1423).xyz;
            vec4 _1436;
            _1436 = vec4(_1443.x, _1443.y, _1443.z, _1436.w);
            float _1446 = 0.0;
            float _1447 = 0.375;
            float _1452 = (_1249 - _1447) * 4.0;
            _1446 = _10(_1452);
            vec3 _1460 = mix(_863.xyz, _1436.xyz, vec3(_1446));
            _1436 = vec4(_1460.x, _1460.y, _1460.z, _1436.w);
        }
    }
    else
    {
        vec4 _1464 = vec4(_764._m15.x, _764._m15.y, 0.0, _1185 - 0.5);
        vec2 _1472 = TEXTURE_LOD(_1289, _1464.xy, _1464.w).xy;
        vec4 _1480 = SAMPLE_TEXTURE(_1298, _1472);
        _1302.x = (_764._m15.x * _1480.x) + _1480.z;
        _1302.y = (_764._m15.y * (_1480.x * _807._m6.x)) + _1480.w;
        _1302.z = _1480.y;
        vec2 _1508 = (dFdx(_764._m15.xy) / vec2(float(gl_FragmentSizeNV.x))) * _1302.z;
        vec2 _1521 = (dFdy(_764._m15.xy) / vec2(float(gl_FragmentSizeNV.y))) * _1302.z;
        vec3 _1540 = TEXTURE_GRAD(_1354, _1302.xy, _1508, _1521).xyz;
        _863 = vec4(_1540.x, _1540.y, _1540.z, _863.w);
    }
    vec2 _1543 = vec2(160.0, 90.0);
    vec2 _1547 = _1543 * _807._m7.zw;
    vec2 _1554 = (gl_FragCoord.xy * _807._m7.zw) * _1543;
    bool _1568 = fract(_1554.x) < _1547.x;
    bool _1577;
    if (_1568)
    {
        _1577 = fract(_1554.y) < _1547.y;
    }
    else
    {
        _1577 = _1568;
    }
    if (_1577)
    {
        uint _1586 = _1102;
        imageStore(_1582, ivec2(_1554), vec4(_35(_1586), 0.0, 0.0, 0.0));
    }
    _862 = _1102;
    _764._m0 = _865.xyz;
    _764._m2 = _866.xyz;
    _764._m1 = _864.xyz;
    _764._m9 = _863.xyz;
    _764._m3 = _863.w;
    _764._m6 = _867.wyz;
    uint _1610 = 8u;
    float _1612 = 16.0;
    float _1614 = 8.0;
    float _1616 = 24.0;
    vec2 _1625 = _764._m16.xy * _807._m7.xy;
    vec3 _1618;
    _1618 = vec3(_1625.x, _1625.y, _1618.z);
    _1618.y = 1.0 - _1618.y;
    
    _1618.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1638 = floor(_1618.xy * vec2(_1612, _1614));
    _1618 = vec3(_1638.x, _1638.y, _1618.z);
    float _1642 = _764._m16.z;
    vec4 _1645 = _807._m8;
    float _1648 = 1.0;
    bool _1649 = false;
    float _1641 = _144(_1642, _1645, _1648, _1649);
    float _1651 = log2(max(1.0, _1641 / _807._m9.z)) * _807._m9.w;
    _1618.z = min(_1616 - 1.0, floor(_1651));
    uint _1667 = uint((_1618.x + (_1618.y * _1612)) + ((_1618.z * _1612) * _1614));
    _1667 = min(_1667, uint(((_1612 * _1614) * _1616) - 1.0));
    bool _1692 = true;
    vec3 _1693 = _764._m6;
    bool _1696 = _1692;
    _764._m7 = _149(_1693, _1696);
    vec3 _1700 = _764._m7;
    mat3 _1703 = _764._m17;
    _764._m6 = _156(_1700, _1703);
    uint _1708 = 0u;
    uint _1709 = 0u;
    uint _1710 = 0u;
    uint _1711 = 0u;
    uint _1712 = 0u;
    uint _1713 = 0u;
    int _1715 = 256;
    _1717 _1719;
    _1719._m0 = _1724._m0[_1667]._m0;
    _1719._m1 = _1724._m0[_1667]._m1;
    int _1733 = _1719._m0 & (~(_1719._m0 >> 31));
    int _1742 = _1719._m1 & (~(_1719._m1 >> 31));
    _1708 = uint((_1733 >> 16) * _1715);
    _1709 = _1708 + uint(_1742 & 255);
    _1710 = _1708;
    _1711 = _1710 + uint((_1742 >> 8) & 255);
    _1712 = _1708;
    _1713 = _1712 + uint((_1742 >> 16) & 255);
    vec3 _1775 = dFdx(_764._m14);
    vec3 _1779 = dFdy(_764._m14);
    uint _1783 = _1710;
    _1820 _1822;
    vec3 _2174;
    float _2279;
    while (_1783 < _1711)
    {
        uint _1793 = _1797._m0[_1783];
        uint _1802 = (_1793 >> uint(12)) & 4095u;
        uint _1808 = _1802;
        if (_1808 >= _1802)
        {
            _1783++;
        }
        int _1817 = 2;
        int _1818 = 2;
        int _1819 = 2;
        _1822._m0 = _1827._m0[(uint(_1817) * _1808) + 0u];
        _1822._m1 = _1827._m0[(uint(_1817) * _1808) + 1u];
        _1822._m2 = _1847._m0[(uint(_1818) * _1808) + 0u];
        float _1861 = _1847._m0[(uint(_1818) * _1808) + 1u].x;
        _1822._m3.x = _39(_1861);
        float _1871 = _1847._m0[(uint(_1818) * _1808) + 1u].y;
        _1822._m3.y = _39(_1871);
        float _1881 = _1847._m0[(uint(_1818) * _1808) + 1u].z;
        _1822._m4.x = _39(_1881);
        float _1891 = _1847._m0[(uint(_1818) * _1808) + 1u].w;
        _1822._m4.y = _39(_1891);
        float _1905 = _1899._m0[(uint(_1819) * _1808) + 0u].x;
        _1822._m5.x = _39(_1905);
        float _1915 = _1899._m0[(uint(_1819) * _1808) + 0u].y;
        _1822._m5.y = _39(_1915);
        float _1925 = _1899._m0[(uint(_1819) * _1808) + 0u].z;
        _1822._m6 = _39(_1925);
        float _1935 = _1899._m0[(uint(_1819) * _1808) + 0u].w;
        _1822._m7 = _39(_1935);
        float _1945 = _1899._m0[(uint(_1819) * _1808) + 1u].x;
        _1822._m8 = _39(_1945);
        float _1955 = _1899._m0[(uint(_1819) * _1808) + 1u].y;
        _1822._m9 = _39(_1955);
        float _1965 = _1899._m0[(uint(_1819) * _1808) + 1u].z;
        _1822._m10 = _39(_1965);
        float _1976 = _1899._m0[(uint(_1819) * _1808) + 1u].w;
        _1822._m11 = _39(_1976);
        vec4 _1981 = vec4(_764._m14, 1.0);
        vec3 _1988 = vec3(dot(_1981, _1822._m0), dot(_1981, _1822._m1), dot(_1981, _1822._m2));
        float _2002 = 0.0039215688593685626983642578125;
        float _2004 = _1988.x;
        float _2007 = _1988.y;
        float _2010 = _1988.z;
        bool _2015 = _55(_2004, _2007, _2010) <= _2002;
        bool _2032;
        if (!_2015)
        {
            float _2019 = _1988.x;
            float _2022 = _1988.y;
            float _2025 = _1988.z;
            _2032 = _50(_2019, _2022, _2025) >= (1.0 - _2002);
        }
        else
        {
            _2032 = _2015;
        }
        if (_2032)
        {
            continue;
        }
        uint _2036 = _1822._m11;
        bool _2040 = _1610 != 0u;
        bool _2047;
        if (_2040)
        {
            _2047 = (_2036 & 1024u) != 0u;
        }
        else
        {
            _2047 = _2040;
        }
        bool _2060;
        if (!_2047)
        {
            bool _2052 = _1610 == 0u;
            bool _2059;
            if (_2052)
            {
                _2059 = (_2036 & 2048u) != 0u;
            }
            else
            {
                _2059 = _2052;
            }
            _2060 = _2059;
        }
        else
        {
            _2060 = _2047;
        }
        if (_2060)
        {
            continue;
        }
        vec3 _2064 = _1822._m0.xyz;
        vec3 _2068 = _1822._m1.xyz;
        vec3 _2072 = _1822._m2.xyz;
        vec2 _2076 = vec2(dot(_1775, _2064), dot(_1775, _2068));
        vec2 _2084 = vec2(dot(_1779, _2064), dot(_1779, _2068));
        float _2092 = 1.0;
        float _2093 = 1.0;
        vec3 _2094 = vec3(0.5, 0.5, 1.0);
        uint _2096 = _1822._m7;
        uint _2100 = _1822._m9;
        vec4 _2099 = _99(_2100);
        uvec2 _2105 = _1822._m5;
        vec4 _2104 = _112(_2105);
        vec2 _2109 = _2076 * _2104.xy;
        vec2 _2114 = _2084 * _2104.xy;
        vec4 _2119 = TEXTURE_GRAD(_2120, (_1988.xy * _2104.xy) + _2104.zw, _2109, _2114);
        _2092 = _2119.z;
        float _2135 = _2119.w;
        _2093 = _64(_2135);
        bool _2142 = _2093 <= (4.0 * _2002);
        bool _2149;
        if (_2142)
        {
            _2149 = _2099.w <= _2002;
        }
        else
        {
            _2149 = _2142;
        }
        if (_2149)
        {
            continue;
        }
        vec2 _2153 = (_2119.xy * 2.0) - vec2(1.0);
        float _2164 = 1.0 - dot(_2153, _2153);
        _2094 = vec3(_2153, sqrt(_10(_2164)));
        if ((_2036 & 256u) != 0u)
        {
            _2174 = vec3(-_2094.x, -_2094.y, _2094.z);
        }
        else
        {
            _2174 = _2094;
        }
        _2094 = _2174;
        uint _2189 = _1822._m8;
        uint _2193 = _2189;
        float _2192 = 1.0 + (_102(_2193).w * 0.062745101749897003173828125);
        uint _2201 = _2096;
        float _2200 = _99(_2201).z;
        float _2214 = _2192 - (_2192 * abs((_1988.z * 2.0) - 1.0));
        _2093 *= _10(_2214);
        if ((_2096 & 64u) != 0u)
        {
            uint _2225 = _2096;
            float _2224 = _99(_2225).x;
            uint _2230 = _2096;
            float _2229 = _102(_2230).y;
            float _2236 = _2224;
            float _2234 = mix(_2229, 0.0, _10(_2236));
            float _2245 = _2092 - (_2234 / 255.0);
            float _2240 = float(_10(_2245) > 0.0);
            _2093 *= _2240;
        }
        vec3 _2252 = normalize(vec3(_764._m17[0].z, _764._m17[1].z, _764._m17[2].z));
        float _2261 = dot(_2252, normalize(_2072));
        float _2266 = _2261;
        vec2 _2271 = _2094.xy * _92(_2266);
        _2094 = vec3(_2271.x, _2271.y, _2094.z);
        if ((_2036 & 32768u) != 0u)
        {
            float _2284 = abs(_2261);
            _2279 = _10(_2284);
        }
        else
        {
            float _2287 = _2261;
            _2279 = _10(_2287);
        }
        float _2274 = _2279;
        float _2291 = _2093 * _2274;
        uint _2295 = _1822._m6;
        uint _2299 = _2295;
        vec4 _2304 = _99(_2299) * _2291;
        vec4 _2298 = _22(_2304);
        _764._m11 = max(_764._m11, _2298.x);
        _2064 += (_2252 * dot(_2064, _2252));
        _2068 += (_2252 * dot(_2068, _2252));
        _2094 = ((normalize(_2064) * _2094.x) + (normalize(_2068) * _2094.y)) + (_2252 * _2094.z);
        if ((_2036 & 512u) != 0u)
        {
            vec3 _2348 = mix(_2252, _2094, _2298.www);
            float _2354 = dot(_2348, _2252);
            _2094 = (_764._m6 * _2354) + ((_2348 - (_2252 * _2354)) * dot(_764._m6, _2252));
        }
        else
        {
            if ((_2036 & 128u) != 0u)
            {
                _2094 = mix(mix(_764._m6, _2252, vec3(_2291)), _2094, _2298.www);
            }
            else
            {
                _2094 = mix(_764._m6, _2094, _2298.www);
            }
        }
        _764._m6 = normalize(_2094);
        uint _2401 = _2189;
        vec3 _2400 = _99(_2401).xyz;
        float _2405 = _2093;
        if ((_2096 & 1u) != 0u)
        {
            uvec2 _2413 = _1822._m3;
            vec4 _2412 = _112(_2413);
            vec2 _2417 = _2076 * _2412.xy;
            vec2 _2422 = _2084 * _2412.xy;
            vec4 _2427 = TEXTURE_GRAD(_2120, (_1988.xy * _2412.xy) + _2412.zw, _2417, _2422);
            vec4 _2440 = _2427;
            _2427 = _70(_2440);
            float _2450 = (_2427.w - _2002) / (1.0 - _2002);
            _2405 = _10(_2450);
            _2400 *= _2427.xyz;
        }
        _764._m0 = mix(_764._m0, _2400, _2298.xxx);
        float _2463 = ((_2274 * _2405) * _2099.w) * _2200;
        _764._m10 += (_2099.xyz * (_2463 * 64.0));
        uint _2482 = _1822._m10;
        uint _2486 = _2482;
        vec4 _2485 = _99(_2486);
        float _2489 = 0.0;
        if ((_2096 & 10u) != 0u)
        {
            uvec2 _2497 = _1822._m4;
            vec4 _2496 = _112(_2497);
            vec2 _2501 = _2076 * _2496.xy;
            vec2 _2506 = _2084 * _2496.xy;
            vec4 _2511 = TEXTURE_GRAD(_2120, (_1988.xy * _2496.xy) + _2496.zw, _2501, _2506);
            if ((_2096 & 2u) != 0u)
            {
                _2485 = _2511 * _2511;
            }
            else
            {
                _2489 = _2511.w;
            }
        }
        _764._m2 = mix(_764._m2, _2485.xyz, _2298.yyy);
        _764._m3 = mix(_764._m3, _2485.w, _2298.z);
        _764._m37 = max(_764._m37, _2489);
        float _2563 = (_2092 - 0.5) * 2.0;
        _764._m38 = max(_764._m38, _10(_2563));
    }
    float _2568 = _764._m37;
    float _2567 = _76(_2568);
    float _2575 = _2567 - 0.5;
    float _2572 = _10(_2575) * 2.0;
    float _2586 = _2567 * 2.0;
    float _2578 = (_764._m38 * _764._m38) * _10(_2586);
    float _2593 = _2578 + _2572;
    float _2589 = _10(_2593);
    if (_2589 > 0.0039215688593685626983642578125)
    {
        vec3 _2601 = _764._m0;
        float _2608 = _2589 * 1.0;
        float _2609 = 0.0;
        float _2610 = 0.3499999940395355224609375;
        _764._m0 = mix(_764._m0, _73(_2601), vec3(_81(_2608, _2609, _2610) * (1.0 - _764._m3)));
        float _2624 = _2589 * 1.0;
        float _2625 = 0.25;
        float _2626 = 0.5;
        _764._m2 = mix(_764._m2, vec3(0.039999999105930328369140625), vec3(_81(_2624, _2625, _2626)));
        vec3 _2631 = vec3(_764._m17[0].z, _764._m17[1].z, _764._m17[2].z);
        float _2645 = _2631.z + 0.0625;
        float _2639 = _2589 * _10(_2645);
        float _2654 = _2639 * 1.0;
        float _2655 = 0.20000000298023223876953125;
        float _2656 = 1.0;
        _764._m3 = mix(_764._m3, 0.89999997615814208984375, _81(_2654, _2655, _2656));
        float _2665 = _2639 * 1.0;
        float _2666 = 0.449999988079071044921875;
        float _2667 = 0.980000019073486328125;
        float _2660 = _81(_2665, _2666, _2667);
        _764._m6 = normalize(mix(_764._m6, vec3(0.0, 0.0, 1.0), vec3(_2660)));
        _764._m7 = mix(_764._m6, vec3(0.5, 0.5, 1.0), vec3(_2660));
        if (_2639 > 0.980000019073486328125)
        {
            float _2690 = _2639 * _2660;
            float _2691 = 0.980000019073486328125;
            float _2692 = 1.0;
            _2631 = normalize(mix(_2631, vec3(0.0, 0.0, 1.0), vec3(_81(_2690, _2691, _2692))));
            _764._m17[0].z = _2631.x;
            _764._m17[1].z = _2631.y;
            _764._m17[2].z = _2631.z;
        }
    }
    vec3 _2706 = vec3(0.0);
    _2706 = _764._m9 * _807._m10.x;
    float _2716;
    if (dot(_764._m10, vec3(1.0)) > 0.0)
    {
        _2716 = -_764._m3;
    }
    else
    {
        _2716 = _764._m3;
    }
    _764._m3 = _2716;
    _764._m18 = _2706;
    _764._m19 = _2706;
    uint _2732 = _1708;
    _2761 _2763;
    vec3 _3081;
    float _3170;
    float _3188;
    uint _3532;
    _3558 _3560;
    uint _3682;
    _3558 _3706;
    while (_2732 < _1709)
    {
        uint _2742 = _1797._m0[_2732];
        uint _2746 = _2742 & 4095u;
        uint _2749 = _2746;
        if (_2749 >= _2746)
        {
            _2732++;
        }
        int _2758 = 4;
        int _2759 = 4;
        int _2760 = 4;
        _2763._m0 = _2767._m0[(uint(_2758) * _2749) + 0u].xyz;
        float _2782 = _2767._m0[(uint(_2758) * _2749) + 0u].w;
        _2763._m1 = _39(_2782);
        _2763._m2 = _2767._m0[(uint(_2758) * _2749) + 1u];
        _2763._m3 = _2767._m0[(uint(_2758) * _2749) + 2u];
        _2763._m4 = _2806._m0[(uint(_2759) * _2749) + 0u];
        _2763._m5 = _2806._m0[(uint(_2759) * _2749) + 1u];
        _2763._m6 = _2806._m0[(uint(_2759) * _2749) + 2u];
        float _2836 = _2767._m0[(uint(_2758) * _2749) + 3u].x;
        _2763._m7.x = _39(_2836);
        float _2846 = _2767._m0[(uint(_2758) * _2749) + 3u].y;
        _2763._m7.y = _39(_2846);
        float _2856 = _2767._m0[(uint(_2758) * _2749) + 3u].z;
        _2763._m7.z = _39(_2856);
        float _2866 = _2767._m0[(uint(_2758) * _2749) + 3u].w;
        _2763._m7.w = _39(_2866);
        _2763._m8 = _2874._m0[(uint(_2760) * _2749) + 0u];
        _2763._m9 = _2874._m0[(uint(_2760) * _2749) + 1u];
        _2763._m10 = _2874._m0[(uint(_2760) * _2749) + 2u];
        _2763._m11 = _2874._m0[(uint(_2760) * _2749) + 3u];
        float _2912 = _2806._m0[(uint(_2759) * _2749) + 3u].x;
        _2763._m12 = _39(_2912);
        float _2922 = _2806._m0[(uint(_2759) * _2749) + 3u].y;
        _2763._m13 = _39(_2922);
        _2763._m14 = _2806._m0[(uint(_2759) * _2749) + 3u].z;
        float _2940 = _2806._m0[(uint(_2759) * _2749) + 3u].w;
        _2763._m15 = _39(_2940);
        uint _2945 = (_2763._m12 >> uint(16)) & 3u;
        if (((_764._m40 >> uint(4)) & 3u) != _2945)
        {
            continue;
        }
        float _2959 = 0.0039215688593685626983642578125;
        vec4 _2960 = vec4(_764._m14, 1.0);
        float _2967 = 1.0 / dot(_2960, _2763._m6);
        vec3 _2973 = vec3(dot(_2960, _2763._m4) * _2967, dot(_2960, _2763._m5) * _2967, dot(_2960, _2763._m3));
        uint _2991 = _2763._m1;
        uint _2994 = _1610;
        _2994 |= 64u;
        float _2998 = _2973.x;
        float _3001 = _2973.y;
        float _3004 = _2973.z;
        bool _3009 = _55(_2998, _3001, _3004) <= _2959;
        bool _3026;
        if (!_3009)
        {
            float _3013 = _2973.x;
            float _3016 = _2973.y;
            float _3019 = _2973.z;
            _3026 = _50(_3013, _3016, _3019) >= (1.0 - _2959);
        }
        else
        {
            _3026 = _3009;
        }
        bool _3034;
        if (!_3026)
        {
            _3034 = (_2991 & _2994) != 0u;
        }
        else
        {
            _3034 = _3026;
        }
        if (_3034)
        {
            continue;
        }
        if ((_2991 & 3u) == 2u)
        {
            vec2 _3053 = fract((_2973.xy * _807._m11.xy) + _807._m11.zw);
            _2973 = vec3(_3053.x, _3053.y, _2973.z);
        }
        vec3 _3056 = _2763._m0;
        float _3059 = 1.0;
        float _3060 = 1.0;
        vec3 _3061 = vec3(0.0, 0.0, 1.0);
        vec3 _3062 = vec3(0.0, 0.0, 1.0);
        uint _3063 = _2763._m1;
        vec3 _3066 = (_2973 * 2.0) - vec3(1.0);
        vec2 _3071 = _2973.xy;
        vec3 _3074 = _2763._m10.xyz;
        if ((_3063 & 3u) == 2u)
        {
            _3081 = _3074;
        }
        else
        {
            _3081 = normalize(_3056 - _764._m14);
        }
        _3061 = _3081;
        _3061 = _3061;
        float _3098 = dot(_764._m6, _3061);
        float _3093 = _10(_3098);
        bool _3102 = _3093 <= _2959;
        bool _3109;
        if (_3102)
        {
            _3109 = (_3063 & 48u) == 0u;
        }
        else
        {
            _3109 = _3102;
        }
        if (_3109)
        {
            continue;
        }
        uvec2 _3114 = _2763._m7.zw;
        vec4 _3113 = _112(_3114);
        float _3119 = TEXTURE_LOD(_3120, vec4((_3071 * _3113.xy) + _3113.zw, 0.0, 0.0).xy, vec4((_3071 * _3113.xy) + _3113.zw, 0.0, 0.0).w).x;
        float _3146 = _3119 * _3119;
        uint _3150 = _3063 & 3u;
        bool _3155 = _3150 == 1u;
        bool _3167;
        if (!_3155)
        {
            bool _3160 = _3150 == 0u;
            bool _3166;
            if (_3160)
            {
                _3166 = _2763._m8.z != 0.0;
            }
            else
            {
                _3166 = _3160;
            }
            _3167 = _3166;
        }
        else
        {
            _3167 = _3155;
        }
        bool _3153 = _3167;
        if (_3153)
        {
            float _3173 = _2763._m8.w;
            _3170 = _10(_3173);
        }
        else
        {
            _3170 = 0.5;
        }
        float _3168 = _3170;
        bool _3181 = _3150 == 0u;
        bool _3187;
        if (_3181)
        {
            _3187 = _2763._m8.z != 0.0;
        }
        else
        {
            _3187 = _3181;
        }
        if (_3187)
        {
            float _3196 = sqrt(dot(_3066, _3066));
            _3188 = min(0.9921875, _10(_3196));
        }
        else
        {
            _3188 = _2973.z;
        }
        float _3179 = _3188;
        uvec2 _3204 = _2763._m7.xy;
        vec4 _3203 = _112(_3204);
        vec2 _3209 = vec2(_3179, _3168);
        float _3213 = TEXTURE_LOD(_3120, vec4((_3209 * _3203.xy) + _3203.zw, 0.0, 0.0).xy, vec4((_3209 * _3203.xy) + _3203.zw, 0.0, 0.0).w).x;
        _3213 *= _3213;
        _3059 = _3213 * _3146;
        if ((_3063 & 48u) != 0u)
        {
            vec4 _3250 = _2763._m10;
            vec4 _3253 = _2763._m8;
            vec4 _3256 = _2763._m9;
            float _3259 = dot(_764._m14, _3250.xyz) + _3250.w;
            if (_3259 < 0.0)
            {
                continue;
            }
            float _3273 = length(_3250.xyz);
            float _3280 = _3259 * 50.0;
            float _3277 = _10(_3280);
            _3059 *= (_3277 * _3277);
            _3259 /= _3273;
            _3250 /= vec4(_3273);
            vec3 _3294 = reflect(-_764._m13, _764._m6);
            if (dot(_3294, _3250.xyz) > 0.0)
            {
                _3294 = reflect(_3294, _3250.xyz);
            }
            float _3312 = dot(_3294, _3250.xyz);
            float _3317 = _3259 / _3312;
            vec3 _3321 = _764._m14 - (_3294 * _3317);
            vec3 _3328 = _3321 - _3056;
            float _3332 = dot(_3328, _3253.xyz) / _3253.w;
            float _3340 = dot(_3328, _3256.xyz) / _3256.w;
            if ((_3063 & 48u) == 32u)
            {
                vec2 _3354 = vec2(_3332, _3340);
                float _3358 = 1.0 / max(1.0, length(vec2(_3332, _3340)));
                _3332 *= (_3358 * _3253.w);
                _3340 *= (_3358 * _3256.w);
            }
            else
            {
                float _3380 = abs(_3332);
                float _3382 = _3332;
                _3332 = (_10(_3380) * _92(_3382)) * _3253.w;
                float _3391 = abs(_3340);
                float _3393 = _3340;
                _3340 = (_10(_3391) * _92(_3393)) * _3256.w;
            }
            vec3 _3400 = (_3253.xyz * _3332) + (_3256.xyz * _3340);
            _3056 += _3400;
            _3061 = normalize(_3056 - _764._m14);
            _3061 = _3061;
        }
        else
        {
            uint _3420 = (_2763._m15 >> uint(16)) & 255u;
            if (_3420 == 0u)
            {
                vec4 _3429 = _2763._m9;
                if (dot(_3429.xyz, _764._m14) < (_3429.w - _2959))
                {
                    continue;
                }
            }
            else
            {
                if (_3420 == 1u)
                {
                    vec3 _3450 = _2763._m9.xyz;
                    float _3455 = _2763._m9.w;
                    uint _3459 = _39(_3455);
                    vec3 _3454 = (((_106(_3459) * 2.0) - vec3(1.0)) * _3450) + _3056;
                    vec3 _3468 = abs((_764._m14 - _3454) / _3450);
                    float _3476 = _3468.x;
                    float _3479 = _3468.y;
                    float _3482 = _3468.z;
                    if (_50(_3476, _3479, _3482) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3059 <= (_2959 / 256.0))
        {
            continue;
        }
        float _3498 = 1.0;
        if ((_2991 & 4u) != 0u)
        {
            float _3505 = float(_2763._m15 & 255u) / 255.0;
            float _3511 = 0.00999999977648258209228515625;
            vec3 _3513 = _764._m14 + (_764._m6 * _3511);
            if ((_2991 & 3u) == 0u)
            {
                vec3 _3526 = _3513 - _2763._m2.xyz;
                float _3533 = _3526.x;
                float _3536 = _3526.y;
                float _3539 = _3526.z;
                _3532 = _61(_3533, _3536, _3539);
            }
            else
            {
                if ((_2991 & 3u) == 2u)
                {
                    float _3549 = 0.0;
                    _3532 = 0u;
                    for (; _3532 < 3u; _3532++)
                    {
                        int _3557 = 5;
                        _3560._m0 = _3564._m0[(uint(_3557) * ((_2991 >> uint(22)) + _3532)) + 0u];
                        _3560._m1 = _3564._m0[(uint(_3557) * ((_2991 >> uint(22)) + _3532)) + 1u];
                        _3560._m2 = _3564._m0[(uint(_3557) * ((_2991 >> uint(22)) + _3532)) + 2u];
                        _3560._m3 = _3564._m0[(uint(_3557) * ((_2991 >> uint(22)) + _3532)) + 3u];
                        _3560._m4 = _3564._m0[(uint(_3557) * ((_2991 >> uint(22)) + _3532)) + 4u];
                        vec2 _3621 = vec2(dot(_3513, _3560._m0.xyz) + _3560._m0.w, dot(_3513, _3560._m1.xyz) + _3560._m1.w);
                        _3621 = abs((_3621 * 2.0) - vec2(1.0));
                        bool _3647 = _3621.x < 0.99500000476837158203125;
                        bool _3653;
                        if (_3647)
                        {
                            _3653 = _3621.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _3653 = _3647;
                        }
                        if (_3653)
                        {
                            _3549 = (1.0 - max(_3621.x, _3621.y)) * _807._m12.w;
                            break;
                        }
                    }
                    _3532 = min(2u, _3532);
                    uint _3670 = uint(_764._m16.x) ^ (uint(_764._m16.y) << uint(1));
                    if (_807._m13.w > 0.0)
                    {
                        _3682 = uint(_807._m14.x);
                    }
                    else
                    {
                        _3682 = 0u;
                    }
                    _3670 ^= _3682;
                    _3532 += uint(int(((float(_3670 & 3u) * 0.25) + 0.125) > _3549));
                }
                else
                {
                    _3532 = 0u;
                }
            }
            int _3705 = 5;
            _3706._m0 = _3564._m0[(uint(_3705) * ((_2991 >> uint(22)) + _3532)) + 0u];
            _3706._m1 = _3564._m0[(uint(_3705) * ((_2991 >> uint(22)) + _3532)) + 1u];
            _3706._m2 = _3564._m0[(uint(_3705) * ((_2991 >> uint(22)) + _3532)) + 2u];
            _3706._m3 = _3564._m0[(uint(_3705) * ((_2991 >> uint(22)) + _3532)) + 3u];
            _3706._m4 = _3564._m0[(uint(_3705) * ((_2991 >> uint(22)) + _3532)) + 4u];
            vec4 _3762 = vec4((_3513.x * _3706._m0.x) + ((_3513.y * _3706._m0.y) + ((_3513.z * _3706._m0.z) + _3706._m0.w)), (_3513.x * _3706._m1.x) + ((_3513.y * _3706._m1.y) + ((_3513.z * _3706._m1.z) + _3706._m1.w)), (_3513.x * _3706._m2.x) + ((_3513.y * _3706._m2.y) + ((_3513.z * _3706._m2.z) + _3706._m2.w)), (_3513.x * _3706._m3.x) + ((_3513.y * _3706._m3.y) + ((_3513.z * _3706._m3.z) + _3706._m3.w)));
            vec3 _3849 = _3762.xyz / vec3(_3762.w);
            _3762 = vec4(_3849.x, _3849.y, _3849.z, _3762.w);
            bool _3857 = min(_3762.x, _3762.y) > 0.0;
            bool _3866;
            if (_3857)
            {
                _3866 = max(_3762.x, _3762.y) < 1.0;
            }
            else
            {
                _3866 = _3857;
            }
            if (_3866)
            {
                vec2 _3878 = (_3762.xy * _3706._m4.xy) + _3706._m4.zw;
                _3762 = vec4(_3878.x, _3878.y, _3762.z, _3762.w);
                if (false)
                {
                    _3498 = textureLod(_3886, vec3(_3762.xyz.xy, _3762.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3893 = (_3762.xy * _807._m15.xy) + vec2(0.5);
                    vec2 _3902 = floor(_3893);
                    vec2 _3905 = _3893 - _3902;
                    _3902 -= vec2(0.5);
                    vec2 _3912 = vec2(4.0) - (_3905 * 3.0);
                    vec2 _3918 = vec2(7.0);
                    vec2 _3921 = vec2(1.0) + (_3905 * 3.0);
                    vec2 _3926 = (_3902 + (((vec2(3.0) - (_3905 * 2.0)) / _3912) - vec2(2.0))) * _807._m15.zw;
                    vec2 _3941 = (_3902 + ((vec2(3.0) + _3905) / _3918)) * _807._m15.zw;
                    vec2 _3953 = (_3902 + ((_3905 / _3921) + vec2(2.0))) * _807._m15.zw;
                    vec3 _3977 = vec3(_3926.x, _3926.y, _3762.z);
                    _3498 = (_3912.x * _3912.y) * textureLod(_3886, vec3(_3977.xy, _3977.z), 0.0);
                    vec3 _3993 = vec3(_3941.x, _3926.y, _3762.z);
                    _3498 += ((_3918.x * _3912.y) * textureLod(_3886, vec3(_3993.xy, _3993.z), 0.0));
                    vec3 _4011 = vec3(_3953.x, _3926.y, _3762.z);
                    _3498 += ((_3921.x * _3912.y) * textureLod(_3886, vec3(_4011.xy, _4011.z), 0.0));
                    vec3 _4029 = vec3(_3926.x, _3941.y, _3762.z);
                    _3498 += ((_3912.x * _3918.y) * textureLod(_3886, vec3(_4029.xy, _4029.z), 0.0));
                    vec3 _4047 = vec3(_3941.x, _3941.y, _3762.z);
                    _3498 += ((_3918.x * _3918.y) * textureLod(_3886, vec3(_4047.xy, _4047.z), 0.0));
                    vec3 _4065 = vec3(_3953.x, _3941.y, _3762.z);
                    _3498 += ((_3921.x * _3918.y) * textureLod(_3886, vec3(_4065.xy, _4065.z), 0.0));
                    vec3 _4083 = vec3(_3926.x, _3953.y, _3762.z);
                    _3498 += ((_3912.x * _3921.y) * textureLod(_3886, vec3(_4083.xy, _4083.z), 0.0));
                    vec3 _4101 = vec3(_3941.x, _3953.y, _3762.z);
                    _3498 += ((_3918.x * _3921.y) * textureLod(_3886, vec3(_4101.xy, _4101.z), 0.0));
                    vec3 _4119 = vec3(_3953.x, _3953.y, _3762.z);
                    _3498 += ((_3921.x * _3921.y) * textureLod(_3886, vec3(_4119.xy, _4119.z), 0.0));
                    _3498 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3498 = float((_2991 & 3u) == 2u);
            }
            float _4133 = float((_2991 >> uint(16)) & 63u) / 63.0;
            float _4147 = ((_3498 * _4133) + 1.0) - _4133;
            _3498 = _10(_4147);
        }
        uint _4150 = _2763._m13;
        vec3 _4149 = (_115(_4150) * _3498) * _3059;
        _3060 *= _2763._m14;
        vec3 _4162 = _4149;
        vec3 _4164 = _3061;
        float _4171 = dot(_764._m6, _4164);
        float _4166 = _10(_4171);
        vec3 _4177 = _764._m6;
        vec3 _4180 = _764._m13;
        vec3 _4183 = _3061;
        vec3 _4185 = _764._m2;
        float _4188 = abs(_764._m3);
        vec3 _4173 = _128(_4177, _4180, _4183, _4185, _4188);
        _764._m20 += (((_4173 * _3060) * _4162) * _4166);
        vec3 _4202 = mix(_4162, vec3(0.0), bvec3((_2991 & 256u) > 0u));
        _764._m19 += (_4202 * _4166);
    }
    float _4217 = _807._m16.x;
    if (_4217 > 0.00999999977648258209228515625)
    {
        float _4224 = float(int(_807._m14.x) & 1023) / 1023.0;
        _4217 = max(0.0, _4217 + (((_4224 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4240 = _764._m13;
        float _4248 = dot(_764._m6, _4240);
        float _4243 = _10(_4248);
        float _4250 = _4243 * _4217;
        vec3 _4258 = _764._m6;
        vec3 _4261 = _764._m13;
        vec3 _4264 = _764._m2;
        float _4267 = abs(_764._m3);
        vec3 _4254 = _135(_4258, _4261, _4264, _4267) * _4217;
        _764._m19 += vec3(_4250);
        _764._m20 += vec3(_4254);
    }
    _764._m19 = _764._m19;
    _764._m20 += _764._m10;
    float _4295 = 0.064999997615814208984375;
    float _4297 = 1.0 + _4295;
    bool _4300 = false;
    uint _4305;
    if (_807._m17.w > 0.00999999977648258209228515625)
    {
        _4305 = uint(_807._m17.x);
    }
    else
    {
        _4305 = 0u;
    }
    uint _4301 = _4305;
    _4323 _4325;
    for (uint _4313 = 0u; _4313 < _4301; _4313++)
    {
        int _4322 = 4;
        _4325._m0 = _4329._m0[(uint(_4322) * _4313) + 0u];
        _4325._m1 = _4329._m0[(uint(_4322) * _4313) + 1u];
        _4325._m2 = _4329._m0[(uint(_4322) * _4313) + 2u];
        float _4359 = _4329._m0[(uint(_4322) * _4313) + 3u].x;
        _4325._m3 = _39(_4359);
        float _4369 = _4329._m0[(uint(_4322) * _4313) + 3u].y;
        _4325._m4 = _39(_4369);
        float _4379 = _4329._m0[(uint(_4322) * _4313) + 3u].z;
        _4325._m5 = _39(_4379);
        vec4 _4384 = vec4(_764._m14, 1.0);
        vec3 _4391 = vec3(dot(_4384, _4325._m1), dot(_4384, _4325._m2), dot(_4384, _4325._m0));
        float _4405 = _4391.x;
        float _4408 = _4391.y;
        float _4411 = _4391.z;
        bool _4415 = _55(_4405, _4408, _4411) >= 0.0;
        bool _4424;
        if (_4415)
        {
            _4424 = max(_4391.x, _4391.y) < 1.0;
        }
        else
        {
            _4424 = _4415;
        }
        bool _4431;
        if (_4424)
        {
            _4431 = _4391.z < _4297;
        }
        else
        {
            _4431 = _4424;
        }
        if (_4431)
        {
            float _4434 = _4391.z;
            vec4 _4437 = vec4(_764._m14, 1.0);
            vec2 _4444 = vec2(0.0);
            _4444 = (((_4437.xy - _807._m18.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4457 = 0.000244140625;
            float _4463 = abs(_764._m6.z) * 2.0;
            _4457 *= _10(_4463);
            vec3 _4467 = vec3(TEXTURE_LOD(_4468, vec4(_4444 + vec2(_4457), 0.0, 0.0).xy, vec4(_4444 + vec2(_4457), 0.0, 0.0).w).x, TEXTURE_LOD(_4468, vec4(_4444, 0.0, 0.0).xy, vec4(_4444, 0.0, 0.0).w).x, TEXTURE_LOD(_4468, vec4(_4444 - vec2(_4457), 0.0, 0.0).xy, vec4(_4444 - vec2(_4457), 0.0, 0.0).w).x);
            float _4531 = 2.0 - (2.0 * (length(_4437.xy - _807._m18.zw) / 16.0));
            _4467 *= _10(_4531);
            float _4538 = 1.0 - _4434;
            float _4535 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4538));
            float _4549 = (_764._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4541 = (_4467 * _4535) * _10(_4549);
            float _4558 = _4297 - _4434;
            float _4552 = (1.0 - _4535) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4558));
            float _4572 = ((-_764._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4562 = (_4467 * _4552) * _10(_4572);
            _4467 = _4541 + _4562;
            float _4583 = 1.02499997615814208984375 - _4434;
            float _4578 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4583));
            float _4586 = _807._m17.w;
            _764._m19 = mix(_764._m19, (_764._m19 * _4467) + (_764._m19 * mix(1.0, 0.5, _4578)), vec3(_4586));
            break;
        }
    }
    _764._m19 *= _764._m0;
    _764._m21 = _764._m19 + _764._m20;
    vec3 _4626 = _764._m19 + _764._m20;
    _4621 = vec4(_4626.x, _4626.y, _4626.z, _4621.w);
    vec3 _4630 = _764._m6;
    bool _4633 = false;
    vec2 _4634 = _165(_4630, _4633);
    _4629 = vec4(_4634.x, _4634.y, _4629.z, _4629.w);
    float _4638 = _764._m2.x;
    float _4642 = _764._m2.y;
    float _4646 = _764._m2.z;
    float _4650 = _764._m3;
    _4637 = vec4(_95(_4638), _95(_4642), _95(_4646), _168(_4650));
    _4655 = vec4(0.0, 0.0, 0.0, float((uint(_785._m16.z) & 3u) << uint(4)) / 255.0);
    vec3 _4668 = _764._m19 + _764._m20;
    _4621 = vec4(_4668.x, _4668.y, _4668.z, _4621.w);
    vec3 _4671 = _764._m6;
    bool _4674 = false;
    vec2 _4675 = _165(_4671, _4674);
    _4629 = vec4(_4675.x, _4675.y, _4629.z, _4629.w);
    float _4678 = _764._m2.x;
    float _4682 = _764._m2.y;
    float _4686 = _764._m2.z;
    float _4690 = _764._m3;
    _4637 = vec4(_95(_4678), _95(_4682), _95(_4686), _168(_4690));
    vec3 _4700 = _4621.xyz + _785._m18.xyz;
    _4621 = vec4(_4700.x, _4700.y, _4700.z, _4621.w);
}


