// DECALS
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection

struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _796
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1090
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _1825
{
    int _m0;
    int _m1;
};

struct _1828
{
    int _m0;
    int _m1;
};

struct _1939
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2936
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3721
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _4545
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 1, binding = 0, std140) uniform _817_819
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _819;

layout(set = 0, binding = 0, std140) uniform _828_830
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _830;

layout(set = 2, binding = 0, std140) uniform _930_932
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
} _932;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1830_1832
{
    _1828 _m0[];
} _1832;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1914_1916
{
    uint _m0[];
} _1916;

layout(set = 0, binding = 15, std140) uniform _1944_1946
{
    vec4 _m0[4096];
} _1946;

layout(set = 0, binding = 16, std140) uniform _1964_1966
{
    vec4 _m0[4096];
} _1966;

layout(set = 0, binding = 17, std140) uniform _2016_2018
{
    vec4 _m0[4096];
} _2018;

layout(set = 0, binding = 19, std140) uniform _2940_2942
{
    vec4 _m0[4096];
} _2942;

layout(set = 0, binding = 20, std140) uniform _2979_2981
{
    vec4 _m0[4096];
} _2981;

layout(set = 0, binding = 21, std140) uniform _3047_3049
{
    vec4 _m0[4096];
} _3049;

layout(set = 0, binding = 23, std140) uniform _3725_3727
{
    vec4 _m0[4095];
} _3727;

layout(set = 0, binding = 25, std140) uniform _4549_4551
{
    vec4 _m0[4096];
} _4551;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4935_4937
{
    uint _m0[];
} _4937;

layout(set = 0, binding = 2, std430) restrict readonly buffer _4939_4941
{
    vec4 _m0[];
} _4941;

layout(push_constant, std430) uniform _4931_4933
{
    int _m0;
    int _m1;
} _4933;

layout(set = 3, binding = 0) uniform texture2D _958[16384];
layout(set = 0, binding = 6) uniform sampler _966;
layout(set = 3, binding = 2) uniform texture2D _976[16384];
layout(set = 0, binding = 7) uniform sampler _981;
layout(set = 3, binding = 1) uniform texture2D _992[16384];
layout(set = 0, binding = 8) uniform sampler _997;
layout(set = 3, binding = 3) uniform texture2D _1006[16384];
layout(set = 0, binding = 9) uniform sampler _1011;
layout(set = 3, binding = 7) uniform texture2D _1021[16384];
layout(set = 0, binding = 10) uniform sampler _1026;
layout(set = 3, binding = 4) uniform texture2D _1035[16384];
layout(set = 0, binding = 11) uniform sampler _1040;
layout(set = 3, binding = 6) uniform texture2D _1049[16384];
layout(set = 0, binding = 12) uniform sampler _1054;
layout(set = 2, binding = 1) uniform SAMPLER_2D _1663;
layout(set = 0, binding = 18) uniform SAMPLER_2D _2239;
layout(set = 0, binding = 22) uniform SAMPLER_2D _3282;
layout(set = 0, binding = 24) uniform sampler2DShadow _4049;
layout(set = 0, binding = 26) uniform SAMPLER_2D _4690;
layout(set = 3, binding = 5) uniform texture2D _4930[16384];
layout(set = 0, binding = 4) uniform sampler3D _4945;
layout(set = 0, binding = 5) uniform sampler3D _4946;

layout(location = 2) in vec4 _810;
layout(location = 6) in vec4 _835;
layout(location = 3) in vec4 _847;
layout(location = 4) in vec4 _850;
layout(location = 5) in vec4 _853;
layout(location = 10) in vec4 _871;
layout(location = 11) in vec4 _875;
layout(location = 12) in vec4 _879;
layout(location = 14) flat in uvec3 _892;
layout(location = 15) in vec4 _895;
layout(location = 0) out vec4 _4848;
layout(location = 1) out vec4 _4856;
layout(location = 2) out vec4 _4864;
layout(location = 3) out vec4 _4882;

float _273;

uvec4 _32(vec4 _31)
{
    return floatBitsToUint(_31);
}

float _52(float _51)
{
    if (_51 <= 0.040449999272823333740234375)
    {
        return _51 / 12.9200000762939453125;
    }
    else
    {
        return pow((_51 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

float _67(float _66)
{
    float _346 = _66;
    return _52(_346);
}

float _58(float _57)
{
    return _57 * ((_57 * ((_57 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

vec3 _55(vec3 _54)
{
    float _275 = _54.x;
    vec3 _274;
    _274.x = _52(_275);
    float _281 = _54.y;
    _274.y = _52(_281);
    float _287 = _54.z;
    _274.z = _52(_287);
    return _274;
}

float _142(float _138, vec4 _139, float _140, bool _141)
{
    float _651 = _139.w / (_138 + _139.z);
    return _651 * _140;
}

vec3 _147(vec3 _145, bool _146)
{
    vec3 _664 = (_145 * 2.0) - vec3(1.0);
    float _681 = (1.0 - (_664.x * _664.x)) - (_664.y * _664.y);
    _664.z = sqrt(_10(_681));
    if (_146 == false)
    {
        _664.z = -_664.z;
    }
    return _664;
}

vec3 _154(vec3 _152, mat3 _153)
{
    return normalize(vec3(dot(_152, _153[0]), dot(_152, _153[1]), dot(_152, _153[2])));
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _97(uint _96)
{
    return unpackUnorm4x8(_96).wzyx;
}

vec4 _110(uvec2 _109)
{
    return vec4(float((_109.x >> uint(16)) & 65535u), float(_109.x & 65535u), float((_109.y >> uint(16)) & 65535u), float(_109.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _100(uint _99)
{
    return vec4(float((_99 >> uint(24)) & 255u), float((_99 >> uint(16)) & 255u), float((_99 >> uint(8)) & 255u), float(_99 & 255u));
}

float _89(float _88)
{
    return (step(0.0, _88) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _61(vec3 _60)
{
    float _310 = _60.x;
    vec3 _309;
    _309.x = _58(_310);
    float _315 = _60.y;
    _309.y = _58(_315);
    float _320 = _60.z;
    _309.z = _58(_320);
    return _309;
}

vec4 _64(vec4 _63)
{
    vec3 _329 = _63.xyz;
    vec4 _328 = vec4(_61(_329), 1.0);
    float _337 = _63.w;
    _328.w = _58(_337);
    return _328;
}

float _73(float _72)
{
    return _72 * _72;
}

vec3 _70(vec3 _69)
{
    return _69 * _69;
}

float _78(float _75, float _76, float _77)
{
    float _368 = (_75 - _76) / (_77 - _76);
    return _10(_368);
}

vec3 _104(uint _103)
{
    return vec3(float((_103 >> uint(21)) & 2047u), float((_103 >> uint(10)) & 2047u), float(_103 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _214 = abs(_48) >= abs(_46);
    bool _222;
    if (_214)
    {
        _222 = abs(_48) >= abs(_47);
    }
    else
    {
        _222 = _214;
    }
    if (_222)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _81(float _80)
{
    return exp2(_80);
}

vec3 _113(uint _112)
{
    uint _466 = _112;
    vec4 _465 = _97(_466);
    float _477 = (_465.w * 255.0) - 128.0;
    return _465.xyz * _81(_477);
}

float _86(float _84, float _85)
{
    return pow(_84, _85);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _118(vec3 _116, float _117)
{
    float _489 = 50.0 * dot(_116, vec3(0.33329999446868896484375));
    float _482 = _10(_489);
    float _498 = 1.0 - _117;
    float _501 = _10(_498);
    float _502 = 5.0;
    vec3 _506 = _116 + ((vec3(_482) - _116) * _86(_501, _502));
    return _16(_506);
}

vec3 _126(vec3 _121, vec3 _122, vec3 _123, vec3 _124, float _125)
{
    vec3 _510 = normalize(_122 + _123);
    float _515 = 1.0 - (_125 * 0.800000011920928955078125);
    _515 *= _515;
    _515 *= _515;
    float _526 = _515 * _515;
    float _534 = dot(_121, _510);
    float _530 = _10(_534);
    float _536 = ((_530 * _530) * (_526 - 1.0)) + 1.0;
    _536 = _526 / ((_536 * _536) + 9.9999999392252902907785028219223e-09);
    float _555 = dot(_121, _122);
    float _551 = (_10(_555) * (1.0 - _515)) + _515;
    float _566 = dot(_121, _123);
    float _562 = (_10(_566) * (1.0 - _515)) + _515;
    _536 /= (((4.0 * _551) * _562) + 9.9999999392252902907785028219223e-09);
    vec3 _584 = _124;
    float _586 = dot(_123, _510);
    return _118(_584, _586) * _536;
}

vec3 _133(vec3 _129, vec3 _130, vec3 _131, float _132)
{
    float _592 = 1.0 - (_132 * 0.800000011920928955078125);
    _592 *= _592;
    _592 *= _592;
    float _602 = _592 * _592;
    float _610 = dot(_129, _130);
    float _606 = _10(_610);
    float _612 = ((_606 * _606) * (_602 - 1.0)) + 1.0;
    _612 = _602 / ((_612 * _612) + 9.9999999392252902907785028219223e-09);
    float _630 = dot(_129, _130);
    float _626 = (_10(_630) * (1.0 - _592)) + _592;
    _612 /= (((4.0 * _626) * _626) + 9.9999999392252902907785028219223e-09);
    vec3 _644 = _131;
    return _16(_644) * _612;
}

vec2 _160(vec2 _159)
{
    return (vec2(1.0) - abs(_159.yx)) * vec2((_159.x >= 0.0) ? 1.0 : (-1.0), (_159.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _165(inout vec3 _163, bool _164)
{
    _163 /= vec3((abs(_163.x) + abs(_163.y)) + abs(_163.z));
    vec2 _748;
    if (_163.z >= 0.0)
    {
        _748 = _163.xy;
    }
    else
    {
        vec2 _754 = _163.xy;
        _748 = _160(_754);
    }
    _163 = vec3(_748.x, _748.y, _163.z);
    if (_164)
    {
        vec2 _769 = (_163.xy * 0.5) + vec2(0.5);
        _163 = vec3(_769.x, _769.y, _163.z);
    }
    return _163.xy;
}

float _92(float _91)
{
    return sqrt(_91);
}

float _168(float _167)
{
    float _779 = abs(_167);
    float _776 = _92(_779);
    float _783;
    if (_167 > 0.0)
    {
        _783 = _776;
    }
    else
    {
        _783 = -_776;
    }
    return (_783 * 0.5) + 0.5;
}

void main()
{
    _796 _798 = _796(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _798._m15 = _810;
    _798._m16 = gl_FragCoord;
    _798._m40 = (uint(_819._m8.z) & 3u) << uint(4);
    _798._m14 = _830._m2.xyz + _835.xyz;
    _798._m13 = normalize(-_835.xyz);
    _798._m17 = mat3(vec3(_847.xyz), vec3(_850.xyz), vec3(_853.xyz));
    _798._m34 = _871;
    _798._m35 = _875;
    _798._m36 = _879;
    uint _882 = 0u;
    vec4 _883 = vec4(0.0);
    vec4 _884 = vec4(0.0);
    vec4 _885 = vec4(0.0);
    vec4 _886 = vec4(0.0);
    vec4 _887 = vec4(0.0);
    uvec3 _890 = _892;
    vec3 _894 = _895.xyz;
    bool _901 = _890.y == 65535u;
    bool _907;
    if (_901)
    {
        _907 = _890.z == 65535u;
    }
    else
    {
        _907 = _901;
    }
    bool _898 = _907;
    bool _908 = !_898;
    bool _911 = _890.z != 65535u;
    uint _915 = _890.x & 7u;
    uint _925;
    if (_830._m4.x == 0.0)
    {
        _925 = _915;
    }
    else
    {
        vec4 _933 = _932._m8;
        uvec4 _929 = _32(_933);
        uint _937 = _929[_915 / 2u];
        uint _942 = 16u * (_915 & 1u);
        _925 = (_937 >> _942) & 65535u;
    }
    uint _951 = _925;
    uint _960 = _951;
    vec3 _953 = texture(sampler2D(_958[nonuniformEXT(_960)], _966), _798._m15.zw).xyz;
    uint _978 = _951;
    vec2 _975 = texture(sampler2D(_976[nonuniformEXT(_978)], _981), _798._m15.zw).yx;
    vec3 _989 = vec3(0.039999999105930328369140625);
    uint _994 = _951;
    _989 = texture(sampler2D(_992[nonuniformEXT(_994)], _997), _798._m15.zw).xyz;
    uint _1008 = _951;
    float _1005 = texture(sampler2D(_1006[nonuniformEXT(_1008)], _1011), _798._m15.zw).x;
    float _1019 = 1.0;
    uint _1023 = _951;
    float _1020 = texture(sampler2D(_1021[nonuniformEXT(_1023)], _1026), _798._m15.zw).x;
    uint _1037 = _951;
    float _1034 = texture(sampler2D(_1035[nonuniformEXT(_1037)], _1040), _798._m15.zw).x;
    uint _1051 = _951;
    vec3 _1048 = texture(sampler2D(_1049[nonuniformEXT(_1051)], _1054), _798._m15.zw).xyz;
    _885 = vec4(_953.x, _953.y, _953.z, _885.w);
    _885.w = _975.y;
    _886 = vec4(_989.x, _989.y, _989.z, _886.w);
    _886.w = _1034;
    _887 = vec4(_887.x, _975.x, _887.z, _975.y);
    _883.x = _1020;
    _883.y = _1019;
    _883.z = _1034;
    _883.w = _1005;
    _884 = vec4(_1048.x, _1048.y, _1048.z, _884.w);
    vec2 _1087 = _810.zw;
    _1090 _1092;
    _1092._m0 = _885;
    _1092._m1 = _886;
    float _1097 = _883.x;
    _1092._m2.x = _67(_1097);
    _1092._m2 = vec4(_1092._m2.x, _883.yzw.x, _883.yzw.y, _883.yzw.z);
    _1092._m3 = _887;
    _1092._m4 = _884;
    _1090 _1111 = _1092;
    vec3 _1113 = vec3(0.0);
    bool _1121;
    if (_908)
    {
        _1121 = _894.x < 65534.0;
    }
    else
    {
        _1121 = _908;
    }
    bool _1127;
    if (_1121)
    {
        _1127 = _894.x > 0.0;
    }
    else
    {
        _1127 = _1121;
    }
    if (_1127)
    {
        uint _1130 = 0u;
        _1090 _1131 = _1090(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1133 = _890.y & 7u;
        uint _1142;
        if (_830._m4.x == 0.0)
        {
            _1142 = _1133;
        }
        else
        {
            vec4 _1146 = _932._m8;
            uvec4 _1145 = _32(_1146);
            uint _1150 = _1145[_1133 / 2u];
            uint _1155 = 16u * (_1133 & 1u);
            _1142 = (_1150 >> _1155) & 65535u;
        }
        uint _1163 = _1142;
        uint _1167 = _1163;
        vec3 _1165 = texture(sampler2D(_958[nonuniformEXT(_1167)], _966), _1087).xyz;
        uint _1177 = _1163;
        vec2 _1175 = texture(sampler2D(_976[nonuniformEXT(_1177)], _981), _1087).yx;
        vec3 _1185 = vec3(0.039999999105930328369140625);
        uint _1187 = _1163;
        _1185 = texture(sampler2D(_992[nonuniformEXT(_1187)], _997), _1087).xyz;
        uint _1197 = _1163;
        float _1195 = texture(sampler2D(_1006[nonuniformEXT(_1197)], _1011), _1087).x;
        float _1205 = 1.0;
        uint _1208 = _1163;
        float _1206 = texture(sampler2D(_1021[nonuniformEXT(_1208)], _1026), _1087).x;
        uint _1218 = _1163;
        float _1216 = texture(sampler2D(_1035[nonuniformEXT(_1218)], _1040), _1087).x;
        uint _1228 = _1163;
        vec3 _1226 = texture(sampler2D(_1049[nonuniformEXT(_1228)], _1054), _1087).xyz;
        _1131._m0 = vec4(_1165.x, _1165.y, _1165.z, _1131._m0.w);
        _1131._m0.w = _1175.y;
        _1131._m1 = vec4(_1185.x, _1185.y, _1185.z, _1131._m1.w);
        _1131._m1.w = _1216;
        _1131._m3 = vec4(_1131._m3.x, _1175.x, _1131._m3.z, _1175.y);
        _1131._m2.x = _1206;
        _1131._m2.y = _1205;
        _1131._m2.z = _1216;
        _1131._m2.w = _1195;
        _1131._m4 = vec4(_1226.x, _1226.y, _1226.z, _1131._m4.w);
        float _1265 = _1131._m2.x;
        _1131._m2.x = _58(_1265);
        float _1270 = _1131._m1.w;
        float _1273 = _894.x * _1270;
        float _1278 = _1092._m2.x;
        float _1281 = 0.0;
        float _1282 = 0.0;
        float _1283 = (_1273 * 1.5) - 0.5;
        float _1291 = 1.0 - _1278;
        float _1288 = _10(_1291);
        float _1300 = ((_1288 + _1283) - 0.5) * 10.0;
        float _1293 = _10(_1300);
        _1281 = _1293;
        float _1303 = (_894.x * 1.5) - 0.5;
        float _1311 = 1.0 - _1278;
        float _1308 = _10(_1311);
        float _1319 = ((_1308 + _1303) - 0.5) * 10.0;
        float _1313 = _10(_1319);
        _1282 = _1313;
        _1111._m0 = mix(_1111._m0, _1131._m0, vec4(_1281));
        _1111._m1 = mix(_1111._m1, _1131._m1, vec4(_1281));
        _1111._m2 = mix(_1111._m2, _1131._m2, vec4(_1281));
        _1111._m3 = mix(_1111._m3, _1131._m3, vec4(_1281));
        _1111._m4 = mix(_1111._m4, _1131._m4, vec4(_1281));
        _882 = (_1281 > 0.5) ? _1130 : _882;
        _1113.x = _1281;
    }
    bool _1375;
    if (_911)
    {
        _1375 = _894.y < 65534.0;
    }
    else
    {
        _1375 = _911;
    }
    bool _1381;
    if (_1375)
    {
        _1381 = _894.y > 0.0;
    }
    else
    {
        _1381 = _1375;
    }
    if (_1381)
    {
        uint _1384 = 0u;
        _1090 _1385 = _1090(vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0), vec4(0.0));
        uint _1386 = _890.z & 7u;
        uint _1395;
        if (_830._m4.x == 0.0)
        {
            _1395 = _1386;
        }
        else
        {
            vec4 _1399 = _932._m8;
            uvec4 _1398 = _32(_1399);
            uint _1403 = _1398[_1386 / 2u];
            uint _1408 = 16u * (_1386 & 1u);
            _1395 = (_1403 >> _1408) & 65535u;
        }
        uint _1416 = _1395;
        uint _1420 = _1416;
        vec3 _1418 = texture(sampler2D(_958[nonuniformEXT(_1420)], _966), _1087).xyz;
        uint _1430 = _1416;
        vec2 _1428 = texture(sampler2D(_976[nonuniformEXT(_1430)], _981), _1087).yx;
        vec3 _1438 = vec3(0.039999999105930328369140625);
        uint _1440 = _1416;
        _1438 = texture(sampler2D(_992[nonuniformEXT(_1440)], _997), _1087).xyz;
        uint _1450 = _1416;
        float _1448 = texture(sampler2D(_1006[nonuniformEXT(_1450)], _1011), _1087).x;
        float _1458 = 1.0;
        uint _1461 = _1416;
        float _1459 = texture(sampler2D(_1021[nonuniformEXT(_1461)], _1026), _1087).x;
        uint _1471 = _1416;
        float _1469 = texture(sampler2D(_1035[nonuniformEXT(_1471)], _1040), _1087).x;
        uint _1481 = _1416;
        vec3 _1479 = texture(sampler2D(_1049[nonuniformEXT(_1481)], _1054), _1087).xyz;
        _1385._m0 = vec4(_1418.x, _1418.y, _1418.z, _1385._m0.w);
        _1385._m0.w = _1428.y;
        _1385._m1 = vec4(_1438.x, _1438.y, _1438.z, _1385._m1.w);
        _1385._m1.w = _1469;
        _1385._m3 = vec4(_1385._m3.x, _1428.x, _1385._m3.z, _1428.y);
        _1385._m2.x = _1459;
        _1385._m2.y = _1458;
        _1385._m2.z = _1469;
        _1385._m2.w = _1448;
        _1385._m4 = vec4(_1479.x, _1479.y, _1479.z, _1385._m4.w);
        float _1518 = _1385._m2.x;
        _1385._m2.x = _58(_1518);
        float _1523 = _1385._m1.w;
        float _1526 = _894.y * _1523;
        float _1531 = _1111._m2.x;
        float _1534 = 0.0;
        float _1535 = 0.0;
        float _1536 = (_1526 * 1.5) - 0.5;
        float _1543 = 1.0 - _1531;
        float _1540 = _10(_1543);
        float _1551 = ((_1540 + _1536) - 0.5) * 10.0;
        float _1545 = _10(_1551);
        _1534 = _1545;
        float _1554 = (_894.y * 1.5) - 0.5;
        float _1562 = 1.0 - _1531;
        float _1559 = _10(_1562);
        float _1570 = ((_1559 + _1554) - 0.5) * 10.0;
        float _1564 = _10(_1570);
        _1535 = _1564;
        _1111._m0 = mix(_1111._m0, _1385._m0, vec4(_1534));
        _1111._m1 = mix(_1111._m1, _1385._m1, vec4(_1534));
        _1111._m2 = mix(_1111._m2, _1385._m2, vec4(_1534));
        _1111._m3 = mix(_1111._m3, _1385._m3, vec4(_1534));
        _1111._m4 = mix(_1111._m4, _1385._m4, vec4(_1534));
        _882 = (_1534 > 0.5) ? _1384 : _882;
        _1113.y = _1534;
    }
    bool _1626;
    if (_908)
    {
        _1626 = _894.z > 0.0;
    }
    else
    {
        _1626 = _908;
    }
    if (_1626)
    {
        _798._m37 = _894.z;
        float _1637 = 1.0 - _1111._m2.x;
        _798._m38 = _10(_1637);
    }
    _885 = _1111._m0;
    _886 = _1111._m1;
    vec3 _1645;
    if (_908)
    {
        _1645 = vec3(0.0);
    }
    else
    {
        _1645 = _883.xyz;
    }
    _883 = vec4(_1645.x, _1645.y, _1645.z, _883.w);
    _883.w = _1111._m2.w;
    _887 = _1111._m3;
    _884 = _1111._m4;
    vec3 _1668 = SAMPLE_TEXTURE(_1663, _810.xy).xyz;
    _798._m26 = _55(_1668) * _932._m9.xyz;
    _798._m10 = vec3(_883.x) * _894;
    _798._m10 *= vec3(_830._m5.x);
    _798._m0 = _885.xyz;
    _798._m2 = _886.xyz;
    _798._m1 = _884.xyz;
    _798._m9 = _883.xyz;
    _798._m3 = _883.w;
    _798._m6 = _887.wyz;
    uint _1709 = uint((_819._m8.x > 0.0) ? 8 : 0);
    float _1715 = 16.0;
    float _1717 = 8.0;
    float _1719 = 24.0;
    vec2 _1728 = _798._m16.xy * _830._m6.xy;
    vec3 _1721;
    _1721 = vec3(_1728.x, _1728.y, _1721.z);
    _1721.y = 1.0 - _1721.y;
    
           // DECALS
    _1721.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1741 = floor(_1721.xy * vec2(_1715, _1717));
    _1721 = vec3(_1741.x, _1741.y, _1721.z);
    float _1746 = _798._m16.z;
    vec4 _1749 = _830._m7;
    float _1752 = 1.0;
    bool _1753 = false;
    float _1744 = _142(_1746, _1749, _1752, _1753);
    float _1755 = log2(max(1.0, _1744 / _830._m8.z)) * _830._m8.w;
    _1721.z = min(_1719 - 1.0, floor(_1755));
    uint _1771 = uint((_1721.x + (_1721.y * _1715)) + ((_1721.z * _1715) * _1717));
    _1771 = min(_1771, uint(((_1715 * _1717) * _1719) - 1.0));
    bool _1796 = true;
    _1796 = gl_FrontFacing;
    vec3 _1801 = _798._m6;
    bool _1804 = _1796;
    _798._m7 = _147(_1801, _1804);
    vec3 _1808 = _798._m7;
    mat3 _1811 = _798._m17;
    _798._m6 = _154(_1808, _1811);
    uint _1816 = 0u;
    uint _1817 = 0u;
    uint _1818 = 0u;
    uint _1819 = 0u;
    uint _1820 = 0u;
    uint _1821 = 0u;
    int _1823 = 256;
    _1825 _1827;
    _1827._m0 = _1832._m0[_1771]._m0;
    _1827._m1 = _1832._m0[_1771]._m1;
    int _1841 = _1827._m0 & (~(_1827._m0 >> 31));
    int _1850 = _1827._m1 & (~(_1827._m1 >> 31));
    _1816 = uint((_1841 >> 16) * _1823);
    _1817 = _1816 + uint(_1850 & 255);
    _1818 = _1816;
    _1819 = _1818 + uint((_1850 >> 8) & 255);
    _1820 = _1816;
    _1821 = _1820 + uint((_1850 >> 16) & 255);
    vec3 _1883 = dFdx(_798._m14);
    vec3 _1887 = dFdy(_798._m14);
    bool _1892 = _1709 == 0u;
    bool _1898;
    if (_1892)
    {
        _1898 = _819._m8.y == 0.0;
    }
    else
    {
        _1898 = _1892;
    }
    _1818 = _1898 ? _1819 : _1818;
    uint _1902 = _1818;
    _1939 _1941;
    vec3 _2293;
    float _2398;
    while (_1902 < _1819)
    {
        uint _1912 = _1916._m0[_1902];
        uint _1921 = (_1912 >> uint(12)) & 4095u;
        uint _1927 = _1921;
        if (_1927 >= _1921)
        {
            _1902++;
        }
        int _1936 = 2;
        int _1937 = 2;
        int _1938 = 2;
        _1941._m0 = _1946._m0[(uint(_1936) * _1927) + 0u];
        _1941._m1 = _1946._m0[(uint(_1936) * _1927) + 1u];
        _1941._m2 = _1966._m0[(uint(_1937) * _1927) + 0u];
        float _1980 = _1966._m0[(uint(_1937) * _1927) + 1u].x;
        _1941._m3.x = _27(_1980);
        float _1990 = _1966._m0[(uint(_1937) * _1927) + 1u].y;
        _1941._m3.y = _27(_1990);
        float _2000 = _1966._m0[(uint(_1937) * _1927) + 1u].z;
        _1941._m4.x = _27(_2000);
        float _2010 = _1966._m0[(uint(_1937) * _1927) + 1u].w;
        _1941._m4.y = _27(_2010);
        float _2024 = _2018._m0[(uint(_1938) * _1927) + 0u].x;
        _1941._m5.x = _27(_2024);
        float _2034 = _2018._m0[(uint(_1938) * _1927) + 0u].y;
        _1941._m5.y = _27(_2034);
        float _2044 = _2018._m0[(uint(_1938) * _1927) + 0u].z;
        _1941._m6 = _27(_2044);
        float _2054 = _2018._m0[(uint(_1938) * _1927) + 0u].w;
        _1941._m7 = _27(_2054);
        float _2064 = _2018._m0[(uint(_1938) * _1927) + 1u].x;
        _1941._m8 = _27(_2064);
        float _2074 = _2018._m0[(uint(_1938) * _1927) + 1u].y;
        _1941._m9 = _27(_2074);
        float _2084 = _2018._m0[(uint(_1938) * _1927) + 1u].z;
        _1941._m10 = _27(_2084);
        float _2095 = _2018._m0[(uint(_1938) * _1927) + 1u].w;
        _1941._m11 = _27(_2095);
        vec4 _2100 = vec4(_798._m14, 1.0);
        vec3 _2107 = vec3(dot(_2100, _1941._m0), dot(_2100, _1941._m1), dot(_2100, _1941._m2));
        float _2121 = 0.0039215688593685626983642578125;
        float _2123 = _2107.x;
        float _2126 = _2107.y;
        float _2129 = _2107.z;
        bool _2134 = _43(_2123, _2126, _2129) <= _2121;
        bool _2151;
        if (!_2134)
        {
            float _2138 = _2107.x;
            float _2141 = _2107.y;
            float _2144 = _2107.z;
            _2151 = _38(_2138, _2141, _2144) >= (1.0 - _2121);
        }
        else
        {
            _2151 = _2134;
        }
        if (_2151)
        {
            continue;
        }
        uint _2155 = _1941._m11;
        bool _2159 = _1709 != 0u;
        bool _2166;
        if (_2159)
        {
            _2166 = (_2155 & 1024u) != 0u;
        }
        else
        {
            _2166 = _2159;
        }
        bool _2179;
        if (!_2166)
        {
            bool _2171 = _1709 == 0u;
            bool _2178;
            if (_2171)
            {
                _2178 = (_2155 & 2048u) != 0u;
            }
            else
            {
                _2178 = _2171;
            }
            _2179 = _2178;
        }
        else
        {
            _2179 = _2166;
        }
        if (_2179)
        {
            continue;
        }
        vec3 _2183 = _1941._m0.xyz;
        vec3 _2187 = _1941._m1.xyz;
        vec3 _2191 = _1941._m2.xyz;
        vec2 _2195 = vec2(dot(_1883, _2183), dot(_1883, _2187));
        vec2 _2203 = vec2(dot(_1887, _2183), dot(_1887, _2187));
        float _2211 = 1.0;
        float _2212 = 1.0;
        vec3 _2213 = vec3(0.5, 0.5, 1.0);
        uint _2215 = _1941._m7;
        uint _2219 = _1941._m9;
        vec4 _2218 = _97(_2219);
        uvec2 _2224 = _1941._m5;
        vec4 _2223 = _110(_2224);
        vec2 _2228 = _2195 * _2223.xy;
        vec2 _2233 = _2203 * _2223.xy;
        vec4 _2238 = TEXTURE_GRAD(_2239, (_2107.xy * _2223.xy) + _2223.zw, _2228, _2233);
        _2211 = _2238.z;
        float _2254 = _2238.w;
        _2212 = _58(_2254);
        bool _2261 = _2212 <= (4.0 * _2121);
        bool _2268;
        if (_2261)
        {
            _2268 = _2218.w <= _2121;
        }
        else
        {
            _2268 = _2261;
        }
        if (_2268)
        {
            continue;
        }
        vec2 _2272 = (_2238.xy * 2.0) - vec2(1.0);
        float _2283 = 1.0 - dot(_2272, _2272);
        _2213 = vec3(_2272, sqrt(_10(_2283)));
        if ((_2155 & 256u) != 0u)
        {
            _2293 = vec3(-_2213.x, -_2213.y, _2213.z);
        }
        else
        {
            _2293 = _2213;
        }
        _2213 = _2293;
        uint _2308 = _1941._m8;
        uint _2312 = _2308;
        float _2311 = 1.0 + (_100(_2312).w * 0.062745101749897003173828125);
        uint _2320 = _2215;
        float _2319 = _97(_2320).z;
        float _2333 = _2311 - (_2311 * abs((_2107.z * 2.0) - 1.0));
        _2212 *= _10(_2333);
        if ((_2215 & 64u) != 0u)
        {
            uint _2344 = _2215;
            float _2343 = _97(_2344).x;
            uint _2349 = _2215;
            float _2348 = _100(_2349).y;
            float _2355 = _2343;
            float _2353 = mix(_2348, 0.0, _10(_2355));
            float _2364 = _2211 - (_2353 / 255.0);
            float _2359 = float(_10(_2364) > 0.0);
            _2212 *= _2359;
        }
        vec3 _2371 = normalize(vec3(_798._m17[0].z, _798._m17[1].z, _798._m17[2].z));
        float _2380 = dot(_2371, normalize(_2191));
        float _2385 = _2380;
        vec2 _2390 = _2213.xy * _89(_2385);
        _2213 = vec3(_2390.x, _2390.y, _2213.z);
        if ((_2155 & 32768u) != 0u)
        {
            float _2403 = abs(_2380);
            _2398 = _10(_2403);
        }
        else
        {
            float _2406 = _2380;
            _2398 = _10(_2406);
        }
        float _2393 = _2398;
        float _2410 = _2212 * _2393;
        uint _2414 = _1941._m6;
        uint _2418 = _2414;
        vec4 _2423 = _97(_2418) * _2410;
        vec4 _2417 = _22(_2423);
        _798._m11 = max(_798._m11, _2417.x);
        _2183 += (_2371 * dot(_2183, _2371));
        _2187 += (_2371 * dot(_2187, _2371));
        _2213 = ((normalize(_2183) * _2213.x) + (normalize(_2187) * _2213.y)) + (_2371 * _2213.z);
        if ((_2155 & 512u) != 0u)
        {
            vec3 _2467 = mix(_2371, _2213, _2417.www);
            float _2473 = dot(_2467, _2371);
            _2213 = (_798._m6 * _2473) + ((_2467 - (_2371 * _2473)) * dot(_798._m6, _2371));
        }
        else
        {
            if ((_2155 & 128u) != 0u)
            {
                _2213 = mix(mix(_798._m6, _2371, vec3(_2410)), _2213, _2417.www);
            }
            else
            {
                _2213 = mix(_798._m6, _2213, _2417.www);
            }
        }
        _798._m6 = normalize(_2213);
        uint _2520 = _2308;
        vec3 _2519 = _97(_2520).xyz;
        float _2524 = _2212;
        if ((_2215 & 1u) != 0u)
        {
            uvec2 _2532 = _1941._m3;
            vec4 _2531 = _110(_2532);
            vec2 _2536 = _2195 * _2531.xy;
            vec2 _2541 = _2203 * _2531.xy;
            vec4 _2546 = TEXTURE_GRAD(_2239, (_2107.xy * _2531.xy) + _2531.zw, _2536, _2541);
            vec4 _2559 = _2546;
            _2546 = _64(_2559);
            float _2569 = (_2546.w - _2121) / (1.0 - _2121);
            _2524 = _10(_2569);
            _2519 *= _2546.xyz;
        }
        _798._m0 = mix(_798._m0, _2519, _2417.xxx);
        float _2582 = ((_2393 * _2524) * _2218.w) * _2319;
        _798._m10 += (_2218.xyz * (_2582 * 64.0));
        uint _2601 = _1941._m10;
        uint _2605 = _2601;
        vec4 _2604 = _97(_2605);
        float _2608 = 0.0;
        if ((_2215 & 10u) != 0u)
        {
            uvec2 _2616 = _1941._m4;
            vec4 _2615 = _110(_2616);
            vec2 _2620 = _2195 * _2615.xy;
            vec2 _2625 = _2203 * _2615.xy;
            vec4 _2630 = TEXTURE_GRAD(_2239, (_2107.xy * _2615.xy) + _2615.zw, _2620, _2625);
            if ((_2215 & 2u) != 0u)
            {
                _2604 = _2630 * _2630;
            }
            else
            {
                _2608 = _2630.w;
            }
        }
        _798._m2 = mix(_798._m2, _2604.xyz, _2417.yyy);
        _798._m3 = mix(_798._m3, _2604.w, _2417.z);
        _798._m37 = max(_798._m37, _2608);
        float _2680 = (_2211 - 0.5) * 2.0;
        _798._m38 = max(_798._m38, _10(_2680));
    }
    float _2685 = _798._m37;
    float _2684 = _73(_2685);
    float _2692 = _2684 - 0.5;
    float _2689 = _10(_2692) * 2.0;
    float _2703 = _2684 * 2.0;
    float _2695 = (_798._m38 * _798._m38) * _10(_2703);
    float _2710 = _2695 + _2689;
    float _2706 = _10(_2710);
    if (_2706 > 0.0039215688593685626983642578125)
    {
        vec3 _2718 = _798._m0;
        float _2725 = _2706 * 1.0;
        float _2726 = 0.0;
        float _2727 = 0.3499999940395355224609375;
        _798._m0 = mix(_798._m0, _70(_2718), vec3(_78(_2725, _2726, _2727) * (1.0 - _798._m3)));
        float _2741 = _2706 * 1.0;
        float _2742 = 0.25;
        float _2743 = 0.5;
        _798._m2 = mix(_798._m2, vec3(0.039999999105930328369140625), vec3(_78(_2741, _2742, _2743)));
        vec3 _2748 = vec3(_798._m17[0].z, _798._m17[1].z, _798._m17[2].z);
        float _2762 = _2748.z + 0.0625;
        float _2756 = _2706 * _10(_2762);
        float _2771 = _2756 * 1.0;
        float _2772 = 0.20000000298023223876953125;
        float _2773 = 1.0;
        _798._m3 = mix(_798._m3, 0.89999997615814208984375, _78(_2771, _2772, _2773));
        float _2782 = _2756 * 1.0;
        float _2783 = 0.449999988079071044921875;
        float _2784 = 0.980000019073486328125;
        float _2777 = _78(_2782, _2783, _2784);
        _798._m6 = normalize(mix(_798._m6, vec3(0.0, 0.0, 1.0), vec3(_2777)));
        _798._m7 = mix(_798._m6, vec3(0.5, 0.5, 1.0), vec3(_2777));
        if (_2756 > 0.980000019073486328125)
        {
            float _2807 = _2756 * _2777;
            float _2808 = 0.980000019073486328125;
            float _2809 = 1.0;
            _2748 = normalize(mix(_2748, vec3(0.0, 0.0, 1.0), vec3(_78(_2807, _2808, _2809))));
            _798._m17[0].z = _2748.x;
            _798._m17[1].z = _2748.y;
            _798._m17[2].z = _2748.z;
        }
    }
    vec3 _2823 = vec3(0.0);
    vec3 _2824 = vec3(_798._m34.x, _798._m34.y, _798._m34.z);
    vec3 _2832 = vec3(_798._m34.w, _798._m35.x, _798._m35.y);
    vec3 _2840 = vec3(_798._m35.z, _798._m35.w, _798._m36.x);
    vec3 _2848 = vec3(_798._m36.y, _798._m36.z, _798._m36.w);
    vec3 _2856 = ((_2824 - (_2832 * _798._m6.y)) + (_2840 * _798._m6.z)) - (_2848 * _798._m6.x);
    float _2879 = _819._m9.x * _830._m9.x;
    _2823 += max(_2856 * _10(_2879), vec3(0.0));
    float _2890;
    if (dot(_798._m10, vec3(1.0)) > 0.0)
    {
        _2890 = -_798._m3;
    }
    else
    {
        _2890 = _798._m3;
    }
    _798._m3 = _2890;
    _798._m18 = _2823;
    _798._m19 = _2823;
    uint _2907 = _1816;
    _2936 _2938;
    vec3 _3256;
    float _3332;
    float _3350;
    uint _3695;
    _3721 _3723;
    uint _3845;
    _3721 _3869;
    while (_2907 < _1817)
    {
        uint _2917 = _1916._m0[_2907];
        uint _2921 = _2917 & 4095u;
        uint _2924 = _2921;
        if (_2924 >= _2921)
        {
            _2907++;
        }
        int _2933 = 4;
        int _2934 = 4;
        int _2935 = 4;
        _2938._m0 = _2942._m0[(uint(_2933) * _2924) + 0u].xyz;
        float _2957 = _2942._m0[(uint(_2933) * _2924) + 0u].w;
        _2938._m1 = _27(_2957);
        _2938._m2 = _2942._m0[(uint(_2933) * _2924) + 1u];
        _2938._m3 = _2942._m0[(uint(_2933) * _2924) + 2u];
        _2938._m4 = _2981._m0[(uint(_2934) * _2924) + 0u];
        _2938._m5 = _2981._m0[(uint(_2934) * _2924) + 1u];
        _2938._m6 = _2981._m0[(uint(_2934) * _2924) + 2u];
        float _3011 = _2942._m0[(uint(_2933) * _2924) + 3u].x;
        _2938._m7.x = _27(_3011);
        float _3021 = _2942._m0[(uint(_2933) * _2924) + 3u].y;
        _2938._m7.y = _27(_3021);
        float _3031 = _2942._m0[(uint(_2933) * _2924) + 3u].z;
        _2938._m7.z = _27(_3031);
        float _3041 = _2942._m0[(uint(_2933) * _2924) + 3u].w;
        _2938._m7.w = _27(_3041);
        _2938._m8 = _3049._m0[(uint(_2935) * _2924) + 0u];
        _2938._m9 = _3049._m0[(uint(_2935) * _2924) + 1u];
        _2938._m10 = _3049._m0[(uint(_2935) * _2924) + 2u];
        _2938._m11 = _3049._m0[(uint(_2935) * _2924) + 3u];
        float _3087 = _2981._m0[(uint(_2934) * _2924) + 3u].x;
        _2938._m12 = _27(_3087);
        float _3097 = _2981._m0[(uint(_2934) * _2924) + 3u].y;
        _2938._m13 = _27(_3097);
        _2938._m14 = _2981._m0[(uint(_2934) * _2924) + 3u].z;
        float _3115 = _2981._m0[(uint(_2934) * _2924) + 3u].w;
        _2938._m15 = _27(_3115);
        uint _3120 = (_2938._m12 >> uint(16)) & 3u;
        if (((_798._m40 >> uint(4)) & 3u) != _3120)
        {
            continue;
        }
        float _3134 = 0.0039215688593685626983642578125;
        vec4 _3135 = vec4(_798._m14, 1.0);
        float _3142 = 1.0 / dot(_3135, _2938._m6);
        vec3 _3148 = vec3(dot(_3135, _2938._m4) * _3142, dot(_3135, _2938._m5) * _3142, dot(_3135, _2938._m3));
        uint _3166 = _2938._m1;
        uint _3169 = _1709;
        _3169 |= 64u;
        float _3173 = _3148.x;
        float _3176 = _3148.y;
        float _3179 = _3148.z;
        bool _3184 = _43(_3173, _3176, _3179) <= _3134;
        bool _3201;
        if (!_3184)
        {
            float _3188 = _3148.x;
            float _3191 = _3148.y;
            float _3194 = _3148.z;
            _3201 = _38(_3188, _3191, _3194) >= (1.0 - _3134);
        }
        else
        {
            _3201 = _3184;
        }
        bool _3209;
        if (!_3201)
        {
            _3209 = (_3166 & _3169) != 0u;
        }
        else
        {
            _3209 = _3201;
        }
        if (_3209)
        {
            continue;
        }
        if ((_3166 & 3u) == 2u)
        {
            vec2 _3228 = fract((_3148.xy * _830._m10.xy) + _830._m10.zw);
            _3148 = vec3(_3228.x, _3228.y, _3148.z);
        }
        vec3 _3231 = _2938._m0;
        float _3234 = 1.0;
        float _3235 = 1.0;
        vec3 _3236 = vec3(0.0, 0.0, 1.0);
        vec3 _3237 = vec3(0.0, 0.0, 1.0);
        uint _3238 = _2938._m1;
        vec3 _3241 = (_3148 * 2.0) - vec3(1.0);
        vec2 _3246 = _3148.xy;
        vec3 _3249 = _2938._m10.xyz;
        if ((_3238 & 3u) == 2u)
        {
            _3256 = _3249;
        }
        else
        {
            _3256 = normalize(_3231 - _798._m14);
        }
        _3236 = _3256;
        _3236 = _3236;
        float _3273 = dot(_798._m6, _3236);
        float _3268 = _10(_3273);
        uvec2 _3276 = _2938._m7.zw;
        vec4 _3275 = _110(_3276);
        float _3281 = TEXTURE_LOD(_3282, vec4((_3246 * _3275.xy) + _3275.zw, 0.0, 0.0).xy, vec4((_3246 * _3275.xy) + _3275.zw, 0.0, 0.0).w).x;
        float _3308 = _3281 * _3281;
        uint _3312 = _3238 & 3u;
        bool _3317 = _3312 == 1u;
        bool _3329;
        if (!_3317)
        {
            bool _3322 = _3312 == 0u;
            bool _3328;
            if (_3322)
            {
                _3328 = _2938._m8.z != 0.0;
            }
            else
            {
                _3328 = _3322;
            }
            _3329 = _3328;
        }
        else
        {
            _3329 = _3317;
        }
        bool _3315 = _3329;
        if (_3315)
        {
            float _3335 = _2938._m8.w;
            _3332 = _10(_3335);
        }
        else
        {
            _3332 = 0.5;
        }
        float _3330 = _3332;
        bool _3343 = _3312 == 0u;
        bool _3349;
        if (_3343)
        {
            _3349 = _2938._m8.z != 0.0;
        }
        else
        {
            _3349 = _3343;
        }
        if (_3349)
        {
            float _3358 = sqrt(dot(_3241, _3241));
            _3350 = min(0.9921875, _10(_3358));
        }
        else
        {
            _3350 = _3148.z;
        }
        float _3341 = _3350;
        uvec2 _3366 = _2938._m7.xy;
        vec4 _3365 = _110(_3366);
        vec2 _3371 = vec2(_3341, _3330);
        float _3375 = TEXTURE_LOD(_3282, vec4((_3371 * _3365.xy) + _3365.zw, 0.0, 0.0).xy, vec4((_3371 * _3365.xy) + _3365.zw, 0.0, 0.0).w).x;
        _3375 *= _3375;
        _3234 = _3375 * _3308;
        if ((_3238 & 48u) != 0u)
        {
            vec4 _3413 = _2938._m10;
            vec4 _3416 = _2938._m8;
            vec4 _3419 = _2938._m9;
            float _3422 = dot(_798._m14, _3413.xyz) + _3413.w;
            if (_3422 < 0.0)
            {
                continue;
            }
            float _3436 = length(_3413.xyz);
            float _3443 = _3422 * 50.0;
            float _3440 = _10(_3443);
            _3234 *= (_3440 * _3440);
            _3422 /= _3436;
            _3413 /= vec4(_3436);
            vec3 _3457 = reflect(-_798._m13, _798._m6);
            if (dot(_3457, _3413.xyz) > 0.0)
            {
                _3457 = reflect(_3457, _3413.xyz);
            }
            float _3475 = dot(_3457, _3413.xyz);
            float _3480 = _3422 / _3475;
            vec3 _3484 = _798._m14 - (_3457 * _3480);
            vec3 _3491 = _3484 - _3231;
            float _3495 = dot(_3491, _3416.xyz) / _3416.w;
            float _3503 = dot(_3491, _3419.xyz) / _3419.w;
            if ((_3238 & 48u) == 32u)
            {
                vec2 _3517 = vec2(_3495, _3503);
                float _3521 = 1.0 / max(1.0, length(vec2(_3495, _3503)));
                _3495 *= (_3521 * _3416.w);
                _3503 *= (_3521 * _3419.w);
            }
            else
            {
                float _3543 = abs(_3495);
                float _3545 = _3495;
                _3495 = (_10(_3543) * _89(_3545)) * _3416.w;
                float _3554 = abs(_3503);
                float _3556 = _3503;
                _3503 = (_10(_3554) * _89(_3556)) * _3419.w;
            }
            vec3 _3563 = (_3416.xyz * _3495) + (_3419.xyz * _3503);
            _3231 += _3563;
            _3236 = normalize(_3231 - _798._m14);
            _3236 = _3236;
        }
        else
        {
            uint _3583 = (_2938._m15 >> uint(16)) & 255u;
            if (_3583 == 0u)
            {
                vec4 _3592 = _2938._m9;
                if (dot(_3592.xyz, _798._m14) < (_3592.w - _3134))
                {
                    continue;
                }
            }
            else
            {
                if (_3583 == 1u)
                {
                    vec3 _3613 = _2938._m9.xyz;
                    float _3618 = _2938._m9.w;
                    uint _3622 = _27(_3618);
                    vec3 _3617 = (((_104(_3622) * 2.0) - vec3(1.0)) * _3613) + _3231;
                    vec3 _3631 = abs((_798._m14 - _3617) / _3613);
                    float _3639 = _3631.x;
                    float _3642 = _3631.y;
                    float _3645 = _3631.z;
                    if (_38(_3639, _3642, _3645) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_3234 <= (_3134 / 256.0))
        {
            continue;
        }
        float _3661 = 1.0;
        if ((_3166 & 4u) != 0u)
        {
            float _3668 = float(_2938._m15 & 255u) / 255.0;
            float _3674 = 0.00999999977648258209228515625;
            vec3 _3676 = _798._m14 + (_798._m6 * _3674);
            if ((_3166 & 3u) == 0u)
            {
                vec3 _3689 = _3676 - _2938._m2.xyz;
                float _3696 = _3689.x;
                float _3699 = _3689.y;
                float _3702 = _3689.z;
                _3695 = _49(_3696, _3699, _3702);
            }
            else
            {
                if ((_3166 & 3u) == 2u)
                {
                    float _3712 = 0.0;
                    _3695 = 0u;
                    for (; _3695 < 3u; _3695++)
                    {
                        int _3720 = 5;
                        _3723._m0 = _3727._m0[(uint(_3720) * ((_3166 >> uint(22)) + _3695)) + 0u];
                        _3723._m1 = _3727._m0[(uint(_3720) * ((_3166 >> uint(22)) + _3695)) + 1u];
                        _3723._m2 = _3727._m0[(uint(_3720) * ((_3166 >> uint(22)) + _3695)) + 2u];
                        _3723._m3 = _3727._m0[(uint(_3720) * ((_3166 >> uint(22)) + _3695)) + 3u];
                        _3723._m4 = _3727._m0[(uint(_3720) * ((_3166 >> uint(22)) + _3695)) + 4u];
                        vec2 _3784 = vec2(dot(_3676, _3723._m0.xyz) + _3723._m0.w, dot(_3676, _3723._m1.xyz) + _3723._m1.w);
                        _3784 = abs((_3784 * 2.0) - vec2(1.0));
                        bool _3810 = _3784.x < 0.99500000476837158203125;
                        bool _3816;
                        if (_3810)
                        {
                            _3816 = _3784.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _3816 = _3810;
                        }
                        if (_3816)
                        {
                            _3712 = (1.0 - max(_3784.x, _3784.y)) * _830._m11.w;
                            break;
                        }
                    }
                    _3695 = min(2u, _3695);
                    uint _3833 = uint(_798._m16.x) ^ (uint(_798._m16.y) << uint(1));
                    if (_830._m12.w > 0.0)
                    {
                        _3845 = uint(_830._m13.x);
                    }
                    else
                    {
                        _3845 = 0u;
                    }
                    _3833 ^= _3845;
                    _3695 += uint(int(((float(_3833 & 3u) * 0.25) + 0.125) > _3712));
                }
                else
                {
                    _3695 = 0u;
                }
            }
            int _3868 = 5;
            _3869._m0 = _3727._m0[(uint(_3868) * ((_3166 >> uint(22)) + _3695)) + 0u];
            _3869._m1 = _3727._m0[(uint(_3868) * ((_3166 >> uint(22)) + _3695)) + 1u];
            _3869._m2 = _3727._m0[(uint(_3868) * ((_3166 >> uint(22)) + _3695)) + 2u];
            _3869._m3 = _3727._m0[(uint(_3868) * ((_3166 >> uint(22)) + _3695)) + 3u];
            _3869._m4 = _3727._m0[(uint(_3868) * ((_3166 >> uint(22)) + _3695)) + 4u];
            vec4 _3925 = vec4((_3676.x * _3869._m0.x) + ((_3676.y * _3869._m0.y) + ((_3676.z * _3869._m0.z) + _3869._m0.w)), (_3676.x * _3869._m1.x) + ((_3676.y * _3869._m1.y) + ((_3676.z * _3869._m1.z) + _3869._m1.w)), (_3676.x * _3869._m2.x) + ((_3676.y * _3869._m2.y) + ((_3676.z * _3869._m2.z) + _3869._m2.w)), (_3676.x * _3869._m3.x) + ((_3676.y * _3869._m3.y) + ((_3676.z * _3869._m3.z) + _3869._m3.w)));
            vec3 _4012 = _3925.xyz / vec3(_3925.w);
            _3925 = vec4(_4012.x, _4012.y, _4012.z, _3925.w);
            bool _4020 = min(_3925.x, _3925.y) > 0.0;
            bool _4029;
            if (_4020)
            {
                _4029 = max(_3925.x, _3925.y) < 1.0;
            }
            else
            {
                _4029 = _4020;
            }
            if (_4029)
            {
                vec2 _4041 = (_3925.xy * _3869._m4.xy) + _3869._m4.zw;
                _3925 = vec4(_4041.x, _4041.y, _3925.z, _3925.w);
                if (false)
                {
                    _3661 = textureLod(_4049, vec3(_3925.xyz.xy, _3925.xyz.z), 0.0);
                }
                else
                {
                    vec2 _4056 = (_3925.xy * _830._m14.xy) + vec2(0.5);
                    vec2 _4065 = floor(_4056);
                    vec2 _4068 = _4056 - _4065;
                    _4065 -= vec2(0.5);
                    vec2 _4075 = vec2(4.0) - (_4068 * 3.0);
                    vec2 _4081 = vec2(7.0);
                    vec2 _4084 = vec2(1.0) + (_4068 * 3.0);
                    vec2 _4089 = (_4065 + (((vec2(3.0) - (_4068 * 2.0)) / _4075) - vec2(2.0))) * _830._m14.zw;
                    vec2 _4104 = (_4065 + ((vec2(3.0) + _4068) / _4081)) * _830._m14.zw;
                    vec2 _4116 = (_4065 + ((_4068 / _4084) + vec2(2.0))) * _830._m14.zw;
                    vec3 _4140 = vec3(_4089.x, _4089.y, _3925.z);
                    _3661 = (_4075.x * _4075.y) * textureLod(_4049, vec3(_4140.xy, _4140.z), 0.0);
                    vec3 _4156 = vec3(_4104.x, _4089.y, _3925.z);
                    _3661 += ((_4081.x * _4075.y) * textureLod(_4049, vec3(_4156.xy, _4156.z), 0.0));
                    vec3 _4174 = vec3(_4116.x, _4089.y, _3925.z);
                    _3661 += ((_4084.x * _4075.y) * textureLod(_4049, vec3(_4174.xy, _4174.z), 0.0));
                    vec3 _4192 = vec3(_4089.x, _4104.y, _3925.z);
                    _3661 += ((_4075.x * _4081.y) * textureLod(_4049, vec3(_4192.xy, _4192.z), 0.0));
                    vec3 _4210 = vec3(_4104.x, _4104.y, _3925.z);
                    _3661 += ((_4081.x * _4081.y) * textureLod(_4049, vec3(_4210.xy, _4210.z), 0.0));
                    vec3 _4228 = vec3(_4116.x, _4104.y, _3925.z);
                    _3661 += ((_4084.x * _4081.y) * textureLod(_4049, vec3(_4228.xy, _4228.z), 0.0));
                    vec3 _4246 = vec3(_4089.x, _4116.y, _3925.z);
                    _3661 += ((_4075.x * _4084.y) * textureLod(_4049, vec3(_4246.xy, _4246.z), 0.0));
                    vec3 _4264 = vec3(_4104.x, _4116.y, _3925.z);
                    _3661 += ((_4081.x * _4084.y) * textureLod(_4049, vec3(_4264.xy, _4264.z), 0.0));
                    vec3 _4282 = vec3(_4116.x, _4116.y, _3925.z);
                    _3661 += ((_4084.x * _4084.y) * textureLod(_4049, vec3(_4282.xy, _4282.z), 0.0));
                    _3661 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3661 = float((_3166 & 3u) == 2u);
            }
            float _4296 = float((_3166 >> uint(16)) & 63u) / 63.0;
            float _4310 = ((_3661 * _4296) + 1.0) - _4296;
            _3661 = _10(_4310);
        }
        uint _4313 = _2938._m13;
        vec3 _4312 = (_113(_4313) * _3661) * _3234;
        _3235 *= _2938._m14;
        vec3 _4325 = _4312;
        vec3 _4327 = _3236;
        float _4334 = dot(_798._m6, _4327);
        float _4329 = _10(_4334);
        vec3 _4340 = _798._m6;
        vec3 _4343 = _798._m13;
        vec3 _4346 = _3236;
        vec3 _4348 = _798._m2;
        float _4351 = abs(_798._m3);
        vec3 _4336 = _126(_4340, _4343, _4346, _4348, _4351);
        _798._m20 += (((_4336 * _3235) * _4325) * _4329);
        vec3 _4365 = mix(_4325, vec3(0.0), bvec3((_3166 & 256u) > 0u));
        float _4373 = 0.100000001490116119384765625;
        float _4385 = (dot(_798._m6, _4327) + _4373) / (1.0 + _4373);
        float _4375 = _10(_4385);
        vec3 _4387 = _3236;
        float _4400 = (dot(_798._m6, -_4327) + _4373) / (1.0 + _4373);
        float _4389 = _10(_4400);
        vec3 _4410 = -_798._m6;
        vec3 _4411 = _798._m13;
        vec3 _4414 = _4387;
        vec3 _4416 = _798._m2;
        float _4419 = abs(_798._m3) * 0.5;
        vec3 _4402 = _126(_4410, _4411, _4414, _4416, _4419);
        vec3 _4421 = (vec3(_4389) + _4402) * _798._m26;
        _798._m19 += ((vec3(_4375) + _4421) * _4325);
    }
    float _4439 = _830._m15.x;
    if (_4439 > 0.00999999977648258209228515625)
    {
        float _4446 = float(int(_830._m13.x) & 1023) / 1023.0;
        _4439 = max(0.0, _4439 + (((_4446 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _4462 = _798._m13;
        float _4470 = dot(_798._m6, _4462);
        float _4465 = _10(_4470);
        float _4472 = _4465 * _4439;
        vec3 _4480 = _798._m6;
        vec3 _4483 = _798._m13;
        vec3 _4486 = _798._m2;
        float _4489 = abs(_798._m3);
        vec3 _4476 = _133(_4480, _4483, _4486, _4489) * _4439;
        _798._m19 += vec3(_4472);
        _798._m20 += vec3(_4476);
    }
    _798._m19 = _798._m19;
    _798._m20 += _798._m10;
    float _4517 = 0.064999997615814208984375;
    float _4519 = 1.0 + _4517;
    bool _4522 = false;
    uint _4527;
    if (_830._m16.w > 0.00999999977648258209228515625)
    {
        _4527 = uint(_830._m16.x);
    }
    else
    {
        _4527 = 0u;
    }
    uint _4523 = _4527;
    _4545 _4547;
    for (uint _4535 = 0u; _4535 < _4523; _4535++)
    {
        int _4544 = 4;
        _4547._m0 = _4551._m0[(uint(_4544) * _4535) + 0u];
        _4547._m1 = _4551._m0[(uint(_4544) * _4535) + 1u];
        _4547._m2 = _4551._m0[(uint(_4544) * _4535) + 2u];
        float _4581 = _4551._m0[(uint(_4544) * _4535) + 3u].x;
        _4547._m3 = _27(_4581);
        float _4591 = _4551._m0[(uint(_4544) * _4535) + 3u].y;
        _4547._m4 = _27(_4591);
        float _4601 = _4551._m0[(uint(_4544) * _4535) + 3u].z;
        _4547._m5 = _27(_4601);
        vec4 _4606 = vec4(_798._m14, 1.0);
        vec3 _4613 = vec3(dot(_4606, _4547._m1), dot(_4606, _4547._m2), dot(_4606, _4547._m0));
        float _4627 = _4613.x;
        float _4630 = _4613.y;
        float _4633 = _4613.z;
        bool _4637 = _43(_4627, _4630, _4633) >= 0.0;
        bool _4646;
        if (_4637)
        {
            _4646 = max(_4613.x, _4613.y) < 1.0;
        }
        else
        {
            _4646 = _4637;
        }
        bool _4653;
        if (_4646)
        {
            _4653 = _4613.z < _4519;
        }
        else
        {
            _4653 = _4646;
        }
        if (_4653)
        {
            float _4656 = _4613.z;
            vec4 _4659 = vec4(_798._m14, 1.0);
            vec2 _4666 = vec2(0.0);
            _4666 = (((_4659.xy - _830._m17.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4679 = 0.000244140625;
            float _4685 = abs(_798._m6.z) * 2.0;
            _4679 *= _10(_4685);
            vec3 _4689 = vec3(TEXTURE_LOD(_4690, vec4(_4666 + vec2(_4679), 0.0, 0.0).xy, vec4(_4666 + vec2(_4679), 0.0, 0.0).w).x, TEXTURE_LOD(_4690, vec4(_4666, 0.0, 0.0).xy, vec4(_4666, 0.0, 0.0).w).x, TEXTURE_LOD(_4690, vec4(_4666 - vec2(_4679), 0.0, 0.0).xy, vec4(_4666 - vec2(_4679), 0.0, 0.0).w).x);
            float _4753 = 2.0 - (2.0 * (length(_4659.xy - _830._m17.zw) / 16.0));
            _4689 *= _10(_4753);
            float _4760 = 1.0 - _4656;
            float _4757 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4760));
            float _4771 = (_798._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4763 = (_4689 * _4757) * _10(_4771);
            float _4780 = _4519 - _4656;
            float _4774 = (1.0 - _4757) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4780));
            float _4793 = ((-_798._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4784 = (_4689 * _4774) * _10(_4793);
            _4689 = _4763 + _4784;
            float _4804 = 1.02499997615814208984375 - _4656;
            float _4799 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4804));
            float _4807 = _830._m16.w;
            _798._m19 = mix(_798._m19, (_798._m19 * _4689) + (_798._m19 * mix(1.0, 0.5, _4799)), vec3(_4807));
            break;
        }
    }
    _798._m19 *= _798._m0;
    _798._m21 = _798._m19 + _798._m20;
    vec3 _4841 = vec3(0.0);
    _798._m19 += _4841;
    vec3 _4853 = _798._m19 + _798._m20;
    _4848 = vec4(_4853.x, _4853.y, _4853.z, _4848.w);
    vec3 _4857 = _798._m6;
    bool _4860 = false;
    vec2 _4861 = _165(_4857, _4860);
    _4856 = vec4(_4861.x, _4861.y, _4856.z, _4856.w);
    float _4865 = _798._m2.x;
    float _4869 = _798._m2.y;
    float _4873 = _798._m2.z;
    float _4877 = _798._m3;
    _4864 = vec4(_92(_4865), _92(_4869), _92(_4873), _168(_4877));
    _4882 = vec4(0.0, 0.0, 0.0, float((uint(_819._m8.z) & 3u) << uint(4)) / 255.0);
    vec3 _4895 = _798._m19 + _798._m20;
    _4848 = vec4(_4895.x, _4895.y, _4895.z, _4848.w);
    vec3 _4898 = _798._m6;
    bool _4901 = false;
    vec2 _4902 = _165(_4898, _4901);
    _4856 = vec4(_4902.x, _4902.y, _4856.z, _4856.w);
    float _4905 = _798._m2.x;
    float _4909 = _798._m2.y;
    float _4913 = _798._m2.z;
    float _4917 = _798._m3;
    _4864 = vec4(_92(_4905), _92(_4909), _92(_4913), _168(_4917));
    vec3 _4927 = _4848.xyz + _819._m10.xyz;
    _4848 = vec4(_4927.x, _4927.y, _4927.z, _4848.w);
}


