#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

struct _882
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    float _m38;
    float _m39;
    uint _m40;
};

struct _1416
{
    int _m0;
    int _m1;
};

struct _1419
{
    int _m0;
    int _m1;
};

struct _1741
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    uint _m12;
    uint _m13;
    float _m14;
    uint _m15;
};

struct _3187
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 0, std140) uniform _904_906
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
} _906;

layout(set = 0, binding = 0, std140) uniform _916_918
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _918;

layout(set = 2, binding = 0, std140) uniform _1067_1069
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _1069;

layout(set = 0, binding = 5, std430) restrict readonly buffer _1421_1423
{
    _1419 _m0[];
} _1423;

layout(set = 0, binding = 6, std430) restrict readonly buffer _1717_1719
{
    uint _m0[];
} _1719;

layout(set = 0, binding = 7, std140) uniform _1746_1748
{
    vec4 _m0[4096];
} _1748;

layout(set = 0, binding = 8, std140) uniform _1785_1787
{
    vec4 _m0[4096];
} _1787;

layout(set = 0, binding = 9, std140) uniform _1853_1855
{
    vec4 _m0[4096];
} _1855;

layout(set = 0, binding = 12, std140) uniform _3191_3193
{
    vec4 _m0[4095];
} _3193;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4105_4107
{
    vec4 _m0[];
} _4107;

layout(push_constant, std430) uniform _4101_4103
{
    int _m0;
    int _m1;
} _4103;

layout(set = 2, binding = 1) uniform SAMPLER_2D _1047;
layout(set = 2, binding = 2) uniform SAMPLER_2D _1182;
layout(set = 1, binding = 1) uniform SAMPLER_2D _1235;
layout(set = 1, binding = 2) uniform SAMPLER_2D _1240;
layout(set = 0, binding = 10) uniform samplerCubeArray _2339;
layout(set = 0, binding = 11) uniform SAMPLER_2D _2748;
layout(set = 0, binding = 13) uniform sampler2DShadow _3515;
layout(set = 3, binding = 0) uniform texture2D _4093[16384];
layout(set = 3, binding = 1) uniform texture2D _4094[16384];
layout(set = 3, binding = 2) uniform texture2D _4095[16384];
layout(set = 3, binding = 3) uniform texture2D _4096[16384];
layout(set = 3, binding = 4) uniform texture2D _4097[16384];
layout(set = 3, binding = 5) uniform texture2D _4098[16384];
layout(set = 3, binding = 6) uniform texture2D _4099[16384];
layout(set = 3, binding = 7) uniform texture2D _4100[16384];
layout(set = 0, binding = 3) uniform sampler3D _4111;
layout(set = 0, binding = 4) uniform sampler3D _4112;

layout(location = 2) in vec4 _897;
layout(location = 6) in vec4 _923;
layout(location = 3) in vec4 _935;
layout(location = 4) in vec4 _938;
layout(location = 5) in vec4 _941;
layout(location = 10) in vec4 _959;
layout(location = 11) in vec4 _963;
layout(location = 12) in vec4 _967;
layout(location = 8) in vec4 _1245;
layout(location = 0) out vec4 _4007;
layout(location = 1) out vec4 _4015;
layout(location = 2) out vec4 _4023;
layout(location = 3) out vec4 _4041;

float _279;

float _65(float _64)
{
    return _64 * _64;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _47(float _46)
{
    return _46 * ((_46 * ((_46 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _50(vec3 _49)
{
    float _316 = _49.x;
    vec3 _315;
    _315.x = _47(_316);
    float _321 = _49.y;
    _315.y = _47(_321);
    float _326 = _49.z;
    _315.z = _47(_326);
    return _315;
}

vec4 _56(vec4 _55)
{
    vec3 _335 = _55.xyz;
    vec4 _334 = vec4(_50(_335), 1.0);
    float _343 = _55.w;
    _334.w = _47(_343);
    return _334;
}

vec4 _112(SAMPLER_2D _110, vec2 _111)
{
    vec4 _471 = SAMPLE_TEXTURE(_110, _111);
    vec4 _475 = _471;
    _471 = _56(_475);
    return _471;
}

float _116(vec3 _115)
{
    return dot(_115, vec3(0.2125999927520751953125, 0.715200006961822509765625, 0.072200000286102294921875));
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _159(vec3 _157, bool _158)
{
    vec3 _736 = (_157 * 2.0) - vec3(1.0);
    float _753 = (1.0 - (_736.x * _736.x)) - (_736.y * _736.y);
    _736.z = sqrt(_10(_753));
    if (_158 == false)
    {
        _736.z = -_736.z;
    }
    return _736;
}

vec3 _166(vec3 _164, mat3 _165)
{
    return normalize(vec3(dot(_164, _165[0]), dot(_164, _165[1]), dot(_164, _165[2])));
}

vec3 _172(vec3 _169, mat3 _170, bool _171)
{
    vec3 _786 = _169;
    bool _788 = _171;
    vec3 _785 = _159(_786, _788);
    vec3 _791 = _785;
    mat3 _793 = _170;
    return _166(_791, _793);
}

float _41(float _40)
{
    if (_40 <= 0.040449999272823333740234375)
    {
        return _40 / 12.9200000762939453125;
    }
    else
    {
        return pow((_40 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _44(vec3 _43)
{
    float _281 = _43.x;
    vec3 _280;
    _280.x = _41(_281);
    float _287 = _43.y;
    _280.y = _41(_287);
    float _293 = _43.z;
    _280.z = _41(_293);
    return _280;
}

vec3 _59(vec3 _58)
{
    vec3 _352 = _58;
    return _44(_352);
}

float _154(float _150, vec4 _151, float _152, bool _153)
{
    float _723 = _151.w / (_150 + _151.z);
    return _723 * _152;
}

vec3 _62(vec3 _61)
{
    return _61 * _61;
}

float _70(float _67, float _68, float _69)
{
    float _374 = (_67 - _68) / (_69 - _68);
    return _10(_374);
}

uint _21(float _20)
{
    return floatBitsToUint(_20);
}

float _32(float _29, float _30, float _31)
{
    return min(_29, min(_30, _31));
}

float _27(float _24, float _25, float _26)
{
    return max(_24, max(_25, _26));
}

vec4 _89(uint _88)
{
    return unpackUnorm4x8(_88).wzyx;
}

float _73(float _72)
{
    return exp2(_72);
}

vec3 _119(uint _118)
{
    uint _490 = _118;
    vec4 _489 = _89(_490);
    float _501 = (_489.w * 255.0) - 128.0;
    return _489.xyz * _73(_501);
}

vec3 _96(uint _95)
{
    return vec3(float((_95 >> uint(21)) & 2047u), float((_95 >> uint(10)) & 2047u), float(_95 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

vec4 _92(uint _91)
{
    return vec4(float((_91 >> uint(24)) & 255u), float((_91 >> uint(16)) & 255u), float((_91 >> uint(8)) & 255u), float(_91 & 255u));
}

vec3 _145(float _142, float _143, vec3 _144)
{
    float _675 = 0.0949999988079071044921875 + (_143 * (0.60000002384185791015625 + (4.190000057220458984375 * _143)));
    float _685 = _142 + 0.02500000037252902984619140625;
    float _689 = (9.5 * _143) * _142;
    float _703 = 1.0 - (14.0 * _142);
    float _695 = (_675 * _685) * _73(_703);
    float _710 = -_689;
    float _706 = 0.4000000059604644775390625 + (0.60000002384185791015625 * (1.0 - _73(_710)));
    return mix(vec3(_695), vec3(_706), _144);
}

vec4 _102(uvec2 _101)
{
    return vec4(float((_101.x >> uint(16)) & 65535u), float(_101.x & 65535u), float((_101.y >> uint(16)) & 65535u), float(_101.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _81(float _80)
{
    return (step(0.0, _80) * 2.0) - 1.0;
}

uint _38(float _35, float _36, float _37)
{
    bool _220 = abs(_37) >= abs(_35);
    bool _228;
    if (_220)
    {
        _228 = abs(_37) >= abs(_36);
    }
    else
    {
        _228 = _220;
    }
    if (_228)
    {
        return uint((_37 < 0.0) ? 5 : 4);
    }
    if (abs(_36) >= abs(_35))
    {
        return uint((_36 < 0.0) ? 3 : 2);
    }
    return uint(int(_35 < 0.0));
}

float _78(float _76, float _77)
{
    return pow(_76, _77);
}

vec3 _124(vec3 _122, float _123)
{
    float _513 = 50.0 * dot(_122, vec3(0.33329999446868896484375));
    float _506 = _10(_513);
    float _522 = 1.0 - _123;
    float _525 = _10(_522);
    float _526 = 5.0;
    vec3 _530 = _122 + ((vec3(_506) - _122) * _78(_525, _526));
    return _16(_530);
}

vec3 _132(vec3 _127, vec3 _128, vec3 _129, vec3 _130, float _131)
{
    vec3 _534 = normalize(_128 + _129);
    float _539 = 1.0 - (_131 * 0.800000011920928955078125);
    _539 *= _539;
    _539 *= _539;
    float _550 = _539 * _539;
    float _558 = dot(_127, _534);
    float _554 = _10(_558);
    float _560 = ((_554 * _554) * (_550 - 1.0)) + 1.0;
    _560 = _550 / ((_560 * _560) + 9.9999999392252902907785028219223e-09);
    float _579 = dot(_127, _128);
    float _575 = (_10(_579) * (1.0 - _539)) + _539;
    float _590 = dot(_127, _129);
    float _586 = (_10(_590) * (1.0 - _539)) + _539;
    _560 /= (((4.0 * _575) * _586) + 9.9999999392252902907785028219223e-09);
    vec3 _608 = _130;
    float _610 = dot(_129, _534);
    return _124(_608, _610) * _560;
}

vec3 _139(vec3 _135, vec3 _136, vec3 _137, float _138)
{
    float _616 = 1.0 - (_138 * 0.800000011920928955078125);
    _616 *= _616;
    _616 *= _616;
    float _626 = _616 * _616;
    float _634 = dot(_135, _136);
    float _630 = _10(_634);
    float _636 = ((_630 * _630) * (_626 - 1.0)) + 1.0;
    _636 = _626 / ((_636 * _636) + 9.9999999392252902907785028219223e-09);
    float _654 = dot(_135, _136);
    float _650 = (_10(_654) * (1.0 - _616)) + _616;
    _636 /= (((4.0 * _650) * _650) + 9.9999999392252902907785028219223e-09);
    vec3 _668 = _137;
    return _16(_668) * _636;
}

vec2 _176(vec2 _175)
{
    return (vec2(1.0) - abs(_175.yx)) * vec2((_175.x >= 0.0) ? 1.0 : (-1.0), (_175.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _181(inout vec3 _179, bool _180)
{
    _179 /= vec3((abs(_179.x) + abs(_179.y)) + abs(_179.z));
    vec2 _833;
    if (_179.z >= 0.0)
    {
        _833 = _179.xy;
    }
    else
    {
        vec2 _839 = _179.xy;
        _833 = _176(_839);
    }
    _179 = vec3(_833.x, _833.y, _179.z);
    if (_180)
    {
        vec2 _854 = (_179.xy * 0.5) + vec2(0.5);
        _179 = vec3(_854.x, _854.y, _179.z);
    }
    return _179.xy;
}

float _84(float _83)
{
    return sqrt(_83);
}

float _184(float _183)
{
    float _864 = abs(_183);
    float _861 = _84(_864);
    float _868;
    if (_183 > 0.0)
    {
        _868 = _861;
    }
    else
    {
        _868 = -_861;
    }
    return (_868 * 0.5) + 0.5;
}

void main()
{
    _882 _884 = _882(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _882 _894 = _882(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 0.0, 0.0, 1.0, 0u);
    _894._m15 = _897;
    _894._m16 = gl_FragCoord;
    _894._m40 = (uint(_906._m25.z) & 3u) << uint(4);
    _894._m14 = _918._m0.xyz + _923.xyz;
    _894._m13 = normalize(-_923.xyz);
    _894._m17 = mat3(vec3(_935.xyz), vec3(_938.xyz), vec3(_941.xyz));
    _894._m34 = _959;
    _894._m35 = _963;
    _894._m36 = _967;
    uint _970 = 0u;
    vec4 _971 = vec4(0.0);
    vec4 _972 = vec4(0.0);
    vec4 _973 = vec4(0.0);
    vec4 _974 = vec4(0.0);
    vec4 _975 = vec4(0.0);
    _894._m0 = _973.xyz;
    _894._m2 = _974.xyz;
    _894._m1 = _972.xyz;
    _894._m9 = _971.xyz;
    _894._m3 = _971.w;
    _894._m6 = _975.wyz;
    _894._m12 = 0.0;
    mat3 _998 = transpose(_894._m17);
    vec3 _1002 = normalize(vec3(dot(_894._m13, _998[0]), dot(_894._m13, _998[1]), dot(_894._m13, _998[2])));
    vec2 _1020 = _897.xy;
    int _1024 = 8;
    vec3 _1025 = vec3(-_1002.xy, 1.0);
    vec3 _1032 = _1025 / vec3(float(_1024));
    vec3 _1038 = vec3(_1020, 0.0);
    vec2 _1043 = _1038.xy;
    float _1062 = TEXTURE_LOD(_1047, vec4(_1038.xy, 0.0, 0.0).xy, vec4(_1038.xy, 0.0, 0.0).w).w;
    float _1046 = _65(_1062);
    float _1065 = _1046 * _1069._m4.x;
    float _1073 = _1065;
    int _1075 = 0;
    for (;;)
    {
        bool _1083 = _1075 < _1024;
        bool _1090;
        if (_1083)
        {
            _1090 = _1038.z < _1065;
        }
        else
        {
            _1090 = _1083;
        }
        if (_1090)
        {
            _1043 = _1038.xy;
            _1073 = _1065;
            _1038 += _1032;
            float _1111 = TEXTURE_LOD(_1047, vec4(_1038.xy, 0.0, 0.0).xy, vec4(_1038.xy, 0.0, 0.0).w).w;
            _1065 = _65(_1111) * _1069._m4.x;
            _1075++;
            continue;
        }
        else
        {
            break;
        }
    }
    float _1119 = _1065 - _1038.z;
    float _1124 = (_1073 - _1038.z) + _1032.z;
    float _1138 = _1119 / (_1119 - _1124);
    float _1132 = _10(_1138);
    vec2 _1140 = mix(_1038.xy, _1043, vec2(_1132));
    vec2 _1148 = _1140;
    vec4 _1147 = _112(_1047, _1148);
    _884._m0 = _1147.xyz;
    vec3 _1156 = _1147.xyz;
    vec3 _1171 = (_1147.www * _1069._m5.w) * 8.0;
    _894._m0 = mix(_1147.xyz, _1069._m5.xyz * _116(_1156), _16(_1171));
    _894._m2 = _1069._m6.xxx;
    _894._m3 = _1069._m6.y;
    _894._m6 = SAMPLE_TEXTURE(_1182, _1020).xyz;
    vec3 _1191 = _884._m0;
    _884._m2 = _1069._m6.zzz * _116(_1191);
    _884._m3 = _1069._m6.w;
    _884._m6 = vec3(1.0) - SAMPLE_TEXTURE1(_1182, vec4(_1140, 0.0, 0.0).xy, vec4(_1140, 0.0, 0.0).w).xyz;
    vec3 _1217 = _884._m6;
    mat3 _1220 = _894._m17;
    bool _1223 = true;
    _884._m6 = _172(_1217, _1220, _1223);
    vec2 _1226 = _897.xy * _906._m26.xy;
    vec4 _1234 = SAMPLE_TEXTURE(_1235, _1226);
    vec4 _1239 = SAMPLE_TEXTURE(_1240, _1226);
    float _1250 = _1245.x * 0.5;
    float _1244 = 1.0 - _10(_1250);
    float _1256 = _1244 * 2.0;
    float _1263 = (_10(_1256) - (1.0 - _1234.w)) * 1.0;
    float _1253 = _10(_1263);
    float _1272 = (_1244 - (1.0 - _1239.w)) * 1.0;
    float _1265 = _10(_1272);
    vec3 _1276 = _1234.xyz;
    _894._m0 = mix(_894._m0, _59(_1276), vec3(_1253));
    _894._m2 = mix(_894._m2, vec3(0.0199999995529651641845703125), vec3(_1253));
    _894._m3 = mix(_894._m3, 0.64999997615814208984375, _1253);
    _894._m6 = mix(_894._m6, _1239.xyz, vec3(_1265));
    uint _1306 = uint((_906._m25.x > 0.0) ? 8 : 0);
    float _1312 = 16.0;
    float _1314 = 8.0;
    float _1315 = 24.0;
    vec2 _1324 = _894._m16.xy * _918._m2.xy;
    vec3 _1317;
    _1317 = vec3(_1324.x, _1324.y, _1317.z);
    _1317.y = 1.0 - _1317.y;
    vec2 _1337 = floor(_1317.xy * vec2(_1312, _1314));
    _1317 = vec3(_1337.x, _1337.y, _1317.z);
    float _1341 = _894._m16.z;
    vec4 _1344 = _918._m3;
    float _1347 = 1.0;
    bool _1348 = false;
    float _1340 = _154(_1341, _1344, _1347, _1348);
    float _1350 = log2(max(1.0, _1340 / _918._m4.z)) * _918._m4.w;
    _1317.z = min(_1315 - 1.0, floor(_1350));
    uint _1366 = uint((_1317.x + (_1317.y * _1312)) + ((_1317.z * _1312) * _1314));
    _1366 = min(_1366, uint(((_1312 * _1314) * _1315) - 1.0));
    bool _1391 = true;
    vec3 _1393 = _894._m6;
    bool _1396 = _1391;
    _894._m7 = _159(_1393, _1396);
    vec3 _1400 = _894._m7;
    mat3 _1403 = _894._m17;
    _894._m6 = _166(_1400, _1403);
    uint _1408 = 0u;
    uint _1409 = 0u;
    uint _1410 = 0u;
    uint _1411 = 0u;
    uint _1412 = 0u;
    uint _1413 = 0u;
    int _1414 = 256;
    _1416 _1418;
    _1418._m0 = _1423._m0[_1366]._m0;
    _1418._m1 = _1423._m0[_1366]._m1;
    int _1432 = _1418._m0 & (~(_1418._m0 >> 31));
    int _1441 = _1418._m1 & (~(_1418._m1 >> 31));
    _1408 = uint((_1432 >> 16) * _1414);
    _1409 = _1408 + uint(_1441 & 255);
    _1410 = _1408;
    _1411 = _1410 + uint((_1441 >> 8) & 255);
    _1412 = _1408;
    _1413 = _1412 + uint((_1441 >> 16) & 255);
    float _1476 = _894._m37;
    float _1474 = _65(_1476);
    float _1483 = _1474 - 0.5;
    float _1480 = _10(_1483) * 2.0;
    float _1495 = _1474 * 2.0;
    float _1486 = (_894._m38 * _894._m38) * _10(_1495);
    float _1502 = _1486 + _1480;
    float _1498 = _10(_1502);
    if (_1498 > 0.0039215688593685626983642578125)
    {
        vec3 _1511 = _894._m0;
        float _1518 = _1498 * 1.0;
        float _1519 = 0.0;
        float _1520 = 0.3499999940395355224609375;
        _894._m0 = mix(_894._m0, _62(_1511), vec3(_70(_1518, _1519, _1520) * (1.0 - _894._m3)));
        float _1536 = _1498 * 1.0;
        float _1537 = 0.25;
        float _1538 = 0.5;
        _894._m2 = mix(_894._m2, vec3(0.039999999105930328369140625), vec3(_70(_1536, _1537, _1538)));
        vec3 _1543 = vec3(_894._m17[0].z, _894._m17[1].z, _894._m17[2].z);
        float _1557 = _1543.z + 0.0625;
        float _1551 = _1498 * _10(_1557);
        float _1566 = _1551 * 1.0;
        float _1567 = 0.20000000298023223876953125;
        float _1568 = 1.0;
        _894._m3 = mix(_894._m3, 0.89999997615814208984375, _70(_1566, _1567, _1568));
        float _1577 = _1551 * 1.0;
        float _1578 = 0.449999988079071044921875;
        float _1579 = 0.980000019073486328125;
        float _1572 = _70(_1577, _1578, _1579);
        _894._m6 = normalize(mix(_894._m6, vec3(0.0, 0.0, 1.0), vec3(_1572)));
        _894._m7 = mix(_894._m6, vec3(0.5, 0.5, 1.0), vec3(_1572));
        if (_1551 > 0.980000019073486328125)
        {
            float _1603 = _1551 * _1572;
            float _1604 = 0.980000019073486328125;
            float _1605 = 1.0;
            _1543 = normalize(mix(_1543, vec3(0.0, 0.0, 1.0), vec3(_70(_1603, _1604, _1605))));
            _894._m17[0].z = _1543.x;
            _894._m17[1].z = _1543.y;
            _894._m17[2].z = _1543.z;
        }
    }
    vec3 _1619 = vec3(0.0);
    vec3 _1620 = vec3(_894._m34.x, _894._m34.y, _894._m34.z);
    vec3 _1628 = vec3(_894._m34.w, _894._m35.x, _894._m35.y);
    vec3 _1636 = vec3(_894._m35.z, _894._m35.w, _894._m36.x);
    vec3 _1644 = vec3(_894._m36.y, _894._m36.z, _894._m36.w);
    vec3 _1652 = ((_1620 - (_1628 * _894._m6.y)) + (_1636 * _894._m6.z)) - (_1644 * _894._m6.x);
    float _1676 = _906._m27.x * _918._m5.x;
    _1619 += max(_1652 * _10(_1676), vec3(0.0));
    float _1687;
    if (dot(_894._m10, vec3(1.0)) > 0.0)
    {
        _1687 = -_894._m3;
    }
    else
    {
        _1687 = _894._m3;
    }
    _894._m3 = _1687;
    _894._m18 = _1619;
    _894._m19 = _1619;
    float _1704 = 1.0;
    uint _1705 = _1412;
    _1741 _1743;
    while (_1705 < _1413)
    {
        uint _1715 = _1719._m0[_1705];
        uint _1724 = (_1715 >> uint(24)) & 4095u;
        uint _1729 = _1724;
        if (_1729 >= _1724)
        {
            _1705++;
        }
        int _1738 = 4;
        int _1739 = 4;
        int _1740 = 4;
        _1743._m0 = _1748._m0[(uint(_1738) * _1729) + 0u].xyz;
        float _1763 = _1748._m0[(uint(_1738) * _1729) + 0u].w;
        _1743._m1 = _21(_1763);
        _1743._m2 = _1748._m0[(uint(_1738) * _1729) + 1u];
        _1743._m3 = _1748._m0[(uint(_1738) * _1729) + 2u];
        _1743._m4 = _1787._m0[(uint(_1739) * _1729) + 0u];
        _1743._m5 = _1787._m0[(uint(_1739) * _1729) + 1u];
        _1743._m6 = _1787._m0[(uint(_1739) * _1729) + 2u];
        float _1817 = _1748._m0[(uint(_1738) * _1729) + 3u].x;
        _1743._m7.x = _21(_1817);
        float _1827 = _1748._m0[(uint(_1738) * _1729) + 3u].y;
        _1743._m7.y = _21(_1827);
        float _1837 = _1748._m0[(uint(_1738) * _1729) + 3u].z;
        _1743._m7.z = _21(_1837);
        float _1847 = _1748._m0[(uint(_1738) * _1729) + 3u].w;
        _1743._m7.w = _21(_1847);
        _1743._m8 = _1855._m0[(uint(_1740) * _1729) + 0u];
        _1743._m9 = _1855._m0[(uint(_1740) * _1729) + 1u];
        _1743._m10 = _1855._m0[(uint(_1740) * _1729) + 2u];
        _1743._m11 = _1855._m0[(uint(_1740) * _1729) + 3u];
        float _1894 = _1787._m0[(uint(_1739) * _1729) + 3u].x;
        _1743._m12 = _21(_1894);
        float _1904 = _1787._m0[(uint(_1739) * _1729) + 3u].y;
        _1743._m13 = _21(_1904);
        _1743._m14 = _1787._m0[(uint(_1739) * _1729) + 3u].z;
        float _1922 = _1787._m0[(uint(_1739) * _1729) + 3u].w;
        _1743._m15 = _21(_1922);
        uint _1927 = (_1743._m12 >> uint(16)) & 3u;
        if (((_894._m40 >> uint(4)) & 3u) != _1927)
        {
            continue;
        }
        vec3 _1941 = vec3((_894._m14.x * _1743._m4.x) + ((_894._m14.y * _1743._m4.y) + ((_894._m14.z * _1743._m4.z) + _1743._m4.w)), (_894._m14.x * _1743._m5.x) + ((_894._m14.y * _1743._m5.y) + ((_894._m14.z * _1743._m5.z) + _1743._m5.w)), (_894._m14.x * _1743._m6.x) + ((_894._m14.y * _1743._m6.y) + ((_894._m14.z * _1743._m6.z) + _1743._m6.w)));
        vec2 _2008 = _1941.xy / vec2(_1941.z);
        _1941 = vec3(_2008.x, _2008.y, _1941.z);
        _1941.z = (_894._m14.x * _1743._m3.x) + ((_894._m14.y * _1743._m3.y) + ((_894._m14.z * _1743._m3.z) + _1743._m3.w));
        float _2032 = 0.0039215688593685626983642578125;
        float _2033 = _1941.x;
        float _2036 = _1941.y;
        float _2039 = _1941.z;
        bool _2044 = _32(_2033, _2036, _2039) < _2032;
        bool _2061;
        if (!_2044)
        {
            float _2048 = _1941.x;
            float _2051 = _1941.y;
            float _2054 = _1941.z;
            _2061 = _27(_2048, _2051, _2054) >= (1.0 - _2032);
        }
        else
        {
            _2061 = _2044;
        }
        if (_2061)
        {
            continue;
        }
        uint _2065 = _1743._m1;
        uint _2069 = _1743._m13;
        vec3 _2068 = _119(_2069);
        float _2073 = _1743._m14;
        vec3 _2076 = _1743._m0;
        if (_1743._m9.w == 0.0)
        {
            if (dot(_1743._m11.xyz, _894._m14) < (_1743._m11.w - _2032))
            {
                continue;
            }
        }
        else
        {
            if (_1743._m9.w == 1.0)
            {
                float _2105 = _1743._m11.w;
                uint _2109 = _21(_2105);
                vec3 _2104 = (((_96(_2109) * 2.0) - vec3(1.0)) * _1743._m11.xyz) + _2076;
                vec3 _2120 = abs(_894._m14 - _2104) / _1743._m11.xyz;
                float _2130 = _2120.x;
                float _2133 = _2120.y;
                float _2136 = _2120.z;
                if (_27(_2130, _2133, _2136) > 1.0)
                {
                    continue;
                }
            }
        }
        uint _2145 = _2065;
        float _2144 = _89(_2145).y;
        vec3 _2149 = (_1941 * 2.0) - vec3(1.0);
        vec3 _2153 = _2149 * sqrt(((vec3(1.0) - ((_2149.yzx * _2149.yzx) * 0.5)) - ((_2149.zxy * _2149.zxy) * 0.5)) + ((((_2149.yzx * _2149.yzx) * _2149.zxy) * _2149.zxy) / vec3(3.0)));
        float _2197 = 1.0 - ((length(_2153) - _2144) / ((1.0 - _2144) + 9.9999999747524270787835121154785e-07));
        float _2186 = _10(_2197);
        _2186 *= _2186;
        _2186 *= (_1743._m8.w * _1704);
        _1704 *= (1.0 - _2186);
        if (_2186 <= (_2032 * 4.0))
        {
            continue;
        }
        vec3 _2219 = _2068;
        uint _2222 = _2065;
        float _2221 = _92(_2222).z;
        vec3 _2226 = vec3(0.0);
        vec3 _2227 = vec3(0.0);
        vec3 _2228 = _894._m6;
        _2228.x = dot(_1743._m2.xy, _894._m6.xy);
        _2228.y = dot(_1743._m2.zw, _894._m6.xy);
        vec3 _2247 = reflect(-_894._m13, _894._m6);
        vec3 _2254 = (_1743._m9.xyz - _894._m14) / _2247;
        vec3 _2263 = (_1743._m8.xyz - _894._m14) / _2247;
        vec3 _2272 = max(_2254, _2263);
        float _2277 = _2272.x;
        float _2280 = _2272.y;
        float _2283 = _2272.z;
        float _2276 = _32(_2277, _2280, _2283);
        vec3 _2287 = _894._m14 + (_2247 * _2276);
        vec3 _2294 = normalize(_2287 - _2076);
        vec3 _2299 = _2294;
        _2299.x = dot(_1743._m2.xy, _2294.xy);
        _2299.y = dot(_1743._m2.zw, _2294.xy);
        float _2321 = dot(_894._m13, _894._m6);
        float _2315 = _10(_2321);
        float _2323 = 0.0;
        float _2324 = 6.0;
        float _2326 = max(_2323, _2324 - (_2324 * abs(_894._m3)));
        _2227 = textureLod(_2339, vec4(_2299, _2221), _2326).xyz * _2073;
        float _2356 = _2315;
        float _2358 = abs(_894._m3);
        vec3 _2359 = _894._m2;
        vec3 _2352 = _145(_2356, _2358, _2359);
        _2227 *= _2352;
        float _2370 = _2186;
        _894._m20 += ((_2227 * _2219) * _10(_2370));
        if (_1704 <= (_2032 * 4.0))
        {
            break;
        }
    }
    uint _2385 = _1408;
    _1741 _2414;
    vec3 _2721;
    float _2798;
    float _2816;
    uint _3161;
    _3187 _3189;
    uint _3311;
    _3187 _3335;
    while (_2385 < _1409)
    {
        uint _2395 = _1719._m0[_2385];
        uint _2399 = _2395 & 4095u;
        uint _2402 = _2399;
        if (_2402 >= _2399)
        {
            _2385++;
        }
        int _2411 = 4;
        int _2412 = 4;
        int _2413 = 4;
        _2414._m0 = _1748._m0[(uint(_2411) * _2402) + 0u].xyz;
        float _2429 = _1748._m0[(uint(_2411) * _2402) + 0u].w;
        _2414._m1 = _21(_2429);
        _2414._m2 = _1748._m0[(uint(_2411) * _2402) + 1u];
        _2414._m3 = _1748._m0[(uint(_2411) * _2402) + 2u];
        _2414._m4 = _1787._m0[(uint(_2412) * _2402) + 0u];
        _2414._m5 = _1787._m0[(uint(_2412) * _2402) + 1u];
        _2414._m6 = _1787._m0[(uint(_2412) * _2402) + 2u];
        float _2479 = _1748._m0[(uint(_2411) * _2402) + 3u].x;
        _2414._m7.x = _21(_2479);
        float _2489 = _1748._m0[(uint(_2411) * _2402) + 3u].y;
        _2414._m7.y = _21(_2489);
        float _2499 = _1748._m0[(uint(_2411) * _2402) + 3u].z;
        _2414._m7.z = _21(_2499);
        float _2509 = _1748._m0[(uint(_2411) * _2402) + 3u].w;
        _2414._m7.w = _21(_2509);
        _2414._m8 = _1855._m0[(uint(_2413) * _2402) + 0u];
        _2414._m9 = _1855._m0[(uint(_2413) * _2402) + 1u];
        _2414._m10 = _1855._m0[(uint(_2413) * _2402) + 2u];
        _2414._m11 = _1855._m0[(uint(_2413) * _2402) + 3u];
        float _2551 = _1787._m0[(uint(_2412) * _2402) + 3u].x;
        _2414._m12 = _21(_2551);
        float _2561 = _1787._m0[(uint(_2412) * _2402) + 3u].y;
        _2414._m13 = _21(_2561);
        _2414._m14 = _1787._m0[(uint(_2412) * _2402) + 3u].z;
        float _2579 = _1787._m0[(uint(_2412) * _2402) + 3u].w;
        _2414._m15 = _21(_2579);
        uint _2584 = (_2414._m12 >> uint(16)) & 3u;
        if (((_894._m40 >> uint(4)) & 3u) != _2584)
        {
            continue;
        }
        float _2598 = 0.0039215688593685626983642578125;
        vec4 _2599 = vec4(_894._m14, 1.0);
        float _2606 = 1.0 / dot(_2599, _2414._m6);
        vec3 _2612 = vec3(dot(_2599, _2414._m4) * _2606, dot(_2599, _2414._m5) * _2606, dot(_2599, _2414._m3));
        uint _2630 = _2414._m1;
        uint _2633 = _1306;
        _2633 |= 64u;
        float _2638 = _2612.x;
        float _2641 = _2612.y;
        float _2644 = _2612.z;
        bool _2649 = _32(_2638, _2641, _2644) <= _2598;
        bool _2666;
        if (!_2649)
        {
            float _2653 = _2612.x;
            float _2656 = _2612.y;
            float _2659 = _2612.z;
            _2666 = _27(_2653, _2656, _2659) >= (1.0 - _2598);
        }
        else
        {
            _2666 = _2649;
        }
        bool _2674;
        if (!_2666)
        {
            _2674 = (_2630 & _2633) != 0u;
        }
        else
        {
            _2674 = _2666;
        }
        if (_2674)
        {
            continue;
        }
        if ((_2630 & 3u) == 2u)
        {
            vec2 _2693 = fract((_2612.xy * _918._m6.xy) + _918._m6.zw);
            _2612 = vec3(_2693.x, _2693.y, _2612.z);
        }
        vec3 _2696 = _2414._m0;
        float _2699 = 1.0;
        float _2700 = 1.0;
        vec3 _2701 = vec3(0.0, 0.0, 1.0);
        vec3 _2702 = vec3(0.0, 0.0, 1.0);
        uint _2703 = _2414._m1;
        vec3 _2706 = (_2612 * 2.0) - vec3(1.0);
        vec2 _2711 = _2612.xy;
        vec3 _2714 = _2414._m10.xyz;
        if ((_2703 & 3u) == 2u)
        {
            _2721 = _2714;
        }
        else
        {
            _2721 = normalize(_2696 - _894._m14);
        }
        _2701 = _2721;
        _2701 = _2701;
        float _2738 = dot(_894._m6, _2701);
        float _2733 = _10(_2738);
        uvec2 _2741 = _2414._m7.zw;
        vec4 _2740 = _102(_2741);
        float _2747 = TEXTURE_LOD(_2748, vec4((_2711 * _2740.xy) + _2740.zw, 0.0, 0.0).xy, vec4((_2711 * _2740.xy) + _2740.zw, 0.0, 0.0).w).x;
        float _2774 = _2747 * _2747;
        uint _2778 = _2703 & 3u;
        bool _2783 = _2778 == 1u;
        bool _2795;
        if (!_2783)
        {
            bool _2788 = _2778 == 0u;
            bool _2794;
            if (_2788)
            {
                _2794 = _2414._m8.z != 0.0;
            }
            else
            {
                _2794 = _2788;
            }
            _2795 = _2794;
        }
        else
        {
            _2795 = _2783;
        }
        bool _2781 = _2795;
        if (_2781)
        {
            float _2801 = _2414._m8.w;
            _2798 = _10(_2801);
        }
        else
        {
            _2798 = 0.5;
        }
        float _2796 = _2798;
        bool _2809 = _2778 == 0u;
        bool _2815;
        if (_2809)
        {
            _2815 = _2414._m8.z != 0.0;
        }
        else
        {
            _2815 = _2809;
        }
        if (_2815)
        {
            float _2824 = sqrt(dot(_2706, _2706));
            _2816 = min(0.9921875, _10(_2824));
        }
        else
        {
            _2816 = _2612.z;
        }
        float _2807 = _2816;
        uvec2 _2832 = _2414._m7.xy;
        vec4 _2831 = _102(_2832);
        vec2 _2837 = vec2(_2807, _2796);
        float _2841 = TEXTURE_LOD(_2748, vec4((_2837 * _2831.xy) + _2831.zw, 0.0, 0.0).xy, vec4((_2837 * _2831.xy) + _2831.zw, 0.0, 0.0).w).x;
        _2841 *= _2841;
        _2699 = _2841 * _2774;
        if ((_2703 & 48u) != 0u)
        {
            vec4 _2879 = _2414._m10;
            vec4 _2882 = _2414._m8;
            vec4 _2885 = _2414._m9;
            float _2888 = dot(_894._m14, _2879.xyz) + _2879.w;
            if (_2888 < 0.0)
            {
                continue;
            }
            float _2902 = length(_2879.xyz);
            float _2909 = _2888 * 50.0;
            float _2906 = _10(_2909);
            _2699 *= (_2906 * _2906);
            _2888 /= _2902;
            _2879 /= vec4(_2902);
            vec3 _2923 = reflect(-_894._m13, _894._m6);
            if (dot(_2923, _2879.xyz) > 0.0)
            {
                _2923 = reflect(_2923, _2879.xyz);
            }
            float _2941 = dot(_2923, _2879.xyz);
            float _2946 = _2888 / _2941;
            vec3 _2950 = _894._m14 - (_2923 * _2946);
            vec3 _2957 = _2950 - _2696;
            float _2961 = dot(_2957, _2882.xyz) / _2882.w;
            float _2969 = dot(_2957, _2885.xyz) / _2885.w;
            if ((_2703 & 48u) == 32u)
            {
                vec2 _2983 = vec2(_2961, _2969);
                float _2987 = 1.0 / max(1.0, length(vec2(_2961, _2969)));
                _2961 *= (_2987 * _2882.w);
                _2969 *= (_2987 * _2885.w);
            }
            else
            {
                float _3009 = abs(_2961);
                float _3011 = _2961;
                _2961 = (_10(_3009) * _81(_3011)) * _2882.w;
                float _3020 = abs(_2969);
                float _3022 = _2969;
                _2969 = (_10(_3020) * _81(_3022)) * _2885.w;
            }
            vec3 _3029 = (_2882.xyz * _2961) + (_2885.xyz * _2969);
            _2696 += _3029;
            _2701 = normalize(_2696 - _894._m14);
            _2701 = _2701;
        }
        else
        {
            uint _3049 = (_2414._m15 >> uint(16)) & 255u;
            if (_3049 == 0u)
            {
                vec4 _3058 = _2414._m9;
                if (dot(_3058.xyz, _894._m14) < (_3058.w - _2598))
                {
                    continue;
                }
            }
            else
            {
                if (_3049 == 1u)
                {
                    vec3 _3079 = _2414._m9.xyz;
                    float _3084 = _2414._m9.w;
                    uint _3088 = _21(_3084);
                    vec3 _3083 = (((_96(_3088) * 2.0) - vec3(1.0)) * _3079) + _2696;
                    vec3 _3097 = abs((_894._m14 - _3083) / _3079);
                    float _3105 = _3097.x;
                    float _3108 = _3097.y;
                    float _3111 = _3097.z;
                    if (_27(_3105, _3108, _3111) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2699 <= (_2598 / 256.0))
        {
            continue;
        }
        float _3127 = 1.0;
        if ((_2630 & 4u) != 0u)
        {
            float _3134 = float(_2414._m15 & 255u) / 255.0;
            float _3140 = 0.001000000047497451305389404296875;
            vec3 _3142 = _894._m14 + (_894._m6 * _3140);
            if ((_2630 & 3u) == 0u)
            {
                vec3 _3155 = _3142 - _2414._m2.xyz;
                float _3162 = _3155.x;
                float _3165 = _3155.y;
                float _3168 = _3155.z;
                _3161 = _38(_3162, _3165, _3168);
            }
            else
            {
                if ((_2630 & 3u) == 2u)
                {
                    float _3178 = 0.0;
                    _3161 = 0u;
                    for (; _3161 < 3u; _3161++)
                    {
                        int _3186 = 5;
                        _3189._m0 = _3193._m0[(uint(_3186) * ((_2630 >> uint(22)) + _3161)) + 0u];
                        _3189._m1 = _3193._m0[(uint(_3186) * ((_2630 >> uint(22)) + _3161)) + 1u];
                        _3189._m2 = _3193._m0[(uint(_3186) * ((_2630 >> uint(22)) + _3161)) + 2u];
                        _3189._m3 = _3193._m0[(uint(_3186) * ((_2630 >> uint(22)) + _3161)) + 3u];
                        _3189._m4 = _3193._m0[(uint(_3186) * ((_2630 >> uint(22)) + _3161)) + 4u];
                        vec2 _3250 = vec2(dot(_3142, _3189._m0.xyz) + _3189._m0.w, dot(_3142, _3189._m1.xyz) + _3189._m1.w);
                        _3250 = abs((_3250 * 2.0) - vec2(1.0));
                        bool _3276 = _3250.x < 0.99500000476837158203125;
                        bool _3282;
                        if (_3276)
                        {
                            _3282 = _3250.y < 0.99500000476837158203125;
                        }
                        else
                        {
                            _3282 = _3276;
                        }
                        if (_3282)
                        {
                            _3178 = (1.0 - max(_3250.x, _3250.y)) * _918._m7.w;
                            break;
                        }
                    }
                    _3161 = min(2u, _3161);
                    uint _3299 = uint(_894._m16.x) ^ (uint(_894._m16.y) << uint(1));
                    if (_918._m8.w > 0.0)
                    {
                        _3311 = uint(_918._m9.x);
                    }
                    else
                    {
                        _3311 = 0u;
                    }
                    _3299 ^= _3311;
                    _3161 += uint(int(((float(_3299 & 3u) * 0.25) + 0.125) > _3178));
                }
                else
                {
                    _3161 = 0u;
                }
            }
            int _3334 = 5;
            _3335._m0 = _3193._m0[(uint(_3334) * ((_2630 >> uint(22)) + _3161)) + 0u];
            _3335._m1 = _3193._m0[(uint(_3334) * ((_2630 >> uint(22)) + _3161)) + 1u];
            _3335._m2 = _3193._m0[(uint(_3334) * ((_2630 >> uint(22)) + _3161)) + 2u];
            _3335._m3 = _3193._m0[(uint(_3334) * ((_2630 >> uint(22)) + _3161)) + 3u];
            _3335._m4 = _3193._m0[(uint(_3334) * ((_2630 >> uint(22)) + _3161)) + 4u];
            vec4 _3391 = vec4((_3142.x * _3335._m0.x) + ((_3142.y * _3335._m0.y) + ((_3142.z * _3335._m0.z) + _3335._m0.w)), (_3142.x * _3335._m1.x) + ((_3142.y * _3335._m1.y) + ((_3142.z * _3335._m1.z) + _3335._m1.w)), (_3142.x * _3335._m2.x) + ((_3142.y * _3335._m2.y) + ((_3142.z * _3335._m2.z) + _3335._m2.w)), (_3142.x * _3335._m3.x) + ((_3142.y * _3335._m3.y) + ((_3142.z * _3335._m3.z) + _3335._m3.w)));
            vec3 _3478 = _3391.xyz / vec3(_3391.w);
            _3391 = vec4(_3478.x, _3478.y, _3478.z, _3391.w);
            bool _3486 = min(_3391.x, _3391.y) > 0.0;
            bool _3495;
            if (_3486)
            {
                _3495 = max(_3391.x, _3391.y) < 1.0;
            }
            else
            {
                _3495 = _3486;
            }
            if (_3495)
            {
                vec2 _3507 = (_3391.xy * _3335._m4.xy) + _3335._m4.zw;
                _3391 = vec4(_3507.x, _3507.y, _3391.z, _3391.w);
                if (false)
                {
                    _3127 = textureLod(_3515, vec3(_3391.xyz.xy, _3391.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3522 = (_3391.xy * _918._m10.xy) + vec2(0.5);
                    vec2 _3531 = floor(_3522);
                    vec2 _3534 = _3522 - _3531;
                    _3531 -= vec2(0.5);
                    vec2 _3541 = vec2(4.0) - (_3534 * 3.0);
                    vec2 _3546 = vec2(7.0);
                    vec2 _3549 = vec2(1.0) + (_3534 * 3.0);
                    vec2 _3554 = (_3531 + (((vec2(3.0) - (_3534 * 2.0)) / _3541) - vec2(2.0))) * _918._m10.zw;
                    vec2 _3569 = (_3531 + ((vec2(3.0) + _3534) / _3546)) * _918._m10.zw;
                    vec2 _3581 = (_3531 + ((_3534 / _3549) + vec2(2.0))) * _918._m10.zw;
                    vec3 _3605 = vec3(_3554.x, _3554.y, _3391.z);
                    _3127 = (_3541.x * _3541.y) * textureLod(_3515, vec3(_3605.xy, _3605.z), 0.0);
                    vec3 _3621 = vec3(_3569.x, _3554.y, _3391.z);
                    _3127 += ((_3546.x * _3541.y) * textureLod(_3515, vec3(_3621.xy, _3621.z), 0.0));
                    vec3 _3639 = vec3(_3581.x, _3554.y, _3391.z);
                    _3127 += ((_3549.x * _3541.y) * textureLod(_3515, vec3(_3639.xy, _3639.z), 0.0));
                    vec3 _3657 = vec3(_3554.x, _3569.y, _3391.z);
                    _3127 += ((_3541.x * _3546.y) * textureLod(_3515, vec3(_3657.xy, _3657.z), 0.0));
                    vec3 _3675 = vec3(_3569.x, _3569.y, _3391.z);
                    _3127 += ((_3546.x * _3546.y) * textureLod(_3515, vec3(_3675.xy, _3675.z), 0.0));
                    vec3 _3693 = vec3(_3581.x, _3569.y, _3391.z);
                    _3127 += ((_3549.x * _3546.y) * textureLod(_3515, vec3(_3693.xy, _3693.z), 0.0));
                    vec3 _3711 = vec3(_3554.x, _3581.y, _3391.z);
                    _3127 += ((_3541.x * _3549.y) * textureLod(_3515, vec3(_3711.xy, _3711.z), 0.0));
                    vec3 _3729 = vec3(_3569.x, _3581.y, _3391.z);
                    _3127 += ((_3546.x * _3549.y) * textureLod(_3515, vec3(_3729.xy, _3729.z), 0.0));
                    vec3 _3747 = vec3(_3581.x, _3581.y, _3391.z);
                    _3127 += ((_3549.x * _3549.y) * textureLod(_3515, vec3(_3747.xy, _3747.z), 0.0));
                    _3127 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3127 = float((_2630 & 3u) == 2u);
            }
            float _3761 = float((_2630 >> uint(16)) & 63u) / 63.0;
            float _3775 = ((_3127 * _3761) + 1.0) - _3761;
            _3127 = _10(_3775);
        }
        uint _3778 = _2414._m13;
        vec3 _3777 = (_119(_3778) * _3127) * _2699;
        _2700 *= _2414._m14;
        vec3 _3790 = _3777;
        vec3 _3792 = normalize(_2696 - _894._m14);
        float _3803 = dot(_894._m6, _3792);
        float _3798 = _10(_3803);
        vec3 _3806 = _894._m6;
        vec3 _3809 = _894._m13;
        vec3 _3812 = _3792;
        vec3 _3814 = _894._m2;
        float _3817 = _894._m3;
        vec3 _3805 = _132(_3806, _3809, _3812, _3814, _3817);
        _894._m20 += (((_3805 * _2700) * _3790) * _3798);
        float _3839 = 1.25;
        float _3842 = (dot(_884._m6, _3792) + 0.25) / _65(_3839);
        float _3832 = _10(_3842);
        _894._m19 += (_3790 * _3832);
        vec3 _3852 = _884._m6;
        vec3 _3855 = _894._m13;
        vec3 _3858 = _3792;
        vec3 _3860 = _884._m2;
        float _3863 = _884._m3;
        vec3 _3851 = _132(_3852, _3855, _3858, _3860, _3863);
        _894._m20 += (((_3851 * _2700) * _3790) * _3798);
    }
    float _3878 = _918._m11.x;
    if (_3878 > 0.00999999977648258209228515625)
    {
        float _3886 = float(int(_918._m9.x) & 1023) / 1023.0;
        _3878 = max(0.0, _3878 + (((_3886 - 0.5) * 2.0) * 0.17499999701976776123046875));
        vec3 _3902 = _894._m13;
        float _3910 = dot(_894._m6, _3902);
        float _3905 = _10(_3910);
        float _3912 = _3905 * _3878;
        vec3 _3920 = _894._m6;
        vec3 _3923 = _894._m13;
        vec3 _3926 = _894._m2;
        float _3929 = abs(_894._m3);
        vec3 _3916 = _139(_3920, _3923, _3926, _3929) * _3878;
        _894._m19 += vec3(_3912);
        _894._m20 += vec3(_3916);
    }
    _894._m19 = _894._m19;
    _894._m20 += _894._m10;
    _894._m19 *= _894._m0;
    _894._m21 = _894._m19 + _894._m20;
    float _3975 = dot(_894._m6, _894._m13);
    float _3969 = _10(_3975);
    vec3 _3978 = _894._m19;
    vec3 _3984 = _894._m6;
    vec3 _3987 = _894._m13;
    vec3 _3990 = _894._m13;
    vec3 _3993 = _894._m2;
    float _3996 = _894._m3;
    vec3 _3977 = (_16(_3978) * _3969) * _132(_3984, _3987, _3990, _3993, _3996);
    _894._m19 += _3977;
    vec3 _4012 = _894._m19 + _894._m20;
    _4007 = vec4(_4012.x, _4012.y, _4012.z, _4007.w);
    vec3 _4016 = _894._m6;
    bool _4019 = false;
    vec2 _4020 = _181(_4016, _4019);
    _4015 = vec4(_4020.x, _4020.y, _4015.z, _4015.w);
    float _4024 = _894._m2.x;
    float _4028 = _894._m2.y;
    float _4032 = _894._m2.z;
    float _4036 = _894._m3;
    _4023 = vec4(_84(_4024), _84(_4028), _84(_4032), _184(_4036));
    _4041 = vec4(0.0, 0.0, 0.0, float((uint(_906._m25.z) & 3u) << uint(4)) / 255.0);
    vec3 _4054 = _894._m19 + _894._m20;
    _4007 = vec4(_4054.x, _4054.y, _4054.z, _4007.w);
    vec3 _4057 = _894._m6;
    bool _4060 = false;
    vec2 _4061 = _181(_4057, _4060);
    _4015 = vec4(_4061.x, _4061.y, _4015.z, _4015.w);
    float _4064 = _894._m2.x;
    float _4068 = _894._m2.y;
    float _4072 = _894._m2.z;
    float _4076 = _894._m3;
    _4023 = vec4(_84(_4064), _84(_4068), _84(_4072), _184(_4076));
    vec3 _4087 = _4007.xyz + _906._m28.xyz;
    _4007 = vec4(_4087.x, _4087.y, _4087.z, _4007.w);
}

