#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _114_116
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _116;

layout(set = 2, binding = 0, std140) uniform _149_151
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _151;

layout(set = 1, binding = 0, std140) uniform _255_257
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
} _257;

layout(set = 0, binding = 1, std430) restrict readonly buffer _378_380
{
    vec4 _m0[];
} _380;

layout(push_constant, std430) uniform _374_376
{
    int _m0;
    int _m1;
} _376;

layout(set = 2, binding = 1) uniform SAMPLER_2D _93;
layout(set = 1, binding = 1) uniform SAMPLER_2D _170;
layout(set = 2, binding = 2) uniform SAMPLER_2D _250;

layout(location = 2) in vec4 _96;
layout(location = 0) out vec4 _162;
layout(location = 8) in vec4 _165;
layout(location = 9) in vec4 _172;
layout(location = 7) in vec4 _252;

float _30(uvec2 _28, uint _29)
{
    uvec2 _49 = _28 & uvec2(3u);
    return float(((((2068378560u * (1u - (_49.x >> uint(1)))) + (1500172770u * (_49.x >> uint(1)))) >> ((_49.y + ((_49.x & 1u) << uint(2))) << uint(2))) + _29) & 15u) / 16.0;
}

void _14(float _13)
{
    if (_13 < 0.0)
    {
        discard;
    }
}

float _21(vec4 _19, vec4 _20)
{
    return dot(_19, _20);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    float _89 = SAMPLE_TEXTURE1(_93, vec4(_96.zw, 0.0, -2.0).xy, vec4(_96.zw, 0.0, -2.0).w).x;
    uint _125;
    if (dot(_116._m5.zw, vec2(1.0)) > 0.0)
    {
        _125 = uint(int(_116._m6.x) & 15);
    }
    else
    {
        _125 = 0u;
    }
    uint _113 = _125;
    uvec2 _143 = uvec2(gl_FragCoord.xy);
    uint _144 = _113;
    float _138 = _30(_143, _144);
    float _159 = (_89 - (_138 * _151._m4.w)) - 0.0039215688593685626983642578125;
    _14(_159);
    _162 = vec4(0.0);
    float _164 = _165.w;
    vec4 _169 = SAMPLE_TEXTURE(_170, _172.xy);
    vec3 _181 = _169.xyz - vec3(0.5);
    _169 = vec4(_181.x, _181.y, _181.z, _169.w);
    if (_151._m5.x > 0.5)
    {
        float _189 = _164;
        float _191 = _189;
        _14(_191);
    }
    vec2 _195 = gl_FragCoord.xy * _116._m7.xy;
    _195.y = 1.0 - _195.y;
    vec4 _207 = vec4((_195.x * 2.0) - 1.0, (_195.y * 2.0) - 1.0, gl_FragCoord.z, 1.0);
    vec3 _222;
    _222.x = dot(_207, _116._m8);
    _222.y = dot(_207, _116._m9);
    _222.z = dot(_207, _116._m10);
    _222 /= vec3(dot(_207, _116._m11));
    float _249 = SAMPLE_TEXTURE(_250, _252.xy * vec2(_257._m28.w)).y;
    vec4 _274 = vec4(_257._m26.xyz, 1.0);
    vec4 _275 = _257._m1;
    vec3 _265;
    _265.x = _21(_274, _275);
    vec4 _287 = vec4(_257._m26.xyz, 1.0);
    vec4 _288 = _257._m2;
    _265.y = _21(_287, _288);
    vec4 _301 = vec4(_257._m26.xyz, 1.0);
    vec4 _302 = _257._m3;
    _265.z = _21(_301, _302);
    vec3 _307 = _265 - _222;
    float _311 = (_249 * _151._m6.x) + (1.0 - _151._m6.x);
    float _320 = length(_307) * _311;
    vec2 _325 = vec2(6.666666507720947265625, 10.0);
    float _329 = _320 - _257._m27.w;
    float _340 = _329 * _325.x;
    float _335 = _10(_340);
    float _347 = _329 * _325.y;
    float _342 = _10(_347);
    float _357 = (1.0 - _342) * _249;
    vec3 _349 = _257._m28.xyz * _10(_357);
    float _360 = _335;
    float _367 = ceil(_360 - 0.001000000047497451305389404296875);
    float _362 = _10(_367);
    float _372 = _362 - 9.9999997473787516355514526367188e-05;
    _14(_372);
}

